#!/usr/bin/perl

############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

###
#
# admin_sku.cgi
#
###

###
# Version 0.9.47 JC 20001003
#     secure sid
# Version 0.9.46 TG 20000922
#     Fixed my bug introduced by checking for '' in search :)
# Version 0.9.45 TG 20000921
#     Replaced ->do with &query, search of only spaces goes to ''
# Version 0.9.44 TG 20000918
#     Set previous_error after message 43 for warehouses
# Version 0.9.43 JC 20000913
#     completion of port
# Version 0.9.42 JC 20000823
#     ->rows  
# Version 0.9.41 TG 20000822
#     Fixed generate triggers for variant products after .pm change
# Version 0.9.40 TG 20000821
#     Added generate_triggers for variant products
# Version 0.9.39 TG 20000817
#    Added generate_triggers
# Version 0.9.38 TG 20000801
#    Fixed SQL statments
# Version 0.9.37 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.36 TG 20000712
#    Hardcoded status to active for variants and pulldowns
# Version 0.9.35 TG 20000710
#    Changed msku for variant products to inherit from master product
# Version 0.9.34 TG 20000707
#    Cleaned up debug and documented
# Version 0.9.33 TG 20000706
#    Fixed 0 to # on search results to be 1 to #.
#    Added pages to search results
# Version 0.9.32 TG 20000705
#    cleaned up debug for preparation for release
#    added type of object for search
# Version 0.9.31 TG 20000630
#    changed visibility to 110000-A for display, 110001-A non-display
# Version 0.9.30 TG 20000629
#    fixed search to split into pages, and added status search
# Version 0.9.29 TG 20000628
#    moved OBJTYPES and OBJCLASS to objects.pm and removed all hardcodes to
#    types and values.  Added warehouse!  fixed check_login to go to login
#    screen if not logged in.  Added session language vs $om_render_lang
# Version 0.9.28 TG 20000622
#    changed CR_to_html to convert string to html before returning
# Version 0.9.27 TG 20000621
#    converted \r\n to <P> in brief and description
#    changed SKU_SERIES to sel_sku_series
# Version 0.9.26 TG 20000620
#    cleaned up, fixed known-bugs
# Version 0.9.25 TG 20000619
#    reorganized editsku mode, fixed missing objid link after error
# Version 0.9.24 TG 20000616
#    fixed search functionality to work with new data structure
# Version 0.9.23 TG 20000615
#    worked on search, changed brands to sku_series
# Version 0.9.21 TG 20000614
#    fixed variant support
# Version 0.9.20 TG 20000612
#    started variant support
# Version 0.9.19 TG 20000609
#    create product line, article, and pulldowns
# Version 0.9.18 IB 20000608
#    language and interface from table 'sessions'
#    added custom-lib.pm
# Version 0.9.11 GF 20000525
#
###

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
   } else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;
   
   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels
   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );
   
   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root
   
} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/variant.pm";
require "$relpath/lib/objects.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/generate_triggers.pm";
require "$relpath/lib/blowfisher.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";


## establish site-specific parameters
#
$site=setsite();

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

## establish connection to database
#
$q = "$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
# $interface = "";

$FORM{'sid'}=&os_unhash(pack(H16,$FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );

if ($FORM{'sid'}) {
   $q="SELECT language,interface FROM sessions WHERE sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $session_lang=$h->{'language'};
   $sts->finish;
   #  $interface=$h->{'interface'};
}

$session_lang="eng" if ( ! $session_lang );

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );


## load messages
#
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

## load in the object class & type definitions
&initClassAndType();

$sid=$FORM{'sid'};

$sid_encrypt=unpack(H16, &os_hash($FORM{'sid'}, $site->{'hash_key'}));


## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","admin_sku.cgi") if (! $ENV{'REQUEST_URI'} );

$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

## path of where admin_sku templates live/also path of where selects live
#
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
#
$nicedt=nicedatetime();

%NVP=();
$NVP{'sitename'}=$site->{'sitename'};

@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

## catch inbounds lacking mode - homepage default
#
if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'}); #in login.pm

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
   }
   elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
      } else {
      ## welcome to the page...
   }
   print "Content-type: text/html\n\n";
   
   } else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

## Define first entries in %NVP based on mode, sid, etc...
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


## now have established acceptable session id
#  proceed to display the appropriate form
#
# PREPROCESS form modes are:
#   findobject - perform a search based on 'skuskel' and
#         change mode afterwards depending upon results:
#         --> listskus (more than one found)
#         --> editsku (only one found)
#         --> home (none found, set error message)
#
# REAL form modes as follow (submode is blank,error,edit):
#   home - homepage, allows creation and editing of skus
#   editsku   - edit a sku (kind?)
#   showsku   - display a sku with linkage to variant and link admin
#
########################################################

###
# Preprocess Certain Modes prior to display
#    (the mode parameter changes based on the outcome
#    of the preprocessing).
#
# check to see if the homepage is simply clearing the form
$debug = 0;
if ($debug) {
   open ERLOG, ">/tmp/admin_sku";
   print ERLOG "Set language to $session_lang!\n";
}

# Flag, set to 0 to have default for Generate page? as no, and 
# set to 1 to have default as yes
$generate_default = 0;

if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findobject")) {
   $FORM{'mode'}="home";
   if ($debug) {
      print ERLOG "Set mode to home in searchclear or findobject!\n";
   }
}

#
# real preprocessing
#

## variants mode, big chunk, variants is handled separately from the flow of the
#  other editskus b/c etc, etc,  -- it's almost it's own script within admin_sku
#  NOT just variants is handled here, also prices
#  again, variants does NOT go through writeskutodb, loadskufromdb, etc, etc.
#  this is both PRE and process and POST
###


# If someone pressed submit on the variant_products page, we need to add
# the variants and then display the existing variants and the new rows
if ($FORM{'mode'} eq "submit") {
   
   if ($debug > 1) {
      print ERLOG "----------- Submitting -----------------------------------------------\n";
      foreach $z (keys %FORM) {
         print ERLOG "\$FORM{$z} = $FORM{$z}\n";
      }
      print ERLOG "\n\n";
      foreach $z (keys %NVP) {
         print ERLOG "\$NVP{$z} = $NVP{$z}\n";
      }
      print ERLOG "\n\n";
   }
   
   if (&validatefields()) {
      $variant_indx = &loadFormVariants(\@form_variants);
      
      $arrIndx = $variant_indx->{$varkey};
      $h = $form_variants[$arrIndx];
      
      # for each objid
      foreach $varkey (keys %{$variant_indx}) {
         next if (length($varkey) == 0);
         
         # Get the array index for the objid
         $arrIndx = $variant_indx->{$varkey};
         
         # Get the objid hash
         $h = $form_variants[$arrIndx];
         if ($debug > 1) {
            foreach $ki (keys %{$h}) {
               print ERLOG "\$h->{$ki} --> $h->{$ki}\n";
            }
            print ERLOG "\n\n\n";
         }
         
         # validate everything
         $h->{'masterobjid'} = $FORM{'masterobjid'};
         $h = &validatevariant($h);
         
         # if there were no errors and we are supposed to write it
         if (($h->{'changestowrite'} eq "yes") && ($h->{'validationcheck'} eq "ok")) {
            
            # insert the new row
            if ($varkey =~ /newrow/) {
               $q = "SELECT body FROM extraprop WHERE objid = '$FORM{'masterobjid'}' AND fieldname = 'sku_series'";
               if ($debug) {
                  print ERLOG "$q\n";
               }
               $numRows = &query($q, $dbh, \@sku_series);
	       $q2 = "SELECT msku FROM things WHERE objid = '$FORM{'masterobjid'}'";

               $n = &query($q2, $dbh, \@res2);

	       if ($debug) {
		   print ERLOG "$q2\nReturned $n rows\n";
	       }

	       $sku = $res2[0]->{'msku'};
               $FORM{'objtype'} = $OBJTYPES->{'product_variant'};
               $admin_objid = &insertThing($sku, "ref_from", "'$FORM{'masterobjid'}'");
	       $h->{'objid_ini'} = $admin_objid;
               if ($debug) {
                  print ERLOG "Objtype is $FORM{'objtype'}\n";
                  print ERLOG "Going to insert $admin_objid for $varkey!!!!\n";
               }
            }
            else {
               $admin_objid = $varkey;
            }
            
            # update the row in things
            &updateVariant($admin_objid, $h);

	    if ($h->{'regenerate_inp'} == 1) {
		print ERLOG "Going into generate triggers for $h->{'objid_ini'}\n";
		&generate_triggers($h->{'objid_ini'});
		print ERLOG "Going into generate triggers for $FORM{'masterobjid'}\n";
		&generate_triggers($FORM{'masterobjid'});
		print ERLOG "Returned from generate_triggers\n";
	    }

         }
         else {
            if ($debug) {
               print ERLOG "There an error?  $h->{'axis_err'}\n";
            }
            $NVP{'axis_err'} = $h->{'axis_err'};
         }
      }
   }
   
   # Set form mode to variants to display the data!
   $FORM{'mode'} = "variants";
   if ($debug) {
      print ERLOG "----------------------------------------------------------\n";
   }


}


if ($FORM{'mode'} eq "submit_editsku") {
   ## load the data from the submitted form elements
   ## cannonicalize brand authors to lowercase
   &checkformbits();
   $h = &validate_object_def();
   
   if ($debug) {
      print ERLOG "After validate_object_def with \$h->{'changestowrite'} = $h->{'changestowrite'},";
      print ERLOG " \$h->{'validationcheck'} = $h->{'validationcheck'}\n";
   }
   
   if ($h->{'validationcheck'} eq "ok") {
      # if there were no errors and we are supposed to write it
      if ($h->{'changestowrite'} eq "yes") {
         
         if ($debug) {
            print ERLOG "loadfrom is $FORM{'loadfrom'} \n ";
         }
         
         if ( $FORM{'loadfrom'} eq "form" ) {           # this is a form submission,
            $writeErrors=&writeskutodb();
            if ($debug) {
               print ERLOG "After write to db \n writeErrors is '$writeErrors'";
            }
            if ( $writeErrors ) {
               $FORM{'mode'}="editsku";
               $FORM{'PAGE_ERROR_MSG'}=$writeErrors;
            }
         }
      }
      
      # set up the links for the home page
      if (!$writeErrors) {
         ## change mode to display sku
         #
         $skulink="<A HREF=admin_sku.cgi";
         $skulink.="\?\&mode=findobject&objskel=$FORM{'objid'}&sid=$sid_encrypt&all=no\>$FORM{'objid'}</A>";
         $skulinks="<A HREF=linkage.cgi";
         $skulinks.="\?\&mode=editlink&obj1=$FORM{'objid'}&sid=$sid_encrypt&loadfrom=db>$script_msg{38}</A>";
         
         $NVP{'links'} = "<TD><FONT face=\"arial, helvetica\" size=\"-1\"><BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp $skulinks</FONT></TD>";
         $inventorylink = "";
         
         if ($FORM{'objtype'} eq $OBJTYPES->{'product'}) {
            $inventorylink="<A HREF=inventory.cgi";
            $inventorylink.="\?\&mode=editsku&objid=$FORM{'objid'}&sid=$sid_encrypt&loadfrom=db&warehouse_inp=>$script_msg{41}</A>";
            $pricelink="<A HREF=inventory.cgi";
            $pricelink.="\?\&mode=editprice&objid=$FORM{'objid'}&sid=$sid_encrypt&loadfrom=db>$script_msg{40}</A>";
            
            $NVP{'inventory'} = "<TD><FONT face=\"arial, helvetica\" size=\"-1\"><BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp $inventorylink</FONT></TD>";
            $NVP{'price'} = "<TD><FONT face=\"arial, helvetica\" size=\"-1\"><BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp $pricelink</FONT></TD>";
         }
         
         
         if ( $FORM{'newflag'} =~ /y/i ) {
            $NVP{'lastaction'}="<FONT face=\"arial, helvetica\" size=\"-1\">$script_msg{10} $skulink $script_msg{35}.  $script_msg{37}";
            
         }
         # if we wrote changes
         elsif ($h->{'changestowrite'} eq "yes")  {
            $NVP{'lastaction'}="<FONT face=\"arial, helvetica\" size=\"-1\">$script_msg{11} $skulink $script_msg{35}.  $script_msg{37}";
         }
         # No changes made
         else {
	     $NVP{'lastaction'}="<FONT face=\"arial, helvetica\" size=\"-1\">$script_msg{34} $skulink.  $script_msg{37}";
         }
         
         # If it is a master product, link it to create variant products
         if (($FORM{'objtype'} eq "$OBJTYPES->{'product'}") &&
            (length($FORM{'axisnames_inp'}) > 0)) {
            $variantlink="<A HREF=admin_sku.cgi";
            $variantlink.="\?\&mode=variants&objskel=$FORM{'objid'}&sid=$sid_encrypt\>$script_msg{39}</A>";
            
            $NVP{'addvariant'} = "<TD><FONT face=\"arial, helvetica\" size=\"-1\"><BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp$variantlink</FONT></TD>";
         }

	 if ($FORM{'regenerate_inp'} == 1) {
	     print ERLOG "Going into generate triggers for $objid, $FORM{'objtype'}\n";
	     &generate_triggers($FORM{'objid'});
	     print ERLOG "Returned from generate_triggers for $FORM{'objid'}, $FORM{'objtype'}\n";
	 }
         $FORM{'mode'} = "home";
         $FORM{'loadfrom'} = "home";
         $NVP{'loadfrom'} = "home";
         $NVP{'lastmode'} = "home";
         $FORM{'lastmode'} = "home";
      } # done if !$writeErrors
   } # Validation ok
   else {
      if ($debug) {
         print ERLOG "Had invalid data, so sent $FORM{'objid'} back to editsku!\n";
      }
      $NVP{'objid'} = $FORM{'objid'};

      $FORM{'mode'} = "editsku";
      # there was invalid data, send back to editsku!
   } #end of if okdata
   
} # done submitting edit sku!


# Simply display the existing variants and new rows
if ($FORM{'mode'} eq "variants") {
   
   if (!$FORM{'objskel'}) {
      $FORM{'objskel'} = $FORM{'masterobjid'};
   }
   
   &loadvariants($FORM{'objskel'});
}

###preprocess findobject mode
#
if ($FORM{'mode'} eq "findobject") {
   
   if ($debug > 1) {
      print ERLOG "----------Findobjects------------------------------------------------\n";
      foreach $z (keys %FORM) {
         print ERLOG "\$FORM{$z} = $FORM{$z}\n";
      }
      print ERLOG "\n\n";
      foreach $z (keys %NVP) {
         print ERLOG "\$NVP{$z} = $NVP{$z}\n";
      }
   }
   &loadfindobject();
}

##preprocess editsku mode
#
if ($FORM{'mode'} eq "editsku" ) {
   
   if ($debug > 1) {
      print ERLOG "-----------editsku-----------------------------------------------\n";
      foreach $z (keys %FORM) {
         print ERLOG "\$FORM{$z} = $FORM{$z}\n";
      }
      print ERLOG "\n\n";
      foreach $z (keys %NVP) {
         print ERLOG "\$NVP{$z} = $NVP{$z}\n";
      }
      print ERLOG "Editsku....loadfrom is $FORM{'loadfrom'} \n";
      print ERLOG "----------------------------------------------------------\n";
   }
   
   #
   $FORM{'loadfrom'}="def" if (! $FORM{'loadfrom'});
   
   ## load sku data into the "_inp" hash entries
   #
   
   if ( $FORM{'loadfrom'} eq "db" ) {
      
      ## load the data from the tables for this sku
      #
      &loadskufromdb($FORM{'objid'});
      
      } else {
      # this is the defaults for a new sku
      &loadskufromdef();
      
   }
} # /editsku preprocessing


## Define the target file for processing ( note .html or more filename needed )
#

$targ="os_allcommerce-".$script."-".$FORM{'mode'};

if ($debug) {
   print ERLOG "$targ \n";
}


########################################################
## Primary Display Mode Handling

if ($FORM{'mode'} eq "searchlist") {
   &printsearch;
   
}
elsif ( $FORM{'mode'} eq "editsku" ) {
   
   if ($debug) {
      print ERLOG " In primary display handling \n";
   }
   
   # the form displayed will depend upon the kind
   # of thing that the sku is - sellable, display, other
   # 2 vars determine form used:
   #     - is it a new creation or editing
   #     - what kind of sku is it?
   #
   &writetonvp;          # push the form data to %NVP
   %sku_name = (
      
      "$OBJTYPES->{'product'}" => "$script_msg{13}",
      "$OBJTYPES->{'article'}" => "$script_msg{14}",
      "$OBJTYPES->{'internal_doc'}" => "$script_msg{16}",
      "$OBJTYPES->{'brand'}" => "$script_msg{17}",
      "$OBJTYPES->{'product_line'}" => "$script_msg{32}",
      "$OBJTYPES->{'warehouse'}" => "$script_msg{36}",
      "$OBJTYPES->{'variant'}" => "$script_msg{18}",
      "$OBJTYPES->{'pulldown'}" => "$script_msg{19}"
   );
   
   # title the page suitably
   $k=$FORM{'objtype'};
   $v=$sku_name{$k};
   $NVP{'objtype'}=$FORM{'objtype'};
   
   if ( $FORM{'newflag'} eq "Y" ) {
      $pagetitle="$script_msg{22} $v $admin_objid";
      $NVP{'newflag'}="Y";
   }
   else {
      $pagetitle="$script_msg{23} $v $script_msg{24} $script_msg{42} $FORM{'objid'} ";

   }
   $regenerate_template = loadtemplate("row_regenerate", $skeletonpath);
   if ($generate_default == 1) {
       $regenerate_template =~ s/__regenerate_inp__/ CHECKED/gms;
   }
   
   $NVP{'pagetitle'}=$pagetitle;
   
   if ($debug) {
      print ERLOG "$NVP{'pagetitle'}, setting loadfrom to form \n";
   }
   
   
   # process the template file and dump to stdout
   
   if ($debug) {
      print ERLOG "Last action is $NVP{'lastaction'}\n";
   }
   if (!$NVP{'lastaction'}) {
      $NVP{'loadfrom'}="form";
      
      if ($debug) {
         print ERLOG "Setting loadfrom to form!\n";
      }
      
      ## html-safe encode all of %NVP before pulldown generation
      #
      foreach ( keys %NVP ) {
         $NVP{$_} = string_tohtml( $NVP{$_} );     #in formtools.pm
      }
      
      ## Generate the Select Pulldowns
      @pulldowns =  ( 'sel_sku_series|4', 'sel_behavior|2','sel_status|2','sel_pagestyle|8', 'sel_visibility|2');
      &loadselects(@pulldowns);
      
      # set the target name for
      # the page template used
      if ( $FORM{'objtype'} eq "$OBJTYPES->{'product'}" ) {
         if ($FORM{'master_objid'} ne "") {
            $v=$targ."-"."product_variant";
            &loadvariants($FORM{'master_objid'});
         }
         else {
            $v=$targ."-"."product";
         }
         
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'brand'}" ) {
         $v=$targ."-"."brand";
         
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'product_line'}" ) {
         $v=$targ."-"."prodline";
         
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'article'}" ) {
         $v=$targ."-"."article";
         
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'internal_doc'}" ) {
         $v=$targ."-"."internal";
         
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'variant'}") {
         $v=$targ."-"."variant";
      }
      
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'warehouse'}") {
         $v=$targ."-"."warehouse";
      }
      
      elsif ($FORM{'mode'} eq "variants") {
         $v=$targ."-"."product_variant";
      }
      elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'pulldown'}") {
         $v=$targ."-"."pulldown";
      }
      
      $FORM{'mode'} = "submit_editsku";
      
      if ($debug) {
         print ERLOG "Going to load template $v!!!\n";
      }
      
      $l = loadtemplate ( $v, $skeletonpath );
      $l = permutebit( $l, \%NVP );
      $l = permutebit( $l, $site ); # JN inserting the whole has in
      $l=~ s/__SKU_SERIES_SELECT__/$NVP{'SKU_SERIES_SELECT'}/gms;
      $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG__'}/gms;
      $l=~ s/__row_regenerate__/$regenerate_template/gms;
      $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
      $l=~ s/__sid__/$sid/gms;
      $l=~ s/__mode__/$FORM{'mode'}/gms;
      $l=~ s/__objid__/$FORM{'objid'}/gms;
      $l = permuteclean($l);
      if (!$already) {
         print $l;
      }
   }
}
# Display the home page!
else {
   
   if ($debug) {
      print ERLOG "Displaying home page!\n";
   }
   ## Generate the Select Pulldowns
   #
   $lastaction =  $NVP{'lastaction'};
   $addvariant =  $NVP{'addvariant'};
   $sid = $FORM{'sid'};
   $NVP{'lastmode'} = "home";
   $FORM{'sku_series_inp'} = "";
   $FORM{'status_inp'} = '15000-A';
   $FORM{'objtype_inp'} = "";
   # Generate the pulldown on the main home page!
   @pulldowns = ( 'sel_status|2', 'sel_sku_series|4' , 'sel_objtype|8');
   &loadselects(@pulldowns);
   
   
   $NVP{'script_version'}=$script_version;
   $NVP{'mode'} = "home";
   $NVP{'addvariant'}=$addvariant;
   $NVP{'lastaction'}=$lastaction;
   $targ="os_allcommerce-admin_sku-home";
   $l = loadtemplate( $targ , $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $l = permutebit( $l, $site );
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__SKU_SERIES_SELECT__/$NVP{'SKU_SERIES_SELECT'}/gms;
   $l=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/home/gms;         ##gotta be a better way to subs--later
   $l = permuteclean($l);
   if (!$already) { print $l};
}

$dbh->disconnect if ( $dbh );


############################# SUBROUTINES ##################################

######################## VALIDATION SUBROUTINES ############################
############################################################################
# PURPOSE      Takes all %FORM entries, seeks _inp entries, and
#              performs field-by-field validation, with
#
# INPUT        None, uses FORM
#
# OUTPUT       returns 1 for OK, 0 for errors
#              generation of _err error messages in %FORM as needed
#
# NOTES        
############################################################################
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($debug) {
         print ERLOG "Validating $kt = $FORM{$k} is $e\n";
      }
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message
      } # done checking for a returned error
   } # done running through form keys
   return $rv;
} #/validatefields

######################### FORM & NVP SUBROUTINES ###########################
############################################################################
# PURPOSE      checks population of _inp, if not set then set it to the 
#              _pre value.  Does not touch NVP hash.
#
# INPUT        None - Uses FORM
#
# OUTPUT       Returns 1
#
# NOTES        Never returns 0, so the return of 1 is not necessary
############################################################################
sub checkformbits {
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys
   
   ## special case - objtype
   if ((! $FORM{'objtype'} ) and ( $FORM{'objtype_inp'} )) {
      $FORM{'objtype'}=$FORM{'objtype_inp'};
   }
   
   if (( $FORM{'objtype'} ) and (! $FORM{'objtype_inp'} )) {
      $FORM{'objtype_inp'}=$FORM{'objtype'};
   } # end of filling in objtype
   
   return 1;
   
} #/checkformbits

############################################################################
# PURPOSE      write form data to NVP hash
#
# INPUT        None - Uses FORM
#
# OUTPUT       Returns 1
#
# NOTES        Never returns 0, so the return of 1 is not necessary
############################################################################
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      }
      elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      }
      elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      }
      elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   return 1;
} #/writetonvp

############################################################################
# PURPOSE    To replace \r\n with <P> for fields that use HTML (brief
#              and descript)
#
# INPUT      @rows - array of rows split on \r\t.
#
# OUTPUT     $newrows - A string of all rows of @rows concatenated and
#             joined by <P>\r\n.  Only one <P> will be inserted
#             for each \r\n, and will contain the \r\n at the
#             end of the <P> for readability
#
# NOTES
#
############################################################################
sub CR_to_html {
   my @rows = @_;
   my ($row, $newrow);
   
   $newrow = "";
   
   for ($i = 0; $i <= $#rows; $i++) {
      $row = $rows[$i];
      # Don't put it on the last line
      if ( ($row !~ /<P>/) && ($i != $#rows) ) {
         $row .= " <P>";
      }
      $row .= "\r\n";
      $newrow .= $row;
   }
   $newrow=string_tohtml($newrow);
   return $newrow;
}

############################################################################
# PURPOSE     Moves _inp to _pre values
#
# INPUT       $h - hashref for a row
#
# OUTPUT      $h - hashref with the _pre values set
#
# NOTES       Could be moved to a library routine, as this is also in
#             other adminstrator CGI scripts
############################################################################
sub agevariant {
   my($h,@temp,$k,$v);
   $h = @_[0];
   
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /_inp$/ );   # only want input values
      $v =  $h->{$k} ;
      $k2 =~ s/_inp$/_pre/ ;
      $h->{$k2}=$v if ( $v );
   }
   return $h;
} #/agevariant

############################################################################
# PURPOSE         Makes title and alttitle keys html-safe
#
# INPUT           $h - hashref of input values
#
# OUTPUT          $h - hashref with title and alttile converted to safe
#                      html
#
# NOTES           Should be moved to a library because is used throughout
#                 other admin CGI scripts
############################################################################
sub variantsafehtml {
   my($h,@temp,$k,$v);
   $h = @_[0];
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /(title|alttitle)/ );   # only want titles
      $h->{$k} = string_tohtml( $h->{$k} ) ;
   }
   return $h;
} #variantsafehtml

########################## OBJID SUBROUTINES ###############################
############################################################################
# PURPOSE      Load the information for the objid from the tables and 
#              and populates the FORM variable
#
# INPUT        None - uses FORM
#
# OUTPUT       Updates FORM with information from the tables
#
# NOTES        Should pass in objid so don't run into the possibility of
#              overwriting the FORM{'objid'} field.
############################################################################
sub loadskufromdb {
   
   $q = 'SELECT * FROM things';
   $q.= " WHERE objid='$FORM{'objid'}' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
#   $num = $sth->rows;
   
   if ($debug) {
      print ERLOG "loadskufromdb: q is $q \n";
      print ERLOG "num is $num \n";
   }
   
#   if ( $num==1 ) {
      # query returned exactly one record
#      $h = $sth->fetchrow_hashref;
   if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {      
      ## set one default
      #
      $FORM{'objtype'}=$h->{'objtype'};
      
      $admin_objid=$h->{'objid'};
      
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      }
      
      ## now dig out the DESCRIPTION and other extracopy fields
      #
      $q ="SELECT objid,fieldname,body FROM extraprop ";
      $q.=" WHERE objid LIKE '$FORM{'objid'}%' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
#      $num = $sth->rows;
      
      if ($debug) {
         print ERLOG "loadskufromdb: q is $q \n";
         print ERLOG "num is $num \n";
      }
      
#      while ($num) {
#         ( $x,$i,$k ) = $sth->fetchrow;
      while ( ( $x,$i,$k ) = $sth->fetchrow ) { 
         
         $k=string_exdbi($k);
         $kt=$i."_inp";
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
         
         ## added population of _pre fields 0.7.3 RF 990821
         #  long time ago done by pushing _inp -> _pre in validation
         #
         $kt=$i."_pre";
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
         
         $num--;
      }
      
      } else {
      # there was an error!
      # send back to homepage with error message
      
      if ($debug) {
         print ERLOG "Set mode to home in error!\n";
      }
      $FORM{'mode'}="home";
   }
   
   $sth->finish;
   return 1;
} #/loadskufromdb

############################################################################
# PURPOSE      Takes objid data from %FORM{_inp|X} entries, determines the
#              objtype and objclass, creates a sku for the objid if required,
#              creates a brand if required, and inserts and/or updates
#              the record if there is no error message and if required
#              for $FORM{'objid'}
#
# INPUT        None - uses FORM
#
# OUTPUT       $rv - "" means no error, non-blank is the error message for
#               the error encountered.
#
# NOTES        Should be re-written to take in a hashref of 1 objid vs using
#              the FORM varianble
#              
############################################################################
sub writeskutodb {
   my($rv,$sku,$fields_prod,$fields_var,$fields_extra,$nsku);
   my(%product,%variant,%extracopy,$q,$sth, $needInsert, $nsku);
   
   $rv="";      # return value, blank is good
   
   if ( $FORM{'newflag'} =~ /[Yy]/ ) {
      $nsku=1;
   }
   else {
      $nsku = 0;
   }
   
   # Product & Brands
   if (($FORM{'objtype'} eq "$OBJTYPES->{'brand'}") ||
      ($FORM{'objtype'} eq "$OBJTYPES->{'product'}")) {
      # initialize to 0
      $needInsert = 0;
   }
   else {
      # don't need a sku for these
      $nsku = 0;
      # Determine if this is a new thing, or just needs to be modified
      if ($FORM{'objid'} eq '') {
         $needInsert = 1;
         $rv = "";
      }
      else {
         $admin_objid=$FORM{'objid'};    # set an objid
         $needInsert = 0;
      }
   }
   
   $now=time();
   
   $sku="";
   $sku=$FORM{'msku'} if ( ! $nsku );
   
   # Only get the sku if we need it
   if ($nsku) {
      if ( ! validatesku($sku) ) {  # no error message is OK
         # have a good sku in $sku
         $admin_objid=$FORM{'objid'};    # set an objid
      }
      else {
         # need a sku, or have a bad one
         $needInsert = 1;
         if ( ! validatebrand($FORM{'sku_series_inp'}) ||
            $FORM{'objtype'} eq "$OBJTYPES->{'brand'}"  ) {  # useable brand
            # Create a sku
            ($sku, $rv) = &createSku($FORM{'sku_series_inp'});
            # if there was no errors
            if (!$rv) {
               # check if it is a bad sku
               if ( length($sku)!= $site->{'site_sku_totlen'} ) {
                  $rv="$script_msg{25} ";
                  $rv.=" matching $sku";
               }
            }
         }
         else {                              # not useable brand
            $rv="$script_msg{30} $FORM{'sku_series_inp'} $script_msg{29}";
         } #/end of brand useable or not
         
      } # end of new vs. bad sku
      
   } #/end of sku validation or assignment
   
   # Already have a sku or don't need one, so set the objid
   else {
      $admin_objid = $FORM{'objid'};
   }
   
   if ( $FORM{'objtype'} eq "$OBJTYPES->{'brand'}" ) {
      $FORM{'sku_series_inp'}=$admin_objid;
      $NVP{'objid'} = $admin_objid;
      $FORM{'objid'}=$admin_objid;
   }


   ## now have a valid sku in $sku if ! $rv
   if ( ! $rv ) {
      if ($needInsert) {

	  print ERLOG "TYPE IS $FORM{'objtype'}!\n";
	  if ($FORM{'objtype'} eq "$OBJTYPES->{'warehouse'}") {
	      $q = "SELECT objid FROM things WHERE objtype = '$OBJTYPES->{'warehouse'}'\n";
	      $numRes = &query($q, $dbh, \@res);
	      if ($debug) {
		  print ERLOG "$q\n";
	      }
	      if ($numRes >= 1) {
		  $rv = $script_msg{43};
		  $NVP{'previous_error'} = "yes";
	      }
	  }
	  if (! $rv) {
	      $admin_objid = &insertThing($sku);
	      $FORM{'objid'} = $admin_objid;
	      $NVP{'objid'} = $admin_objid;
	      $FORM{'msku'}=$sku;
	  }
      }
      if (! $rv) {
	  &updateThing($admin_objid);
	  
	  # dynamically generate the new brand pulldowns
	  if ( $FORM{'objtype'} eq "$OBJTYPES->{'brand'}") {
	      if ($debug) {
		  print ERLOG "Going into generate_temps for $FORM{'objtype'}\n";
	      }
	      `$site->{'fsrootcron'}/generate_temps.pl $FORM{'objtype'}`;
	  }
      
	  # dynamically generate the new brand pulldowns
	  if ( $FORM{'objtype'} eq "$OBJTYPES->{'warehouse'}") {
	      if ($debug) {
		  print ERLOG "Going into generate_temps for $FORM{'objtype'}\n";
	      }
	      `$site->{'fsrootcron'}/generate_temps.pl $FORM{'objtype'}`;
	  }
	  
	  # dynamically generate the new pulldowns
	  if ( $FORM{'objtype'} eq $OBJTYPES->{'pulldown'} ) {
	      if ($debug) {
		  print ERLOG "Going into generate_temps for $FORM{'objid'}\n";
	      }
	      `$site->{'fsrootcron'}/generate_temps.pl $FORM{'objid'}`;
	  }
      }
  }

   return $rv;
}

############################################################################
# PURPOSE    To create a Sku for an item and perform error checking on it
#
# INPUT      Nothing
#
# OUTPUT     $sku - sku that was formed in the routine
#            $rv - error code if sku is invalid
#
# NOTES
############################################################################
sub createSku {
   my ($sku_series) = @_;
   my ($q, $sth, $skel, $num, $sku, $rv);
   
   if ($debug) {
      print ERLOG "In createSku with $sku_series sku_series!\n";
   }
   $sku = "";
   $q="SELECT body,objid,fieldname FROM extraprop ";
   $q.=" WHERE objid='$sku_series' AND fieldname='sku_skel' ";
   $sth = $dbh->prepare( $q );
   $sth->execute;
#   $num=$sth->rows;
#   $skel=( $sth->fetchrow )[0];
   if ( $skel=( $sth->fetchrow )[0] ) {
      $num=1;
   }
   if ($debug) {
      print ERLOG "$q \n";
   }
   
   if ( $FORM{'objtype'} eq "$OBJTYPES->{'brand'}" ) {
      $skel = $FORM{'sku_skel_inp'};
      $num=1;
   }
   if ( $num ) {   # got at least one row
      $skel =~ tr/ //d ;
      # check the length of what we have and see
      # if it the ample sku length
      if ( $site->{'site_sku_prelen'} == length($skel) ) {
         # now get the next value for this sku
         $sku=&nextskuinseries($skel);
         if ($debug) {
            print ERLOG " $sku \n";
         }
      } #/done examining new sku's length
      else {
         $rv="$script_msg{26} $skel $script_msg{27}";
      } #/done examining skeleton length
      } else {          # if no rows
      $rv="$script_msg{28} ";
      #	$rv.=" $FORM{'sku_series_inp'} $script_msg{29}";
      $rv.=" $sku_series $script_msg{29}";
   } #/done seeing if the brand has a record
   
   return ($sku, $rv);
   
}

############################################################################
# PURPOSE    To update an existing row in the things table with any
#              input from the FORM
#
# INPUT      $objid - the objid created in insertThing, or the objid
#              passed into via the FORM
#
# OUTPUT     Nothing
#
# NOTES      Should maybe have output an error if the SQL fails
#
############################################################################
sub updateThing {
   my ($objid) = @_;
   my ($q, $sth, $num, $h, $fields_prod, $k, $x);
   my (%extracopy, %products, $now, $kt, $qq);
   
   
   if ($debug) {
      print ERLOG "In  updateThing!\n";
   }
   $now = time();
   
   ## get fields in products
   $q="SELECT * FROM things ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
#   $num=$sth->rows;
   
   if ($debug) {
      print ERLOG "$q\n";
   }
   
#   if ($num > 0) {
   if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {  
      # only get one row, as we only want the field names
#      $h = $sth->fetchrow_hashref;
      } else {
      $h={};
   }
   
   $fields_prod = join ',', ( keys %{$h} );
   
   ## go through the form fields and push them into products
   #
   %product=();
   %extracopy=();
   
   foreach ( keys %FORM ) {
      next if ( $_ !~ /_inp$/ );
      next if ($_ =~ /objid/);
      next if ( $_ =~ /^msku$/ );
      next if ($_ =~ /regenerate/);
      $k=$_;
      $kt=$k;
      $kt=~ s/_inp$// ;
      
      # Convert \r\n to <P> in brief and description
      if (($kt =~ /brief/) || ($kt =~ /descript/)) {
         @rows = split /\r\n/, $FORM{$k};
         $FORM{$k} = &CR_to_html(@rows);
      }
      
      if ( $fields_prod =~ /$kt/ ) {      # product field
         $product{$kt} = $FORM{$k};
         
         # Handle master product!  NEED TO CATCH FOR VARIANT PRODUCT
         if ($kt =~ /axisname/) {
            if ((length($FORM{$k}) > 0) &&
               ($FORM{'objtype'} eq "$OBJTYPES->{'product'}")) {
               $product{'ref_from'} = $FORM{'objid'};
               
            }
            else {
               $product{'ref_from'} = '';
            }
         }
         
         } else {                            # assume extracopy field
         $extracopy{$kt}=$FORM{$k};
      }
      
   }
   
   ## now have fields split out into target tables
   #
   
   # update products first
   $q="";
   
   foreach ( keys %product ) {
      $q.="," if ( $q );
      $q.=$_."='".string_todbi($product{$_})."'";
      $after = string_todbi($product{$_});
      
   }
   
   if ($q) {
      $q.=",mdate='$now'";     # add a timestamp
      $q = "UPDATE things SET $q WHERE objid='$objid'";
#      $dbh->do( $q );
#      $stz=$dbh->prepare( $q );
#      $stz->execute;
      $x = &query($q, $dbh, \@junk);
   }
   
   if ($debug) {
      print ERLOG "$q\n";
   }
   
   ## now remainder goes to extracopy
   
   $x=( keys %extracopy );
   foreach ( keys %extracopy ) {
      $qq = 'SELECT * FROM extraprop ';
      $qq.= "WHERE objid='$objid' AND fieldname='$_' ";
      $sth=$dbh->prepare( $qq );
      $sth->execute;
#      $k=$sth->rows;
      if ($debug) {
         print ERLOG "$qq\n";
      }
      
#      if ( $k==1 ) {         # one row, update it
      if ( $rwh = $sth->fetchrow_hashref(NAME_lc) ) {
         $q = "UPDATE extraprop SET ";
         $q.= "body='".string_todbi($extracopy{$_})."',mdate='$now' ";
         $q.= "WHERE objid='$objid' AND fieldname='$_' ";
#         $dbh->do( $q );
#         $stz=$dbh->prepare( $q );
#         $stz->execute;
	 $x = &query($q, $dbh, \@junk);
         if ($debug) {
            print ERLOG "$q\n";
         }
         
      }
#      elsif ( ! $k ) {     # no rows, insert
      else {
         $q = "INSERT INTO extraprop ";
         $q.= "(objid,fieldname,body,cdate,mdate, language) ";
         $q.= " VALUES ('$objid','$_',";
            #	    $q.= "'".string_todbi($extracopy{$_})."',$now,$now, '$om_render_lang') ";
         $q.= "'".string_todbi($extracopy{$_})."',$now,$now, '$session_lang') ";
         if ($debug) {
            print ERLOG "$q\n";
         }
#         $dbh->do( $q );
	 $x = &query($q, $dbh, \@junk);
#         $stz=$dbh->prepare( $q );
#         $stz->execute;
         
      } #/end of sensible actions on extracopy
   } #/end of processing each extracopy key

}

############################################################################
# PURPOSE    To insert a new entry into the things table
#
# INPUT      $sku - msku to insert into the table.  Will be blank for
#              anything other than products & brands
#
# OUTPUT     $objid - the objid of the entry created in things
#
# NOTES      Should maybe have output an error if the SQL fails
#
############################################################################
sub insertThing {
   my ($sku, $fields, $values) = @_;   
   
   my ($now) = time();
   my ($q, $dvalue, $sth, $objid, $event, $series);
   my (@res_arr, $numRows);
   
   # site_sku_totlen set in site.pm
   # create an objid
   $dvalue="$sid\t Create ObjID";
   
   if ( $site->{'site_datadriver'} =~ /Oracle/ ) {

      $q="INSERT into levents (event,dtable,dvalue,cdate,series) values ";
      $q.=" (levents_event.nextval,'things','$dvalue',$now,'$site->{'series'}') ";
#      $dbh->do($q);
      $x = &query($q, $dbh, \@junk);
#      $stz=$dbh->prepare($q);
#      $stz->execute;

      $q="SELECT levents_event.currval FROM DUAL";
      $sts=$dbh->prepare($q);
      $sts->execute;
      $event=$sts->fetchrow;

      $q="SELECT series from levents where dtable='things' ";
      $q.= " AND dvalue='$dvalue' AND cdate=$now ";  
      $numRows = &query($q, $dbh, \@res_arr);
      $objid=$event."-".$res_arr[0]->{'series'};

   } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {

      $q="INSERT INTO levents (dtable,dvalue,cdate,series) values ";
      $q.=" ('things','$dvalue','$now','$site->{'series'}') ";
      $x = &query($q, $dbh, \@junk);
#      $dbh->do($q);
   
      if ($debug) {
         print ERLOG "$q\n";
      }
   
      $q="SELECT event,series FROM levents WHERE dtable='things' ";
      $q.= " AND dvalue='$dvalue' AND cdate=$now ";
      $numRows = &query($q, $dbh, \@res_arr);
      $objid = $res_arr[0]->{'event'}."-".$res_arr[0]->{'series'};
  
   } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

       $q="INSERT INTO levents (event,dtable,dvalue,cdate,series) values ";
       $q.=" (NEXTVAL('event'),'things','$dvalue','$now','$site->{'series'}') ";
       $x = &query($q, $dbh, \@junk);
       if ($debug) {
           print ERLOG "$q\n";
       }
       $q="SELECT CURRVAL('event'),series FROM levents WHERE dtable='things' ";
       $q.= " AND cdate=$now ";
       $numRows = &query($q, $dbh, \@res_arr);
       $objid = $res_arr[0]->{'currval'}."-".$res_arr[0]->{'series'}; 
   }


   if ($debug) {
      print ERLOG "$q\n";
      print ERLOG "Created objid: $objid\n";
   }
   
   ## make an entry for this object sku in things
   #
   
   # Set up the object class!
   if ($FORM{'objtype'} eq "$OBJTYPES->{'product'}") {  # PRODUCT
      $objclass = "$OBJCLASSES->{'product'}";
   }
   elsif ($FORM{'objtype'} eq "$OBJTYPES->{'brand'}") {  # SKU_SERIES
      $objclass = "$OBJCLASSES->{'brand'}";
   }
   elsif ($FORM{'objtype'} eq "$OBJTYPES->{'variant'}") {
      $objclass = "$OBJCLASSES->{'variant'}";
   }
   elsif ($FORM{'objtype'} eq "$OBJTYPES->{'pulldown'}") {
      $objclass = "$OBJCLASSES->{'pulldown'}";
   }
   elsif ($FORM{'objtype'} eq "$OBJTYPES->{'warehouse'}") {
      $objclass = "$OBJCLASSES->{'warehouse'}";
   }
   elsif ($FORM{'objtype'} eq "$OBJTYPES->{'product_variant'}") {
      $objclass = "$OBJCLASSES->{'product_variant'}";
   }
   else {
      $objclass = "$OBJCLASSES->{'nonproduct'}";
   }
   
   $q="INSERT INTO things (objid,msku,cdate,objclass,objtype,language ";
      if ($fields) {
         $q .= ", $fields";
      }
   $q .= ") VALUES ";
   
   #    $q .=" ('$objid','$sku','$now', '$objclass', '$FORM{'objtype'}','$om_render_lang'";
   $q .=" ('$objid','$sku','$now', '$objclass', '$FORM{'objtype'}','$session_lang'";
      if ($fields) {
         $q .= ", $values";
      }
   $q .= ") ";
   $x = &query($q, $dbh, \@junk);
#   $sth=$dbh->prepare($q);
#   $sth->execute;   
#   $dbh->do($q);
#      $stz=$dbh->prepare($q);
#      $stz->execute; 
   if ($debug) {
      print ERLOG "$q\n";
   }


   return $objid;
}

############################################################################
# PURPOSE      Sets the defaults for a new object, and sets the _pre values
#
# INPUT        None - uses FORM
#
# OUTPUT       Updates FORM with the default values
#
# NOTES        
############################################################################
sub loadskufromdef {
   local($i,$y);
   
   if ( $FORM{'objtype'} eq "$OBJTYPES->{'product'}" ) {         # object is Merchadise
      ## default stock behavior is saleable irrespective of stock
      #
      $FORM{'behavior_inp'}="90006-A";
      
   }
   elsif ( $FORM{'objtype'} eq "$OBJTYPES->{'brand'}" ) {    # Brand SKU
      
      ## default stock behavior is saleable irrespective of stock
      #
      $FORM{'behavior_inp'}="90006-A";
      
   }
   elsif (( $FORM{'objtype'} eq "$OBJTYPES->{'variant'}" )  || 
          ( $FORM{'objtype'} eq "$OBJTYPES->{'pulldown'}")){
       $FORM{'status_inp'}="15000-A";
   }
   # prime the form

   foreach ( keys %FORM ) {
      $y=$_;
      next if ( $y !~ /_inp$/ );
      $y=~ s/_inp//;
      $y="__".$y."_pre__";
      $NVP{$y}=$FORM{$_};
   }
   
   return 1;
}
# /loadskufromdef

############################################################################
# PURPOSE      Takes 4 char code, returns next sku in the series of skus
#
# INPUT        $sk - sku_skel from the brand
#
# OUTPUT       $rv - the next sku in the series
#
# NOTES        Skus are only used as reference for products and brands, and
#              are only present to  help with the transition to this version.
#              They are not used as key values anywhere, and will be 
#              eventually phased out.
############################################################################
sub nextskuinseries {
   my($skel,$q,$sth,$x,$xn,$n,$num,$rv);
   $rv="";
   $sk=$_[0];
   
   if ( $site->{'site_sku_prelen'} == length($sk) ) {
      
      $q="SELECT msku FROM things WHERE msku LIKE ";
      $q.=" '$sk%' ORDER BY msku DESC ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
#      $num = $sth->rows;
      
      if ($debug) {
         print ERLOG "$q \n";
      }
      
#      if ( $num>0 ) {              # not the first in this series
#         ($x) = $sth->fetchrow;
      if ( ($x) = $sth->fetchrow ) {
         
         $sitesku=( $site->{'site_sku_prelen'} + length($site->{'sitecode'}) );
         $x = substr($x,$sitesku,$site->{'site_sku_numlen'});
         $xn=$x+1;
         $xn="$xn";
         } else {
         # first sku in this series
         $xn = "0";
      }
      
      $n=$site->{'site_sku_numlen'} - length($xn);
      
      $rv=$sk.$site->{'sitecode'} ;
      
      while ( 0<$n ) {
         $rv.="0";
         $n--;
      }
      $rv.=$xn;
      
      if ($debug) {
         print ERLOG "next sku is $rv \n";
      }
      
   } # done with "if skuskel legal length
   
   return $rv;
   
} #/nextskuinseries

############################################################################
# PURPOSE      Loads all variants for the master object passed in, and sets
#              up the edit page to create/modify variant products for the
#              master product.
#
# INPUT        $master_objid - objid of the master record to load variants
#               for
#
# OUTPUT       permuted page for variants, and changes mode to submit to
#              prepare for submition of user input
#
# NOTES        
############################################################################
sub loadvariants {
   my ($master_objid) = @_;
   #load primary permute hash values
   #
   my (@existing_variants, $numVariants, $numAxisNames);
   
   if ($debug) {
      print ERLOG "\nIN LOAD VARIANTS!  Master product is $master_objid!\n";
   }
   
   $NVP{'pagetitle'}="$script_msg{2} $script_msg{3} $master_objid \n";
   $NVP{'select1'}="&nbsp;";
   $NVP{'select2'}="&nbsp;";
   $NVP{'select3'}="&nbsp;";
   $NVP{'select4'}="&nbsp;";
   $NVP{'masterobjid'} = $master_objid;
   
   if ($debug) {
      print ERLOG "Setting \$NVP{'masterobjid'} to $master_objid -- > $NVP{'masterobjid'}!!!!!!!!!!!!!!\n";
   }
   
   if (length($master_objid) == 0) {
      $master_objid = $NVP{'master_objid'};
   }
   
   # Get the variants to display in pulldown lists
   &getVariantPulldowns($master_objid, \@axis_title);
   
   # Get the already existing variant products
   $numVariants = &getExistingVariants($master_objid, "objid, vcode, status, visibility",  $dbh, \@existing_variants);
   
   for ($i=0; $i< $numVariants; $i++) {
      foreach $key (keys %{$existing_variants[$i]}) {
         $v = string_exdbi($existing_variants[$i]->{$key});
         $inp = $key."_inp";
         $pre = $key."_pre";
         $ini = $key."_ini";
         $existing_variants[$i]->{$pre} = $v;
         $existing_variants[$i]->{$inp} = $v;
         $existing_variants[$i]->{$ini} = $v;
      }
   }
   
   # Display the page
   $v="os_allcommerce-admin_sku-editsku-product_variant";
   $pagetemplate= loadtemplate ( $v, $skeletonpath );
   
   if ($numVariants >0 ) {
      @rownames=( "row_variant_product_exists");
      &loadRows($numVariants, \@existing_variants, @rownames);
   }
   
   @rownames=("row_variant_product_new" );
   $numRows = &createnewrows(1,\@new_rows);
   &loadRows($numRows, \@new_rows, @rownames);
   
   $NVP{'mode'}="submit";
   
   $pagetemplate = permutebit( $pagetemplate, \%NVP );
   $pagetemplate = permutebit( $pagetemplate, $site );
   $pagetemplate=~ s/__axis1_title__/$axis_title[1]/gms;
   $pagetemplate=~ s/__axis2_title__/$axis_title[2]/gms;
   $pagetemplate=~ s/__axis3_title__/$axis_title[3]/gms;
   $pagetemplate=~ s/__axis4_title__/$axis_title[4]/gms;
   $pagetemplate=~ s/__pagetitle__/$NVP{'pagetitle'}/gms;
   $pagetemplate=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $pagetemplate=~ s/__sid__/$sid/gms;
   $pagetemplate=~ s/__mode__/$FORM{'mode'}/gms;
   $pagetemplate = permuteclean($pagetemplate);
   print $pagetemplate;
   $already="yes";
}

######################### VARIANT SUBROUTINES ##############################
############################################################################
# PURPOSE  This routine is called once for every variant row to update
#
# INPUT    $objid - object id of the master product
#          $variant - hash ref to one variant of the master product
#
# OUTPUT   none
#
# NOTES
#
############################################################################
sub updateVariant {
   my ($objid, $variant) = @_;
   my ($q, $sth, $num, $h, $fields_prod, $k, $x);
   my (%extracopy, %products, $now, $kt, $qq);
   
   $now = time();
   
   ## get fields in products
   $q="SELECT * FROM things ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
#   $num=$sth->rows;
   
   if ($debug) {
      print ERLOG "updateVariant:  $q\n";
   }
   
#   if ($num > 0) {
      # only get one row, as we only want the field names
   if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
#      $h = $sth->fetchrow_hashref;
      } else {
      $h={};
   }
   
   $fields_prod = join ',', ( keys %{$h} );
   
   ## go through the form fields and push them into products
   #
   %product=();
   %extracopy=();
   
   foreach $k ( keys %{$variant} ) {
      next if ($k =~ /title/);    # variants don't have titles, they are dynamic
      next if ($k =~ /regenerate/);
      next if ( $k !~ /_inp$/ );
      
      $kt=$k;
      $kt=~ s/_inp$// ;
      if ($debug) {
         print ERLOG "KT is $kt\n";
      }
      if ($kt =~ /axis/) {
         if ($kt =~(/\w*(\d+)\w*/)) {
            $num = $1;
         }
         $axis[$num] = $variant->{$k};
         if ($debug) {
            print ERLOG "$k --> Set axis[$num] to $axis[$num]\n";
         }
         next;
      }
      
      if ( $fields_prod =~ /$kt/ ) {      # product field
         $product{$kt} = $variant->{$k};
         if ($debug) {
            print ERLOG "Setting \$product{$kt} = $product{$kt}\n";
         }
         
         } else {                            # assume extracopy field
         $extracopy{$kt}=$variant->{$k};
         if ($debug) {
            print ERLOG "Setting \$extracopy{$kt} = $extracopy{$kt}\n";
         }
      }
      
   }
   
   # only want to define vcode for newrows, leave existing as it is!
   undef $vcode;
   if (!defined $variant->{'vcode_pre'}) {
      $vcode = $axis[1] if (defined $axis[1]);
      $vcode .= ":" . "$axis[2]" if (defined $axis[2]);
      $vcode .= ":" . "$axis[3]" if (defined $axis[3]);
      $vcode .= ":" . "$axis[4]" if (defined $axis[4]);
      if (defined $vcode) {
         if ($debug) {
            print ERLOG "VCODE IS $vcode\n";
         }
         $product{'vcode'} = $vcode;
      }
   }
   
   ## now have fields split out into target tables
   # update products first
   $q="";
   
   foreach ( keys %product ) {
      $q.="," if ( $q );
      $q.=$_."='".string_todbi($product{$_})."'";
   }
   
   if ($q) {
      $q.=",mdate='$now'";     # add a timestamp
      $q = "UPDATE things SET $q WHERE objid='$objid'";
#      $dbh->do( $q );
#      $stz=$dbh->prepare( $q );
#      $stz->execute;
      $x = &query($q, $dbh, \@junk);
      if ($debug) {
         print ERLOG "$q\n";
      }
   }
   
   ## now remainder goes to extracopy
   
   $x=( keys %extracopy );
   foreach ( keys %extracopy ) {
      $qq = 'SELECT * FROM extraprop ';
      $qq.= "WHERE objid='$objid' AND fieldname='$_' ";
      $sth=$dbh->prepare( $qq );
      $sth->execute;
#      $k=$sth->rows;
      if ($debug) {
         print ERLOG "$qq\n";
      }
      
#      if ( $k==1 ) {         # one row, update it
      if ( $rwh = $sth->fetchrow_hashref(NAME_lc) ) {
         $q = "UPDATE extraprop SET ";
         $q.= "body='".string_todbi($extracopy{$_})."',mdate='$now' ";
         $q.= "WHERE objid='$objid' AND fieldname='$_' ";
#         $dbh->do( $q );
	 $x = &query($q, $dbh, \@junk);
#         $stz=$dbh->prepare($q);
#         $stz->execute;
         if ($debug) {
            print ERLOG "$q\n";
         }
         
#      }
#      elsif ( ! $k ) {     # no rows, insert
      } else {
         $q = "INSERT INTO extraprop ";
         $q.= "(objid,fieldname,body,cdate,mdate, language) ";
         $q.= " VALUES ('$objid','$_',";
            #	    $q.= "'".string_todbi($extracopy{$_})."',$now,$now, '$om_render_lang') ";
         $q.= "'".string_todbi($extracopy{$_})."',$now,$now, '$session_lang') ";
         if ($debug) {
            print ERLOG "$q\n";
         }
#         $dbh->do( $q );
	 $x = &query($q, $dbh, \@junk);
#         $stz=$dbh->prepare($q);
#         $stz->execute;
         
      } #/end of sensible actions on extracopy
   } #/end of processing each extracopy key
}

############################################################################
# PURPOSE      To dynamically produce the pulldowns for variant products.
#              Retreives the titles and values for the pulldowns for each
#              axis_name configured in the master objid
#
# INPUT        $master_objid - objid of master product to determine variants
#               for.
#              $axis_title - reference to an array to set the titles for
#               each variant pulldown.  Returned to calling routine for
#               permuting page
#              
# OUTPUT       $axis_title - array of variant pulldown titles
#              
#
# NOTES        Should be moved to the variant.pm library
############################################################################
sub getVariantPulldowns {
   my ($master_objid) = $_[0];
   my ($axis_title) =  $_[1];
   
   my ($q, $numAxisNames, @axisnames, $axiscode, @axis, @axisBody, $var_objid);
   if ($debug) {
      print ERLOG "In getVariantPulldowns, $master_objid!\n";
   }
   undef @axisnames;
   # get the axisnames FROM the master product
   $q="SELECT axisnames FROM things WHERE objid = '$master_objid'";
   $numAxisNames = &query($q, $dbh, \@axisnames);
   if ($debug) {
      print ERLOG "$q\n$numAxisNames\n";
   }
   
   $axiscode = $axisnames[0]->{'axisnames'};
   
   # Get the axises for pulldowns and store in $axisBody[0..$numVariants]
   @axis = split /:/,$axiscode;
   if ($debug) {
      print ERLOG "There are $#axis variants defined!\n";
   }
   
   # Get all of the require data
   $i = 0;
   foreach $var_objid (@axis) {
      $q = "SELECT body FROM extraprop WHERE objid = '$var_objid'";
      #	$q .= " AND fieldname = 'encoding' AND language = '$om_render_lang'\n";
      $q .= " AND fieldname = 'encoding' AND language = '$session_lang'\n";
      if ($debug) {
         print ERLOG "$q\n";
      }
      $num_axis[$i] = &query($q, $dbh, \@body);
      $axisBody[$i] = $body[0];
      $q = "SELECT title FROM things WHERE objid = '$var_objid'";
      if ($debug) {
         print ERLOG "$q\n";
      }
      $numTitles = &query($q, $dbh, \@var_title);
      $axisTitle[$i] = $var_title[0]->{'title'};
      if ($debug) {
         print ERLOG "TITLE IS $axisTitle[$i]\n";
      }
      $i++;
   }
   
   # Generate axis1 - axis 4 where available
   $num_indx = 1;
   $title_indx = 0;
   foreach $var (@axisBody) {
      $var->{'body'} =~ s/\r//g;
      @rows = split /\n/, $var->{'body'};
      $i = 0;
      foreach $row (@rows) {
         ($vcode, @title) = split /:/, $row;
         if ($#title == 0) {
            $title = $title[0];
         }
         # in case there is a - in the text of the variant!
         else {
            $title = join ":", @title;
         }
         $variants[$i][0] = $vcode;
         $variants[$i][1] = $title;
         $i++;
      }
      
      $axis_loc = "axis$num_indx";
      $axis_loc_inp = $axis_loc . "_inp";
      $axis_loc_name = "row." . "__objid__" . ".$axis_loc_inp";
      if ($debug) {
         print ERLOG "$axis_loc_name is the pulldown name!\n";
      }
      $msg = $axisTitle[$title_indx++];
      $$axis_title[$num_indx] = $msg;
      if ($debug) {
         print ERLOG "AXIS TITLE IS : $$axis_title[$num_indx]\n";
      }
      
      $NVP{$newkt} = &gen_variant_sel('',$i, @variants);
      $NVP{$axis_loc} =" <SELECT NAME=\"$axis_loc_name\"> $NVP{$newkt} ";
      $NVP{$axis_loc} .= "</SELECT>";
      
      # set the pulldowns for the row
      @pulldowns = ('sel_status|2','sel_visibility|2');
      foreach ( @pulldowns) {
         ( $k,$v) = split /\|/, $_;
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         # Make the sel_ files work with the current procedure.
         if ($k =~ /sel_/) {
            $k =~ s/sel_//gms;
            $k = uc($k);
            if ($debug) {
               print ERLOG "New pulldown name is $k\n";
            }
         }
         $kt=$k."_SELECT";
         $k = lc($k);
         $NVP{$kt}= gen_select( '',$v,@raw );
      }
      
      if ($debug) {
         print ERLOG "Generated: $axis_loc: $NVP{$axis_loc}\n";
      }
      $num_indx++;
   }
}

############################################################################
# PURPOSE     Sorts the %FORM hash into variant product rows, which have 
#             objid and all values to insert into the tables from the FORM
#
# INPUT       $variants - pointer to an array which will be populated with
#              the sorted %FORM row data
#
# OUTPUT      $objid_indx - hash of keys which are objids with return the
#              index into the variants array where the row exists
#             $variants - array of variants, each index being one unique row
#              of data.
#
# NOTES       Should be generalize to loadFormRows data and put into a
#             library as it is used in other admin CGI scripts
############################################################################
sub loadFormVariants {
   my ($variants) = @_;
   my ($key, $row, $objid, $field, $numVariants);
   
   $numVariants = 0;
   $arrIndx = 0;
   foreach $key (keys %FORM) {
      if ($key =~ /row/) {
         ($row, $objid, $field) = split(/\./,$key);
         if (length($objid) == 0) {
            if ($debug) {
               print ERLOG "loadFormVariants: Got a blank objid for $key!\n";
            }
         }
         else {
            if (!($objids =~ /$objid/)) {
               $numVariants++;
               
               # Save the index into the array to know what index to put all of the data in
               if (!defined $objid_indx->{$objid}) {
                  $objid_indx->{$objid} = $arrIndx;
                  $arrIndx++;
               }
            }
            
            # get the index for the objid
            $varIndx = $objid_indx->{$objid};
            
            # set the field
            $$variants[$varIndx]->{$field} = $FORM{$key};
         }
      }
   }
   
   return $objid_indx;
}

######################### SEARCH SUBROUTINES ###############################
############################################################################
# PURPOSE     Searches things for all products that  match the criteria
#             specified.  If one row is a result of the search, the 
#             individual edit screen for that object is displayed.  If
#             no rows are returned, a message is sent back to the home
#             page, and if more than 1 row is returned, the query
#             is saved and passed onto printsearch.
#
# ALGORITHM   If you enter more than one criteria in the search form the
#             query if formuated by AND
#
#             Object searches for a all objects LIKE the inputted object
#             string in the objid field that are a product class
#
#             Keywords searches title for objects LIKE the inputted keywords
#                    OR brief LIKE inputted keywords
#                    OR keywords like inputted keywords
#
#             Status searches for all objects that have the inputted status
#             in the things table.
#
#             Brand limits the products to be a part of that brand if 
#             specified.
#
#             Type of Object selects from ALL objclasses if All Types is 
#             specified, or limits it to the specified classes if any other
#             type is specified.
#
# INPUT       none
#
# OUTPUT      if 0 rows returned - error message for page
#             if 1 row returned - edit page for object
#             if >1 row returned - nothing, pass onto printsearch by changing
#             mode
#
# NOTES       Should be made consistent between all managers and moved out
#             to a search.pm library
#
#             Keyword has to match EXACTLY how you type it in the keyword
#             input.  If you put in more than one word, it doesn't split
#             them out into numerous LIKE statements, it just does the one
#             Something to think about for the new release.
#
############################################################################
sub loadfindobject {
   # perform a search against the database
   
   if ($debug) {
      print ERLOG " in findobject \n";
   }
   
   chomp $FORM{'objskel'};
   $isblank = $FORM{'objskel'};
   $isblank =~ s/ //gms;
   if (length ($isblank) == 0) {
       $FORM{'objskel'} = "";
   }
   chomp $FORM{'keyword'};
   $isblank = $FORM{'keyword'};
   $isblank =~ s/ //gms;
   if (length ($isblank) == 0) {
       $FORM{'keyword'} = "";
   }
   chomp $FORM{'sku_series'};
   $isblank = $FORM{'sku_series'};
   $isblank =~ s/ //gms;
   if (length ($isblank) == 0) {
       $FORM{'sku_series'} = "";
   }
   
   if ($FORM{'all'} eq "no") {
      $query = "SELECT objid,msku,repl_by,title,brief,objtype,";
      $query .="objclass,keywords,ref_from FROM things ";
      $query .="WHERE objid = '$FORM{'objskel'}'";
   }
   else {
      
      # Get the body of the brand for the 3 letter sku_skel
      if ($FORM{'sku_series'} ne "") {
         $query="SELECT body FROM extraprop WHERE objid='$FORM{'sku_series'}' AND fieldname = 'sku_skel'";
         $numSkuSeries = &query($query, $dbh, \@sku_res);
         if ($debug) {
            print ERLOG "$query\n";
         }
         
         if ($numSkuSeries <= 0) {
            $err = "Cannot find brand $FORM{'sku_series'}!\n";
            if ($debug) {
               print ERLOG $err;
            }
         }
         else {
            # Get the sku, there should only ever be one
            $sku_skel = $sku_res[0];
         }
      }
      
      $query = "SELECT objid,msku,repl_by,title,brief,objtype,";
      $query .="objclass,keywords,ref_from FROM things ";
      $query .="WHERE status = '$FORM{'status_inp'}' AND language = '$session_lang' AND ";
      
      $flag=0;
      
      if ( $FORM{'objskel'} ne "" ) {
         $query .="(( objid LIKE '\%$FORM{'objskel'}\%' OR ";
            $query .="repl_by LIKE '\%$FORM{'objskel'}\%' )";
            # ignore initial data load stuff
#         $query .="AND objtype <> '')";
         $query .=" ) ";         
         $flag=1;
         
      } 
      else {
         $query .="objid LIKE '\%$FORM{'objskel'}\%' ";
         # ignore initial data load stuff
#         $query .="AND objtype <> ''";
         $flag = 1;
      }
      
      if ($FORM{'keyword'} ne "" ) {
         if ($flag) {
            $query .= " AND ";
         }
         
         $query.="( title LIKE '%$FORM{'keyword'}%' OR ";
            $query.="brief LIKE '%$FORM{'keyword'}%' OR ";
         $query.="keywords LIKE '%$FORM{'keyword'}%' ) ";
         $flag=1;
         
      } 
      
      if ($FORM{'sku_series'} ne "" ) {
         if ($flag) {
            $query .= " AND ";
         }
         $query.=" msku like '%$sku_skel->{'body'}%' ";
         $flag=1;
      }
      
      if ( $FORM{'objtype'} ne "") {
         if ($flag) {
            $query .= " AND ";
         }
         $query.=" objtype = '$FORM{'objtype'}' ";
         $flag=1;
      }      
      $query .=" ORDER BY TITLE ";
      
   }
   if ($debug) {
      print ERLOG "$query\n";
      
   }
   
   $sth = $dbh->prepare( $query );
   $sth->execute;
$foo=$sth->rows;
   $num=0;
   while ( $fda=$sth->fetchrow_hashref(NAME_lc) ) {
      $num++;
   }
   $sth = $dbh->prepare( $query );
   $sth->execute;
                     
#   $num = $sth->rows;
#   $num=0 if (! $num);      #interesting
#   $num=0 if ($num < 0);    #even more interesting--paranoia
   
   # the query returned nothing,
   # default to home mode
   
   if ( ! $num ) {
      if ($debug) {
         print ERLOG "Set mode to home in !$num!\n";
      }
      $FORM{'mode'}='home';
      
      ## push error message into page error message
      #
      $errm=$script_msg{6};
      $NVP{'PAGE_ERROR_MSG'}=$errm;
      $NVP{'skuskel_prev'}=$FORM{'skuskel'};
      
   }
   elsif ( $num==1 ) {
      ## exactly one row returned
      # --> send directly to appropriate editor routine
      
      $row = $sth->fetchrow_hashref(NAME_lc);
      $FORM{'mode'}="editsku";
      $FORM{'loadfrom'}="db";
      $NVP{'objskel_prev'}=$FORM{'objskel'};
      $NVP{'objid'}=$row->{'objid'};
      $FORM{'objid'}=$row->{'objid'};
      if ($debug) {
         print ERLOG "Setting FORM{'objid'} to $FORM{'objid'} from row!\n";
      }
      
      # Only set this if it is a product variant!
      if (($row->{'ref_from'} ne '') && ($row->{'ref_from'} ne $row->{'objid'})) {
         $FORM{'master_objid'} = $row->{'ref_from'};
         if ($debug) {
            print ERLOG "Set master_objid to $row->{'master_objid'}, $row{'ref_from'}, $row->{'ref_from'}\n";
         }
      }
      
      } else {
      # more than one row returned, show list of skus
      # and allow selection based on that
      #
      # read out skus and stash relevant bits in array
      #
      $FORM{'mode'}="searchlist";
      $FORM{'query'}=$query;
   }
   $sth->finish;
   
}

############################################################################
# PURPOSE      Displays the search results $maxrows at a time, setting the
#              Next, Back and pages links if required.  Displays link to
#              objid to edit, link to links, and a link to variants if it
#              is a master object.
#
# INPUT        None - uses $FORM{'query'} populated by loadfindobjects.
#
# OUTPUT       permuted page of search results, $maxrows at a time
#
# NOTES        
############################################################################
sub printsearch {
   my ($query, $foundcount, $num, $sth, $maxrows);
   $maxrows = 10;
   if ($debug) {
      print ERLOG " -------In search and form brand is $FORM{'objid'}--------- \n";
   }
   
   $query = $FORM{'query'};
   $sth = $dbh->prepare ( $query );
   $sth->execute;
#   $num = $sth->rows;

   $num=0;
   while ( $rwh=$sth->fetchrow_hashref(NAME_lc) ) {
      $num++;
   }   
   $sth = $dbh->prepare ( $query );
   $sth->execute;   

   $foundcount = $num;
   
   if ($debug > 1) {
      foreach $k (keys %FORM) {
         print ERLOG "$k = $FORM{$k}\n";
      }
      print ERLOG "$query\n";
      print ERLOG "Found $num results!\n";
   }
   
   ## parse out the template
   #
   $FORM{'sitename'}=$site->{'sitename'};
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";
   $FORM{'row_admin_sku_search'}="";
   
   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid_encrypt&mode=editsku&loadfrom=db";
   $v2="&sid=$sid_encrypt&mode=editlink&loadfrom=db";
   
   $old="old";
   
   if ($FORM{maxrows} ne "") {
   $maxrows = $FORM{maxrows}; }
   if ($maxrows > 200) { $maxrows = 200; }
   
   if ($FORM{startrow} ne "") {
      $startrow = $FORM{startrow};
      } else {
      $startrow = 0;
   }
   
   $lastrow = $startrow + $maxrows;
   if ($lastrow > $foundcount) {
      $lastrow = $foundcount;
   }
   
   if ($debug) {
      print ERLOG "Start: $startrow, lastrow: $lastrow, maxrows: $maxrows\n";
   }
   for ($rowctr = 0; $rowctr < $num; $rowctr++) {
      $y={};
      %row=%{$sth->fetchrow_hashref(NAME_lc)};
      if (($rowctr >= $startrow) && ($rowctr < $lastrow)) {
         $row{'title'}=string_exdbi($row{'title'});
         $k="objid=$row{'objid'}";
         $k2="obj1=$row{'objid'}";
         $outlink=$row{'objid'}.".shtml";
         
         $y->{'SKULINK'}="<A HREF=\"$scriptname\?$v&$k\">$row{'objid'}</A>";
         $y->{'PAGE'}="<A HREF=\/html\/$outlink>$script_msg{4}</A>";
         $y->{'LINKS'}="<A HREF=\"linkage.cgi\?$v2&$k2\">$script_msg{38}</A>";
         
         # only put out links to variants if it is a master product
         if ($row{'objid'} eq $row{'ref_from'}) {
            $v3="&sid=$sid_encrypt&mode=variants&objskel=$row{'ref_from'}";
            $y->{'VARIANTS'}="<A HREF=\"$scriptname\?$v3\">$script_msg{39}</A>";
         }
         
         
         # get the title of the variant & set the object sku to the master product variant!
         if (($row{'ref_from'} ne "") && ($row{'ref_from'} ne $row{'objid'})) {
            $results =  &get_fields_and_title("","",$row{'objid'},$dbh);
            $y->{'title'} = $results->{'title'};
            $v3="&sid=$sid_encrypt&mode=variants&objskel=$row{'ref_from'}";
            $y->{'SKULINK'}="<A HREF=\"$scriptname\?$v3\">$row{'objid'}</A>";
            $FORM{'ref_from'} = $row{'ref_from'};
         }
         else {
            $y->{'title'} = $row{'title'};
         }
         
         
         $rowtemplate=loadtemplate("row_admin_sku_search","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
         
         $FORM{'row_admin_sku_search'}.= permutebit($rowtemplate, $y);
         $old=$row{'objid'};
      }
   }
   
   $NVP{'query'} = $query;
   $FORM{'query'} = $query;
   $FORM{'searchnum'}=$foundcount;
   
   $pr = "sid=$sid_encrypt&mode=findobject&objskel=$FORM{objskel}&keyword=$FORM{keyword}&sku_series=$FORM{sku_series}&status_inp=$FORM{status_inp}&objtype=$FORM{objtype}";
   ($back, $next, $pages, $firstrecord) = &setSearchNavigation($pr, $foundcount,$maxrows, $startrow, $lastrow);
   
   $thispage=loadtemplate($targ,$skeletonpath);
   if ($debug) {
      print ERLOG "Set back to $back, next to $next, start is $start, lastrow is $lastrow!\n";
   }
   $startlink = $startrow + 1;
   $thispage=~ s/__pages__/$pages/gms;
   $thispage=~ s/__back__/$back/gms;
   $thispage=~ s/__next__/$next/gms;
   $thispage=~ s/__start__/$startlink/gms;
   $thispage=~ s/__end__/$lastrow/gms;
   
   $FORM{'script'}="admin_sku.cgi";
   $thispage = permutebit( $thispage, \%FORM );
   $thispage = permutebit( $thispage, $site );
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;
   $thispage = permuteclean ( $thispage );
   print $thispage;
   $sth->finish;
   return 1;
}

######################### ROW SUBROUTINES ##################################
############################################################################
# PURPOSE      Permute the rows into the main page template
#
# INPUT        $numRows - number of rows to load
#              $vals - an array of hashrefs with the information to load,
#               one index for each row.
#              @rownames - array of rownames templates to permute the $vals
#               into
#
# OUTPUT       permuted page template
#
# NOTES        The main page MUST be loaded prior to calling loadRows! The
#              location for the rows to be inserted in the main page MUST
#              be the name of the row template              
# 
#              Should be generalize and moved into a library
############################################################################
sub loadRows {
   my ($numRows) = $_[0];
   my ($vals) =  $_[1];
   my (@rownames) = $_[2];
   
   my ($thisrow, $target, $rowval, $rowtemplate, $errortrap, $i);
   
   if ($debug) {
      print ERLOG "In load rows with $numRows, $vals, @rownames!\n";
   }
   
   ## expand row entries
   #
   while (@rownames) {
      
      $thisrow=shift @rownames;
      
      $target=$thisrow;   # compute from $rownames[$i]
      $rowval="";
      
      $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
      ## run through each linkage...
      #
      $errortrap="";
      
      for ( $i=0; $i<$numRows; $i++ ) {
         $indx = $i+1;
         $$vals[$i]->{'axis1'} = $NVP{'axis1'};
         $$vals[$i]->{'axis2'} = $NVP{'axis2'};
         $$vals[$i]->{'axis3'} = $NVP{'axis3'};
         $$vals[$i]->{'axis4'} = $NVP{'axis4'};

         $regenerate_template = loadtemplate("row_regenerate", "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
	 if ($generate_default == 1) {
	     $regenerate_template =~ s/__regenerate_inp__/ CHECKED/gms;
	 }
	 $rowname = "row." . "__objid__" . ".regenerate_inp";
	 $regenerate_template =~ s/regenerate_inp/$rowname/gms;
	 $regenerate_template =~ s/Generate Page\?//gms;
	 $regenerate_template =~ s/__COLSPAN__/ALIGN=CENTER/gms;
	 $rowtemplate =~ s/__row_regenerate__/$regenerate_template/gms;
	 $$vals[$i]->{'regenerate'} = $generate_default;

         # set the axis name
         if ($$vals[$i]->{'objid'} =~ /newrow/) {
            $newrow = "newrow$indx";
            $$vals[$i]->{'axis1'} =~ s/__objid__/$newrow/gms;
            $$vals[$i]->{'axis2'} =~ s/__objid__/$newrow/gms;
            $$vals[$i]->{'axis3'} =~ s/__objid__/$newrow/gms;
            $$vals[$i]->{'axis4'} =~ s/__objid__/$newrow/gms;
         }
         
         if ($$vals[$i]->{'objid_err'}) { $errortrap ="yes";}
         ## append to processed template to growing rowval
         #     move linkage row data forward first
         
         $$vals[$i] = &agevariant($$vals[$i]);
         $$vals[$i] = &variantsafehtml( $$vals[$i] );
         
         ## construct pulldowns as hashref entries
         #
         
	 $rowval.=permutebit( $rowtemplate, $$vals[$i] );
      
      }
      ## now substitute back into page template
      #
      $thisrow="__".$thisrow."__";
      $pagetemplate =~ s/$thisrow/$rowval/gs ;
   }
}


############################################################################
# PURPOSE      Create and initialize a new row
#
# INPUT        $n - the number of rows to initialize and create
#              $rows - pointer to an array of hashrefs.  One entry is 
#               defined per new row with the default information
# 
# OUTPUT       %h - returns a hashref to a blank newrow of number n
#              $rows - pointer to array of hashrefs
#
# NOTES       
############################################################################
sub createnewrows {
   my ($n) = $_[0];     # the passed row number
   my ($rows) = $_[1];
   my($h, $i, $rownum);
   
   for ($i = 0; $i < $n; $i++) {
      $h = {};
      $h->{'objid'}="";
      $h->{'title'}="";
      $h->{'alttitle'}="";
      $h->{'axis1'}="";
      $h->{'axis2'}="";
      $h->{'axis3'}="";
      $h->{'axis4'}="";
      $h->{'regenerate'}="";
      @temp=keys %{$h};
      while (@temp) {
         $k = shift @temp;
         $k2 = $k."_ini";
         $h->{$k2}=$h->{$k};
         $k2 = $k."_inp";
         $h->{$k2}=$h->{$k};
         
      }
      
      $selected{'status'} = "15000-A";
      $selected{'visibility'} = "110000-A";
      
      # set the pulldowns for the row
      @pulldowns = ('sel_status|2','sel_visibility|2');
      foreach ( @pulldowns) {
         ( $k,$v) = split /\|/, $_;
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         # Make the sel_ files work with the current procedure.
         if ($k =~ /sel_/) {
            $k =~ s/sel_//gms;
            $k = uc($k);
            if ($debug) {
               print ERLOG "New pulldown name is $k\n";
            }
         }
         $kt=$k."_SELECT";
         $k = lc($k);
         $h->{$kt}= gen_select($selected{$k},$v,@raw );
      }
      
      $rownum = $i + 1;
      $h->{'objid'}="newrow$rownum";
      $$rows[$i] = $h;
      
   }
   return $i;
} #/createnewrow


############################################################################
# PURPOSE     To load in the messages to support multi-language
#
# INPUT       none
#
# OUTPUT      global hash script_msg holding all of the messages that
#             need to be used in the script
#
# NOTES       This would be much more readable throughout the code
#             if we used english STRINGS to reference the hash that
#             are meaningful, vs using just numbers
############################################################################
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Editing Variant Products for ";
      $script_msg{3}="Master Product";
      $script_msg{4}="page";
      $script_msg{6}="Nothing found! Please try another search";
      $script_msg{10}="Created";
      $script_msg{11}="Submitted changes to";
      $script_msg{12}="Variants and Pricing";
      $script_msg{13}="Product";
      $script_msg{14}="Article";
      $script_msg{15}="Intermediate Page";
      $script_msg{16}="Internal Document";
      $script_msg{17}="Brand";
      $script_msg{18}="Variant";
      $script_msg{19}="Pulldown";
      $script_msg{22}="Creation of a New";
      $script_msg{23}="Editing";
      $script_msg{24}="for";
      $script_msg{25}="Error - unable to obtain new sku";
      $script_msg{26}="Error - sku skeleton";
      $script_msg{27}="wrong length!";
      $script_msg{28}="Error - new sku and rows but brand";
      $script_msg{29}="not valid!";
      $script_msg{30}="Error - new sku but brand";
      $script_msg{32}="Product Line";
      $script_msg{33}="Variant ";
      $script_msg{34}="No changes made to";
      $script_msg{35}="successfully";
      $script_msg{36}="Warehouse";
      $script_msg{37}="Edit:";
      $script_msg{38}="Links";
      $script_msg{39}="Variants";
      $script_msg{40}="Pricing";
      $script_msg{41}="Inventory";
      $script_msg{42}="Object ID";
      $script_msg{43}="This version of AllCommerce only supports one warehouse!";
      } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
   
}

1;







