#!/usr/bin/perl
#
###############################################################
#
# Homepage Linker for Zelerate AllCommerce 1.0.4.1 
#
#  (c) 2000 - 2001 Guardian Digital, Inc.
#
#  Written by Nick DeClario <nick@guardiandigital.com>
#
#  This script will run the Zelerate tools/link_home.pl
#  script with the given input from the Admininstration 
#  section of AllCommerce. 
#
#  It will also supply the user with a drop down menu of all
#  available pages to link and their titles.
#
###############################################################
#
# + 01/08/01 Nick DeClario <nick@guardiandigital.com>
#   - Created
#
##################################
#
&initpath();
&initsite();

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

if ($FORM{'mode'} eq "main") {
$FORM{'mode'} = "home"; }

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});
if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
      } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__page_error_msg__'}=$FORM{'sid_ok'};
      } else {
      ## welcome to the page...
   }
   print "Content-type: text/html\n\n";
   } else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

if ($FORM{'mode'} eq "result") {
	&linkpage();
	&loadresult();
	exit;
}

&loadmain();

############################################################################
# PURPOSE      Load the  page
#
# INPUT        None
#
# OUTPUT       Set the browser to display the home page
#
# NOTES
############################################################################
sub loadresult {

   my ($pageInfo);

   $FORM{'status_inp'} = "15000-A";
   @pulldowns = ('sel_status|2');
   &loadselects(@pulldowns);

   $v="os_allcommerce-link-result";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("os_allcommerce-inventory-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"os_allcommerce-inventory-homespine.html\"-->/$spine/gms;
   $l=~ s/__brand_select__/$NVP{'brand_select'}/gms;
   $l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
   $l=~ s/__warehouse__/$NVP{'warehouse'}/gms;
   $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
   $l=~ s/__sitename__/$site->{'sitename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $siteURL = "http:\/\/" . $site->{'siteserver'} . $site->{'sitedomain'};
   $l=~ s/__LINKED_OBJECT__/$FORM{'select-link'}/gms;
   $l=~ s/__LINK_URL__/$siteURL/gms;  
   $l=~ s/__RESULT_MESSAGE__/$result_msg/gms;
 
   $l = permuteclean($l);
   print $l;
}

############################################################################
# PURPOSE      Load the home page
#
# INPUT        None
#
# OUTPUT       Set the browser to display the home page
#
# NOTES
############################################################################
sub loadmain {

   my ($pageInfo);

   $FORM{'status_inp'} = "15000-A";
   @pulldowns = ('sel_status|2');
   &loadselects(@pulldowns);

   $pageinfo = &getPages();

   $v="os_allcommerce-link-main";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("os_allcommerce-inventory-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"os_allcommerce-inventory-homespine.html\"-->/$spine/gms;
   $l=~ s/__brand_select__/$NVP{'brand_select'}/gms;
   $l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
   $l=~ s/__warehouse__/$NVP{'warehouse'}/gms;
   $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sitename__/$site->{'sitename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   $l=~ s/__OBJECT_SELECT__/$pageinfo/gms;

   $l = permuteclean($l);
   print $l;
}

############################################################################
# PURPOSE      Link given object to home.shtml 
#
# INPUT        None
#
# OUTPUT       Set the browser to display the home page
#
# NOTES
############################################################################
#
sub linkpage {
  my ($reldir, $dir);

  $reldir = &getRelPath();
  $dir = $reldir . "/html/eng";
  chdir($dir);

  if ( -f "./auto/$FORM{'select-link'}" ) {
        `cp ./home.shtml ./home-old.shtml` if ( !-f "./home-old.shtml" );
	`ln -fs ./auto/$FORM{'select-link'} home.shtml`;
	$result_msg = "<BLOCKQUOTE><FONT FACE=\"arial, helvetica\" SIZE=3><B>\n";
        $result_msg .= "<A TARGET=\"_NEW\" HREF=\"http:\/\/$site->{'siteserver'}$site->{'sitedomain'}\">";
        $result_msg .= "http:\/\/$site->{'siteserver'}$site->{'sitedomain'}<\/A>\n";
        $result_msg .= "<\/B><\/FONT>\n<\/BLOCKQUOTE>";
  }
  else {
	$result_msg = "<BLOCKQUOTE><FONT FACE=\"arial, helvetica\" COLOR=RED SIZE=\"3\">\n";
	$result_msg .= "<B>Error linking homepage<\/B><\/FONT><\/BLOCKQUOTE>";  

  }
}


######################## INITIALIZATION SUBROUTINES #######################

sub initpath {
   ## determine path from store (site) root and store db name...
   #
   #  note - this script runs at server root or in cgi-bin/om/admin,
   #    generally. Test these conditions first.
   #  $0 - may not contain a full path, bootstrap with "pwd"
   #
   if ( $0 !~ /^\// ) {  # $0 is not an absolute path
      $s=`pwd`;          # hope pwd on path...
      chomp $s;
      $s.="/$0";
      } else {              # $0 IS an absolute path
      $s=$0;
   } # done determining if $0 is relative or absolute
   @temp=split /\//, $s;
  
   @rpath=@temp;

   $scriptname = pop @rpath;
   $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

   $rundir= join "/", @rpath;
   chdir( $rundir );
  
   $relpath="";
   $siteshortname="";
   ## short circuit if $s does not contain cgi-bin
   if ( $s !~ /cgi-bin/ ) {
      $siteshortname = pop @rpath;
      $relpath=".";
      @temp=();
   } # done testing for degenerate case

   while ( @temp ) {
      $u = pop @temp;

      ## skip references to the present directory
      next if ( $u eq '.' );
      next if ( length($u)==0 );        # skip null directory levels

      $relpath.="/.." if ( $relpath);
      $relpath.="." if ( ! $relpath );

      if ( $u eq "cgi-bin" ) {
         $siteshortname = $temp[$#temp];
         @temp=();
      } # note - cgi-bin is off the site root, so the next up is site root

   } # done constructing relative path to store root

   $relpath .= "/../$siteshortname";

}

sub initsite {
   use DBI;
   # Version 0.9.7
   require "$relpath/lib/variant.pm";
   require "$relpath/lib/cgi-lib.pm";
   require "$relpath/lib/conversions.pm";
   require "$relpath/lib/filetools.pm";
   require "$relpath/lib/formtools.pm";
   require "$relpath/lib/login.pm";
   require "$relpath/lib/validate.pm";
   require "$relpath/lib/objects.pm";
   require "$relpath/conf/site.pm";
   require "$relpath/lib/localization.pm";
   require "$relpath/lib/generate_triggers.pm";
   require "$relpath/lib/blowfisher.pm";

   # must be the last require statement
   require "$relpath/lib/custom-lib.pm";

   ## establish site-specific parameters
   #
   $site=setsite();

   ## get form data, if any was submitted
   #
   %FORM=();
   &ReadParse();

   $FORM{'sid'}=&os_unhash(pack(H16,$FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );
   $sid_encrypt=unpack(H16, &os_hash($FORM{'sid'}, $site->{'hash_key'}));
   $sid=$FORM{'sid'};

   $find=$FORM{'skuskel'};
   if (!$find) {$find=$FORM{'keyword'};}
   $brandtype=$FORM{'brand'};

   ## connect to database
   # system 6 database state, products, and customer tables are collapsed
   #
   $q = "$site->{'db_site_config'}";
   $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

   $om_render_lang = "";
   $interface = "";

   if ($FORM{'sid'}) {
      $q="SELECT language,interface FROM sessions WHERE sid=$FORM{'sid'} ";
      $sts = $dbh->prepare( $q );
      $sts->execute;
      $h=$sts->fetchrow_hashref(NAME_lc);
      $om_render_lang=$h->{'language'};
      $session_lang = $h->{'language'};
      $interface=$h->{'interface'};
      $sts-finish;
   }

   $om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
   $om_render_lang="eng" if ( ! $om_render_lang );
   $session_lang="eng" if ( ! $session_lang );
   $interface="html" if ( ! $interface );

   ## load messages
   %script_msg=();      # user interaction messages
   $script=( split /\./, $scriptname )[0];
   &message;
   &initClassAndType();

   ## done with pull-from-file bits, rest of global settings...
   #
   $x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
   @temp=split /\//, $x;
   @temp=("cgi-bin","test","inventory.cgi") if (! $ENV{'REQUEST_URI'} );

   $script=( split /\./, $scriptname )[0];
   $n= $#temp - 1;
   $scriptpath = join "/", ( @temp[0..$n] );
   $skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
   $selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

   ## filled in with time/context variable info
   $nicedt=nicedatetime();

}

############################################################################
# PURPOSE     To load in the messages to support multi-language
#
# INPUT       none
#
# OUTPUT      global hash script_msg holding all of the messages that
#             need to be used in the script
#
# NOTES       This would be much more readable throughout the code
#             if we used english STRINGS to reference the hash that
#             are meaningful, vs using just numbers
############################################################################
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Nothing found! Please try a simpler search";
      $script_msg{3}="Error - your search returned nothing";
      $script_msg{4}="Try again";
      $script_msg{5}="Product";
      $script_msg{6}="Editing Inventory";
      $script_msg{7} = "Product";
      $script_msg{8}="Editing Prices";
      $script_msg{9}="Prices";
      $script_msg{10} = "Back to Master Object";
      $script_msg{12} = "Master Object";
      $script_msg{13} = "Currently there are";
      $script_msg{14} = "items in inventory";

      $script_msg{15} = "Modify prices:";
      $script_msg{16} = "Auto generated prices:";
      $script_msg{17} = "Enter new price:";
      $script_msg{18} = "Nothing found!  Please try another search";
      } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}

############################################################################
# PURPOSE     Get's pages for homepage by objID and Title 
#
# INPUT       none
#
# OUTPUT      HTML formated string of objects and titles
#
############################################################################
#
sub getPages {

  my($c, $dir, $str, @lines, $tmp, $obj);

  $relPath = &getRelPath();
  $dir = $relPath . "/html/eng";
  chdir ($dir);
  $str = "\n";
  $c = 0;

  while ( $tmp = glob("*-AA.shtml")) {
     $c++;
     $obj = $tmp;
     open (OBJECT, "<$tmp");
        
       @lines = <OBJECT>; 
       foreach $line (@lines) {     
	  $tmp .= " -- $1" if ($line =~ m/<TITLE>(.*)<\/TITLE>/) 
       }

     close (OBJECT);

     $tmp =~ s/\.shtml//;
     chomp $tmp;

     $str .= "		<OPTION VALUE=\"$obj\">$tmp</OPTION>\n";
 
  } 

  $str = "<OPTION VALUE=\"0\">No Items Found<\/OPTION>\n" if ($c <= 0);

  return $str;
}

###########################################################################
# PURPOSE     Get the current relative path 
#
# INPUT       none
#
# OUTPUT      The current relative path 
#
############################################################################
#
sub getRelPath {

  if ( $0 !~ /^\// ) {  # $0 is not an absolute path
     $s=`pwd`;          # hope pwd on path...
     chomp $s;
     $s.="/$0";
     } else {              # $0 IS an absolute path
     $s=$0;
  } # done determining if $0 is relative or absolute
  @temp=split /\//, $s;

  @rpath=@temp;
  $scriptname = pop @rpath;
  $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

  $rundir= join "/", @rpath;
  #chdir( $rundir );

  $relpath="";
  $siteshortname="";
  ## short circuit if $s does not contain cgi-bin
  if ( $s !~ /cgi-bin/ ) {
     $siteshortname = pop @rpath;
     $relpath=".";
     @temp=();
  } # done testing for degenerate case

  while ( @temp ) {
     $u = pop @temp;

     ## skip references to the present directory
     next if ( $u eq '.' );
     next if ( length($u)==0 );        # skip null directory levels

     $relpath.="/.." if ( $relpath);
     $relpath.="." if ( ! $relpath );

     if ( $u eq "cgi-bin" ) {
        $siteshortname = $temp[$#temp];
        @temp=();
     } # note - cgi-bin is off the site root, so the next up is site root
  }
  $relpath .= "/../$siteshortname";

  return $relpath;

}

