#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
###
#
# inventory.cgi
#
###
###
#
# Version 0.9.35 JC 20001009
#    moved secure sid to after readparse
# Version 0.9.34 JC 20001003
#    secure sid
# Version 0.9.33 JC 20000928
#    Remove all " " from search string, and if empty, then just return
#    everything
# Version 0.9.32 JC 20000913
#    bug fixes
# Version 0.9.31 JC 20000910
#    oracle intergration
# Version 0.9.30 JC 20000823
#    ->rows    
# Version 0.9.29 TG 20000817
#    Added generate_triggers
# Version 0.9.28 TG 20000807
#    Removed script_html
# Version 0.9.27 TG 20000803
#    Fixed SQL statements
# Version 0.9.26 TG 20000724
#    fixed master link message from inventory to prices for pricing.
# Version 0.9.24 GF 20000720
#    changed title names
# Version 0.9.23 IB 20000717
#    $om_render_language=$om_render_lang
# Version 0.9.22 TG 20000714
#    Changed alignment of back to master link for prices
# Version 0.9.21 TG 20000710
#    Fixed OBJID link for master products
# Version 0.9.20 TG 20000707
#    Finished documentation
# Version 0.9.19 TG 20000706
#    Fixed 0 to # on search results to be 1 to #.
#    Added pages to search results
# Version 0.9.18 TG 20000705
#    Added language to extraprop, set unitct to 1 for this release.
#    Finished documentation and debug cleanup
# Version 0.9.17 TG 20000629
#    Fixed call to loadseltomem from STATUS to sel_status
#    seperated search out into subroutines for use in content manager
# Version 0.9.16 TG 20000628
#    Fixed cdate and mdate for updates
#    Fixed check_login to go to login screen if not logged in
# Version 0.9.15 TG 20000627
#    Started documentation and re-arranged to readable format
# Version 0.9.14 TG 20000626
#    Rewrote inventory to support new format
# Version 0.9.13 TG 20000623
#    Changed title of price page to Prices vs Pricing
# Version 0.9.12 TG 20000622
#    Added prices - see known bugs
# Version 0.9.11 TG 20000621
#    started pricing support, fixed search but does not work with warehouse
# Version 0.9.10 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.9 TG 20000605
#    Replaced 15000-A with Active and 15001-A with inactive
#    Moved all HTML into rows templates
# Version 0.9.8 TG 20000602
#    Fixed for multiple variance
# Version 0.9.7 TG 20000601
#     added single variance
#     fixed search results
# Version 0.9.6 IB 20000531
#    added custom-lib.pm
# Version 0.9.5 IB 20000531
#    corrected the output for nonexistent item (set $findcount to 0)
# Version 0.9.4 GF 20000529
#    cleaned up formatiing issues
# Version 0.9.3 SC 20000524
#    Display only a few rows from findsku
# Version 0.9.2 SC 20000523
#    complete overhaul to 1.0 table structure.  Moved init stuff to subs.
# Version 0.9.1 IB 20000502
#    introduced variable $script
# Version 0.7.20 IB 20000420
#    insert->INSERT, update->UPDATE, set->SET
# Version 0.7.19 JC 20000411
#    $om_render_lang update
# Version 0.7.18 JC 20000410
#    multilingual messages
# Version 0.7.17 IB 20000402
#    new directory structure
# Version 0.7.16 JC 20000330
#    changed connect statement
# Version 0.7.15 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.14 IB 20000327
#    corrected $relpath
# Version 0.7.13 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.12 IB 20000302
#    updated copyright and removed -w
# Version 0.7.11 IB 20000228
#    changed store to site
# Version 0.7.9 IB 991201
#    converted ref to $sochbrandtype to $FORM{'sochbrandtype'}
# Version 0.7.8 IB 991127
#    fixing of header
# Version 0.7.7 IB 991126
#    fixing of a comment statement
# Version 0.7.6 IB 991124
#    fixed a database call
# Version 0.7.5 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.3 IB 991102
#    general cleanup
# Version 1 SH 990708
#
##

# Version 0.9.15
$debug = 0;
if ($debug) {
   open INV_ERLOG,  ">/tmp/inventory";
   print INV_ERLOG "Debugging inventory.cgi...\n";
}

# Flag, set to 0 to have default for Generate page? as no, and 
# set to 1 to have default as yes
$generate_default = 0;

&initpath();
&initsite();

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};
@skuvars=();       # array of hashrefs for holding sku variants
@skulinks=();      # array of hashrefs for holding linkages

######################### MOD-HANDLING ############################

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

if ($FORM{'mode'} eq "main") {
$FORM{'mode'} = "home"; }

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});
if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
      } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__page_error_msg__'}=$FORM{'sid_ok'};
      } else {
      ## welcome to the page...
   }
   print "Content-type: text/html\n\n";
   } else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}


## Define first entries in %NVP based on mode, sid, etc...
#
$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;


# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "findsku")) {
   $FORM{'mode'}="home";
}
# real preprocessing

if ($FORM{'mode'} eq "findsku") {
   &printsearch();
   exit;
}

########################################################
## Primary Display Mode Handling

if ($debug) {
   print INV_ERLOG "MODE IS $FORM{'mode'}!\n";
}
if ($FORM{'mode'} eq "searchlist") {
   &printsearch;
}
elsif ($FORM{'mode'} eq "submitinv") {
   
   if ($debug) {
      print INV_ERLOG "In submit inventory, master is $FORM{'master_objid'}!\n";
   }
   &submitInventory($FORM{objid});
   $FORM{'mode'} = "editsku";
}
elsif ( $FORM{'mode'} eq "submitprice" ) {
   &submitPrice($FORM{objid});
}

if ( $FORM{'mode'} eq "editsku" ) {
   $NVP{'master_objid'} = $FORM{'master_objid'};
   $STATUS_TXT = &loadseltomem("sel_status");
   &loadinventory($FORM{objid});
}

if ( $FORM{'mode'} eq "editprice" ) {
   $STATUS_TXT = &loadseltomem("sel_status");
   
   $q = "SELECT lstock FROM inventory WHERE objid = '$FORM{'objid'}'";
   $numRows = &query($q, $dbh, \@lstock);
   
   
   if ($debug) {
      print INV_ERLOG "$q\n";
   }
   $inventory = 0;
   foreach $stock (@lstock) {
      $inventory = $inventory + $stock->{'lstock'};
      
      if ($debug) {
         print INV_ERLOG "$inventory is inventory!\n";
      }
   }
   
   $NVP{'objid'} = $FORM{'objid'};
   &loadprices($FORM{objid}, $inventory);
}

if ($FORM{'mode'} eq "home") {
    &loadhome();
}

$dbh->disconnect if ( $dbh ) ;
close (INV_ERLOG);

############################################################################
# PURPOSE      Load the home page
#
# INPUT        None
#
# OUTPUT       Set the browser to display the home page
#
# NOTES
############################################################################
sub loadhome {

   $FORM{'status_inp'} = "15000-A";
   @pulldowns = ('sel_status|2');
   &loadselects(@pulldowns);
   
   $v="os_allcommerce-inventory-home";
   $l = loadtemplate ( $v, $skeletonpath );
   $l = permutebit( $l, \%NVP );
   $spine=loadtemplate("os_allcommerce-inventory-homespine",$skeletonpath);
   $l=~ s/<\!--#include virtual=\"os_allcommerce-inventory-homespine.html\"-->/$spine/gms;
   $l=~ s/__brand_select__/$NVP{'brand_select'}/gms;
   $l=~ s/__WAREHOUSE_SELECT__/$NVP{'WAREHOUSE_SELECT'}/gms;
   $l=~ s/__warehouse__/$NVP{'warehouse'}/gms;
   $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sitename__/$site->{'sitename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/$FORM{'mode'}/gms;
   
   $l = permuteclean($l);
   print $l;
}

######################### INVENTORY SUBROUTINES ############################

############################################################################
# PURPOSE      Load all existing inventory for $objid from tables
#              Set links to variant products if $objid
#              is a master product.  Get the form ready to allow user to
#              edit the data.
#
# INPUT        $objid - objid to get inventory for
#
# OUTPUT       Set $FORM{mode} to submitinv
#
# NOTES
############################################################################
sub loadinventory {
   my ($objid) = @_;
   
   my (@existing_inventory, $numInventory, $numAxisNames);
   
   if ($debug) {
      print INV_ERLOG "\nIN LOAD INVENTORY!  Product is $objid!\n";
   }
   
   $NVP{'sitename'}=$site->{'sitename'};
   $NVP{'searchnum'}=1;
   $NVPM{'lastmode'}=$FORM{'mode'};
   $NVP{'scriptname'}="$scriptname";
   $NVP{'scriptpath'}="$scriptpath";
   
   # Display the page
   $v="os_allcommerce-inventory-editsku";
   $l = loadtemplate ( $v, $skeletonpath );
   
   $isItMaster = &isProductMaster($objid, $dbh);
   # Set up a non-master product
   if (!$isItMaster) {
      $row_enter_button = "<TR> <TD COLSPAN=4 ALIGN=RIGHT><INPUT TYPE=IMAGE SRC=\"/images/eng/os_allcommerce/admin/buttons/enter.gif\"";
      $row_enter_button .= " BORDER=0></TD> </TR>";
      $NVP{'row_enter_button'} = $row_enter_button;
      
      $edit_target_headers = "row_inventory_headers";
      $header_template=loadtemplate($edit_target_headers, $skeletonpath);
      $numInv = &getExistingInv($objid, \@warehouse_inv);
      
      $edit_target_headers = "row_inventory_headers";
      $header_template=loadtemplate($edit_target_headers, $skeletonpath);
      
      if ($FORM{'master_objid'} ne "") {
         
         if ($debug) {
            print INV_ERLOG "Printing master_objid of $FORM{'master_objid'}!\n";
         }
         $pr="&sid=$sid_encrypt&mode=editsku&loadfrom=db";
         &setBackToMaster($FORM{'master_objid'}, $pr, "COLSPAN=4 ALIGN=RIGHT");
      }
      
      @rownames=( "row_inventory_editsku");
      &loadRows($numWarehouses, "inventory", \@warehouse_inv, @rownames);
   }
   # Set up a master product
   else {
      $NVP{'master_objid'} = $FORM{'master_objid'};
      $titles = &get_fields_and_title("","",$objid, $dbh);
      $NVP{'pagetitle'}="$script_msg{6} $script_msg{12} \($objid\) $titles->{'title'} \n";
      $pr="&sid=$sid_encrypt&mode=editsku&loadfrom=db&master_objid=$objid";
      &setUpMasterLinks($objid,$pr, "inventory");

      $edit_target_varheaders = "row_inventory_varheaders";
      $varheader_template=loadtemplate($edit_target_varheaders, $skeletonpath);        
   }
   
   $FORM{'status_inp'} = '';

   &checkformbits();
   
   &writetonvp();
   $NVP{'mode'}="submitinv";
   
   
   if ($debug) {
      print INV_ERLOG "Set to $NVP{'mode'}!\n";
   }
   
   $l = permutebit( $l, \%NVP );
   
   if ($debug) {
      print INV_ERLOG "Replacing __STATUS_SELECT__ with $NVP{'STATUS_SELECT'}\n";
   }
   $l=~ s/__STATUS_SELECT__/$NVP{'STATUS_SELECT'}/gms;
   $l=~ s/__row_inventory_header__/$header_template/gms;
   $l=~ s/__row_inventory_varheader__/$varheader_template/gms;
   $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sitename__/$site->{'sitename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/editprice/gms;
   $l=~ s/__objid__/$FORM{'objid'}/gms;
   $l =~ s/__row_price_headers__/$header_template/gms;
   $l =~ s/__manual_title__/$manual_title/gms;
   $l =~ s/__manual_header__/$manual_header/gms;
   $l =~ s/__auto_title__/$auto_title/gms;
   $l =~ s/__auto_header__/$auto_header/gms;
   $l =~ s/__new_title__/$new_title/gms;
   $l =~ s/__new_header__/$new_header/gms;
   $l = permuteclean($l);
   print $l;
   $already="yes";
}

############################################################################
# PURPOSE      To get all existing prices for $objid that match $where
#              clause, and store in $prices array.
#
# INPUT        $objid - objid to search for prices
#              $current_inv - array of inventory that are returned from query,
#                each index is a hash with one row from the price table
#
# OUTPUT       $numWarehouses - number of active warehouses
#              $prices - array of prices that are returned from query, each
#                index is a hash with  one row from the price table
#
# NOTES
############################################################################
sub getExistingInv {
   my ($objid) = $_[0];
   my ($current_inv) = $_[1];
   
   $q = "SELECT objid, title FROM things WHERE objtype = '$OBJTYPES->{'warehouse'}' AND objclass = '$OBJCLASSES->{'warehouse'}' AND status = '15000-A'";
   $numWarehouses = &query($q, $dbh, \@warehouse_inv);
   if ($debug) {
      print INV_ERLOG "$q\nFound $numWarehouses warehouses!\n";
   }
   
   $titles = &get_fields_and_title("","",$objid, $dbh);
   $NVP{'pagetitle'}="$script_msg{6} \($objid\) $titles->{'title'} \n";
   
   for ($i = 0; $i < $numWarehouses; $i++) {
      $wh_inv = $warehouse_inv[$i];
      $wh_inv->{'wh_inp'} = $wh_inv->{'objid'};
      $wh_inv->{'wh_inp'} = $wh_inv->{'objid'};
      $wh_inv->{'wh'} = $wh_inv->{'objid'};
      $wh_inp = "row.$wh_inv->{'objid'}.wh_inp";
      $wh_inv->{$wh_inp} = $wh_inv->{'objid'};
      $wh_inv->{'wh_title'} = $wh_inv->{'title'};
      $wh_inv->{'title'} = $title;
      $invrow = &getInventoryData($objid, $wh_inv->{'wh_inp'}, '');
      $wh_inv->{'lstock'} = $invrow->{'lstock'};
      $wh_inv->{'status'} = $invrow->{'status'};
      
      @pulldowns = ('sel_status|2');
      foreach ( @pulldowns) {
         ( $k,$v) = split /\|/, $_;
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         # Make the sel_ files work with the current procedure.
         if ($k =~ /sel_/) {
            $k =~ s/sel_//gms;
            $k = uc($k);
            if ($debug) {
               print ERLOG "New pulldown name is $k\n";
            }
         }
         $kt=$k."_SELECT";
         $k = lc($k);
         $NVP{$kt}= gen_select( $wh_inv->{$k},$v,@raw );
         $wh_inv->{$kt} = $NVP{$kt};
         $inp = $k . "_inp";
         if ($debug) {
            print INV_ERLOG "JUST MADE \$NVP{$kt} --> $NVP{$kt} with \$wh_inv->{$k} --> $wh_inv->{$k}\n";
            print INV_ERLOG "INP was $wh_inv->{$inp}\n";
         }
      }
      
      foreach $key (keys %{$wh_inv}) {
         next if ($key =~ /SELECT$/);
         $v = string_exdbi($wh_inv->{$key});
         $kp=$key."_pre";
         $kn=$key."_ini";
         $ki=$key."_inp";
         $wh_inv->{$key}=$v;
         $wh_inv->{$kp}=$v;
         $wh_inv->{$kn}=$v;
         $wh_inv->{$ki}=$v;
      }
      
      $$current_inv[$i] = $wh_inv;
   }
   
   return ($numWarehouses);
}

############################################################################
# PURPOSE    Get the inventory data for the objid, warehouse and status.
#            Used in search and loading the edit page for editing inventory
#
# INPUT      $objid - objid to get the inventory for
#            $wh - warehouse to get inventory for
#            $status - status of data to get inventory for
#
# OUTPUT     $invdata - hash consisting of the row selected from inventory
#
# NOTES
############################################################################
sub getInventoryData {
   my $objid = $_[0];
   my $wh = $_[1];
   my $status = $_[2];
   my ($sth, $num, $q);
   
   if ($status =~ /Not Specified/ig) {  # Ignore Parameter if "Not Specified"
   $status = ""; }
   
   if ($status eq '') {
      $q="SELECT * FROM inventory WHERE objid=\'$objid\'";
   }
   else {
      $q="SELECT * FROM inventory WHERE objid=\'$objid\' AND status like \'\%$status\%\'";
   }
   
   if ($wh ne "") {
      $q .= " AND wh=\'$wh\'";
   }
   
   if ($debug) {
      print INV_ERLOG "In getInventoryData --> $q\n";
   }
   $sth=$dbh->prepare($q);
   $sth->execute;
#   $num=$sth->rows;
   
#   if ($num > 0) {
   if ( $invdata = $sth->fetchrow_hashref(NAME_lc) ) {  
#      $invdata = $sth->fetchrow_hashref;
      if ($debug) {
         print INV_ERLOG "\tIn getInventoryData: Found $num rows!\n";
      }
      } else {
   return; }
   
   $invdata->{'rows'} = $num;
   return($invdata);
}

############################################################################
# PURPOSE      Submit all inventory that are entered and validated in the
#              %FORM for $objid.  Determines whether an update or insert
#              is required, and sets error messages if necessary
#
# INPUT        $objid - objid to submit inventory for
#
# OUTPUT       %FORM error message set, %FORM mode set to editsku
#
# NOTES
############################################################################
sub submitInventory {
   my $objid = $_[0];
   
   my $rv = "";
   
   # load all of the prices that may be modified
   $inv_indx = &loadFormInventory(\@form_inv);
   if ($debug) {
      print INV_ERLOG "There are $inv_indx->{'numInv'} rows to deal with!\n";
   }
   
   foreach $invkey (keys %{$inv_indx}) {
      
      # Get the array index for the objid
      $arrIndx = $inv_indx->{$invkey};
      
      # Get the objid hash
      $h = $form_inv[$arrIndx];
      next if ($invkey =~ /numInv/);
      next if (length($invkey) == 0);
      
      $h->{'key'} = $invkey;
      if (($h->{'lstock_pre'} ne '') || ($h->{'adjust_inp'} ne '')) {
         $check = &validate_row($h);
         if ($debug > 1) {
            foreach $x (keys %{$h}) {
               print INV_ERLOG "\$h->{$x} = $h->{$x}\n";
               
            }
         }
         $form_inv[$arrIndx] = $h;
         
         if (($check->{'changestowrite'} eq "yes") && ($check->{'validationcheck'} eq "ok")) {
            if ($debug) {
               print INV_ERLOG "OBJID is $h->{'objid'}!\n";
            }
            &updateInventory($h, $objid);
         }
      }
   }
   
   $FORM{'adjust_inp'} = '';
   $FORM{'mode'} = "editsku";
}

############################################################################
# PURPOSE     Sorts the %FORM hash into inventory rows, which have objid and
#             all values to insert into the tables from the FORM
#
# INPUT       $inv - pointer to an array which will be populated with
#              the sorted %FORM price data
#
# OUTPUT      $objid_indx - hash of keys which are objids with return the
#              index into the price array where the row exists
#             $inv - array of prices, each index being one unique row
#              of data.
#
# NOTES
############################################################################
sub loadFormInventory {
   my ($inv) = @_;
   my ($key, $row, $objid, $field, $numInv);
   
   if ($debug) {
      print INV_ERLOG "In loadFormInventory!\n";
   }
   $numInv = 0;
   $arrIndx = 0;
   foreach $key (keys %FORM) {
      if ($key =~ /row/) {
         ($row, $objid, $field) = split(/\./,$key);
         if (length($objid) == 0) {
            if ($debug) {
               print INV_ERLOG "loadFormInv: Got a blank objid for $key!\n";
            }
         }
         else {
            if (!($objids =~ /$objid/)) {
               $numInv++;
               
               # Save the index into the array to know what index to put all of the data in
               if (!defined $objid_indx->{$objid}) {
                  $objid_indx->{$objid} = $arrIndx;
                  if ($debug) {
                     print INV_ERLOG "Saving the index $arrIndx in \$objid_indx->{$objid}!\n";
                  }
                  $arrIndx++;
               }
            }
            
            # get the index for the objid
            $varIndx = $objid_indx->{$objid};
            
            # set the field
            if ($debug) {
               print INV_ERLOG "Trying to set \$\$inv[$varIndx]->{$field} = \$FORM{$key}, $$inv[$varIndx]->{$field} = $FORM{$key}\n";
            }
            $$inv[$varIndx]->{$field} = $FORM{$key};
         }
      }
   }
   
   $objid_indx->{'numInv'} = $arrIndx-1;
   return $objid_indx;
}

############################################################################
# PURPOSE     To update the inventory record with the values from the hash
#
# INPUT       $h - hash with the appropriate _inp values to update the
#                  row with
#             $objid - objid of the inventory row to update
#
# OUTPUT      none
#
# NOTES
############################################################################

sub updateInventory {
   my ($h) = $_[0];
   my ($objid) = $_[1];
   my ($q, $sth, $stu, $num, $flag, $stock);
   
   if ($debug) {
      print INV_ERLOG "in updateInventory for $objid\n";
   }
   if ($debug > 1) {
      foreach $ki (keys %{$h}) {
         print INV_ERLOG "\$h->{$ki} --> $h->{$ki}\n";
      }
   }
   
   # Insert
   if ($h->{'lstock_pre'} eq '') {
      $stock=$h->{'adjust_inp'};
      $now = time();
      
      $q="INSERT INTO inventory (objid, lstock, wh, status, cdate, mdate) VALUES ('$objid', '$stock', \'$h->{'wh_ini'}\', \'$h->{'status_inp'}\', $now, $now ) ";
      $numRes = &query($q, $dbh, \@res);
      if ($debug) {
         print INV_ERLOG "$q \n\t--> $numRes rows affected\n";
      }
   }
   
   # Update
   else {
      $q="SELECT lstock FROM inventory WHERE objid='$objid' AND wh = '$h->{'wh_ini'}'";
      if ($debug) {
         print INV_ERLOG " Get Stock $q";
      }
      $numRes = &query($q, $dbh, \@cur_inv);
      $stock = $cur_inv[0]->{'lstock'};
      $stock= $stock + $h->{'adjust_inp'};
      if ($debug) {
         print INV_ERLOG "New stock is $stock!\n";
      }
      $now = time();

      $q = "UPDATE inventory SET status = '$h->{'status_inp'}', lstock = $stock, mdate = $now ";
      $q .= " WHERE objid = '$objid' AND wh = '$h->{'wh_ini'}'";
      if ($debug) {
         print INV_ERLOG "$q!\n";
      }
      $numRows = &query($q, $dbh, \@res_array);
   }
}

######################### PRICING SUBROUTINES ############################

############################################################################
# PURPOSE      Load all existing prices for $objid from tables, display
#              the $inventory for the object.
#              Set links to variant products if $objid
#              is a master product.  Get the form ready to allow user to
#              edit the data.  Splits the form into existing manual prices,
#              existing auto generated prices, and a location to make
#              new manual prices
#
# INPUT        $objid - objid to get prices for
#              $inventory - current inventory for the objid
#
# OUTPUT       Set $FORM{mode} to editprice
#
# NOTES
############################################################################
sub loadprices {
   my ($objid, $inventory) = @_;
   #load primary permute hash values
   #
   my (@existing_prices, $numPrices, $numAxisNames);
   my ($regenerate_template);

   if ($debug) {
      print INV_ERLOG "\nIN LOAD PRICES!  Product is $objid!\n";
   }
   
   $NVP{'sitename'}=$site->{'sitename'};
   $NVP{'searchnum'}=1;
   $NVPM{'lastmode'}=$FORM{'mode'};
   $NVP{'scriptname'}="$scriptname";
   $NVP{'scriptpath'}="$scriptpath";
   
   
   # Display the page
   $v="os_allcommerce-inventory-editpriceP";
   $l = loadtemplate ( $v, $skeletonpath );
   
   $edit_target_headers = "row_price_headers";
   $header_template=loadtemplate($edit_target_headers, $skeletonpath);
   $titles = &get_fields_and_title("","",$objid, $dbh);
   
   # set up master product pricing
   if (&isProductMaster($objid, $dbh)) {
      $NVP{'master_objid'} = $FORM{'master_objid'};
      $titles = &get_fields_and_title("","",$objid, $dbh);
      $NVP{'pagetitle'}="$script_msg{8} $script_msg{12} \($objid\) $titles->{'title'} \n";
      $pr="&sid=$sid_encrypt&mode=editprice&loadfrom=db&master_objid=$objid";
      &setUpMasterLinks($objid,$pr, "prices");

     $edit_target_varheaders = "row_price_varheaders";
     $varheader_template=loadtemplate($edit_target_varheaders, $skeletonpath); 

   }
   # Set up non-master product pricing
   else {
      $NVP{'inventory'}="$script_msg{13} $inventory $script_msg{14}\n";
      $NVP{'pagetitle'}="$script_msg{8} \($objid\) $titles->{'title'} \n";
      
      if ($FORM{'master_objid'} ne "") {
         if ($debug) {
            print INV_ERLOG "Printing master_objid of $FORM{'master_objid'}!\n";
         }
         $pr="&sid=$sid_encrypt&mode=editprice&loadfrom=db";
         &setBackToMaster($FORM{'master_objid'}, $pr,"COLSPAN=5 ALIGN=RIGHT");
      }
      
      # Get the existing prices
      $numPrices = &getExistingPrices($FORM{'objid'},"unitct, unitpr, status, autogen", "autogen = 'N'", \@existing_prices);
      
      if ($numPrices >0 ) {
         $manual_header = $header_template;
	 $manual_title = loadtemplate("row_price_title", $skeletonpath);
	 $manual_title =~ s/__title__/$script_msg{15}/gms;
         @rownames=( "row_manual_price_exists");
         &loadRows($numPrices,"price", \@existing_prices, @rownames);
      }
      
      # Get the existing prices
      $numAutoPrices = &getExistingPrices($FORM{'objid'},"unitct, unitpr, status, autogen", "autogen = 'Y'", \@auto_prices);
      
      
      if ($numAutoPrices >0 ) {
         $auto_header = $header_template;
         $auto_title = "<TR> <TD COLSPAN=2><FONT FACE=\"arial,helvetica\" COLOR=\"#0066CC\" SIZE=+1> $script_msg{16}</TD>";
         $auto_title .= " <TD COLSPAN=4 ALIGN=RIGHT><INPUT TYPE=IMAGE SRC=\"/images/eng/os_allcommerce/admin/buttons/enter.gif\"";
         $auto_title .= " BORDER=0></TD> </TR>";
         for ($i=0; $i<$numAutoPrices; $i++) {
            $auto_prices[$i]->{'status_inp'} = $STATUS_TXT->{$auto_prices[$i]->{'status'}};
         }
         
         @rownames=( "row_autogen_price_exists");
         &loadRows($numAutoPrices, "price", \@auto_prices, @rownames);
      }
      
      @rownames=( "row_price_new");
      &loadRows(1,"price", '', @rownames);
      
      $new_header = $header_template;
      $new_title = "<TR> <TD COLSPAN=2><FONT FACE=\"arial,helvetica\" COLOR=\"#0066CC\" SIZE=+1>$script_msg{17}</TD>";
      $new_title .= " <TD COLSPAN=4 ALIGN=RIGHT><INPUT TYPE=IMAGE SRC=\"/images/eng/os_allcommerce/admin/buttons/enter.gif\"";
      $new_title .= " BORDER=0></TD> </TR>";
      
      #Load the status pulldown for the new information
      $FORM{'status_inp'} = '';
      @pulldowns = ( 'sel_status|2');
      &loadselects(@pulldowns);
      &checkformbits();

   $regenerate_template = loadtemplate("row_regenerate", $skeletonpath);
   if ($generate_default == 1) {
       $regenerate_template =~ s/__regenerate_inp__/ CHECKED/gms;
   }
   $regenerate_template =~ s/__COLSPAN__/COLSPAN=2/gms;
   print INV_ERLOG "generate: $regenerate_template\n";

   }
   
   &writetonvp();
   $NVP{'mode'}="submitprice";
   
   $l = permutebit( $l, \%NVP );

   if ($debug) {
      print INV_ERLOG "Replacing __STATUS_SELECT__ with $NVP{'STATUS_SELECT'}\n";
   }
   $l=~ s/__row_regenerate__/$regenerate_template/gms;         # hardcode to 1 for this release
   print INV_ERLOG "page, $l\n";
   $l=~ s/__unitct_pre__/1/gms;         # hardcode to 1 for this release
   $l=~ s/__STATUS_SELECT__/$NVP{'STATUS_SELECT'}/gms;
   $l=~ s/__page_error_msg__/$NVP{'page_error_msg__'}/gms;
   $l=~ s/__script__/$scriptpath\/$script.cgi/gms;
   $l=~ s/__sitename__/$site->{'sitename'}/gms;
   $l=~ s/__sid__/$sid/gms;
   $l=~ s/__mode__/editprice/gms;
   $l=~ s/__objid__/$FORM{'objid'}/gms;
   $l =~ s/__row_price_headers__/$header_template/gms;
   $l=~ s/__row_price_varheader__/$varheader_template/gms;
   $l =~ s/__manual_title__/$manual_title/gms;
   $l =~ s/__manual_header__/$manual_header/gms;
   $l =~ s/__auto_title__/$auto_title/gms;
   $l =~ s/__auto_header__/$auto_header/gms;
   $l =~ s/__new_title__/$new_title/gms;
   $l =~ s/__new_header__/$new_header/gms;
   $l = permuteclean($l);
   print $l;
   $already="yes";
}

############################################################################
# PURPOSE      To get all existing prices for $objid that match $where
#              clause, and store in $prices array.
#
# INPUT        $objid - objid to search for prices
#              $fields - fields to return from search
#              $where - additional where clause conditions
#              $prices - array of prices that are returned from query, each
#                index is a hash with one row from the price table
#
# OUTPUT
#              $prices - array of prices that are returned from query, each
#                index is a hash with  one row from the price table
#
# NOTES
############################################################################
sub getExistingPrices {
   my ($objid, $fields, $where, $prices) = @_;
   my ($q, $sth, $res, @res_arr, $numRows);
   
   $q = "SELECT ";
   $q .= $fields;
   $q .= " FROM prices WHERE objid = '$objid'";
   
   if ($where) {
      $q .= " AND $where";
   }
   
   $q .= " ORDER by unitpr";
   
   if ($debug) {
      print INV_ERLOG "$q\n";
   }
   
   $numRows = &query($q, $dbh, \@res_arr);
   
   if ($debug) {
      print INV_ERLOG "There are $numRows prices for $objid!\n";
   }
   for ($i = 0; $i < $numRows; $i++) {
      $res = $res_arr[$i];
      
      $q = "SELECT body FROM extraprop WHERE objid = '$objid' AND fieldname = 'weight' AND body like '%| $res->{'unitct'} | $res->{'unitpr'}'";
      $numRes = &query($q, $dbh, \@ext_arr);
      if ($debug) {
         print INV_ERLOG "Found $numRes results for $q!\n";
      }
      ($weight_val, $junk) = split /\|/, $ext_arr[0]->{'body'};
      $weight_val =~ s/ //g;
      $res->{'weight'} = $weight_val;
      # set the pulldowns for the row
      @pulldowns = ('sel_status|2');
      foreach ( @pulldowns) {
         ( $k,$v) = split /\|/, $_;
         open(FH, "<$selskeletonpath/$k.sel");
         @raw=<FH>;
         chomp @raw;
         close(FH);
         # Make the sel_ files work with the current procedure.
         if ($k =~ /sel_/) {
            $k =~ s/sel_//gms;
            $k = uc($k);
            if ($debug) {
               print ERLOG "New pulldown name is $k\n";
            }
         }
         $kt=$k."_SELECT";
         $k = lc($k);
         $NVP{$kt}= gen_select( $res->{$k},$v,@raw );
         $res->{$kt} = $NVP{$kt};
         if ($debug) {
            print INV_ERLOG "JUST MADE \$NVP{$kt} --> $NVP{$kt} with \$res->{$k} --> $res->{$k}\n";
         }
         $inp = $k . "_inp";
         if ($debug) {
            print INV_ERLOG "INP was $wh_inv->{$inp}\n";
         }
      }
      
      
      foreach $key (keys %{$res}) {
         next if ($key =~ /SELECT$/);
         $v = string_exdbi($res->{$key});
         $kp=$key."_pre";
         $kn=$key."_ini";
         $ki=$key."_inp";
         $res->{$key}=$v;
         $res->{$kp}=$v;
         $res->{$kn}=$v;
         $res->{$ki}=$v;
      }
      
      # save the hash of the row
      $$prices[$i] = $res;
   }
   
   if ($debug > 1) {
      print INV_ERLOG "---------------------------------------------\n";
      print INV_ERLOG "getprices: Number of rows are $numRows\n";
      for ($i = 0; $i < $numRows; $i++) {
         $res = $$prices[$i];
         foreach $key (keys %{$res}) {
            print INV_ERLOG "$key --> $res->{$key}\n";
         }
      }
      print INV_ERLOG "---------------------------------------------\n";
   }
   return $numRows;
}

############################################################################
# PURPOSE      Submit all prices that are entered and validated in the
#              %FORM for $objid.  Determines whether an update or insert
#              is required, and sets error messages if necessary
#
# INPUT        $objid - objid to submit prices for
#
# OUTPUT       %FORM error message set, %FORM mode set to editprice
#
# NOTES
############################################################################
sub submitPrice {
   my $objid = $_[0];
   
   my $rv = "";
   
   # load all of the prices that may be modified
   $price_indx = &loadFormPrices(\@form_prices);
   if ($debug) {
      print INV_ERLOG "There are $price_indx->{'numPrices'} rows to deal with!\n";
   }
   
   foreach $pricekey (keys %{$price_indx}) {
      next if ($pricekey =~ /numPrices/);
      next if (length($pricekey) == 0);
      
      # Get the array index for the objid
      $arrIndx = $price_indx->{$pricekey};
      
      # Get the objid hash
      $h = $form_prices[$arrIndx];
      $h->{'objid'} = $pricekey;
      $h->{'key'} = $pricekey;
      $check = &validate_row($h);
      if ($debug > 1) {
         foreach $k (keys %{$h}) {
            print INV_ERLOG "\$h->{$k} = $h->{$k}\n";
         }
      }
      $form_prices[$arrIndx] = $h;
      
      if (($check->{'changestowrite'} eq "yes") && ($check->{'validationcheck'} eq "ok")) {
         if ($debug) {
            print INV_ERLOG "OBJID is $h->{'objid'}!\n";
         }
         ($objid, $row) = split /_/,$h->{'objid'};
         $FORM{'objid'} = $objid;
         if ($debug) {
            print INV_ERLOG "FORM objid is $FORM{'objid'}\n";
         }
         &updatePriceRecord($h);
      }
   }
   
   
   if ($debug) {
      print INV_ERLOG "Unitct is $FORM{'unitct_inp'}!\n";
   }
   
   # To remove multiple unitct support for this release UCT
   $FORM{'unitct_inp'} = '1';
   
   if ($FORM{'unitpr_inp'} ne '') {
      $new->{'unitct_pre'} = $FORM{'unitct_pre'};
      $new->{'unitct_inp'} = $FORM{'unitct_inp'};
      $new->{'unitct_ini'} = $new->{'unitct_inp'};   # put it like this for validation
      $new->{'unitpr_pre'} = $FORM{'unitpr_pre'};
      $new->{'unitpr_inp'} = $FORM{'unitpr_inp'};
      $new->{'weight_inp'} = $FORM{'weight_inp'};
      $new->{'weight_pre'} = $FORM{'weight_pre'};
      $new->{'status_inp'} = $FORM{'status_inp'};
      $new->{'objid'} = $objid;
      $check = &validate_row($new);
      if (($check->{'changestowrite'} eq "yes") && ($check->{'validationcheck'} eq "ok")) {
         $now = time();

         $new->{'unitpr_inp'} =~ s/^0//g;

         ($int_val, $dec) = split /\./, $new->{'unitpr_inp'};

         if (length($dec) == 0) {
            $new->{'unitpr_inp'} = $new->{'unitpr_inp'} . ".00";

         }
         if (length($dec) == 1) {
            $new->{'unitpr_inp'} = $new->{'unitpr_inp'} . "0";
         }

         if ($debug) {
            print INV_ERLOG "New price is: $new->{'unitpr_inp'}!\n";
         }        

         $q = "INSERT INTO prices (objid, status, unitct, unitpr, autogen, mdate, cdate, pkflag, currency) VALUES ";
         $q .= "('$FORM{'objid'}', '$FORM{'status_inp'}', '$FORM{'unitct_inp'}', '$new->{'unitpr_inp'}', ";
         $q .= "'N', $now, $now, 'N', '$site->{'om_locale_curr_def'}')";
         if ($debug) {
            print INV_ERLOG "$q\n";
         }
         $res = &query($q, $dbh, \@res_insert);
         
         $now = time();
         $new->{'unitpr_inp'}=nicedecimals($new->{'unitpr_inp'});
         $weight_val = "$new->{'weight_inp'} | $new->{'unitct_inp'} | $new->{'unitpr_inp'}";
         $q = "INSERT INTO extraprop (objid, fieldname, body, cdate, mdate, language) VALUES ('$FORM{'objid'}', 'weight', '$weight_val', $now, $now, '$session_lang')";
         if ($debug) {
            print INV_ERLOG "$q\n";
         }
         $res = &query($q, $dbh, \@res_insert);
      }
      
   }
   
   if ($FORM{'regenerate_inp'} == 1) {
       print INV_ERLOG "Going into generate_triggers with $FORM{'objid'}\n";
       &generate_triggers($FORM{'objid'});
       print INV_ERLOG "Returning from generate_triggers with $FORM{'objid'}\n";
   }


   $FORM{'unitpr_inp'} = '';
   $FORM{'unitct_inp'} = '1';
   $FORM{'weight_inp'} = '';
   $FORM{'mode'} = "editprice";
}

############################################################################
# PURPOSE     Sorts the %FORM hash into price rows, which have objid and
#             all values to insert into the tables from the FORM
#
# INPUT       $price - pointer to an array which will be populated with
#              the sorted %FORM price data
#
# OUTPUT      $objid_indx - hash of keys which are objids with return the
#              index into the price array where the row exists
#             $prices - array of prices, each index being one unique row
#              of data.
#
# NOTES
############################################################################
sub loadFormPrices {
   my ($prices) = @_;
   my ($key, $row, $objid, $field, $numPrices);
   
   $numPrices = 0;
   $arrIndx = 0;
   foreach $key (keys %FORM) {
      if ($key =~ /row/) {
         ($row, $objid, $field) = split(/\./,$key);
         if ($debug) {
            print INV_ERLOG "loadFormPrices: $row. $objid. $field!\n";
         }
         if (length($objid) == 0) {
            if ($debug) {
               print INV_ERLOG "loadFormPrices: Got a blank objid for $key!\n";
            }
         }
         else {
            if (!($objids =~ /$objid/)) {
               $numPrices++;
               
               # Save the index into the array to know what index to put all of the data in
               if (!defined $objid_indx->{$objid}) {
                  $objid_indx->{$objid} = $arrIndx;
                  $arrIndx++;
               }
            }
            
            # get the index for the objid
            $varIndx = $objid_indx->{$objid};
            
            # set the field
            $$prices[$varIndx]->{$field} = $FORM{$key};
         }
      }
   }
   
   $objid_indx->{'numPrices'} = $arrIndx-1;
   return $objid_indx;
}

############################################################################
# PURPOSE     To update the price record with the values from the hash
#
# INPUT       $h - hash with the appropriate _inp values to update the
#                  row with
#
# OUTPUT      none
#
# NOTES
############################################################################
sub updatePriceRecord {
   my ($h) = $_[0];
   my ($q, $sth, $stu, $num, $flag, $stock);
   
   if ($debug) {
      print INV_ERLOG "in updatePriceRecord!\n";
   }
   $now = time();

   $h->{'unitpr_inp'} =~ s/^0//g;

   ($int_val, $dec) = split /\./, $h->{'unitpr_inp'};

   if (length($dec) == 0) {
      $h->{'unitpr_inp'} = $h->{'unitpr_inp'} . ".00";

   }
   if (length($dec) == 1) {
      $h->{'unitpr_inp'} = $h->{'unitpr_inp'} . "0";
   }   

   $q = "UPDATE prices SET status = '$h->{'status_inp'}', unitpr = '$h->{'unitpr_inp'}', mdate = $now";
   $q .= " WHERE objid = '$FORM{'objid'}' AND unitct = '$h->{'unitct_ini'}' AND unitpr = '$h->{'unitpr_pre'}' AND autogen = 'N'";
   $numRows = &query($q, $dbh, \@res_array);

   
   if ($debug) {
      print INV_ERLOG "$q\nNum rows are $numRows!\n";
   }
   
   if ($h->{'weight_inp'} ne '') {
      
      $weight_val = "$h->{'weight_inp'} | $h->{'unitct_ini'} | $h->{'unitpr_inp'}";
      $now = time();
      $q = "UPDATE extraprop SET body = '$weight_val', mdate = $now WHERE objid = '$FORM{'objid'}' AND fieldname = 'weight' AND body like '%| $h->{'unitct_ini'} | $h->{'unitpr_pre'}'";
      if ($debug) {
         print INV_ERLOG "$q!\n";
      }
      $numRows = &query($q, $dbh, \@res_array);
   }
}

####################### MASTER PRODUCT SUBROUTINES #########################
############################################################################
# PURPOSE     Set a link to go back to master from a variant product
#
# INPUT       $master_objid - objid of the master to go back to
#             $pr - partial string for the link, with:
#                  "&sid=$sid&mode=$mode&loadfrom=$loadfrom";
#                   Where $sid is the session id
#                         $mode is the mode you want to go to
#                         $loadfrom is where to load it from
#              $td_props - Properties for the TD that may want to be
#              encorporated - COLOR, ALIGN, etc
#
# OUTPUT      Sets 'back_to_master' and 'master_objid' in NVP
#
# NOTES       Should return the links and remove the NVP to be able to
#             move to library routine
############################################################################
sub setBackToMaster {
   my ($master_objid) = $_[0];
   my ($pr) = $_[1];
   my ($td_props) = $_[2];
   
   my ($k, $whtocken, $master, $master_link, $ln);
   
   $k="objid=$master_objid";
   $whtoken = "warehouse_inp=";
   $master = "$scriptname\?$pr&$k&$whtoken";
   if ($td_props) {
      $ln =  "<TD $td_props VALIGN=BOTTOM NOWRAP>";
   }
   else {
      $ln =  "<TD ALIGN=CENTER VALIGN=BOTTOM NOWRAP>";
   }
   $master_link = "$ln<A HREF=\"$master\"><FONT FACE=\"arial,helvetica\" SIZE=-1>$script_msg{10} $FORM{'master_objid'}</FONT></TD>";
   $NVP{'back_to_master'} = $master_link;
   $NVP{'master_objid'} = $master_objid;
}

############################################################################
# PURPOSE     To set up links to all of the variant products for master
#             products
#
# INPUT       $objid - master object id
#             $pr - partial string for the link, with:
#                  "&sid=$sid&mode=$mode&loadfrom=$loadfrom";
#                   Where $sid is the session id
#                         $mode is the mode you want to go to
#                         $loadfrom is where to load it from
#              $type_link - string price or inventory to concatenate
#                           to the error messages
#
# OUTPUT       $linkrows - the links that were generated
#
#              Updates the $NVP{'variants'}  with the linkrows.
#
# NOTES       Could generalize where they pass in a scriptname so it
#             doesn't use this script, and we can point other places,
#             then it could be moved to a library routine.
#
#             Could remove the assignment to 'varaints' to make it more
#             general and put in a library routine
############################################################################
sub setUpMasterLinks {
   my ($objid) = $_[0];
   my ($pr) = $_[1];
   my ($type_link) = $_[2];
   
   my ($q, $numVarRows, $linkrows, $i, $h);
   
   $q = "SELECT objid FROM things WHERE ref_from = '$objid' AND objid <> '$objid'";
   $numVarRows = &query($q, $dbh, \@res);
   
   $linkrows = "";
   for ($i = 0; $i < $numVarRows; $i++) {
      if ($debug) {
         print INV_ERLOG "In creating links with $i of $numVarRows!\n";
      }
      $h = $res[$i];
      $var_titles = &get_fields_and_title("","",$h->{'objid'}, $dbh);
      $k="objid=$h->{'objid'}";
      $whtoken = "warehouse_inp=";

      $links = "$scriptname\?$pr&$k&$whtoken";
      $linkrows .= "<TR><TD><A HREF=\"$links\"><FONT FACE=\"arial,helvetica\" SIZE=-1>$h->{'objid'}</FONT></TD>";
      $linkrows .= " <TD><FONT FACE=\"arial,helvetica\" SIZE=-1>$var_titles->{'title'}</FONT></TD></TR>";
   }
   if ($numVarRows == 0) {
      $linkrows = "<FONT FACE=\"arial,helvetica\" SIZE=+1 COLOR=\"#FF0000\">You must configure variant products prior to assigning $type_link\n";
   }
   
   $NVP{'master_objid'} = $objid;
   if ($debug) {
      print INV_ERLOG "Link rows is $linkrows!\n";
   }
   $NVP{'variants'} = $linkrows;
   return $linkrows;
}

############################ SEARCH SUBROUTINES ############################

############################################################################
# PURPOSE     Searches things for all products that  match the criteria
#             specified, and displays the results as links to
#             inventory and prices for each object in things that matches
#             the search criteria.  The objid is linked back to the 
#             content manager edit screen.
#
# ALGORITHM   If you enter more than one criteria in the search form the
#             query if formuated by AND
#
#             Object searches for a all objects LIKE the inputted object
#             string in the objid field that are a product class
#
#             Keywords searches title for objects LIKE the inputted keywords
#                    OR brief LIKE inputted keywords
#                    OR keywords like inputted keywords
#
#             Status searches for all objects that have the inputted status
#             in the things table.
#
# INPUT       none
#
# OUTPUT      permuted search page
#
# NOTES       Should be made consistent between all managers and moved out
#             to a search.pm library
#
#             Keyword has to match EXACTLY how you type it in the keyword
#             input.  If you put in more than one word, it doesn't split
#             them out into numerous LIKE statements, it just does the one
#             Something to think about for the new release.
############################################################################
sub printsearch {
   my ($sth, $stc, $q, $num, $thisobjid, $maxrows, $foundcount);
   my ($startrow, $whereclause, $rowctr, $titles);
   
   $rowctr = 0;
   $maxrows = 10;
   $foundcount = 0;
   
   chomp $FORM{'keyword'};
   $isblank = $FORM{'keyword'};
   $isblank =~ s/ //gms;
   if (length ($isblank) == 0) {
       $FORM{'keyword'} = "";
   }

   # Only want products for this search
   $whereclause = "objclass=\'$OBJCLASSES->{'product'}\'";
   $q = &formSearchQuery($FORM{'skuskel'}, $FORM{'keyword'}, $FORM{'status_inp'},'','', $whereclause);
   
   $sth=$dbh->prepare($q);
   $sth->execute;
#   $num=$sth->rows;
   $num=0;
   while ( $rwh=$sth->fetchrow_hashref(NAME_lc) ) {
      $num++;
   } 

   $sth=$dbh->prepare($q);
   $sth->execute;  

   ## parse out the template
   #
   $FORM{'sitename'}=$site->{'sitename'};
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

   print ERLOG "Num is $num!\n";
   if ( $num == 0) {
      if ($debug) {
         print ERLOG "Set mode to home in !$num!\n";
      }
      $errm=$script_msg{18};
      $NVP{'PAGE_ERROR_MSG'}=$errm;
      &loadhome();
   }
   else {
       if ($debug) {
	   print INV_ERLOG "Number of Rows ==> $num\n";
       }
       
       $foundcount = $num;
       $FORM{'searchnum'}=$foundcount;
       $FORM{'sochname'}=$find;
       
       ## call out page and cell templates
       #
       
       @pulldowns = ( 'sel_status|2');
       &loadselects(@pulldowns);
       
       $targ="os_allcommerce-inventory-searchlist";
       $thispage=loadtemplate($targ,$skeletonpath);
       
       ## output the file
       #
       ## put session data in $v for GET URL construction
       #
       
       $v="&sid=$sid_encrypt&mode=editsku&loadfrom=db";
       
       
       if ($FORM{maxrows} ne "") {
	   $maxrows = $FORM{maxrows}; }
       if ($maxrows > 200) { $maxrows = 200; }
       
       if ($FORM{startrow} ne "") {
	   $startrow = $FORM{startrow};
       } else {
	   $startrow = 0;
       }
       
       $lastrow = $startrow + $maxrows;
       if ($lastrow > $foundcount) {
	   $lastrow = $foundcount;
       }
       
       for ($rowctr = 0; $rowctr < $num; $rowctr++) {
	   ($thisobjid, $thistitle) = $sth->fetchrow;
	   if (($rowctr >= $startrow) && ($rowctr < $lastrow)) {
	       # Version 0.9.7 does extra query...
	       $titles = &get_fields_and_title("","",$thisobjid, $dbh);
	       $title = $titles->{'title'};
	       $k="objid=$thisobjid";
	       $whtoken = "warehouse_inp=$FORM{warehouse_inp}";
	       
	       $invrow = &getInventoryData($thisobjid, $FORM{'warehouse_inp'}, $FORM{'status_inp'});
	       $ROW{'objid_ini'}=$thisobjid;

	       $master = "";
	       $master = &isVariantProduct($thisobjid, $dbh);
	       if ($master ne "") {
		   $v3="&sid=$sid_encrypt&mode=variants&objskel=$master";
		   $ROW{'objid_link'}="admin_sku.cgi\?$v3";
	       }
	       else {
		   $ROW{'objid_link'}="admin_sku.cgi\?$v&$k";
	       }


	       $ROW{'inventory_link'}="$scriptname\?$v&$k&$whtoken";
	       if ($debug) {
		   print INV_ERLOG "Inventory link is $ROW{'inventory_link'}\n";
	       }
	       $ROW{'inventory_ini'}="Inventory";
	       
	       $pr="&sid=$sid_encrypt&mode=editprice&loadfrom=db";
	       $ROW{'price_link'}="$scriptname\?$pr&$k&$whtoken";
	       if ($debug) {
		   print INV_ERLOG "price link is $ROW{'price_link'}\n";
	       }
	       $ROW{'price_ini'}="$script_msg{9}";
	       
	       
	       $target2 = "row_inventory_searchlist";
	       $rowtemplate=loadtemplate($target2, $skeletonpath);
	       $ROW{'obj_ini'} = $thisobjid;
	       $ROW{'title_ini'} = $title;
	       $ROW{'in_stock_ini'} = $invrow->{'lstock'};
	       $ROW{'warehouse_ini'} =  $invrow->{'wh'};
	       $ROW{'status_ini'} = $STATUS_TXT->{$invrow->{'status'}};
	       
	       if ($debug) {
		   print INV_ERLOG "$ROW{'obj_ini'}, $ROW{'title_ini'},$ROW{'in_stock_ini'}, ";
		   print INV_ERLOG " $ROW{'warehouse_ini'}, $ROW{'status_ini'}\n";
	       }
	       
	       $thisrow = permutebit( $rowtemplate, \%ROW );
	       $expand1 .= $thisrow;
	   }
       }
       
       
       $pr = "sid=$sid_encrypt&mode=findsku&skuskel=$FORM{skuskel}&status_inp=$FORM{status_inp}&keyword=$FORM{keyword}";
       ($back, $next, $pages, $firstrecord) = &setSearchNavigation($pr, $foundcount,$maxrows, $startrow, $lastrow);

       # Search link preparation
       $search="<A HREF=\"$scriptpath/$scriptname\?$pr";
       $search.="&startrow=$startrow\"><FONT FACE=\"arial,helvetica\" SIZE=\"-1\">Return to search</FONT></A>&nbsp;&nbsp;"; 
       $FORM{'search'} = $search;
       print INV_ERLOG "Set search to \n$search\n";


       $startlink = $startrow;
       if ($foundcount != 0) {
	   $startlink++;
       }
       
       $thispage=~ s/__pages__/$pages/gms;
       $thispage=~ s/__back__/$back/gms;
       $thispage=~ s/__next__/$next/gms;
       $thispage=~ s/__start__/$startlink/gms;
       $thispage=~ s/__end__/$lastrow/gms;
       
       
       $FORM{'row_inventory_searchlist'}=$expand1;
       $FORM{'script'}="inventory.cgi";
       $thispage = permutebit( $thispage, \%FORM );
       $thispage=~ s/__brand_select__/$NVP{'brand_select'}/gms;
       $thispage=~ s/__STATUS_SELECT__/$NVP{'STATUS_SELECT'}/gms;
       $thispage=~ s/__page_error_msg__/$NVP{'page_error_msg'}/gms;
       $thispage=~ s/__script__/$FORM{'script'}/gms;
       $thispage=~ s/__sitename__/$site->{'sitename'}/gms;
       $thispage=~ s/__sid__/$sid/gms;
       $thispage=~ s/__mode__/$FORM{'mode'}/gms;
       
       $thispage = permuteclean ( $thispage );
       print $thispage;
       $sth->finish;
       return 1;
   }
}

############################# ROW SUBROUTINES ##############################

############################################################################
# PURPOSE     To take in an array of hashes (one entry per row), which has
#             all of the values that are needed for in each @rownames.  The
#             __ values in the template are then permuted with the values
#             from the $vals array
#
# INPUT       $numRows - number of rows to permute
#             $type - type of rows that we are loading - inventory or price
#             $vals - array of hashes, each row representing 1 row, and
#                     containing the values of the __ values in the row
#                     template
#             @rownames - list of row names that are to be permuted.  These
#                         names MUST be the exact same as the names in the
#                         main template where the rows are to be placed,
#                         as well as the same name as the actual row
#                         templates
#
# OUTPUT      Replaces the __row__ where __row__ is the name of each of the
#             row templates passed in by @rownames with the permuted values.
#
# NOTES       The main template with the __row__ where __row__ is the name
#             of the row template, must be opened prior to calling this
#             routine
#
#             $type should be removed with a key field in the hash, which
#             will be used to populate the __objid__ portion of the row,
#             so that this can be used for any row!
#
#             Should be eventually moved to a row.pm library, and should
#             split up the number of rows to show at one time, with a
#             Next and Back link
############################################################################
sub loadRows {
   my ($numRows) = $_[0];
   my ($type) = $_[1];
   my ($vals) =  $_[2];
   my (@rownames) = $_[3];
   
   my ($thisrow, $target, $rowval, $rowtemplate, $errortrap, $i);
   
   if ($debug) {
      print INV_ERLOG "In load rows with $numRows, $vals, @rownames!\n";
   }
   
   ## expand row entries
   #
   while (@rownames) {
      
      $thisrow=shift @rownames;
      
      $target=$thisrow;   # compute from $rownames[$i]
      $rowval="";
      
      $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
      ## run through each linkage...
      #
      $errortrap="";
      
      
      for ( $i=0; $i<$numRows; $i++ ) {
         
         $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
         
         $ROW = $$vals[$i];
         
         if ($type eq "price") {
            $row_objid = $FORM{'objid'} . "_" . $ROW->{'unitct_ini'} . "_" . $i;
            $ROW->{'objid'} = $row_objid;
         }
         else {
            $row_objid = $ROW->{'wh_inp'};
            $ROW->{'objid'} = $row_objid;
         }
         
         $ROW = &agerow($ROW);
         $ROW = &rowsafehtml( $ROW);
         
         $rowval.=permutebit( $rowtemplate, $ROW);
         if ($debug) {
            print INV_ERLOG "\n\n";
         }
      }
      ## now substitute back into page template
      #
      $thisrow="__".$thisrow."__";
      if ($debug) {
         print INV_ERLOG "Substituting back: $thisrow!\n";
      }
      $l =~ s/$thisrow/$rowval/gs ;
   }
}


############################################################################
# PURPOSE     Moves _inp to _pre values
#
# INPUT       $h - hashref for a row
#
# OUTPUT      $h - hashref with the _pre values set
#
# NOTES       Could be moved to a library routine, as this is also in
#             other adminstrator CGI scripts
############################################################################
sub agerow {
   my($h,@temp,$k,$v);
   $h = @_[0];
   
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /_inp$/ );   # only want input values
      $v =  $h->{$k} ;
      $k2 =~ s/_inp$/_pre/ ;
      $h->{$k2}=$v if ( $v );
   }
   return $h;
} #/agerow

############################################################################
# PURPOSE         Makes title and alttitle keys html-safe
#
# INPUT           $h - hashref of input values
#
# OUTPUT          $h - hashref with title and alttile converted to safe
#                      html
#
# NOTES           Should be moved to a library because is used throughout
#                 other admin CGI scripts
############################################################################
sub rowsafehtml {
   my($h,@temp,$k,$v);
   $h = @_[0];
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /(title|alttitle)/ );   # only want titles
      $h->{$k} = string_tohtml( $h->{$k} ) ;
   }
   return $h;
} #rowsafehtml

############################################################################
# PURPOSE     checks population of _inp
#
# INPUT       none
#
# OUTPUT      updates the global FORM hash
#
# NOTES       updates the FORM global
#             does not touch the NVP hash
############################################################################
sub checkformbits {
   my($k,$kt,@keys);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );
      } # only really concerned with _pre/_inp pairs
   } # done with all keys
   
   ## special case - objclass
   #
   
   if ((! $FORM{'objclass'} ) and ( $FORM{'objclass_inp'} )) {
      $FORM{'objclass'}=$FORM{'objclass_inp'};
   }
   if (( $FORM{'objclass'} ) and (! $FORM{'objclass_inp'} )) {
      $FORM{'objclass_inp'}=$FORM{'objclass'};
   } # end of objclass fillin
   return 1;
} #/checkformbits

############################################################################
# PURPOSE     Write FORM data to NVP hash
#
# INPUT       none
#
# OUTPUT      Updates the global NVP hash
#
# NOTES
############################################################################
sub writetonvp {
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
         } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
         } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
         } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'objclass'}=$FORM{'objclass_inp'} if (( ! $NVP{'objclass'} ) and ( $FORM{'objclass_inp'} ));
   return 1;
} #/writetonvp


######################### INITIALIZATION SUBROUTINES #######################

sub initpath {
   ## determine path from store (site) root and store db name...
   #
   #  note - this script runs at server root or in cgi-bin/om/admin,
   #    generally. Test these conditions first.
   #  $0 - may not contain a full path, bootstrap with "pwd"
   #
   if ( $0 !~ /^\// ) {  # $0 is not an absolute path
      $s=`pwd`;          # hope pwd on path...
      chomp $s;
      $s.="/$0";
      } else {              # $0 IS an absolute path
      $s=$0;
   } # done determining if $0 is relative or absolute
   @temp=split /\//, $s;
   
   @rpath=@temp;
   
   $scriptname = pop @rpath;
   $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff
   
   $rundir= join "/", @rpath;
   chdir( $rundir );
   
   $relpath="";
   $siteshortname="";
   ## short circuit if $s does not contain cgi-bin
   if ( $s !~ /cgi-bin/ ) {
      $siteshortname = pop @rpath;
      $relpath=".";
      @temp=();
   } # done testing for degenerate case
   
   while ( @temp ) {
      $u = pop @temp;
      
      ## skip references to the present directory
      next if ( $u eq '.' );
      next if ( length($u)==0 );        # skip null directory levels
      
      $relpath.="/.." if ( $relpath);
      $relpath.="." if ( ! $relpath );
      
      if ( $u eq "cgi-bin" ) {
         $siteshortname = $temp[$#temp];
         @temp=();
      } # note - cgi-bin is off the site root, so the next up is site root
      
   } # done constructing relative path to store root
   
   $relpath .= "/../$siteshortname";
   
}

sub initsite {
   use DBI;
   # Version 0.9.7
   require "$relpath/lib/variant.pm";
   require "$relpath/lib/cgi-lib.pm";
   require "$relpath/lib/conversions.pm";
   require "$relpath/lib/filetools.pm";
   require "$relpath/lib/formtools.pm";
   require "$relpath/lib/login.pm";
   require "$relpath/lib/validate.pm";
   require "$relpath/lib/objects.pm";
   require "$relpath/conf/site.pm";
   require "$relpath/lib/localization.pm";
   require "$relpath/lib/generate_triggers.pm";
   require "$relpath/lib/blowfisher.pm"; 
  
   # must be the last require statement
   require "$relpath/lib/custom-lib.pm";
   
   ## establish site-specific parameters
   #
   $site=setsite();
   
   ## get form data, if any was submitted
   #
   %FORM=();
   &ReadParse();

   $FORM{'sid'}=&os_unhash(pack(H16,$FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );  
   $sid_encrypt=unpack(H16, &os_hash($FORM{'sid'}, $site->{'hash_key'})); 
   $sid=$FORM{'sid'};
   
   $find=$FORM{'skuskel'};
   if (!$find) {$find=$FORM{'keyword'};}
   $brandtype=$FORM{'brand'};
   
   ## connect to database
   # system 6 database state, products, and customer tables are collapsed
   #
   $q = "$site->{'db_site_config'}";
   $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
   
   $om_render_lang = "";
   $interface = "";
   
   if ($FORM{'sid'}) {
      $q="SELECT language,interface FROM sessions WHERE sid=$FORM{'sid'} ";
      $sts = $dbh->prepare( $q );
      $sts->execute;
      $h=$sts->fetchrow_hashref(NAME_lc);
      $om_render_lang=$h->{'language'};
      $session_lang = $h->{'language'};
      $interface=$h->{'interface'};
      $sts-finish;
   }
   
   $om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
   $om_render_lang="eng" if ( ! $om_render_lang );
   $session_lang="eng" if ( ! $session_lang );
   $interface="html" if ( ! $interface );
   
   ## load messages
   %script_msg=();  	# user interaction messages
   $script=( split /\./, $scriptname )[0];
   &message;
   &initClassAndType();
   
   ## done with pull-from-file bits, rest of global settings...
   #
   $x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
   @temp=split /\//, $x;
   @temp=("cgi-bin","test","inventory.cgi") if (! $ENV{'REQUEST_URI'} );
   
   $script=( split /\./, $scriptname )[0];
   $n= $#temp - 1;
   $scriptpath = join "/", ( @temp[0..$n] );
   $skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
   $selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";
   
   ## filled in with time/context variable info
   $nicedt=nicedatetime();
   
}

############################################################################
# PURPOSE     To load in the messages to support multi-language
#
# INPUT       none
#
# OUTPUT      global hash script_msg holding all of the messages that
#             need to be used in the script
#
# NOTES       This would be much more readable throughout the code
#             if we used english STRINGS to reference the hash that
#             are meaningful, vs using just numbers
############################################################################
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Nothing found! Please try a simpler search";
      $script_msg{3}="Error - your search returned nothing";
      $script_msg{4}="Try again";
      $script_msg{5}="Product";
      $script_msg{6}="Editing Inventory";
      $script_msg{7} = "Product";
      $script_msg{8}="Editing Prices";
      $script_msg{9}="Prices";
      $script_msg{10} = "Back to Master Object";
      $script_msg{12} = "Master Object";
      $script_msg{13} = "Currently there are";
      $script_msg{14} = "items in inventory";
      $script_msg{15} = "Modify prices:";
      $script_msg{16} = "Auto generated prices:";
      $script_msg{17} = "Enter new price:";
      $script_msg{18} = "Nothing found!  Please try another search";
      } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}
1;
