#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# linkage.cgi
#
# RF 981106 to manage linkages
#####

$script_version="Version 0.9.26 - 20001003";

#####
#
# Version 0.9.26 JC 20001003
#    secure sid
# Version 0.9.25 JC 20000927
#    fixed duplicate cellstyle
# Version 0.9.24 TG 20000817
#    Added generate_triggers
# Version 0.9.23 TG 20000811
#    Added previous_error flag under objid check
# Version 0.9.22 TG 20000803
#    Fixed alttitle bug with modifying
# Version 0.9.21 TG 20000801
#    Fixed SQL statements, added pagestyle to linkage screen for main product
#    getPageStyleText subroutine
# Version 0.9.20 TG 20000725
#    Cleared obj1_pre on refresh of home
# Version 0.9.19 TG 20000719
#    Removed relpath from get_fields_and_title call to fix variant titles
#    in linkage and title page
# Version 0,9.18 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.17 TG 20000707
#    Changed search error message to be consistent with
#    other managers, documented and cleaned up debug
# Version 0.9.16 TG 20000706
#    Fixed allowing ' in alttitle
# Version 0.9.15 TG 20000705
#    Only allow editing of links for particular language
# Version 0.9.14 TG 20000630
#    Fixed linkage to be able to change alttitle and weight
# Version 0.9.13 TG 20000629
#    Fixed title for variant products on main page, fixed linkage validation
#    to verify that it isn't already linked.  Allow to clear alttitle and weight
# Version 0.9.12 TG 20000628
#    Fixed check_login to go to login screen if not logged in
# Version 0.9.11 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.10 TG 20000606
#    Fixed sorting of weights - removed sortlinks, as the routine to use is in formtools
#    Added alttitle, and celldepth support, just validate if celldepth is an integer
#       KNOWN BUGS:
#             If you put invalid input in the new links, especially in the weight field,
#             the error message shows up in other rows.  This is because of sortlinks which
#             is based on the weight.  The sortlinks routine should ONLY sort the linked links,
#             not any new, unvalidated entries!
# Version 0.9.9 TG 20000531
#    removed variant support and put into variant.pm library
#    replaced calls directly to get the title with library call get_fields_and_title
## Version 0.9.8 IB 20000531
#    added custom-lib.pm
# Version 0.9.7 TG 20000531
#    fixed validate objid for the linked object
#    fixed cell linkage problems
#    fixed linkage entries to include status
#    fixed levents to add the series
#    added variant support for linkage
#    put debug in with debug flag
# Version 0.9.2 GF 20000524
#    check_login commented out
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.21 IB 20000420
#    set->SET
# Version 0.7.20 IB 20000411
#    eliminated ERLOK (probably misspelled ERLOG)
# Version 0.7.19 JC 20000410
#    multilingual messages
# Version 0.7.18 IB 20000402
#    new directory structure
# Version 0.7.17 IB 20000330
#    changed connect statement
# Version 0.7.16 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.15 20000327
#    corrected $relpath
# Version 0.7.14 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.13 20000302
#    updated copyright
# Version 0.7.12 20000228
#    changed store to site
# Version 0.7.11 20000124 KMS
#    addes storename NVI to Merchandise Manger template routine.
# Version 0.7.10 991202 IB\GF
#    fixed problem regarding CELLSTYLE sel
# Version 0.7.9 991201 IB
#    fixed global names
# Version 0.7.8 991126 IB
#    fixed script version number
# Version 0.7.7 991121 IB
#    corrected bits to bits/site/sel
# Version 0.7.6 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 991109 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 991107 IB
#    removed redundant statement
# Version 0.7.3 991103 IB
#    general cleanup
# Version 0.7.1 990713 GF
#    revised for system 6 structure
#
#####

##### To Be Done and Bugs
#        - enhance homepage - better search options
#        - autopopulation of defaultable fields
#        - resorting of links by cellwidth, weight

##### Setup and Initialization

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#

# Flag, set to 0 to have default for Generate page? as no, and 
# set to 1 to have default as yes
$generate_default = 0;

#$debug = 0;           # set to 0 for no debug

if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
   } else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;
   
   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels
   
   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );
   
   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root
   
} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;

require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/variant.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/generate_triggers.pm";
require "$relpath/lib/blowfisher.pm"; 

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

$debug = 0;
if ($debug) {
   open ERLOG, ">/tmp/linkage";
}


## establish site-specific parameters
#
$site=setsite();

## get form data if any was submitted
#

%FORM=();
&ReadParse;

## database connection
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
$interface = "";
$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );
if ($FORM{'sid'}) {
   $q="SELECT language,interface FROM sessions WHERE sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $session_lang=$h->{'language'};
   $interface=$h->{'interface'};
   $sts->finish;
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$session_lang="eng" if ( ! $session_lang );
$interface="html" if ( ! $interface );

## load messages
%script_msg=();		# user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

$q = ( split /\?/, $ENV{'REQUEST_URI'} )[0];
@temp=split /\//, $q;
@temp=("cgi-bin","test","linkage.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html";

## filled in with time
$nicedt=nicedatetime();

## blankrows are the number of new linkage rows to
#     display at bottom of a linkage editing page
$blankrows=3;

## session id
#
$sid=$FORM{'sid'};

if ($FORM{'obj1'} && $FORM{'obj1'} ne "__obj1_pre__" ) {
$FORM{'obj1_pre'}=$FORM{'obj1'};}
else {
   $FORM{'obj1_pre'}="";
}

$NVP{'obj1_pre'}=$FORM{'obj1_pre'};

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

## login control
#
$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ($debug) {
   print ERLOG " Form mode is $FORM{'mode'} \n";
}


if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
      
      } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
      
      } else {
      # welcome to the page
   }
   
   ## script outputs to html
   #
   print "Content-type: text/html\n\n";
}

if ($debug) {
   print ERLOG " form mode is now $FORM{'mode'} \n";
}

if ($FORM{'mode'} eq "submitlink" ) {
   
   &loadskutonvp( $FORM{'obj1'} );
   
   ## load linkage information from form
   #
   $FORM{'loadfrom'}="form";
   
   @links=&loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'} );
   
   for ( $i=0; $i<=$#links; $i++ ) {
      # next if ( ! $links[$i]->{'KILL_inp'} );
      
      # there is a kill entry!
      
      if ( $links[$i]->{'objid'} =~ /^newrow/ && $links[$i]->{'KILL_inp'} ) {
         # just reinitialize
         $x=$links[$i]->{'objid'};
         
         $x =~ tr/A-Za-znewrow//d ;      # strip alphas
         $links[$i]=&createnewrow($x);
         
      }
      elsif ($links[$i]->{'objid'} !~ /^newrow/) {
         # existing sku, kill the record and the list entry
         #
         if ($links[$i]->{'KILL_inp'}) {
            $q="UPDATE linkage SET status='15001-A' WHERE ";
            $q.="obj1='$FORM{'obj1'}' AND obj2='$links[$i]->{'obj2_ini'}' ";
#            $dbh->do( $q );
            $sth=$dbh->prepare($q);
            $sth->execute;
            $q="UPDATE extraprop SET status='15001-A' WHERE ";
            $q.="objid='$links[$i]->{'objid'}'";
#            $dbh->do( $q );
            $sth=$dbh->prepare($q);
            $sth->execute;            
            if ($debug) {
               print ERLOG "$q\n";
            }
            
            ## kill it from the list
            #
            
            $ip=$i-1;
            $ix=$i+1;
            if ($ip > -1 && $#links >= $ix) {
               @links=( @links[0..$ip],@links[$ix..$#links] );
               } elsif ($ip < 0 and $#links >= 1) {
               @links=@links[1..$#links];
               } elsif ($ix > $#links && $ip >= 0) {
               @links=@links[0..$ip];
            }
            #/ checking how to remake @links
            
            $i--;         # decrement one so auto-increment net zero
            
         }
      } # end of choosing how to kill the entry
   } # done killing links
   
   ## validate submitted data, write changes to tables
   #
   for ( $i=0; $i<=$#links; $i++ ) {


       if ($links[$i]->{'obj2_ini'}) { # existing links
	   $checkVarObjid = $links[$i]->{'obj2_ini'};
       }
       else {   # new links
	   $checkVarObjid = $links[$i]->{'obj2_inp'};
       }
       $vcodeq = "SELECT vcode FROM things WHERE objid = '$checkVarObjid'";
       $numVrows = &query($vcodeq, $dbh, \@res);
       if ($res[0]->{'vcode'} ne "") {
	   $links[$i]->{'vcode'} = $res[0]->{'vcode'};
       }

      $links[$i] = validatelink( $links[$i] );
      
      if ($debug) {
	  print ERLOG "Extra query $vcodeq\n$numVrows returned\n";
         print ERLOG "After validate link with \$links[$i]->{'changestowrite'} = $links[$i]->{'changestowrite'}";
         print ERLOG " and \$links[$i]->{'validationcheck'} = $links[$i]->{'validationcheck'}!\n";
      }

      # Do not want to enter a row with a blank obj2 and valid other data!
      # We must check the _inp & _ini to handle both new and old links
      if ( ($links[$i]->{'obj2_inp'} eq '') && ($links[$i]->{'obj2_ini'} eq '') &&
         ($links[$i]->{'changestowrite'} eq "yes") &&
         ($links[$i]->{'validationcheck'} eq "ok")) {
         $links[$i]->{'changestowrite'} = "no";
         $links[$i]->{'validationcheck'} = "";
	 $links[$i]->{'previous_error'} = "yes";
         $links[$i]->{'obj2_err'} = $script_msg{NO_OBJ};
      }
      
      
      if ($links[$i]->{'objid'} =~ /newrow/) {
         $h2 = $links[$i];
         if ($debug > 1) {
            print ERLOG "......................................\n";
            foreach $k2 (keys %{$h2}) {
               print ERLOG "$k2 = $h2->{$k2}\n";
               
            }
         }
         $q = "SELECT objid FROM linkage WHERE obj1 = '$FORM{'obj1_pre'}' AND obj2 = '$links[$i]->{'obj2_inp'}' AND status = '15000-A'";
         $numRows = &query($q, $dbh, \@res);
         if ($numRows > 0) {
            $links[$i]->{'validationcheck'} = "";
            $links[$i]->{'changestowrite'} = "no";
            # Error - Object $links[$i]->{'obj2_inp'} is already linked
            $links[$i]->{'obj2_err'} = "$script_msg{ERROR} $script_msg{OBJECT} $links[$i]->{'obj2_inp'} $script_msg{ALREADY_LINKED}";
         }
      }

       # force update of alternate title
       if ( ( $links[$i]->{'validationcheck'} eq "ok" )
          && ( $links[$i]->{'alttitle_changed'} eq "yes" ) ) {
	   $links[$i]->{'changestowrite'} =  "yes";
       }

       if ( ( $links[$i]->{'validationcheck'} eq "ok" )
          && ( $links[$i]->{'changestowrite'} eq "yes" ) ) {
         # write and log changes
         if ( $links[$i]->{'objid'} =~ /^newrow/ ) {
            push @links, &writelink( $links[$i] );
            $x=$links[$i]->{'objid'};
            $x =~ tr/[A-Za-z_.]//d ;      # strip alphas
            $links[$i]=&createnewrow($x);
            } 
	 else {
            # it is an existing row, just update it
            $links[$i]=&writelink( $links[$i] );
	    print ERLOG "Checking regenerate_inp, $FORM{'regenerate_inp'}\n";

         } # end of testing for new or not
         #
      } # end of data write cycle
   }

   if ($FORM{'regenerate_inp'} == 1) {
       print ERLOG "Going into generate triggers for $FORM{'obj1'}\n";
       &generate_triggers($FORM{'obj1'});
       print ERLOG "Returned from $FORM{'obj1'}\n";
   }

} #/submitlink


if ($FORM{'mode'} eq "editlink" ) {
   
   $x = ValidateOBJID($FORM{'obj1'}, $dbh);
   
   if ( ! $x ) {                         # object exists!
      
      ## load primary sku's data to NVP
      &loadskutonvp( $FORM{'obj1'} );
      
      ## now load linkage information
      #
      $FORM{'loadfrom'}="db" if (! $FORM{'loadfrom'} );
      
      @links=&loadlinkages( $FORM{'loadfrom'}, $FORM{'obj1'} );
      
      for ( $i=0; $i<=$#links; $i++ ) {
         @temp=sort keys %{$links[$i]};
         while (@temp) {
            $x=shift @temp;
         }
      }
      
      } else {                              # sku was bad
      $FORM{'mode'}="home";
      $FORM{'obj1_err'}=$script_msg{$x};
   }
} #/editlink

## last moment mode changes
#
if ( $FORM{'mode'} eq "submitlink" ) {
   $FORM{'mode'}="editlink";
}

## populate deterministic NVP elements
#
&populate_nvp();


#################################################################
## display routine for form modes
#
if ( $FORM{'mode'} eq "editlink" ) {
   
   $target="os_allcommerce-".$script."-".$FORM{'mode'};
   $pagetemplate =
   loadtemplate($target,$skeletonpath);
   $regenerate_template = loadtemplate("row_regenerate", $skeletonpath);
   if ($generate_default == 1) {
       $regenerate_template =~ s/__regenerate_inp__/ CHECKED/gms;
   }
   $pagetemplate =~ s/__row_regenerate__/$regenerate_template/gms;
   $pagetemplate =~ s/__COLSPAN__/COLSPAN=2/gms;

   @rs_CELLSTYLE = split /\n/,
   loadtemplate("sel_cellstyle.sel",$selskeletonpath);
   @rs_CELLDEPTH = split /\n/,
   loadtemplate("sel_celldepth.sel",$selskeletonpath);

   
   #    @links = sortlinks(@links);
   
   
   $res = &get_fields_and_title("pagestyle","",$FORM{'obj1'},$dbh,"");
   if ($res) {
      $NVP{'title'} = $res->{'title'};
      $NVP{'pagestyle'} = &getPageStyleText($res->{'pagestyle'});
   } #
   if ($debug) {
      print ERLOG "OBJID Is $FORM{'obj1'}, $NVP{'title'}, $NVP{'pagestyle'}!\n";
   }
   
   @rownames=( "row_linkageed_a","row_linkagenew_a" );    # manual stub
   
   ## expand row entries
   #
   while (@rownames) {
      
      $thisrow=shift @rownames;
      
      $target=$thisrow;   # compute from $rownames[$i]
      $rowval="";
      
      $rowtemplate=loadtemplate( $target, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin" );
      ## run through each linkage...
      #
      $errortrap="";
      for ( $i=0; $i<=$#links; $i++ ) {
         if ($links[$i]->{'obj2_err'}) { $errortrap ="yes";}
         
         ## skip links not relevant to this row group
         
         next if ( ( $thisrow =~ /new_/ )
         and ( $links[$i]->{'objid'} !~ /newrow/ ) );
         
         next if ( ( $thisrow !~ /new_/ )
         and ( $links[$i]->{'objid'} =~ /newrow/ ) );
         
         ## append to processed template to growing rowval
         #     move linkage row data forward first
         
         $links[$i] = &agelink($links[$i]);
         $links[$i] = &linksafehtml( $links[$i] );
         
         ## construct pulldowns as hashref entries
         #
         
         $links[$i]->{'CELLSTYLE_SELECT'} =
         gen_select( $links[$i]->{'cellstyle_inp'},5,@rs_CELLSTYLE );
         $links[$i]->{'CELLDEPTH_SELECT'} =
         gen_select( $links[$i]->{'cellstyle_inp'},1,@rs_CELLDEPTH );
         @temp = sort keys %{$links[$i]};
         
         while (@temp) {
            
            $k = shift @temp;
            
         } # done dumping linkage to logfile
         #
         
         $rowval.=permutebit( $rowtemplate, $links[$i] );
         
         if ($debug) {
            print ERLOG "PREVIOUS ERROR IS $links[$i]->{'previous_error'}\n";
         }
         $rowval =~ s/__previous_error__/$links[$i]->{'previous_error'}/;
         
      }
      ## now substitute back into page template
      #
      $thisrow="__".$thisrow."__";
      $pagetemplate =~ s/$thisrow/$rowval/gs ;
   }
   
   ##### garbage
   
   # populate template
   
   ## override anything inherited for these vars:
   #
   $NVP{'mode'}="submitlink";
#   $spine=loadtemplate("openmerchant-linkage-spine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
   $pagetemplate = permutebit( $pagetemplate, \%NVP );
   $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
   # spew template
   
#   $pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-spine.html\"-->/$spine/gms;
   
   $pagetemplate=~ s/__sid__/$sid/g;
   $pagetemplate=~ s/__obj1_pre__/$FORM{'obj1'}/g;
   print $pagetemplate;
   print "\n";
   
   } else  {                                          # default to show search
   # engine box
   
   ## locate and load the primary page template
   #
   $target="os_allcommerce-"."linkage-home";

   $NVP{'obj1_pre'}="";   # clear search field on home

#   $spine=loadtemplate("openmerchant-linkage-homespine","/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
   $pagetemplate=loadtemplate($target,"/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin");
   # populate template
   $pagetemplate = permutebit( $pagetemplate, \%NVP );
   $pagetemplate = permuteclean( $pagetemplate, \%NVP );
   
#   $pagetemplate=~ s/<\!--#include virtual=\"openmerchant-linkage-homespine.html\"-->/$spine/gms;
   
   $pagetemplate=~ s/__sid__/$sid/g;
   
   
   # spew template
   print $pagetemplate;
   print "\n";
}

## terminal cleanup
#

$x = $dbh->disconnect if ( $dbh );

############################# SUBROUTINES ##################################

############################################################################
# PURPOSE      load sku-by-sku linkage data from form or database
#
# INPUT        $source - where to get the data from, db or form
#              $objid - objid of the object to get the data for (obj1 in
#               linkage table
#
# OUTPUT       @links - Sorted array of hashrefs.  Each hash is for one
#               objid, and are sorted on column width and weight
#
# NOTES        Sorting is commented out for this release, will be added in
#              the future
############################################################################
sub loadlinkages {
   my( $source,$objid ) = @_;
   my(%tfld,$sti,$n,$m,$q,$sku,@linkah,$h,$k,$k2,$k3);
   # initialize hasref
   @linkah = ();      # array of hashrefs
   $h = {};           # temp for each linkage
   
   if ( $source eq "db" ) {
      $q='SELECT objid,obj2,status,linkwt_man ';
      $q.=" FROM linkage ";
      $q.=" WHERE obj1='$objid' AND status='15000-A'";
      
      if ($debug) {
         print ERLOG "$q\n";
      }
      
      $sti = $dbh->prepare( $q );
      $sti->execute;
#      $n=$sti->rows;
      
      ## go through the returned rows
      #
#      for ( $i=0; $i<$n; $i++ ) {
#         $j=$i+1;
      $j=1;
      while ( $rr=($sti->fetchrow)[0] ) {
         $j++; 
#         $h=&loadlinktohash( ($sti->fetchrow)[0], $j );
         $h=&loadlinktohash( $rr, $j );
         
         push @linkah, $h;
         
      }
      $sti->finish;
      
      ## create the rows for new entries
      #
      for ( $i=1; $i<= $blankrows; $i++ ) {
         push @linkah, &createnewrow($i);
      }
      
      ## fill in lost _inp elements
      #
      for ( $i=0; $i<=$#linkah; $i++ ) {
         $linkah[$i] = &filllostinp( $linkah[$i] );
      } # done building linkah form-ish fields
      
      } else {
      
      ## assume load from form
      #
      %rowids = ();
      @formkeys = sort keys %FORM;
      ## now run through formkeys and construct $linkhh
      #
      while ( @formkeys ) {
         $s = shift @formkeys;
         next if ( $s !~ /^row/ );      # skip over the non-repetitive elements
         ## extract the rowid
         #
         $rid = (split /\./, $s )[1];
         ## check to see if the rowid has already been created
         #     if not, push a new hashref onto @linkah and record the
         #     mapping of rowid onto array element number
         
         if ( defined($rowids{$rid}) ) {
            ## get the rowid for hash referencing
            #
            $rn=$rowids{$rid};
            
            } else {
            ##
            #
            push @linkah, {};
            $rowids{$rid} = $#linkah;
            $rn=$#linkah;
            $linkah[$rn]->{'objid'}=$rid;
            
         }
         ## now have the row number in $rn
         #     compute the field-key name from the form key
         
         @temp = split /\./, $s;
         $k = join ".", @temp[2..$#temp] ;
         
         ## write the hash entry
         
         $linkah[$rn]->{$k} = $FORM{$s};
         
      } #/formkeys
      
      #
      ## linkah now constructed, perform data validation elsewhere
      #     each linkage is now a hashref of it's own
      #
      
      for ( $i=0; $i<=$#linkah; $i++ ) {
         
         ## check for lost inputs
         #
         $linkah[$i] = &filllostinp( $linkah[$i] );
         $linkah[$i]->{'cellwidth_ini'} = ( split /_/,
         $linkah[$i]->{'cellstyle_inp'} )[1];
         
      } # done checking for lost inputs
      
   } #/source variations
   
   # return the hashref array...
   return @linkah;
} #/loadlinkages

############################################################################
# PURPOSE      Populate the NVP hash from %FORM elements
#
# INPUT        None
#
# OUTPUT       The FORM hash updated with anything that was set in the nvp
#              hash
#
# NOTES
############################################################################
sub populate_nvp {
   my(@keys,$k);
   
   @keys = sort keys %FORM;
   ## separate repetitive elements from non-repetitive
   #
   while (@keys) {
      $k = shift @keys;
      next if ( $k =~ /^row/ );       # skip repetitive bits
      $NVP{$k}=$FORM{$k} if ( ! defined($NVP{$k}) );
   } #/while running through keys
   
   ## stuff from localization specific data
   #
   #$NVP{'script'}="$scriptpath/login.cgi?mode=main";
   $NVP{'script'}="$scriptpath/$scriptname";
   $NVP{'scriptname'}=$scriptname;
   $NVP{'scriptpath'}=$scriptpath;
   $NVP{'sitename'}=$site->{'sitename'};
   
   return 1;
} # /populate_nvp


############################################################################
# PURPOSE      Create and initialize a new row
#
# INPUT        $n - the number of rows to initialize and create
#
# OUTPUT       %h - returns a hashref to a blank newrow of number n
#
# NOTES       
############################################################################
sub createnewrow {
   my($h,$n);
   $n=$_[0];     # the passed row number
   
   $h = {};
   $h->{'obj2'}="";
   $h->{'title'}="";
   $h->{'linkwt_use'}="";
   $h->{'linkwt_man'}="";
   $h->{'cellstyle'}="";
   $h->{'celldepth'}="";
   $h->{'status'}="";
   @temp=keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $k2 = $k."_ini";
      $h->{$k2}="";
      $k2 = $k."_inp";
      $h->{$k2}="";
   }
   
   $h->{'objid'}="newrow$n";
   return $h;
} #/createnewrow

############################################################################
# PURPOSE      fill in lost _inp fields
#
# INPUT        $h - hashref for a row of links
#
# OUTPUT       $h - hashref for the row of links, setting the _inp to the
#               _pre values if they were not inputted by the user via
#               the FORM
#
# NOTES
############################################################################
sub filllostinp {
   my(@temp,$h,$k,$k2);
   $h=$_[0];
   
   @temp = keys %{$h};
   foreach $k ( @temp ) {
      next if ( $k !~ /_pre$/ );
      $k2 = $k;
      $k2 =~ s/_pre$/_inp/ ;
      if (( ! exists( $h->{$k2} ) ) and ( $h->{$k} )) {
         $h->{$k2}=$h->{$k};
      }
   }
   return $h;
} #/filllostinp

############################################################################
# PURPOSE      To update exisiting modified rows, insert new rows, and
#              remove any rows requested by the user via the FORM
#
# INPUT        $h - hashref of one row to write to the table
#
# OUTPUT       $h - new hashref of the updated record
#
# NOTES
############################################################################
sub writelink {
   my($h,$sti,$t,$q,$k,$fn);
   $h = $_[0];
   
   $fields_linkage="obj1,obj2,objclass,title,linkwt_man,";
   $fields_linkage.="manweight,cellstyle,celldepth,";
   $fields_linkage.="objclass,status,cdate,mdate";
   $t = time();
   $q="";             # holder for UPDATE statement
   
   $h->{'obj1_inp'}=$FORM{'obj1'};
   $h->{'obj1_ini'}="";
   
   ## insert a blank record if new, use to set objid
   #
   
   if ( $h->{'objid'} !~ /new/ ) {
      $h->{'updateit'} = 1;
   }
   
   # new sku
   if ( $h->{'objid'} =~ /new/ ) {    # new sku
      
      # see if it already exists but is inactive
      $wow="SELECT objid FROM linkage WHERE obj1='$h->{'obj1_inp'}' ";
      $wow.=" AND obj2='$h->{'obj2_inp'}' AND status='15001-A' ";
      
      if ($debug) {
         print ERLOG "$wow\n";
      }
      $stw=$dbh->prepare($wow);
      $stw->execute;
#      $numw=$stw->rows;
#      if ($numw == 1) {
#         ($objid)=$stw->fetchrow;
      if ( ($objid)=$stw->fetchrow ) {
         $h->{'objid'}=$objid;
         $h->{'updateit'} = 1;
      }
      else {
         $h->{'updateit'} = 0;
      }
      
      if ($h->{'updateit'} == 0) {
         $h = &insertLink($h);
      }
      
   } # end of initial insertion for new skus
   
   if ($h->{'updateit'} == 1) {
      $h = &inheritValues($h);
      
      ## run through fields, look for non-initial values
      $q="";
      @temp = sort keys %{$h};
      while (@temp) {
         
         $k = shift @temp;
         
         next if ( $k !~ /_inp$/ );  # only care about entered fields
         next if ( $k =~ /^KILL/ );  # only care about entered fields
         next if ( $k =~ /^objid/ ); # NEVER update the objid
         next if ( $k =~ /cellstyle/ ); # remove duplicate cell style         
 
         $fn = $k;
         $fn =~ s/_inp$// ;         # fieldname root
         $k2 = $fn."_ini";          # initial value
         
         next if ( $fields_linkage !~ /$fn/ );  # a real field?
         
         # now compare and construct the insert clause
         if ( exists($h->{$k2}) and ( $h->{$k2} ne $h->{$k} )) {
            # meaningful comparison
            $q.="," if ( $q );
            $q.="$fn='".string_todbi($h->{$k})."'";
         } #/done evaluating if this is a change or not
      } # end of running through fields
      
      ## finish the query
      #
      if ($q) {
         # update syntax
         $q.=",mdate=$t";
         $q .= ",cellstyle='$links[$i]->{'cellstyle_inp'}' ";
#         $q.= ",linkwt_man='$links[$i]->{'linkwt_man_inp'}' ";
#         $q.=",celldepth='$links[$i]->{'celldepth_inp'}' ";
         $q.=",status='15000-A'";
         $q = "UPDATE linkage SET $q WHERE objid='$h->{'objid'}'";
         if ($debug) {
            print ERLOG "$q\n";
         }
#         $dbh->do( $q );
         $sth=$dbh->prepare($q);
         $sth->execute;
         # If there was something initially set for the alttitle, update it
         if ($debug) {
            print ERLOG "PRE: $h->{'alttitle_pre'}, INP: $h->{'alttitle_inp'}, INI: $h->{'alttitle_ini'}\n\n";
         }
         # used to be ''
         
         if ($h->{'alttitle_changed'} eq "yes") {
            # assume update and if fails, then insert it
            $h->{'alttitle_inp'} = string_todbi($h->{'alttitle_inp'});
            $mdate = time();
            $q = "UPDATE extraprop SET body = '$h->{'alttitle_inp'}', mdate = $mdate ";
            $q .= "WHERE objid = '$h->{'objid'}' AND fieldname = 'alttitle' AND language = '$om_render_lang' AND status = '15000-A'";
            $numRows = &query($q, $dbh, \@res);
            if ($debug) {
               print ERLOG "$q\n";
            }
            if ($numRows == 0) {
               $cdate = $mdate = time();
               $q="INSERT INTO extraprop (objid,fieldname, body, language, cdate, mdate, status) ";
               $q.=" VALUES ('$h->{'objid'}','alttitle', '$h->{'alttitle_inp'}', '$om_render_lang', $cdate, $mdate, '15000-A')\n";
               if ($debug) {
                  print ERLOG "$q\n";
               }
               $numRows = &query($q, $dbh, \@res);
            }
         }
      }
   }
   
   
   $h=&loadlinktohash( $h->{'objid'} );
   
   return $h;
} #/writelink

############################################################################
# PURPOSE    To insert a new row into the linkage table.  It is known at
#            time of calling this routine that an insert is necessary
#
# INPUT      $h - hashref of the new row to insert into the table
#
# OUTPUT     $h - hashref of the newly updated record after insertion
#
# NOTES
############################################################################
sub insertLink {
   my ($h) = $_[0];
   
   $dvalue=$h->{'obj1_inp'}."\t".$h->{'obj2_inp'};

   if ( $site->{'site_datadriver'} =~ /Oracle/ ) {

      $q="INSERT INTO levents (event,dtable,dvalue,cdate,series) VALUES ";
      $q.=" (levents_event.nextval,'linkage','$dvalue','$t','$site->{'series'}') ";
#      $dbh->do($q);
      $sth=$dbh->prepare($q);
      $sth->execute;

      $q="SELECT levents_event.currval FROM DUAL";
      $sts=$dbh->prepare($q);
      $sts->execute;
      $event=$sts->fetchrow;

      $q="SELECT series from levents where dtable='linkage' ";
      $q.= " AND dvalue='$dvalue' AND cdate='$t' ";
      $sts=$dbh->prepare($q);
      $sts->execute;
      ($series)=$sts->fetchrow;
      $objid=$event."-"."AA";   

   } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {

      $p="INSERT INTO levents (dtable,dvalue,cdate,series) VALUES('linkage','$dvalue','$t','$site->{'series'}') ";
      if ($debug) {
         print ERLOG "$p\n";
      }
      $stp=$dbh->prepare( $p );
      $stp->execute;
      $e="SELECT event,series FROM levents WHERE dtable='linkage' AND ";
      $e.=" dvalue='$dvalue' AND cdate='$t' ";
      $ste=$dbh->prepare($e);
      $ste->execute;
      ($event, $series) = $ste->fetchrow;
      $objid=$event."-".$series;
  
   } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

      $p="INSERT INTO levents (event,dtable,dvalue,cdate,series) VALUES(NEXTVAL('event'),'linkage','$dvalue','$t','$site->{'series'}') ";
      if ($debug) {
         print ERLOG "$p\n";
      }
      $stp=$dbh->prepare( $p );
      $stp->execute;
      $e="SELECT CURRVAL('event'),series FROM levents WHERE dtable='linkage' AND ";
      $e.=" dvalue='$dvalue' AND cdate='$t' ";
      $ste=$dbh->prepare($e);
      $ste->execute;
      ($event, $series) = $ste->fetchrow;
      $objid=$event."-".$series;

   }
 
   # added status to the query
   $q="INSERT INTO linkage (objid,obj1,obj2,linkwt_man,cellstyle,celldepth,cdate,mdate,status) ";
   $q.=" VALUES ('$objid','$h->{'obj1_inp'}','$h->{'obj2_inp'}','$h->{'linkwt_man_inp'}', ";
   $q.="'$h->{'cellstyle_inp'}','$h->{'celldepth_inp'}','$t','$t','15000-A') ";
   if ($debug) {
      print ERLOG "$q\n";
   }
   $sti=$dbh->prepare( $q );
   $sti->execute;
   $h->{'objid'}=$objid;
   $sti->finish;
   
   # Insert the alternate title if one is set
   if ($debug) {
      print ERLOG "ALTTITLE IS $h->{'alttitle_inp'}!\n";
   }
   if ($h->{'alttitle_inp'} ne '') {
      $cdate = $mdate = time();
      $h->{'alttitle_inp'} = string_todbi($h->{'alttitle_inp'});
      $q="INSERT INTO extraprop (objid,fieldname, body, language, cdate, mdate, status) ";
      $q.=" VALUES ('$objid','alttitle', '$h->{'alttitle_inp'}', '$om_render_lang', $cdate, $mdate, '15000-A')\n";
      if ($debug) {
         print ERLOG "$q\n";
      }
      $sti=$dbh->prepare( $q );
      $sti->execute;
      $sti->finish;
   }
   return $h;
}

############################################################################
# PURPOSE      check for passable values of LNKWEIGHT
#
# INPUT        $h - hashref of a linkage row
#
# OUTPUT       $h - hashref of the updated linkage row, with the
#               weight_man from things set in the linkwt_man field if
#               the linkwt_man was not set.
#
# NOTES        This might supposed to inherit the cellstyle as well,
#              although it does not do this!
############################################################################
sub inheritValues {
   my ($h) = $_[0];
   
   if ( ! $h->{'linkwt_man_inp'} ) {
      $q="SELECT objid,weight_man FROM things WHERE objid=";
      $q.="'$h->{'obj2_inp'}'";
      if ($debug) {
         print ERLOG "$q\n";
      }
      $sti = $dbh->prepare( $q );
      $sti->execute;
      $q=$sti->{'errstr'};
#      $x = $sti->rows;
      
#      if ( $x == 1 ) {
#         ( $k,$v ) = $sti->fetchrow;
      if ( ( $k,$v ) = $sti->fetchrow ) {
         $h->{'linkwt_man_inp'}=$v;
         $h->{'linkwt_man_ini'}="" if ( ! $h->{'linkwt_man_ini'} );
      } # else wrong number of rows...
      
   } # end of evaluation of value of LNKWEIGHT
   
   # now check the cellwidth entry...
   ( $v ) = ( split /_/, $h->{'cellstyle_inp'} )[1];
   
   return $h;
}

############################################################################
# PURPOSE      Load a link to the hash for a specified objid from the tables
#
# INPUT        $objid - objid of the linkage record to load to a hash
#
# OUTPUT       $h - hashref of the rows data from the tables
#
# NOTES
############################################################################
sub loadlinktohash {
   my ($objid)=$_[0];
   my($h,$sti,$q);
   
   $h={};
   
   if ( $objid ) {
      #  Changed status check
      $q="SELECT * FROM linkage WHERE objid='$objid' AND status = '15000-A'";
      if ($debug) {
         print ERLOG "$q\n";
      }
      $sti = $dbh->prepare( $q );
      $sti->execute;
      if ($debug) {
         print ERLOG "$q \n";
      }
#      if ( $sti->rows == 1 ) {
#         $h=$sti->fetchrow_hashref;
      if ( $h=$sti->fetchrow_hashref(NAME_lc) ) {    
         $h->{'objid'}=$objid;
         $q = "SELECT body FROM extraprop WHERE objid = '$h->{'objid'}' AND fieldname = 'alttitle' AND language = '$om_render_lang' AND status = '15000-A'";
         if ($debug) {
            print ERLOG "$q\n\n";
         }
         
         $sti = $dbh->prepare( $q );
         $sti->execute;
#         if ($sti->rows == 1) {
#            $alt = $sti->fetchrow_hashref;
         if ( $alt=$sti->fetchrow_hashref(NAME_lc) ) { 
            $h->{'alttitle_pre'} = $alt->{'body'};
         }
         
         
         ## now load the default title,weight...
         # Start variant support
         # Use get_fields_and_title from the variant.pm library, as variants require a lot of work to get the title
         
	 $res = &get_fields_and_title("weight_man","",$h->{'obj2'},$dbh, "");
         if ($res) {
            $h->{'title'} = $res->{'title'};
            $h->{'weight_man'} = $res->{'weight_man'};
         } # end of variant support
         if ($debug) {
            print ERLOG "Set $res->{'title'} AND $res->{'weight_man'} for linkages!\n";
         }
         
         @temp = keys %{$h};
         while ( @temp ) {
            $k = shift @temp;
            $v = string_exdbi($h->{$k});
            $kp=$k."_pre";
            $kn=$k."_ini";
            $ki=$k."_inp";
            $h->{$k}=$v;
            $h->{$kp}=$v;
            $h->{$kn}=$v;
            $h->{$ki}=$v;
         } # done permuting fieldnames
      } # done loading if one record
      $sti->finish;
   } # done acting on good rowid
   
   return $h;
} #/loadlinktohash

############################################################################
# PURPOSE     Moves _inp to _pre values
#
# INPUT       $h - hashref for a row
#
# OUTPUT      $h - hashref with the _pre values set
#
# NOTES       Could be moved to a library routine, as this is also in
#             other adminstrator CGI scripts
############################################################################
sub agelink {
   my ($h) = $_[0];
   my(@temp,$k,$v);
   
   #    @temp = sort keys %{$h};
   #    @temp = keys %{$h};
   foreach $k (keys %{$h}) {
      next if ( $k !~ /_inp/ );   # only want input values
      $v =  $h->{$k} ;
      $k2 = $k;
      $k2 =~ s/_inp/_pre/ ;
      if ( $v ) {
         $h->{$k2}=$v
      }
   }
   return $h;
} #/agelink

############################################################################
# PURPOSE      Makes title and alttitle keys html-safe, catching key perl
#              variables, such as ', $ ...
#
# INPUT        $h - hashref to a linkage row
#
# OUTPUT       $h - hashref to the linkage row with safe title and alttitle
#
# NOTES
############################################################################
sub linksafehtml {
   my($h,@temp,$k,$v);
   $h = @_[0];
   @temp = sort keys %{$h};
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      next if ( $k !~ /(title|alttitle)/ );   # only want titles
      $h->{$k} = string_tohtml( $h->{$k} ) ;
   }
   return $h;
} #/linksafehtml

############################################################################
# PURPOSE      Loads objects data to NVP
#
# INPUT        $sku - objid to load to NVP hash
#
# OUTPUT       updated NVP with the row's data loaded in
#
# NOTES        Never returns 0, so return of 1 is not really necessary!
############################################################################
sub loadskutonvp {
   my($h,$k,@temp,$k2,$sku);
   $sku=$_[0];
   
   ## load parent sku's data from db
   #
   $h = {};
   $h=loadskutohash( $sku );
   
   @temp = keys %{$h};
   while (@temp) {
      $k = shift @temp;
      $NVP{$k} = $h->{$k};
      $k2=$k."_pre";
      $NVP{$k2} = $h->{$k};
      $k2=$k."_ini";
      $NVP{$k2} = $h->{$k};
   }
   ## special cases
   #
   $NVP{'lengthdescr'}=length($NVP{'descript'});
   $NVP{'lengthdescr'}.=" Characters";
   
   return 1;
} #/loadskutonvp

############################################################################
# PURPOSE      To get the text representation for the value of pagestyle
#              that is retreived from the database
#
# INPUT        $db_pagestyle - the db value stored for the pagestyle
#
# OUTPUT       $val - the text representation for db_pagestyle, or 
#                     $script_msg{NO_PAGESTYLE} if no pagestyle defined
#
# NOTES       
############################################################################
sub getPageStyleText {
    my ($db_pagestyle) = @_;

    my (@raw, $row, $code, $val);

    if ($debug) {
	print ERLOG "IN getPageStyleText with $db_pagestyle, looking for sel_pagestyle.sel in $selskeletonpath\n";
    }
    $db_pagestyle = string_exdbi($db_pagestyle);
    open(PSFH, "<$selskeletonpath/sel/sel_pagestyle.sel");
    @raw=<PSFH>;
    chomp @raw;
    close(PSFH);
    
    print ERLOG "@raw is $#raw values long!\n";
    foreach $row (@raw) {
	($code, $val) = split /\|/, $row;
	if ($debug) {
	    print ERLOG "code is $code, val is $val, pagestyle is $db_pagestyle\n";
	}
	if ($code eq $db_pagestyle) {
	    return $val
	}
    }

    return ($script_msg{NO_PAGESTYLE});
}

############################################################################
# PURPOSE     To load in the messages to support multi-language
#
# INPUT       none
#
# OUTPUT      global hash script_msg holding all of the messages that
#             need to be used in the script
#
# NOTES       This would be much more readable throughout the code
#             if we used english STRINGS to reference the hash that
#             are meaningful, vs using just numbers
############################################################################
sub message {
   if ($debug) {
      print ERLOG " IN message................... \n";
   }
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{INVALID_OBJ}="Nothing found!  Please try another search";
      $script_msg{NO_OBJ}="You must specify an object to link to!";
      $script_msg{NO_ALT_FOR_VARIANT}="You cannot enter an alternate title for a variant product";
      $script_msg{NO_PAGESTYLE}="not defined for this Object ID";
      $script_msg{ALREADY_LINKED}="is already linked!";
      $script_msg{ERROR} = "Error -";
      $script_msg{OBJECT} = "Object";
      } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}


1;
