#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# login.cgi
# user login/logout validation script
#
# written on 981022 RF 
#####

####
#       
# Version 0.7.27 JC 20001003
#    secure sid
# Version 0.7.26 JC 20000913
#    oracle port
# Version 0.7.25 JC 20000807
#    added case sensitive login/passwd check
# Version 0.7.24 JC 20000717
#    removed multilingual select for next version 
#    $om_render_language->$om_render_lang
# Version 0.7.23 JC 20000706
#    added multilingual select
# Version 0.7.22 IB 20000608
#    language and interface from table 'sessions'
# Version 0.7.21 IB 20000531
#    added custom-lib.pm
# Version 0.7.20 GF 20000522
#    retrofit of templates for allcommerce
#    added objclass and objtype
#    repaired query for session update
# Version 0.7.18 IB 20000409
#    determine the language
# Version 0.7.17 JC 20000407
#    added message subroutine
# Version 0.7.16 IB 20000402
#    new directory structure
# Version 0.7.15 JC 20000330
#    changed connect statement
# Version 0.7.14 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.13 IB 20000327
#    corrected $relpath
# Version 0.7.12 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.11 IB 20000302
#    updated copyright
# Version 0.7.10 IB 20000228
#    changed store to site
# Version 0.7.9 20000117 GF
#    replace calls to newsid with setsessionid   
#    remove error logging
# Version 0.7.8 991210 GF
#    added in om_version detection
# Version 0.7.7 991126 IB
#    fixed script version number
# Version 0.7.6 991124 IB
#    corrected database call
# Version 0.7.5 991121 IB
#    corrected bits/sel to bits/site/sel
# Version 0.7.4 991112 IB
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.3 991108 IB
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 991103 IB
#    general cleanup
# Version 7 990617 GF
#    fixed to work with system 6 file system 
####

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/conversions.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/blowfisher.pm"; 

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## get form data, if any was submitted
#
%FORM=();
&ReadParse();

## connect to database
#
$q = "$site->{'db_site_config'}"; 
$dbc = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'}); 

$om_render_lang = "";
$interface = "";

$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );
#$sid_jon=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );
$sid_jon=$FORM{'sid'};
$FORM{'sid'}=string_todbi($FORM{'sid'});
#$sid_jon=10;
if ($FORM{'sid'}) {
#   $q="SELECT language,interface from sessions where sid='$sid_jon' ";
$q="SELECT language,interface from sessions where sid='$FORM{'sid'}' ";
   $sts = $dbc->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

## language pull down
#

#@langs = split /\,/, $site->{'om_locale_lang_act'};
#push @langs, $site->{'om_locale_lang_def'};

#foreach $lang (@langs) {
#   next if ( ! $lang);
#   $result=&om_iso_639($lang);
#   $longlang=(split/\t/, $result)[3]; 
#   push @langlist, "$lang|$longlang";
#}

#$language_select = gen_select( "$site->{'om_locale_lang_def'}",2,@langlist );
 
## load messages
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;

## strip get stuff
#
$x=(split /\?/, $ENV{'REQUEST_URI'})[0]; 
@temp=split /\//, $x;
@temp=("cgi-bin","test","login.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/site/sel";

## filled in with time/context variable info
#
$nicedt=nicedatetime();
$timenow=time();

## construct some shorthands
#
$script_html = join "-", ($site->{'siteshortname'},$script,"");
$skeltarg = $script_html;
$skeltarg="os_allcommerce-login-";

## initial population of %NVP
#
%NVP=();
$NVP{'datetime'}=$nicedt;
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'scriptpath'}="$scriptpath";
$NVP{'script_version'}=$script_version;
$NVP{'cookie'}=$ENV{'HTTP_COOKIE'};
$NVP{'sitename'}=$site->{'sitename'};
$NVP{'om_version'}=$site->{'om_version'};
#$NVP{'language_select'}=$language_select;

$FORM{'mode'}="login" if (! $FORM{'mode'} );


## check to see that there is a cookie or session ID
#
if (! $FORM{'sid'} ) {
  $sid=setsessionid();
   }

   ## this script always dumps to html 
   #
   print "Content-type: text/html\n\n";

 
                                     # validate session 
                                     # if not, new

   if ( $FORM{'mode'} != /^(submitlogin|login)/ ) {
      $FORM{'sid_ok'}=check_login($script,$FORM{'mode'},$FORM{'sid'});

    } else {
      $FORM{'sid_ok'}="yes";
    }

if ( $FORM{'mode'} eq "submitlogin" ) {         # preprocessing data
                                                # login attempt, 
                                                # check submitted information
   ## see if this user is in contacts
   #
   $q = "SELECT objid,uname,passwd,mdate from contacts where ";
   $q.= "passwd='$FORM{'passwd_inp'}' and ";
   $q.= " uname='$FORM{'uid_inp'}' and objclass='128-A' ";
   $q.= " and objtype='39004-A' and status='15000-A' ";
   $sti = $dbc->prepare( $q );
   $sti->execute;
#   $num=$sti->rows;

   ## case sensitive
   #
#   if ( $num==1 ) {
#      ($objid,$uname,$passwd,$mdate)=$sti->fetchrow; 
   if ( ($objid,$uname,$passwd,$mdate)=$sti->fetchrow ) {  
      if ( ( $uname eq $FORM{'uid_inp'} ) && ( $passwd eq $FORM{'passwd_inp'} ) ) {
         ## case sentive check ok 
         $num=1;
      } else {
         $num=0;
      } 
   }

   if ( $num==1 ) {                             #  Successful login!

      ## get language from select
      #
      $lng=$FORM{'lang'};

      ## now update sessions
      #
      $q = "UPDATE sessions SET custid='$objid',mdate='$timenow',language='$lng' where"; 
      $q.= " sid=$FORM{'sid'}";
      $sti = $dbc->do( $q );

      ## now update the last login data
      #
      $q = "UPDATE contacts SET mdate='$timenow' where ";
      $q.= "passwd=('$FORM{'passwd_inp'}') and ";
      $q.= " uname='$FORM{'uid_inp'}' and objclass='128-A' and ";
      $q.= " objtype='39004-A'";
      $sti = $dbc->do( $q );

      $FORM{'mode'} = "main";

   } else {                                     # not a valid login

      $NVP{'uid_err'}=$script_msg{1};
      $NVP{'uid_pre'}=$FORM{'uid_inp'};
      $NVP{'PAGE_ERROR_MSG'}=$script_msg{2};
      $FORM{'mode'} = "login";
   }

}


################################
## Mode Display Handling
#

if (($FORM{'sid_ok'} =~ /^ERROR/i ) or ($FORM{'mode'} eq "login") or (!$FORM{'mode'})) {
   ## bad session id, display login box again
   #
   $target=$skeltarg."login";
   $l=loadtemplate( $target, $skeletonpath );
   $l=permutebit( $l, \%NVP );
   $l=permuteclean( $l );
   print "$l";
 
} else {
   ## we know the person is logged in. Present "where to?" screen
   #  as a default, otherwise act according to the mode FORM value
   #
   if ( $FORM{'mode'} eq "logout" ) {
      ## show length of time logged in
      #

      ## prime variables
      #
   
      ## display "You logged out" page     
      #
      $target=$skeltarg."logout";

      $l=loadtemplate($target, $skeletonpath);
      $l=permutebit( $l, \%NVP );
      $l=permuteclean( $l ); 
      print "$l";
      # /logout mode

   } elsif ( $FORM{'mode'} eq "changepass" ) {

   } elsif ( $FORM{'mode'} eq "adminuser" ) {

   } elsif ( $FORM{'mode'} eq "main" ) {

      $target=$skeltarg."main";
      $l=loadtemplate( $target, $skeletonpath );
      $l=permutebit( $l, \%NVP );
      $l=permuteclean( $l );
      print "$l";

   } else {
      # default mode

   }

} # /display mode actions

$sts->finish;
$dbc->disconnect if ( $dbc );

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below

   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="This username is not valid with this password";
      $script_msg{2}="Bad Login Attempt! User Name/Password combo invalid!";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$scriptname.$om_render_lang.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}    

1;
