#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# order.cgi
#
# Version 0.9.39 JC  20001006
#    changed error message setup
#    set shipcost to zero for void
# Version 0.9.38 JC  20001005
#    fixed shipping address
# Version 0.9.37 JC  20001004
#    fixed shiptotal issue 
#    put in error message for blank shipping address
# Version 0.9.36 JC  20001003
#    secure sid
# Version 0.9.35 LCF 20001002
#	 needed to void shipping total for voided orders
# Version 0.9.34 JC 20001001
#    revision to new business model
# Version 0.9.33 IB 20000929
#    fixed quanitity->quantity
# Version 0.9.31 LCF 20000926
#    fixed incorrect quantity check
# Version 0.9.30 LCF 20000925
#    fixed bugs with subtotals and taxes (nicedecimals-related)
# Version 0.9.29 TG 20000925
#    Fixed order subtotal to use calculated value, not from database. 
#    NOTE: Calculated value of st_taxable has a max of 99999.99, and if
#          higher, it will store the max (99999.99)
#    - Allow refund of full number, just 33 vs 33.00
# Version 0.9.28 LCF 20000921
#    fixed refund bugs
# Version 0.9.26 JC 20000913
#    oracle port
# Version 0.9.25 JC 20000831
#    fixed error message
# Version 0.9.24 JC 20000816
#    fixed wh bug
# Version 0.9.23 JC 20000807
#    fixed misc bugs
# Version 0.9.22 JC 20000728
#    added in phone entries
#    select out in searchlist "in checkout" orders
# Version 0.9.21 JC 20000727
#    fixed refund error
# Version 0.9.20 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.27 IB 20000420
#    insert->INSERT, set->SET
# Version 0.7.27 JC 20000411
#    $om_render_lang update
# Version 0.7.26 JC 20000410
#    multilingual messages
# Version 0.7.25 IB 20000402
#    new directory structure
# Version 0.7.24 JC 20000330
#    changed connect statement
# Version 0.7.23 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.22 IB 20000327
#    corrected $relpath
# Version 0.7.21 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.20 IB 20000302
#    updated copyright
# Version 0.7.19 IB 20000228
#    changed store to site
# Version 0.7.18 JZ 20000224
#    Add funciton to show order, change SHIPSTATUS to ORDERSTATUS 
# Version 0.7.17 JZ 20000216
#    Add cancellation of order, replace html with templates
# Version 0.7.16 JZ 20000210
#    show address and credit card information
# Version 0.7.15 JZ 20000117
#    removed CALLSTATUS
# Version 0.7.14 JZ 20000114
#    fixed shipping and call information
# Version 0.7.13 JZ 20000112
#    fixed searching date validation err msg
# Version 0.7.12 JZ 20000108
#    fixed finding problem
#    add validation check of date format
# Version 0.7.11 IB 991205
#    replaced exmysql with exdbi
# Version 0.7.10 IB 991203
#    Corrected om directory
# Version 0.7.9 IB 991202
#    fixing of global variables
# Version 0.7.8 IB 991126
#    fixing of a comment statement
# Version 0.7.7 IB 991121
#    corrected bits/sel to bits/site/sel
# Version 0.7.6 IB 991112
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.5 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.4 IB 991103
#    general cleanup
# Version 0.7.3 RF 990908
#    changed embeded html bits to utilize $script instead of hard paths
# version 0.7.2 SH 990831
#    added in vcode display from myhome
#    fix weird bug where i had to substr selects but no more   
# SH Major Version whatever many many many rewrites 
# SH will fill in later what i did
#

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/blowfisher.pm";

## establish site-specific parameters
#
$site=setsite();

## get the CGI bits
#
%FORM=();
&ReadParse;

## connect to database
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'}); 

$om_render_lang = "";
# $interface = "";

$FORM{'sid'}=&os_unhash(pack(H16,$FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
#  $interface=$h->{'interface'};
   $sts->finish;
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
   
$sid = $FORM{'sid'};
$sid_encrypt=unpack(H16, &os_hash($sid, $site->{'hash_key'}));
                                              
## load messages
#
$verbose_errors=1;
%script_msg=();          # user interaction messages
%script_err=();
$script=( split /\./, $scriptname )[0];
&message; 
&hardcodes;

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","order.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );
$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

$now=time();

## construct some shorthands
$script_html = join "-", ($site->{'siteshortname'},$script,"");

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};
$NVP{'currency_symbol'}=$site->{'currency_symbol'};  
$spine=loadtemplate("os_allcommerce-order-spine",$skeletonpath);  
foreach ( 'sel_orderstatus|2', 'sel_warehouse|2') {
   local($k,$v,$x,@raw);
   ( $k,$v) = split /\|/, $_;
   open(FH, "<$selskeletonpath/$k.sel");
   @raw=<FH>;
   chomp @raw;
   close(FH);
   $x=$k."_inp";;
   $kt=$k."_select";
   $NVP{$kt}= gen_select( "",$v,@raw );
}

open(WH, "<$selskeletonpath/sel_warehouse.sel");
@raw=<WH>;
close(WH);
$wh = (split /\|/, $raw[1])[1];
$wh = (split /\|/, $raw[0])[1] if ( ! $wh );

if (! $FORM{'mode'}) {
   $FORM{'mode'}="home";
}

$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
      exit 0;
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'page_error_msg'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";

} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HREAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

## get values from cookie and script above and put them in NVP hash
#

$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

# check to see if the homepage is simply clearing the form
if (($FORM{'searchclear'}) and ($FORM{'mode'} eq "find")) {
   $FORM{'mode'}="home";
} #

## determine which mode needs to be rendered
#
#     valid modes are home,find,showorder,update,searchlist,and stats 
#
#     home is starting page
#     find is used internally to determine mode
#     showorder will display order and allow update
#     update is used internally to update tables
#     searchlist is used determine which order you want
#     stats is summary information of orders

## query using start date, end date, order status, warehouse, and/or order #
# 
#     order of query through tables should be "orders","ocart",and "levents"

$FORM{'activity'} =~ s/\"//g;
$FORM{'ship'} =~ s/\"//g;  

if ($FORM{'mode'} eq "find" ) {

   $FORM{'mode'}="home";
   chomp $FORM{'orderstatus'} if $FORM{'orderstatus'};  # get order status if any
   chomp $FORM{'warehouse'} if $FORM{'warehouse'};  # get warehouse if any
   $FORM{'orderstatus'} =~ s/\"//g;
   $FORM{'warehouse'} =~ s/\"//g;
   $orderid_pre = '';
   if ($FORM{'orderid'}) {     # get order id                
      $orderid_pre = $FORM{'orderid'};  
      $FORM{'orderid'} =~ s/\s//g; 
      $FORM{'orderid'} =~ s/'/''/g; 
      $FORM{'orderid'} =~ s/\\/\\\\/g;
   }
   $FORM{'startdate'} =~ s/\s*//g if $FORM{'startdate'}; # get start date 
   $FORM{'enddate'} =~ s/\s*//g if $FORM{'enddate'}; # get enddate
   $dateflag = 0;
   $x = 0;
   $nodate=0;

   ## check for valid start and end dates
   #
   if ($FORM{'startdate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/ && $FORM{'enddate'} =~ /^\d{1,2}\/\d{1,2}\/\d{4}$/) {
      @start= split /\//, $FORM{'startdate'};
      @end= split /\//, $FORM{'enddate'};
      if ($start[0] > 12 || $start[1] > 31 || $end[0] > 12 || $end[1] > 31) {
         $NVP{'page_error_msg'} = "$script_msg{10}";
      } elsif ( $start[0] == 2 && $start[1] > 29 || $end[0] == 2 && $end[1] > 29 ) {
         $NVP{'page_error_msg'} = "$script_msg{10}";
      } elsif ( $start[0] == 4 && $start[1] > 30 || $end[0] == 4 && $end[1] > 30 || $start[0] == 6 && $start[1] > 30 || $end[0] == 6 && $end[1] > 30 || $start[0] == 9 && $start[1] > 30 || $end[0] == 9 && $end[1] > 30 || $start[0] == 11 && $start[1] > 30 || $end[0] == 11 && $end[1] > 30  ) { 
         $NVP{'page_error_msg'} = "$script_msg{10}";
      } else { 
         use Time::Local;
         $starttime=timelocal(0,0,0, $start[1], $start[0]-1, $start[2]);
         $endtime=timelocal(59,59,23, $end[1], $end[0]-1, $end[2]);
         $now = time();
         if ($starttime == -1 || $endtime == -1) {
            $NVP{'page_error_msg'} = "$script_msg{11}";
         } elsif ($starttime > $endtime) {
            $NVP{'page_error_msg'} = "$script_msg{12}";     
         } elsif ($starttime > $now) {
            $NVP{'page_error_msg'} = "$script_msg{13}";
         } else { $dateflag = 1;}
      }
   }  elsif ( !$FORM{'enddate'} && !$FORM{'startdate'}) {
      $nodate=1;
      if (!$FORM{'callstatus'} && !$FORM{'orderstatus'} && !length($FORM{'orderid'}) && !$FORM{'warehouse'} && !$FORM{'custname'} ) {
         $NVP{'page_error_msg'} = "$script_msg{14}";
      } else { 
         $x = 1;
      }
   } elsif ( !$FORM{'enddate'} || !$FORM{'startdate'}) {
      $NVP{'page_error_msg'} = "$script_msg{15}";
   } else {
      $NVP{'page_error_msg'} = "$script_msg{16}";
   }

   ## inital query to determine which path to take 
   #
   if ($x || $dateflag ) {
      $query = "SELECT objid,custid,sid,status,cdate,shipto from orders where objid LIKE '%'"; 
      if ( length($FORM{'orderid'}) > 0 ) {
         $query .=" AND objid='$FORM{'orderid'}' ";
      } elsif ($dateflag) {
         $query .=" AND cdate >= '$starttime' AND cdate <= '$endtime'"; 
         $flag = 1;
      }
      if ( $FORM{'orderstatus'} && !$FORM{'orderid'}) { 
         $query.=" AND status='$FORM{'orderstatus'}'"; 
         $flag = 1;
      } 
      if ( $FORM{'warehouse'} && !$FORM{'orderid'} ) {
         $query.=""; 
      }
      $query .=" AND status!='15012-A'";
      $query .=" ORDER BY cdate";

      $sth = $dbh->prepare($query);
      $sth->execute;
#     $num = $sth->rows;

      $num=0;
      while ( $rwh = $sth->fetchrow_hashref(NAME_lc) ) {
         $num++;
      }
      $sth = $dbh->prepare($query);
      $sth->execute;  

      if ( $num < 1 ) {
         # the query returned nothing
   	  
         $FORM{'mode'}='home';
   
         # push error message into page error message 
         $NVP{'page_error_msg'} = "$script_msg{17}";
         $NVP{'orderid_prev'}="";
         $NVP{'startdate_prev'}="";
         $NVP{'enddate_prev'}="";
         $NVP{'orderstatus_prev'}="";
         $NVP{'custname_prev'}="";   
      } elsif ( $num==1 ) {
         # exactly one row returned
         # --> send directly to appropriate editor routine
   	 $FORM{'mode'}="showorder";      
         $FORM{'loadfrom'}="db";    
         $FORM{'query'}=$query;
         $NVP{'orderid_prev'}=$orderid_pre;
      } else {
         $FORM{'mode'}="searchlist";
         $FORM{'query'}=$query if ( $query );
      }

         $sth->finish;

   } else {
      $FORM{'mode'}="home";
      $NVP{'orderid_prev'}="";
      $NVP{'startdate_prev'}="";
      $NVP{'enddate_prev'}="";
      $NVP{'custname_prev'}=""; 
   }

} 
## need stats/summary instead of order info
#
if ($FORM{'stats'} eq "yes" && ( $dateflag == 1 || $nodate == 1 )) {
   $FORM{'mode'}="stats";
} elsif ( $FORM{'stats'} eq "yes" && $dateflag == 0 && $nodate == 0 ) {
   $FORM{'mode'}="home";
   $NVP{'orderid_prev'}="";
   $NVP{'startdate_prev'}="";
   $NVP{'enddate_prev'}="";
   $NVP{'custname_prev'}=""; 
}
## update info
#
if ($FORM{'mode'} eq "update" ) {
   # handle shipped, remove, update QTY, return, reship information
   $update=0; 


$FORM{'mode'}="showorder";

   ## get old information from the update
   #
   $orderid = $FORM{'orderid'};
   $sid = $FORM{'sid'};
   $custid = $FORM{'custid'};

   ## get new information from the update
   #

   $uname=$FORM{'uname'};
   $address1=$FORM{'address1'};
   $address2=$FORM{'address2'};
   $city=$FORM{'city'};
   $state=$FORM{'state'};
   $postcode=$FORM{'postcode'};
   $refund=$FORM{'refund'};
   $activity=$FORM{'activity'};
   $ship=$FORM{'ship'};
   $phone=$FORM{'phone'};
 
   ## general orders query
   #
   $query = "SELECT status,custid,shipto FROM orders WHERE objid='$orderid'";
   $sth = $dbh->prepare($query);
   $sth->execute;
   ($orderst,$custid,$shipto) = $sth->fetchrow_array;

$noaddress="no";
if ( ! $uname || ! $address1 || ! $city || ! $state || ! $postcode || ! $phone ) {
   $NVP{'page_error_msg'} = "You did not fill out all of the shipping address information below.";
   $noaddress="yes";
} elsif
 ( length($uname) < 5 ) {
   $NVP{'page_error_msg'} = "The name length is too short.";
   $noaddress="yes";
} elsif 
 ( length($postcode) < 5 ) {
   $NVP{'page_error_msg'} = "The zipcode length is too short.";
   $noaddress="yes";
} elsif 
 ( $postcode =~ /[a-zA-Z]/ ) {
   $NVP{'page_error_msg'} = "The zipcode must only contain numbers.";
   $noaddress="yes";
}

if ( $orderst eq "15012-A" ) { 
   $NVP{'page_error_msg'} = "You can not edit an order while still in checkout"; 
}

if ( $activity eq "15027-A" ) {

   $NVP{'page_error_msg'} = "The order status you selected is currently unavailable, the selection will be available in the next release";

} elsif ( ( $orderst ne "15020-A" || $activity ne "15020-A" ) && $orderst ne "15012-A") { 
   ## do they need to have a refund
   #
      ## see if we need to change shipping address 
      #
      $add2="";
      $query = "SELECT name,address1,address2,city,state,postcode,dayphone FROM addresses WHERE objid='$shipto'";
      $sth = $dbh->prepare($query);
      $sth->execute;
      ($nm,$add1,$add2,$cy,$st,$zipcode,$ph) = $sth->fetchrow_array;
      $uname =~ s/\s$//g;
      $uname =~ s/\s/\|/;
      $uname = $uname."\|";   
      $phone =~ s/\-//g;
      if ( ($nm ne $uname || $add1 ne $address1 || $add2 ne $address2 || $cy ne $city || $st ne $state || $zipcode ne $postcode || $ph ne $phone) && $noaddress eq "no" ) {

         $dvalue=$FORM{'sid'}."\tCreate AddressID";

         if ( $site->{'site_datadriver'} =~ /Oracle/ ) {

            $q="INSERT into levents (event,dtable,dvalue,cdate,custid,series) values ";
            $q.=" (levents_event.nextval,'addresses','$dvalue','$now','$custid','$site->{'series'}') ";
#            $dbh->do($q);
            $sts=$dbh->prepare($q);
            $sts->execute;
            $q="SELECT levents_event.currval FROM DUAL";
            $sts=$dbh->prepare($q);
            $sts->execute;
            $event=$sts->fetchrow;
            $addrid=$event."-".$site->{'series'}; 

         } elsif ( $site->{'site_datadriver'} =~ /mysql/ ) {

         $query="INSERT into levents (dtable, dvalue, cdate, custid) values('addresses','$dvalue','$now','$custid')";
         $sth=$dbh->prepare($query);
         $sth->execute;

         $query="SELECT event, series FROM levents WHERE dtable='addresses' AND dvalue='$dvalue' AND cdate='$now' ORDER BY event";
         $sth=$dbh->prepare($query);
         $sth->execute;
         #$numh=$sth->rows;
         ($event, $series)=$sth->fetchrow;
         $addrid=$event."-".$site->{'series'}; 

         } elsif ( $site->{'site_datadriver'} =~ /Pg/ ) {

         $query="INSERT into levents (event,dtable, dvalue, cdate, custid) values(NEXTVAL('event'),'addresses','$dvalue','$now','$custid')";
         $sth=$dbh->prepare($query);
         $sth->execute;

         $query="SELECT CURRVAL('event'), series FROM levents WHERE dtable='addresses' AND dvalue='$dvalue' AND cdate='$now' ORDER BY event";
         $sth=$dbh->prepare($query);
         $sth->execute;
         #$numh=$sth->rows;
         ($event, $series)=$sth->fetchrow;
         $addrid=$event."-".$site->{'series'};

         }
 
         $q="INSERT INTO addresses ";
         $q.=" (objid,custid,name,address1,address2,city,state,";
         $q.="postcode,dayphone,cdate,mdate) ";
         $q.="VALUES ('$addrid','$custid','$uname','$address1','$address2','$city','$state','$postcode','$phone','$now','$now')"; 
         $sth=$dbh->prepare($q);
         $sth->execute;

         $query = "UPDATE orders SET shipto='$addrid' WHERE objid='$orderid'";
         $sth = $dbh->prepare($query);
         $sth->execute;  
      }

      $query = "SELECT st_taxable,st_nontax from orders WHERE objid='$orderid'";
      $sth = $dbh->prepare($query);
      $sth->execute;
      ($taxed,$notaxed) = $sth->fetchrow;
      $oldtotal=nicedecimals($taxed + $notaxed);   

      ## need to find out how many line items are in ocart that is not shipping (140-A)
      #
      $query = "SELECT lineobjid from ocart WHERE orderid='$orderid' AND objclass!='140-A'";
      $sth = $dbh->prepare($query);
      $sth->execute;
#      $num = $sth->rows;
      ## run through each line item and change quanity if needed
      #
#      for (1..$num) {
#         $lineobjid = $sth->fetchrow;
      $currdiff=0;
      while ( $lineobjid = $sth->fetchrow ) { 

         $qt="qty"."$lineobjid";
         $qty  = $FORM{$qt};

         $query = "SELECT quant,unitpr from ocart WHERE orderid='$orderid' AND lineobjid='$lineobjid' AND objclass != '140-A'";
         $stl = $dbh->prepare($query);
         $stl->execute;
         ($quant,$unitpr) = $stl->fetchrow;

         if ( $qty > -1  && $qty =~ /^\d+$/ ) {
            if ( $quant ne $qty ) {
               $linetotal=$qty * $unitpr;
               $oldlinetotal=$quant * $unitpr;
               $diff=$linetotal - $oldlinetotal;
               $newtotal=nicedecimals($diff + $oldtotal + $currdiff); 
               if ( $linetotal > 99999.99 || $newtotal > 99999.99 ) {
                  $NVP{'page_error_msg'}="Invalid quantity - exceeds database table limits";  
               } else {
               $currdiff += $diff;
#               $l="UPDATE ocart SET quant='$qty',linetotal='$linetotal' WHERE orderid='$orderid' AND lineobjid='$lineobjid' AND objclass != '140-A'";
#               $stl=$dbh->prepare($l);
#               $stl->execute;

               $l="SELECT lstock FROM inventory WHERE objid='$lineobjid'";
               $stl=$dbh->prepare($l);
               $stl->execute;
               $lstock = $stl->fetchrow;

               if ( $lstock ) {

                  $qtydiff = $quant - $qty;
                  $lstock = $lstock + $qtydiff;
                  if ( $lstock > 0 ) {
                     $l="UPDATE ocart SET quant='$qty',linetotal='$linetotal' WHERE orderid='$orderid' AND lineobjid='$lineobjid' AND objclass != '140-A'";
                     $stl=$dbh->prepare($l);
                     $stl->execute;

                     $l = "UPDATE inventory SET lstock='$lstock' WHERE objid='$lineobjid'";
                     $stl=$dbh->prepare($l);
                     $stl->execute;
                  } else {
                     $NVP{'page_error_msg'}="Invalid quantity - not enough stock to make change";
                  }
               } 
 
               $query = "SELECT body FROM extraprop WHERE objid='$lineobjid' AND fieldname='weight'";
               $stl = $dbh->prepare($query);
               $stl->execute;
               $weight = $stl->fetchrow;
               $weight = (split/\|/, $weight)[0];
               $weight = $weight * $qty;  
               }
            } else {
               $qty=$quant;
            }
         } else {
            $qty=$quant;
            $NVP{'page_error_msg'}="Invalid quantity - must be positive integer";
         }
         $totalweight = $weight; 
      }  

      ## need to readd the linetotals to get st_taxable
      #
      $query="SELECT linetotal FROM ocart WHERE orderid='$orderid' AND objclass != '140-A'"; 
      $stl=$dbh->prepare($query);
      $stl->execute;
#      $num=$stl->rows;
#      for (1..$num) {
#         $linetotal = $stl->fetchrow;
      while ( $linetotal = $stl->fetchrow ) { 
         $st_taxable = $st_taxable + $linetotal; 

      }

      $query="SELECT linetotal FROM ocart WHERE orderid='$orderid' AND objclass = '140-A'";    
      $stl=$dbh->prepare($query);
      $stl->execute;
      $scost=$stl->fetchrow;

## insert refund here

   ## do they need to have a refund
   #

   if ( $refund == 0 ) { 
       $refund = "0.00"; 
   }

   if ($refund !~ /\./) {
         $refund = "$refund.00";   # force it to have decimal places
   }

   if ( $refund && $refund > -1 && $refund =~ /^(\d+\.\d{0,2}|\.\d{0,2})$/ && $st_taxable >= $refund ) {
      $query = "SELECT * FROM extraprop WHERE objid='$orderid' AND fieldname='refund'";
      $sth = $dbh->prepare($query);
      $sth->execute;
#      $num=$sth->rows;
#      if ( $num == 0 ) 
      while ( $rwh=$sth->fetchrow_hashref(NAME_lc) ) {
         $num++;
      }
      $sth = $dbh->prepare($query);
      $sth->execute;
      if ( $num == 0 ) { 
         $query = "INSERT INTO extraprop (objid,fieldname,body) VALUES ('$orderid','refund','$refund')";
         $sth = $dbh->prepare($query);
         $sth->execute;
      } elsif ( $refund > -1) {
         $query = "UPDATE extraprop SET body='$refund' WHERE objid='$orderid' AND fieldname='refund'";
         $sth = $dbh->prepare($query);
         $sth->execute;
      }
   } elsif ( $refund ) {
      if ( $NVP{'page_error_msg'} ne "" ) {
         $NVP{'page_error_msg'}="Invalid refund and quantity entries";
         $refund=0; 
      } else {
         $NVP{'page_error_msg_refund'}="Invalid refund entry";
         $refund=0;
      }
   } else {
      $refund=0;
   }            

      ## get tax rate and calculate amount of tax
      #
      $query="SELECT taxrate FROM orders WHERE objid='$orderid'";
      $stl=$dbh->prepare($query);
      $stl->execute;
      $taxrate = $stl->fetchrow;
      $st_tax = ($taxrate/100) * ($st_taxable );   
      $st_tax = nicedecimals($st_tax); 

      #warn "Tax is $st_tax\n";
	
      $query = "SELECT shipwt from orders WHERE objid='$orderid'";
      $stn = $dbh->prepare($query);
      $stn->execute;
      $shipwt = $stn->fetchrow;

      ## calculate shipping cost
      #
      if ( $shipst ne $ship || $quant ne $qty || $postcode ne $zipcode ) {
         ## no quantity change we can use shipwt from orders 
         #
         if ( $quant eq $qty ) {
            $query = "SELECT status,shipwt from orders WHERE objid='$orderid'";
            $stn = $dbh->prepare($query);
            $stn->execute;
            ($shstatus,$shipwt) = $stn->fetchrow; 
         } else { ## quanity change - need to recalculate shipping weight 
            $shipwt = $totalweight;  
         }
         $shipst = $ship;
         $query = "SELECT shipzone FROM zonemap WHERE shipmeth='$ship' AND destzipmn<='$postcode' AND destzipmx>='$postcode'";
         $stn = $dbh->prepare($query);
         $stn->execute;
         $shipzone = $stn->fetchrow;

         $scost=0;
         $swt=100000;
         $query = "SELECT shipcost,shipwt FROM zonerate WHERE shipmeth='$ship' AND shipwt>='$shipwt' AND shipzone='$shipzone' ORDER BY shipcost";
         $stn = $dbh->prepare($query);
         $stn->execute;
#         $num = $stn->rows;
#         for (1..$num) {
#            ($shipcost,$shippingwt) = $stn->fetchrow;
         while ( ($shipcost,$shippingwt) = $stn->fetchrow ) {  
            if ( ($shippingwt < $swt ) || $scost == 0 ) { $scost = $shipcost; $swt=$shippingwt;}
         }
         $scost="0.00" if ( $activity eq "15028-A" || $status eq "15028-A");
         $l="UPDATE ocart SET lineobjid='$ship',linetotal='$scost' WHERE orderid='$orderid' AND objclass='140-A'";
         $stl=$dbh->prepare($l);
         $stl->execute;
      }


 	  $st_taxable = 0 if ( $st_taxable < 0 );

	  
      $ordtotal = $st_taxable + $st_tax + $scost - $refund;
	  $ordtotal = &nicedecimals($ordtotal);
	  
      $query="UPDATE orders SET ordtotal='$ordtotal',st_taxable='$st_taxable',st_tax='$st_tax',shipwt='$shipwt' WHERE objid='$orderid'"; 
      $stl=$dbh->prepare($query);
      $stl->execute;
      $update=1;
      
} # orderst conditional
 
if ( $NVP{'page_error_msg'} eq "" ) { 
   if ( $orderst ne $activity ) {
      $status = $activity;
#     if ( $activity eq "105028" || $activity eq "105029" ) {
#         &cancelorder($orderid)
#     }
#     if ( $activity eq "105027" ) {
#        &chargeorder($orderid)
#     }
      $l="UPDATE orders SET status='$activity' where objid='$orderid'";
      $stl=$dbh->prepare($l);
      $stl->execute;
      $update=1;
   }
}
}
$targ="os_allcommerce"."-".$script."-".$FORM{'mode'};  

########################################################
## Primary Display Mode Handling

## more than one order was found under the query, need to have list to pick from
#

if ($FORM{'mode'} eq "searchlist") {
   $pagetitle="$script_msg{19}";

&printsearch;
#   if ($FORM{'query'}) {
#      $query = $FORM{'query'};
#   } else {
#      $query = "select DVALUE, CDATE from levents where DVALUE LIKE '\%success\%' AND DVALUE LIKE '$FORM{'orderid'}\t\%' ";
#   }

#   $sth = $dbh->prepare ( $query );
#   $sth->execute;
#   $num = $sth->rows;
#   $expand1 = "";
#   $v="&sid=$sid&mode=showorder&loadfrom=db";
#   $old = "old";

#   $t = loadtemplate("row_order_searchlist", $skeletonpath);
#   $t =~ s/<!--.*-->//s;
#   for (1..$num) {
#      %row=%{$sth->fetchrow_hashref};
#      $objid=$row{'objid'};
#      next if ( ! $objid );
#      $k="orderid=$objid";
#      $old=$objid;
#      next if ( $row{'status'} eq "15012-A" );

#      $qu = "SELECT wh FROM ocart WHERE orderid='$objid' AND objclass != '140-A'";
#      $sta = $dbh->prepare ( $qu );
#      $sta->execute;
#      $warehouse = $sta->fetchrow;

#      @keys= keys %row;

#      $date = $row{'cdate'};

#      @date=localtime($date);
#      $month=$date[4]+1;
#      $date[5] += 1900;
#      $date[0] = "0".$date[0] if ( $date[0] < 10 );
#      $date[1] = "0".$date[1] if ( $date[1] < 10 );

#      $SL{'date'} = "$month/$date[3]/$date[5]";
#      $SL{'time'} = "$date[2]:$date[1]:$date[0]";
#      $SL{'orderid'} = $objid;  
#      $SL{'oidref'} = "$scriptpath/$scriptname\?$v\&$k";
#      $SL{'ship'} = $sstatus->{$row{'status'}};  
#     $SL{'wh'} = $wh;

#      $NVP{'column_215_1'} .= permutebit($t, \%SL);
#   }

} elsif ( $FORM{'mode'} eq "showorder" ) {
   $NVP{'mode'} = "update";
   if ($FORM{'query'}) {
      $query = $FORM{'query'};
   }  else {
      $query = "SELECT objid,custid,sid,status,cdate from orders WHERE objid='$FORM{'orderid'}'";
   }
 
   $sth = $dbh->prepare ( $query );
   $sth->execute;
#   $num = $sth->rows;

   $v="&sid=$sid_encrypt&mode=update&loadfrom=db";
   $old="";
  
#   if ( ($status eq "15018-A" || $activity eq "15018-A") && $FORM{'ccinfo'} eq "yes" ) {
#      $ccst=$status if ( $status );
#      $q="SELECT body FROM extraprop WHERE objid='$orderid' AND fieldname LIKE 'CC|%'";   
#      $stz = $dbh->prepare( $q );
#      $stz->execute;
#      $ccinfo=$stz->fetchrow;

#      @bits=split /\|/, $ccinfo;
#      $ccnum=$bits[0];
#      $ccexp="$bits[2]/$bits[3]";
#      $NVP{'ccinfo'}="$ccnum - $ccexp";
#   }

   ## query database now for information
   # 
#   if ($num > 0) {
#      %row=%{$sth->fetchrow_hashref};
   while ( %row=%{$sth->fetchrow_hashref(NAME_lc)} ) { 
      ## obtain information from orders 
      #

      $orderid = $row{'objid'};
      $oid = $row{'objid'};
      $objid = $row{'objid'};
      $sid = $row{'sid'}; 
      $custid = $row{'custid'};
      $shipto = $row{'shipto'};
      $cdate = $row{'cdate'};
      $mdate = $row{'mdate'};
      $status = $row{'status'};

      if ( $status eq "15025-A" || $activity eq "15025-A" ) {
         $targ="os_allcommerce"."-".$script."-"."showorder4";
      }

      if ( $status eq "15020-A" || $activity eq "15020-A" ) {
         $targ="os_allcommerce"."-".$script."-"."showorder2";     
      }

      if ( $status eq "15028-A" || $activity eq "15028-A" ) {
         $targ="os_allcommerce"."-".$script."-"."showorder3";
      }           

      if ( $status eq "15012-A" ) {
         $NVP{'page_error_msg'} = "You can not edit an order while still in checkout"; 
      }

      ## obtain information from orders 
      #
      $m="SELECT status,st_tax,st_taxable,st_nontax,ordtotal,shipwt,shipto from orders where objid='$orderid'";
      $stm=$dbh->prepare($m);
      $stm->execute;
      ($status,$st_tax,$st_taxable,$st_nontax,$ordtotal,$shipwt,$shipto) = $stm->fetchrow;

      $NVP{'taxtotal'}=$st_tax;  

      ## obtain shipping information from ocart
      #
      $m="SELECT linetotal,lineobjid from ocart where orderid='$orderid' AND objclass='140-A'";
      $stm=$dbh->prepare($m);
      $stm->execute;
      ($shipcost, $shipstatus) = $stm->fetchrow;
      $shipcost="0.00" if ( ! $shipcost || $activity eq "15028-A" || $status eq "15028-A" );
      
      $NVP{'shippingtotal'}=nicedecimals($shipcost);   

      ## obtain product information from ocart
      #
      $l="SELECT lineobjid, wh, msku, vcode, quant, linetotal, unitpr from ocart WHERE orderid='$orderid' AND objclass!='140-A'";
      $stl=$dbh->prepare($l);
      $stl->execute;
#      $numl=$stl->rows;   

      $t = loadtemplate("row_order_showorder", $skeletonpath);
      $t = loadtemplate("row_order_showorder2", $skeletonpath) if ( $status eq "15020-A" || $status eq "15028-A" || $status eq "15025-A");
      $t =~ s/<!--.*-->//s;  

      $op = loadtemplate("row_option", $skeletonpath);   
      $op =~ s/<!--.*-->//s;
      $subtotal = 0.00;
      $totitem = "";
      $linecounter=0;
      
      ## display refund, if any
      #
      $query="SELECT body FROM extraprop WHERE objid='$orderid' AND fieldname='refund'";
      $sth=$dbh->prepare($query);
      $sth->execute;  
#      $numr = $sth->rows;
#      if ( $numr > 0 ) {
#         $refund = $sth->fetchrow;
      if ( $refund = $sth->fetchrow ) {
      } else {
         $refund = "0.00";
      }

      $NVP{'refund'} = $refund;

      ## subtotal display
      #
	  if (($st_taxable + $st_nontax) >= $refund) {
	      $subtotal = $st_taxable + $st_nontax - $refund; 
	  } else {
	  	  $subtotal = $st_taxable + $st_nontax;
	  }
      ## determine allowable shipping methods
      #
      $query = "SELECT postcode FROM addresses WHERE objid='$shipto'";
      $stn = $dbh->prepare($query);
      $stn->execute;
      $postcode = $stn->fetchrow;
 
      $query = "SELECT shipzone,shipmeth FROM zonemap WHERE destzipmn<='$postcode' AND destzipmx>='$postcode'";
      $stn = $dbh->prepare($query);
      $stn->execute;
#      $shipnum=$stn->rows;
#      for (1..$shipnum) {
#         ($shipzone,$shipmeth) = $stn->fetchrow;
      while ( ($shipzone,$shipmeth) = $stn->fetchrow ) { 
         $query = "SELECT shipcost FROM zonerate WHERE shipmeth='$shipmeth' AND shipwt>='$shipwt' AND shipzone='$shipzone' AND shipcost>0 ORDER BY shipcost";
         $stz = $dbh->prepare($query);
         $stz->execute;
#         $numcost = $stz->rows;
         $already="no";
#         for (1..$numcost) {
#            $shipcost = $stz->fetchrow;
         while ( $shipcost = $stz->fetchrow ) { 
               foreach $methk (@smethodok) {
                   if ( $methk eq $shipmeth) { $already="yes"; }
               }
               if ( $already eq "no" ) { push @smethodok, $shipmeth; }
         }

      }
#      for (1..$numl) {
#	  ($lineobjid, $warehouse, $msku, $vcode, $quant, $linetotal, $unitpr)=$stl->fetchrow;
      while ( ($lineobjid, $warehouse, $msku, $vcode, $quant, $linetotal, $unitpr)=$stl->fetchrow ) { 
	  $SO{'lid'} = $lineobjid;
          $SO{'qtyid'} = "qty"."$lineobjid"; 
          $linecounter ++; 
          $SO{'lineid'} = "LINE".$linecounter;
          $SO{'sku'} = "$msku"."$vcode";

          $SO{'wh'} = $wh;  
          $NVP{'wh'} = $wh;
	  $SO{'qty'} = $quant;
	  $SO{'linetotal'} = nicedecimals($linetotal);
	  $SO{'price'} = $unitpr;
	  $totitem += $quant;
          $vardescript="";
	  $s="SELECT title,ref_from,vcode FROM things WHERE objid='$lineobjid'";
	  $sts=$dbh->prepare($s);
	  $sts->execute;
          ($title,$ref_from,$vcode)=$sts->fetchrow; 
          if ( ! $title && $ref_from ) {
             $s="SELECT title,axisnames FROM things WHERE objid='$ref_from'";
             $sts=$dbh->prepare($s);
             $sts->execute;
             ($title,$axisnames)=$sts->fetchrow; 
             @vcodes = split /:/, $vcode;
             @axisname = split /:/, $axisnames;
             foreach $axis (@axisname) {
                $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
                $sts=$dbh->prepare($s);
                $sts->execute;    
                ($body)=$sts->fetchrow; 
                @valuepairs = split /\r\n/, $body;
                foreach $pair (@valuepairs) {
                   ($key,$value) = split/:/, $pair;
                   $variant{$key}=$value;
                } 
                $code = shift @vcodes;
                $vardescript.=" ".$variant{$code};
             }
             $title = $title.$vardescript;
          }
          $SO{'title'} = $title;

          $so = permutebit( $t, \%SO);
          $NVP{'tableinfo'} .= permuteclean($so);

          $NVP{'linecount'} = $linecounter;
	  $NVP{'totitem'} = $totitem;
	  $subtotal = &nicedecimals($subtotal);
	  $NVP{'subtotal'} = $subtotal;
     #     $subtotal = sprintf("%0.2d", $subtotal);
     #     ($NVP{'subtotal'}, $temp) = split /\./, $NVP{'subtotal'};
	 # $temp .= "00"; 
     #     $high .= "\.".substr( $temp, 0, 3);    
     #     $low .= "\.".substr( $temp, 0, 2);      
     #     $diff = $high - $low;
     #     $NVP{'subtotal'} .= "\.".substr( $temp, 0, 2);
     #     $NVP{'subtotal'}=$NVP{'subtotal'} + 0.01 if ( $diff > 0.005 );

        @orderlist=();        

        ## generate order select
        #
        foreach $key (sort keys %{$sstatus} ) {
           next if $key eq "15012-A";
           $statusnum = $status;
           $keynum = $key;
           $statusnum =~ s/-A//g;
           $keynum =~ s/-A//g; 
           next if $keynum < $statusnum;
           $select=$key."|".$sstatus->{$key};
           push @orderlist, $select;
        } 

        $NVP{'orderstatus_select'}=gen_select($status,"4",@orderlist);

        @shiplist=();

        ## generate shipping select
        #
        if ( ! $shipstatus ) { push @shiplist, "|Shipping not specified"; } 
        foreach $key (@smethodok) {
           $select=$key."|".$smethod->{$key};
           push @shiplist, $select;
        }  
        if ( ! @smethodok ) { @shiplist=("|Shipping not available"); } 

        $NVP{'ship_select'}=gen_select($shipstatus,"4",@shiplist); 

       };
       
       $NVP{'shipstatus'}=$smethod->{$shipstatus};
       $NVP{'shipstatus'}="Shipping not available" if ( ! $shipstatus || ! @smethodok );       

       ## shipping billing info from orders
       #
       $o="SELECT uname, custid, billto, shipto, ordtotal, taxrate FROM orders WHERE objid='$objid' ";
       $sto=$dbh->prepare($o);
       $sto->execute;
#       $numo=$sto->rows;
       ($ccname, $ccid, $billto, $shipto, $ordtotal, $taxrate)=$sto->fetchrow;    
       $ccname =~ s/\|/ /g;
       $NVP{'ccname'}=$ccname;
       $NVP{'ccid'}=$ccid;
       $NVP{'billto'}=$billto;
       $NVP{'shipto'}=$shipto;
       $NVP{'ordtotal'}=$ordtotal;
       $NVP{'taxrate'}=$taxrate;

       ## billing info
       # 
       $s="SELECT name, address1, address2, city, state, postcode, dayphone FROM addresses WHERE objid='$billto' \n";
       $sts=$dbh->prepare($s);
       $sts->execute;
#       $nums=$sts->rows;
       ($buname, $baddress1, $baddress2, $bcity, $bstate, $bpostcode, $bdayphone)=$sts->fetchrow;
       $buname =~ s/\|/ /g;
       $NVP{'buname'}=$buname;
       $NVP{'baddress1'}=$baddress1;
       $NVP{'baddress2'}=$baddress2;
       $NVP{'bcity'}=$bcity;
       $NVP{'bstate'}=$bstate;
       $NVP{'bpostcode'}=$bpostcode; 

       $bdayphone =~ s/-|\(|\)|\s*//g;
       $bplen = length($bdayphone);
       $NVP{'bdayphone'} = substr($bdayphone, -4);
       $NVP{'bdayphone'} = substr($bdayphone, -7, 3)."-".substr($bdayphone, -4);
       if ($bplen>7 && $bplen<11) { $NVP{'bdayphone'} = substr($bdayphone, 0, $bplen-7)."-".$NVP{'bdayphone'}; }
       if ($bplen>10) { $NVP{'bdayphone'} = substr($bdayphone, 1, $bplen-8)."-".$NVP{'bdayphone'};  $NVP{'bdayphone'} = substr($bdayphone, 0, $bplen-10)."-".$NVP{'bdayphone'}; }


       $NVP{'billadd'} = "<BR><font FACE=arial,helvetica,arial size=-1><b>Bill to:</b></font>
                            <BR><font FACE=arial,helvetica,arial size=-1>__buname__</font>
                            <BR><font FACE=arial,helvetica,arial size=-1  >__baddress1__</font>";

       if ($baddress2) { $NVP{'billadd'} .= '<BR><font FACE=arial,helvetica,arial size=-1 >__baddress2__</font>'; }

       $NVP{'billadd'} .= '<BR><font FACE=arial,helvetica,arial size=-1 >__bcity__ , 
                            __bstate__ 
                            __bpostcode__ </font> ';
       $NVP{'billadd'} .= '<BR><font FACE=arial,helvetica,arial size=-1 > __bdayphone__ </font> ';
       $NVP{'billadd'} = permutebit($NVP{'billadd'}, \%NVP);   

       ## shipping info
       #
       $b="SELECT name, address1, address2, city, state, postcode, dayphone FROM addresses WHERE objid='$shipto' \n";
       $stb=$dbh->prepare($b);
       $stb->execute;
#       $numb=$stb->rows;
       ($uname, $address1, $address2, $city, $state, $postcode, $dayphone)=$stb->fetchrow;
       $uname =~ s/\|/ /g;  
       $NVP{'uname'}=$uname;
       $NVP{'address1'}=$address1;
       $NVP{'address2'}=$address2;
       $NVP{'city'}=$city;
       $NVP{'state'}=$state;
       $NVP{'postcode'}=$postcode; 

	$dayphone =~ s/-|\(|\)|\s*//g;
	$plen = length($dayphone);
	$NVP{'phone'} = substr($dayphone, -4);
	$NVP{'phone'} = substr($dayphone, -7, 3)."-".substr($dayphone, -4);
	if ($plen>7 && $plen<11) { $NVP{'phone'} = substr($dayphone, 0, $plen-7)."-".$NVP{'phone'}; }
        if ($plen>10) { $NVP{'phone'} = substr($dayphone, 1, $plen-8)."-".$NVP{'phone'};  $NVP{'phone'} = substr($dayphone, 0, $plen-10)."-".$NVP{'phone'}; }  

       $num--
   }

   if ( $status eq "15025-A" || $status eq "15028-A" ) {
      $q="DELETE FROM extraprop WHERE objid='$orderid' AND fieldname LIKE 'CC|%'";
      $stz = $dbh->prepare( $q );
      $stz->execute; 
   }

   if ( $status eq "15028-A" ) {
      $q ="SELECT lineobjid, hquant FROM ocart WHERE orderid='$orderid' AND objclass != '140-A' ";
      $stz = $dbh->prepare( $q );
      $stz->execute;

      while ($productref = $stz->fetchrow_hashref(NAME_lc)) {
         my $now = time();
         $q ="UPDATE inventory SET lstock= lstock+$productref->{'hquant'}, mdate='$now' WHERE objid = '$productref->{'lineobjid'}' ";
         $sth = $dbh->prepare( $q );
         $sth->execute;
      }

   }


   if ( ($status eq "15018-A" || $activity eq "15018-A") && $FORM{'ccinfo'} eq "yes" ) {
      $ccst=$status if ( $status );
      $q="SELECT body FROM extraprop WHERE objid='$orderid' AND fieldname LIKE 'CC|%'";
      $stz = $dbh->prepare( $q );
      $stz->execute;
      $ccinfo=$stz->fetchrow;
      
      @bits=split /\|/, $ccinfo;

      if ( $site->{'cclength'} eq "all" ) {
         $bits[0]=&os_unhash(pack(H16, $bits[0]), $site->{'hash_key'});
         $bits[1]=&os_unhash(pack(H16, $bits[1]), $site->{'hash_key'});
         $ccnum=$bits[0].$bits[1]."<BR>"; 
         $ccexp="$bits[3]/$bits[4]";
      } else {
         $ccnum=$bits[0];
         $ccexp="$bits[2]/$bits[3]";
      }
      $NVP{'ccinfo'}="$ccnum - $ccexp";
   }       

#   $NVP{'ordertotal'} = $ordtotal."00";
#   ($NVP{'ordertotal'}, $temp) = split /\./, $NVP{'ordertotal'};
#   $temp .= "00"; 
#   $NVP{'ordertotal'} .= "\.".substr( $temp, 0, 2);
   $NVP{'ordertotal'}=nicedecimals($ordtotal);

#   $NVP{'totaltax'} = $NVP{'subtotal'} * $taxrate;
#   ($NVP{'totaltax'}, $temp) = split /\./, $NVP{'totaltax'};
#   $temp .= "00";
#   $NVP{'totaltax'} .= "\.".substr( $temp, 0, 2);
   $NVP{'totaltax'} = nicedecimals($NVP{'totaltax'});

   $NVP{'deliver'} = "none";
   $NVP{'deliver'} = $instructions if ($instructions);

   $NVP{'info'}.="<font face=helvetica,arial size=-1>Order Total = \$$ordtotal</font> <p>";
   $NVP{'info'}.= "<font face=helvetica,arial size=-1>Delivery Instructions:</font> ";
   if (!$instructions) {
   $NVP{'info'}.="<font face=helvetica,arial size=-1>none</font><BR><P>";} else {$NVP{'info'}.="<font face=helvetica,arial size=-1>$instructions</font><BR><p>";
   } 

   if (!$FORM{'orderid'}) {
      $FORM{'orderid'} = $oid;
   }
   $pagetitle="$script_msg{33} $FORM{'orderid'} ";
   $NVP{'pagetitle'}=$pagetitle;
   $NVP{'orderid'}=$FORM{'orderid'};

} elsif ( $FORM{'mode'} eq "stats" ) {
   $NVP{'summary'}="";
   
$NVP{'totalpro'}="0.00";
$NVP{'totaltax'}="0.00";
$NVP{'totalship'}="0.00"; 

if ( ! $starttime && ! $endtime ) { 
$NVP{'startdate'}="the beginning";
$NVP{'enddate'}="now";
} else {
$NVP{'startdate'}=$FORM{'startdate'};
$NVP{'enddate'}=$FORM{'enddate'}; 
}

   $ordertotal="0.00";
   $taxtotal="0.00";
   $shiptotal="0.00"; 
   foreach $key (sort keys %{$sstatus}) { 
      next if ( $key eq "15012-A" || $key eq "15028-A" || $key eq "15029-A");
         $ordertotal="0.00";
         $taxtotal="0.00";
         $shiptotal="0.00"; 
      ## get shipping totals
      #
      $query = "SELECT objid from orders WHERE status='$key' AND objid LIKE '%-%'";
      if ( $starttime && $endtime ) { $query .= "AND cdate >= '$starttime' AND cdate <= '$endtime'"; }
      $sth = $dbh->prepare( $query );
      $sth->execute;
#      $num = $sth->rows;
#      if ($num > 0) {
#         for (1..$num) {
#            ($ord)= $sth->fetchrow_array;
      while ( ($ord)= $sth->fetchrow_array ) {        
            next if ( ! $ord );
            $query = "SELECT linetotal from ocart WHERE orderid='$ord' AND objclass='140-A'";
            $stg = $dbh->prepare( $query );
            $stg->execute;
#            $nums = $stg->rows;
#            for (1..$nums) {
#               ($linetotal)=$stg->fetchrow;
            while ( ($linetotal)=$stg->fetchrow ) {  
               $shiptotal+=$linetotal;
            }
         }
#      }

      ## get tax totals
      #
      $query = "SELECT st_tax from orders WHERE status='$key' AND objid LIKE '%-%'";
      if ( $starttime && $endtime ) { $query .= "AND cdate >= '$starttime' AND cdate <= '$endtime'"; }
      $sth = $dbh->prepare( $query );
      $sth->execute;
#      $num = $sth->rows;
#      if ($num > 0) {
#         for (1..$num) {
#            ($st_tax)=$sth->fetchrow;
      while ( ($st_tax)=$sth->fetchrow ) { 
            $taxtotal+=$st_tax;
         }
#      }

      ## get order totals
      #
      $query = "SELECT objid from orders WHERE status='$key' AND objid LIKE '%-%'";
      if ( $starttime && $endtime ) { $query .= "AND cdate >= '$starttime' AND cdate <= '$endtime'"; }
      $sth = $dbh->prepare( $query );
      $sth->execute;
#      $num = $sth->rows; 
#      if ($num > 0) {
#         for (1..$num) {
#            ($ord)= $sth->fetchrow_array;
      while ( ($ord)= $sth->fetchrow_array ) {
            next if ( ! $ord );
            $query = "SELECT quant,unitpr from ocart WHERE orderid='$ord' AND objclass!='140-A'";
            $stg = $dbh->prepare( $query );
            $stg->execute;
#            $nums = $stg->rows;
#            for (1..$nums) {
            while ( ($quant,$unitpr)=$stg->fetchrow ) {  
#               ($quant,$unitpr)=$stg->fetchrow;
               $ordertotal+=$quant*$unitpr;
            }
         }
#      }
      ## display each line item
      #
      if ( $ordertotal !~ /\./ ) {
         $ordertotal = $ordertotal.".00";
      } elsif ( $ordertotal !~ /\.\d\d/ ) {
         $ordertotal = $ordertotal."0";
      }
      if ( $taxtotal !~ /\./ ) {
         $taxtotal = $taxtotal.".00";
      } elsif ( $taxtotal !~ /\.\d\d/ ) {
         $taxtotal = $taxtotal."0";
      }
      if ( $shiptotal !~ /\./ ) {
         $shiptotal = $shiptotal.".00";
      } elsif ( $shiptotal !~ /\.\d\d/ ) {
         $shiptotal = $shiptotal."0";
      }


      $NVP{'summary'}.="<TR></TR><TR><TD colspan=3 font face=helvetica,arial size=-1>$sstatus->{$key}</TD><TD align=right>$ordertotal</TD><TD align=right>$taxtotal</TD><TD align=right>$shiptotal</TD></TR>";

      ## final totals
      #
      $NVP{'totalpro'}+=nicedecimals($ordertotal);
      $NVP{'totaltax'}+=nicedecimals($taxtotal);
      $NVP{'totalship'}+=nicedecimals($shiptotal);

   }
   if ( $NVP{'totalpro'} !~ /\./ ) {
         $NVP{'totalpro'} = $NVP{'totalpro'}.".00";
      } elsif ( $NVP{'totalpro'} !~ /\.\d\d/ ) {
         $NVP{'totalpro'} = $NVP{'totalpro'}."0";
   } 
   if ( $NVP{'totaltax'} !~ /\./ ) {
        $NVP{'totaltax'} = $NVP{'totaltax'}.".00";
      } elsif ( $NVP{'totaltax'} !~ /\.\d\d/ ) {
         $NVP{'totaltax'} = $NVP{'totaltax'}."0";
   } 
   if ( $NVP{'totalship'} !~ /\./ ) {
        $NVP{'totalship'} = $NVP{'totalship'}.".00";
      } elsif ( $NVP{'totalship'} !~ /\.\d\d/ ) {
        $NVP{'totalship'} = $NVP{'totalship'}."0";
   } 

}

foreach ( keys %NVP ) {
   $NVP{$_} = string_tohtml( $NVP{$_} );
}


&writetonvp;

if ($NVP{'lastaction'}) {
   $targ="os_allcommerce-order-home";
   $FORM{'mode'}="home";
}
$l = loadtemplate($targ, $skeletonpath);
$l=permutebit($l, \%NVP);

$l =~ s/__pages__/$pages/gms;
$l =~ s/__back__/$back/gms;
$l =~ s/__next__/$next/gms;
$l =~ s/__start__/$startlink/gms;
$l =~ s/__end__/$lastrow/gms; 

#$thispage = permutebit( $thispage, \%FORM );
#$thispage = permutebit( $thispage, $site );

$l=~ s/__orderstatus_select__/$NVP{'orderstatus_select'}/gms;
$l=~ s/__warehouse_select__/$NVP{'warehouse_select'}/gms;
$l=~ s/__callstatus_select__/$NVP{'callstatus_select'}/gms;
$l=~ s/__page_error_msg__/$NVP{'page_error_msg'}/gms;
$l=~ s/__script__/$scriptpath\/$script.cgi/gms;
$l=~ s/__sitename__/$site->{'sitename'}/gms;
$l=~ s/__sid__/$sid/gms;
$l=~ s/__mode__/$NVP{'mode'}/gms if $NVP{'mode'};
$l=~ s/__mode__/$FORM{'mode'}/gms;
$l = permuteclean($l);
print $l;

$dbh->disconnect if ( $dbh );

######################################################
## subroutines
##
######################################################

##### cancelorders
#        cancel order
#
sub cancelorders {

}


##### chargeorders
#        charge order that has not been charge
#
sub chargeorders {

}


##### validatefields
#        takes all %FORM entries, seeks _inp entries, and 
#        performs field-by-field validation, with 
#        generation of _err error messages in %FORM as needed
#     returns 1 for OK, 0 for errors
#        - run after checkformbits
#        - does not need explicit fieldlist
#     Version 1 RF 981123
sub validatefields {
   # reads global %FORM
   my(@keys,$k,$e,$rv);
   $rv=1;                  # default OK, to 0 if error
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      next if ( $k !~ /_inp$/ );
      $kt = $k;
      $kt =~ s/_inp$// ;
      next if ( $kt =~ /[a-z]/ );   # fields are all uppercase
      $e=validatefield( $kt,$FORM{$k}, \%FORM );
      if ($e) {
         $rv=0;           # there was an error returned
         $kt.="_err";
         $FORM{$kt}=$e;   # emplace the error message 
      } # done checking for a returned error
   } # done running through form keys 
   return $rv;
} #/validatefields


##### checkformbits - checks population of _inp, does not touch
#        NVP hash
#
sub checkformbits {
   # goes through global %FORM
   #

   my($k,$kt,@keys);

   @keys = keys %FORM;

   while (@keys) {

      $k=shift @keys;
      next if ( $k =~ /_ini$/ );   # nothing to do with ini
      if ( $k =~ /_pre$/ ) {
         # check to see if the inp key exists
         # if it doesn't exist, then create and set to _pre
         $kt=$k;
         $kt =~ s/_pre$/_inp/ ;
         $FORM{$kt}=$FORM{$k} if ( ! exists($FORM{$kt}) );

      } # only really concerned with _pre/_inp pairs
   } # done with all keys

   return 1;
} #/checkformbits

##### writetonvp - write form data to NVP hash
sub writetonvp {
   # could rewrite to take a hashref
   my(@keys,$k,$kt);
   @keys = keys %FORM;
   while (@keys) {
      $k=shift @keys;
      $kt = $k;
      $kt =~ s/(_ini|_inp|_pre|_err)$// ;
      if ( $k =~ /_inp$/ ) {           # _inp -> _pre
         $kt.="_pre";
         $NVP{$kt}=$FORM{$k};
      } elsif ( $k =~ /_ini$/ ) {      # _ini -> _ini
         $NVP{$k}=$FORM{$k};
      } elsif ( $k =~ /_err$/ ) {      # _err -> _err
         $NVP{$k}=$FORM{$k};
      } elsif ( $k eq $kt ) {          # X -> X
         if (( $kt !~ /[a-z]/ ) and ( ! exists($NVP{$kt}) )) {
            # this looks like a fieldname and is not yet set
            $NVP{$kt}=$FORM{$kt} if ( $FORM{$kt} );
         }
      } # any other inheritance modes?
   } # done running through form keys
   ## special cases
   #
   $NVP{'skukind'}=$FORM{'SKUKIND_inp'} if (( ! $NVP{'skukind'} ) and ( $FORM{'SKUKIND_inp'} ));
   return 1; 
} #/writetonvp

##### LoadSkuFromDb
sub loadskufromdb {

   $q = 'SELECT * from ocart';
   $q.= " WHERE lineid='$FORM{'lineid'}' ";
   if (!$FORM{'lineid'}) {$q=" SELECT * from ocart WHERE oid='$FORM{'orderid'}' ";}

   $sth = $dbh->prepare( $q );
   $sth->execute;
#   $num = $sth->rows;

#   if ( $num==1 ) {
       # query returned exactly one record
#      $h = $sth->fetchrow_hashref;
   if ( $h = $sth->fetchrow_hashref(NAME_lc) ) {
      foreach (keys %{$h} ) {
         $x = string_exdbi($h->{$_});
         $kt=$_."_inp";
         $FORM{$kt}=$x if ( ! exists($FORM{$kt}) );
      }
 
      $q ="SELECT OBJID, FIELDNAME, BODY from extraprop ";
      $q.=" WHERE OBJID LIKE '$h->{'LINEID'}' ";
      $sth = $dbh->prepare( $q );
      $sth->execute;
#      $num = $sth->rows;
#      while ($num) {
#         ( $x,$i,$k ) = $sth->fetchrow;
      while ( ( $x,$i,$k ) = $sth->fetchrow ) {
         $k=string_exdbi($k);
         $kt=$i."_inp";        
         $FORM{$kt}=string_tohtml($k) if ( ! $FORM{$kt} );
         $num--;
      }

   } else {
      # there was an error!
      # send back to homepage with error message
      $FORM{'mode'}="home";
   }
   $sth->finish;
   return 1;
}
# /loadskufromdb

############################################################################
# PURPOSE      Displays the search results $maxrows at a time, setting the
#              Next, Back and pages links if required.  Displays link to
#              objid to edit, link to links, and a link to variants if it
#              is a master object.
#
# INPUT        None - uses $FORM{'query'} populated by loadfindobjects.
#
# OUTPUT       permuted page of search results, $maxrows at a time
#
# NOTES
############################################################################
sub printsearch {
   my ($query, $foundcount, $num, $sth, $maxrows);
   $maxrows = 10;

   if ( ! $query ) {
      $query = "SELECT objid,custid,sid,status,cdate,shipto from orders where objid LIKE '%'";
      $query .=" AND objid='$FORM{'orderid'}' " if ( $FORM{'orderid'} );
      $query .=" AND cdate >= '$FORM{'starttime'}' AND cdate <= '$FORM{'endtime'}'" if ( $FORM{'starttime'} && $FORM{'endtime'} );
      $query .=" AND status='$FORM{'orderstatus'}'" if ( $FORM{'orderstatus'} );
      $query .=" AND status!='15012-A' ";
      $query .=" ORDER BY cdate"; 

      $starttime=$FORM{'starttime'};
      $endtime=$FORM{'endtime'};
      $orderstatus=$FORM{'orderstatus'};
      $orderid=$FORM{'orderid'};
   }



   $sth = $dbh->prepare ( $query );
   $sth->execute;
#   $num = $sth->rows;
   $num=0;
   while ( %{$rwh}=%{$sth->fetchrow_hashref(NAME_lc)} ) {
      $num++;
   }   
   $foundcount = $num;

   $sth = $dbh->prepare ( $query );
   $sth->execute; 

   ## parse out the template
   #
   $FORM{'sitename'}=$site->{'sitename'};
   $FORM{'lastmode'}=$FORM{'mode'};
   $FORM{'scriptname'}="$scriptname";
   $FORM{'scriptpath'}="$scriptpath";

   ## put session data in $v for GET URL construction
   #
   $v="&sid=$sid_encrypt&mode=showorder&loadfrom=db"; 
   $old="old";

   $t = loadtemplate("row_order_searchlist", $skeletonpath);
   $t =~ s/<!--.*-->//s;

   if ($FORM{maxrows} ne "") {
   $maxrows = $FORM{maxrows}; }
   if ($maxrows > 200) { $maxrows = 200; }

   if ($FORM{startrow} ne "") {
      $startrow = $FORM{startrow};
      } else {
      $startrow = 0;
   }

   $lastrow = $startrow + $maxrows;
   if ($lastrow > $foundcount) {
      $lastrow = $foundcount;
   }

   for ($rowctr = 0; $rowctr < $num; $rowctr++) {
      %row=%{$sth->fetchrow_hashref(NAME_lc)};
      if (($rowctr >= $startrow) && ($rowctr < $lastrow)) {
## put in order specific routines 

      $objid=$row{'objid'};
      next if ( ! $objid );
      $k="orderid=$objid";
      $old=$objid;
      next if ( $row{'status'} eq "15012-A" );

#      $qu = "SELECT wh FROM ocart WHERE orderid='$objid' AND objclass != '140-A'";
#      $sta = $dbh->prepare ( $qu );
#      $sta->execute;
#      $warehouse = $sta->fetchrow;

      @keys= keys %row;

      $date = $row{'cdate'};

      @date=localtime($date);
      $month=$date[4]+1;
      $date[5] += 1900;
      $date[0] = "0".$date[0] if ( $date[0] < 10 );
      $date[1] = "0".$date[1] if ( $date[1] < 10 );

      $SL{'date'} = "$month/$date[3]/$date[5]";
      $SL{'time'} = "$date[2]:$date[1]:$date[0]";
      $SL{'orderid'} = $objid;
      $SL{'oidref'} = "$scriptpath/$scriptname\?$v\&$k";
      $SL{'ship'} = $sstatus->{$row{'status'}};
      $SL{'wh'} = $wh;

      $NVP{'column_215_1'} .= permutebit($t, \%SL); 
      }
   }

   $NVP{'starttime'}=$starttime;
   $NVP{'endtime'}=$endtime;
   $NVP{'orderid'}=$orderid;
   $NVP{'orderstatus'}=$orderstatus;
   $NVP{'warehouse'}=$warehouse;

   $FORM{'query'} = $query;
   $FORM{'searchnum'}=$foundcount;
   $NVP{'searchnum'}=$foundcount;  

#   $pr = "sid=$sid&mode=findobject&objskel=$FORM{objskel}&keyword=$FORM{keyword}&sku_series=$FORM{sku_series}&status_inp=$FORM{status_inp}&objtype=$FORM{objtype}";

   $pr = "sid=$sid_encrypt&mode=searchlist&starttime=$FORM{starttime}&endtime=$FORM{endtime}&orderstatus=$FORM{orderstatus}&orderid=$FORM{orderid}&warehouse=$FORM{warehouse}";

   ($back, $next, $pages, $firstrecord) = &setSearchNavigation($pr, $foundcount,$maxrows, $startrow, $lastrow);

   $startlink = $startrow + 1;
   $thispage=~ s/__pages__/$pages/gms;
   $thispage=~ s/__back__/$back/gms;
   $thispage=~ s/__next__/$next/gms;
   $thispage=~ s/__start__/$startlink/gms;
   $thispage=~ s/__end__/$lastrow/gms;

   $FORM{'script'}="order.cgi";
   $thispage = permutebit( $thispage, \%FORM );
   $thispage = permutebit( $thispage, $site );
   $thispage=~ s/__PAGE_ERROR_MSG__/$NVP{'PAGE_ERROR_MSG'}/gms;
   $thispage=~ s/__script__/$FORM{'script'}/gms;
   $thispage=~ s/__sid__/$sid/gms;
   $thispage=~ s/__mode__/$FORM{'mode'}/gms;
   $thispage = permuteclean ( $thispage ); 
#   print $thispage;
   $sth->finish;
   return 1;
}   


sub hardcodes {

$sstatus = {
               '15012-A' => 'in checkout',
               '15018-A' => 'Tentative Order -  Authorization Pending',
               '15020-A' => 'Awaiting Fulfillment',
               '15025-A' => 'Left Facility and in Route to Customer',
               '15027-A' => 'Shipped with Funds Captured',
               '15028-A' => 'Voided',
            };

$smethod = {
               "50100-A"  => "UPS 2nd Day Air",
               "50101-A"  => "UPS 2nd Day Air AM",
               "50102-A"  => "UPS 3 Day Select Commercial",
               "50103-A"  => "UPS 3 Day Select Residential",
               "50104-A"  => "UPS Ground to Commercial",
               "50105-A"  => "UPS Ground to Residential",
               "50106-A"  => "UPS Ground to Residential (area surcharge)",
               "50107-A"  => "UPS Next Day Air",
               "50108-A"  => "UPS Next Day Air Early AM",
               "50109-A"  => "UPS Next Day Air Saver",
               "50150-A"  => "USPS Bound Printed Matter",
               "50151-A"  => "USPS Express Mail",
               "50152-A"  => "USPS First Class Mail",
               "50153-A"  => "USPS Parcel Post",
               "50154-A"  => "USPS Priority Mail",
               "50155-A"  => "USPS Special Standard Mail", 
               "50000-A"  => "FedEx 2 Day",
               "50001-A"  => "FedEx Express Saver",
               "50002-A"  => "FedEx First Overnight",
               "50003-A"  => "FedEx Freight",
               "50004-A"  => "FedEx Priority Overnight",
               "50005-A"  => "FedEx Standard Overnight",
};

}

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="Date entered invalid";
      $script_msg{3}="Date entered invalid, please don't try any impractical date.";
      $script_msg{4}="Ending date should be later than starting date.";
      $script_msg{5}="Starting date can not be now or later.";
      $script_msg{6}="Please enter both dates!";
      $script_msg{7}="Date format invalid!";
      $script_msg{8}="('Jan'=>0,'Feb'=>1,'Mar'=>2,'Apr'=>3,'May'=>4,'Jun'=>5,'Jul'=>6,'Aug'=>7,'Sep'=>
8,'Oct'=>9,'Nov'=>10,'Dec'=>11 )";
      $script_msg{9}="Today's hour and min data invalid!";
      $script_msg{10}="Date entered invalid";
      $script_msg{11}="Date entered invalid, please don't try any impractical date.";
      $script_msg{12}="Ending date should be later than starting date.";
      $script_msg{13}="Starting date can not be now or later.";
      $script_msg{14}="You must specify at least one of the following items for search";
      $script_msg{15}="You should specify both of the dates for search";
      $script_msg{16}="Date must be of the form mm/dd/yyyy";
      $script_msg{17}="Nothing found! Please try another search.";
      $script_msg{18}="Submitted changes to order";
      $script_msg{19}="Searchlist";
      $script_msg{20}="Shipped";
      $script_msg{21}="UnShipped";
      $script_msg{22}="Not Specified";
      $script_msg{23}="Shipped";
      $script_msg{24}="Unship";
      $script_msg{25}="ToBeShipped";
      $script_msg{26}="Update QTY";
      $script_msg{27}="Remove";
      $script_msg{28}="Reship";
      $script_msg{29}="Return";
      $script_msg{30}="Ship Entire Order";
      $script_msg{31}="See Ship Info";
      $script_msg{32}="Shipped";
      $script_msg{33}="Order ID:";
      $script_msg{34}="Change Bill Address";
      $script_msg{35}="Change Shipping Address";
      $script_msg{36}="Address:";
      $script_msg{37}="Shipping Order Number:";
      $script_msg{38}="Order Statistics";
      $script_msg{39}="Show Order Statistics";
      $script_msg{40}="Shipping Information for Order Number";
      $script_msg{41}="This Line id was shipped:";
      $script_msg{42}="Shipped";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }

   if ( $verbose_errors ) {
      if ($om_render_lang eq "eng" ) {
         $script_msg{1}="looking for";
      } else {
         open( EM, "<$relpath/bits/$om_render_lang/system/$script.errors");
         while(<EM>) {
            chomp;
            next if /^\#/;
            next if (! $_);
            @temp=split /\t/;
            $script_msg{$temp[0]}=$temp[1];
         }
         close(EM);
      }
   }

}

1;

