#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# statsman.cgi
#    Administration of stats reports
#
# Version 0.9.15 JC 20001003
#    secure sid
# Version 0.9.14 JC 20000823
#    ->rows
# Version 0.9.13 IB 20000719
#    FORM variables were not being filled before the second pass
# Version 0.9.12 IB 20000717
#    put names of months into message table
#    om_render_language->om_render_lang
# Version 0.9.11 IB 20000712
#    selection of dates at the end of the report
# Version 0.9.10 IB 20000701
#    moved the stats reports from stats to data/stats
# Version 0.9.9 JC 20000628
#    patch for line 193 on bad cookies
# Version 0.9.8 IB 20000608
#    language and interface from table 'sessions'
# Version 0.9.7 IB 20000607
#    Corrected a message.
# Version 0.9.6 IB 20000606
#    corrected the database call
# Version 0.9.5 IB 20000603
#    further conversion
# Version 0.9.4 IB 20000602
#    converted to Rel. 1.0.1
# Version 0.9,3 IB 20000531
#    added custom-lib.pm
# Version 0.9.2 GF 20000524
#    changed targ
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.15 JC 20000411
#    $om_render_lang update
# Version 0.7.14 JC 20000410
#    multilingual messages
# Version 0.7.13 IB 20000402
#    new directory structure
# Version 0.7.12 JC 20000330
#    changed connect statement
# Version 0.7.11 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.10 IB 20000327
#    corrected $relpath
# Version 0.7.9 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.8 IB 20000302
#    updated copyright
# Version 0.7.7 IB 20000228
#    changed store to site
# Version 0.7.6 JZ 20000216
#    show all stats files
# Version 0.7.5 JZ 20000214
#    use templates for snapshot  
# Version 0.7.4 JZ 20000211
#    corrected dir files lookup and run_stats argument
# Version 0.7.3 JZ 20000204
#    change to dynamic stats output
# Version 0.7.2 JZ 20000202
#    add snapshot view
# Version 0.7.1 JZ 20000126
#    creation

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om/admin,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/conversions.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/login.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/blowfisher.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## get the CGI bits
#
%FORM=();
&ReadParse;
$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ($FORM{'sid'});
$sid=$FORM{'sid'};

## establish connection in
#
$s = "$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
$interface = "";

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $interface=$h->{'interface'};
   $sts->finish;
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

## load messages
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message; 

## done with pull-from-file bits, rest of global settings...
#
$x= (split /\?/, $ENV{'REQUEST_URI'})[0];   # strip get stuff
@temp=split /\//, $x;

@temp=("cgi-bin","test","statsman.cgi") if (! $ENV{'REQUEST_URI'} );

$script=( split /\./, $scriptname )[0];
$n= $#temp - 1;
$scriptpath = join "/", ( @temp[0..$n] );

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/admin";
$selskeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/$om_render_lang/html/sel";

## filled in with time/context variable info
$nicedt=nicedatetime();

$now=time();

## construct some shorthands
$script_html = join "-", ("os_allcommerce",$script,"");

## start the replacements hash
#
%NVP=();
$NVP{'sitename'}=$site->{'sitename'};

$FORM{'sid_ok'} = check_login($script,$FORM{'mode'},$FORM{'sid'});

if ( $FORM{'sid_ok'} ) {
   if ( $FORM{'sid_ok'} =~ /^ERROR/ ) {
      ## hard error, redirected to login page
      print "Location: /cgi-bin/om/admin/login.cgi\n\n";
      exit 0 ; 
   } elsif ( $FORM{'sid_ok'} =~ /^Error/ ) {
      ## soft error, send to default mode
      $FORM{'mode'}="home";
      $NVP{'__PAGE_ERROR_MSG__'}=$FORM{'sid_ok'};
   } else {
      ## welcome to the page...
   }   
   print "Content-type: text/html\n\n";
} else {
   ## unknown why sid_ok not populated with some string...
   #
   print "Content-type: text/html\n\n";
   print "<HTML><HEAD></HEAD><BODY>\n";
   print "$FORM{'sid'} sid $script_msg{1} $FORM{'sid_ok'} \n";
   exit 0;
}

$NVP{'sid'}=$FORM{'sid'};
$NVP{'lastmode'}=$FORM{'mode'};
$NVP{'script'}="$scriptpath/$scriptname";
$NVP{'datetime'}=$nicedt;
$NVP{'scriptpath'}=$scriptpath;

$crondir = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/data/stats/cron";
opendir (DIR, $crondir);
@statsfiles = readdir(DIR);
close (DIR);
shift @statsfiles;
shift @statsfiles;   

#create stats file

if ($FORM{'mode'} eq 'home') { #home, need to create stats snapshot

        $q = "SELECT custid from sessions where sid=$FORM{'sid'} ";
        $sth = $dbh->prepare($q);
        $sth->execute;
#        $num = $sth->rows;
 
#        if ( $num==1 ) {
        if ( $rw = $sth->fetchrow ) {
           $q = "SELECT uname from contacts where objid='$custid' ";
           $sts = $dbh->prepare($q);
           $sts->execute;
           $statsuser = $sts->fetchrow;
           $sts->finish;
        } else {
           print "Content-type: text/html\n\n";
           print "<HTML><HEAD></HEAD><BODY>\n";
           print "$statsuser $script_msg{3}\n";
           exit 0;
        }

        $sth->finish;
	$statsuser = 'Opensales' if (!$statsuser);
	#special characters is assumed not allowed in uname in database
	$statsuser =~ s/"/\\"/g;
	$statsuser =~ s/`/\\`/g;
	$statsuser =~ s/\$/\\\$/g;

	$statsdata = `$site->{'fsrootcron'}/run_stats.pl "$statsuser" $now`;

	#get the snapshot view data
	@snap = split /\&/, $statsdata;
	$NVP{'fromtime'} = shift @snap;
	$NVP{'totime'} = shift @snap;
	$NVP{'statsuser'} =  shift @snap;
	$NVP{'tot_page'} =  shift @snap;
	$NVP{'tot_visitor'} =  shift @snap;
	$NVP{'tot_order'} =  shift @snap;
	$NVP{'order_total'} =  shift @snap;
	$NVP{'topitems'} =  shift @snap;
	$NVP{'filedate'} =  shift @snap;

} elsif ($FORM{'detail'}) { #mode is display, check if display detailed realtime stats
	open(D, "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/data/stats/include/$FORM{'detail'}");
	while (<D>) { $statsdata .= $_; }
	close(D);
} else { 
	# find the file and display
	$filename = $FORM{'statsfile'};

	$statsdata ="";
	foreach $f (@statsfiles) {
		if ( $f eq $filename ) {
			open(DF, "<$crondir/$f");
			while (<DF>) { $statsdata .= $_; }
			close (DF);		
			last;
		}
	}
	
	if (!$statsdata) { 
		$NVP{'PAGE_ERROR_MSG'} = "$script_msg{2}";
		$FORM{'mode'} = 'home';
		$NVP{'fromtime'} = $FORM{'fromtime'};
		$NVP{'totime'} = $FORM{'totime'}; 
		$NVP{'statsuser'} = $FORM{'statsuser'} ;
		$NVP{'tot_page'} = $FORM{'tot_page'} ;
	        $NVP{'tot_visitor'} =  $FORM{'tot_visitor'} ;
        	$NVP{'tot_order'} = $FORM{'tot_order'} ;
        	$NVP{'order_total'} = $FORM{'order_total'}; 
       	 	$NVP{'topitems'} = $FORM{'topitems'} ;
        	$NVP{'filedate'} =$FORM{'filedate'} ;
	}
}

$t = loadtemplate("row_option", $skeletonpath);
$t =~ s/<!--.*-->\n//s;
@mh=($script_msg{4}, $script_msg{5}, $script_msg{6}, $script_msg{7}, $script_msg{8}, $script_msg{9}, $script_msg{10}, $script_msg{11}, $script_msg{12}, $script_msg{13}, $script_msg{14}, $script_msg{15});
foreach $f (sort @statsfiles) {
	next if $f !~ /\d+\.html$/;
	$y = substr($f, 0, 4);
	$m = $mh[substr($f, 4, 2)-1];
	$d = substr($f, 6, 2);
	$ST{'VALUE'} = $f;
	$ST{'DVALUE'} = "$m  $d  $y";
	$select .= permutebit($t, \%ST);
}

$targ="os_allcommerce-".$script."-".$FORM{'mode'};
if ($NVP{'lastaction'}) {
	$targ="os_allcommerce-statsman-home";
	$FORM{'mode'}="home";
}

$l = loadtemplate($targ, $skeletonpath);
$l=permutebit($l, \%NVP);

$l=~ s/__selectstats__/$select/;
$l =~ s/__statsdata__/$statsdata/;
$l = permuteclean($l);

print $l;

$dbh->disconnect if ( $dbh );

sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="evaluates as";
      $script_msg{2}="No information was found for a specified date. Please try another date.";
      $script_msg{3}="unknown.";
      $script_msg{4}="Jan";
      $script_msg{5}="Feb";
      $script_msg{6}="Mar";
      $script_msg{7}="Apr";
      $script_msg{8}="May";
      $script_msg{9}="Jun";
      $script_msg{10}="Jul";
      $script_msg{11}="Aug";
      $script_msg{12}="Sep";
      $script_msg{13}="Oct";
      $script_msg{14}="Nov";
      $script_msg{15}="Dec";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
} 

1;
