#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# cart.cgi
#    shopping cart script
#    RF 981203
#
####

####
# Version 5 JC 20001003
#       encrypt sid
# Version 4 NC 20000920
#       change $dbh->do( $q ); to $sth=$dbh->prepare( $q ); $sth->execute;
# Version 3 JC 20000908 
#       Oracle specific changes
# Version 2 LCF 20000907
#	moved more of mthe rows stuff into cart-lib,
#	changed "where am I" code to new version
# Version 0.8.62 LCF 20000825
#    added use strict, put much stuff in cart-lib.pm
# Version 0.8.61 JC 20000822
#    put purchase limit on cart
# Version 0.8.60 JC 20000722
#    bug fixes
# Version 0.8.59 IB 20000717
#    om_render_language -> om_render_lang
# Version 0.8.57 JC 20000708
#    fixed messaging error
# Version 0.8.56 JC 20000706
#    fixed price listing so that it is the lowest
# Version 0.8.55 IB 20000606
#    language and interface from table 'sessions'
# Version 0.8.54 IB 20000503
#    added custom-lib.pm
# Version 0.8.53 GF 20000524
#    objtype to objclass
# Version 0.8.52 GF 20000521
#    added logic for variants/master
# Version 0.8.47 GF 20000516
#    variants squashed into things   
# Version 0.8.46 GF 20000508
#    error messages
# Version 0.8.41 GF 20000504
#    takes an objid    
# Version 0.8.40 GF 20000504
#    sku -> objid   
#    lowercase field names
#    u_email to custid
# Version 0.8.36 JC 20000417
#    changed loadtemplate to localize_template
# Version 0.8.35 IB 20000417
#    fixed messages
# Version 0.8.34 GF 20000413
#    fixed sku, var translations 
#    changed UID to U_EMAIL
#       TBD - hardcode xpr for promotions
#           - translation of sku, vsku and vcode 
# Version 0.8.33 IB 20000411
#    default to language in site.pm
# Version 0.8.32 IB 20000410
#    corrected a comment
# Version 0.8.31 IB 20000409
#    language
# Version 0.8.30 IB 20000405
#    language fix
#    corrected a typo
# Version 0.8.29 IB 20000404
#    new directory structure
# Version 0.8.28 IB 20000402
#    new directory structure
# Version 0.8.27 IB 20000331
#    cell templates renaming
# Version 0.8.26 IB 20000330
#    changed connect statement
# Version 0.8.25 JC 20000329
#    changed DBI prepare/connect
# Version 0.8.24 IB 20000327
#    corrected $relpath
# Version 0.8.23 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.8.22 JC 20000322
#    put colon in at ssl_prefix
# Version 0.8.21 IB 20000317
#    renaming of templates
# Version 0.8.20 IB 20000313
#    corrected an operator
# Version 0.8.19 IB 20000302
#    updated copyright information and removed -w
# Version 0.8.18 IB 20000226
#    changed store to site
# Version 0.8.17 GF 20000202
#    added in no_item message when cart is empty
# Version 0.8.16 IB 20000128
#    fixed storeurl
# Version 0.8.15 JN 20000127
#    fixed addrid bug
# Version 0.8.14 JN 20000124
#    added wishlist and registry.cgi
# Version 0.8.13 JN 20000117
#    changed http to store.pm ref when accessing checkout
# Version 0.8.12 JN 20000103
#    fixed the price display when adding more items to an existing item
#    in the cart
# Version 0.8.11 IB 991217
#    reversed the order of two instructions in order to avoid messages
#    on the screen
# Version 0.8.10 IB 991203
#    added track.cgi
# Version 0.8.8 IB/GF 991202
#    added bits/site to bits
#    added in loadtemplate for footer element
#    removed bottom_nav loadtemplate element
# Version 0.8.7 JN 991202
#    variant support fixed
# Version 0.8.6 IB 991126
#    corrected bits/pages to bits/site/pages
# Version 0.8.4 IB 991111
#    corrected the determining of a relpath
#    removed foreach
#    corrected $scriptname
# Version 0.8.3 IB 991111
#    corrected DBI statement position, eliminated store_env
# Version 0.8.2 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.8.1 IB 991102
#    general cleanup
# Version 0.7.6 SH 990903
#    specify active prices
# Version 0.7.1 GF 990829
#    Made work with variants
#    Accepts a VCODE and then translates sku and vcode
# Version 1 - 981204
#
####
# Start docs
=pod

=head1 NAME 

cart.cgi

=head1 SYNOPSIS

This cgi creates and manages the shopping cart display.

=head1 DESCRIPTION

This script manages items in the shopping cart. Whenever a user views their cart, removes items, or changes quantities of items, this is the code that deals with that.

=head1 NOTES & BUGS

Still somewhat messy. More of the program logic should be in cart-lib.pm.

=cut
# End docs

#use strict;
my ($sth);	# Standard statement handle var

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#

# Find out where we are, so we can load libs.
##
use Cwd;
my $separator = '/'; # What separates dirnames in this architecture?
my ($scriptname, $args, $rundir);
($scriptname, $args) = split /\?/, $0;
if ($scriptname =~ /$separator/) {
	$scriptname =~ /^(.*)$separator(.*?)$/;
	$rundir = $1;
	$scriptname = $2;
} else {
	$rundir = cwd();
}
my @path = split(/$separator/, $rundir);
my $relpath;
while (my $d = pop @path) {
	$relpath .= "..$separator";
	if ($d eq 'cgi-bin') {
		$relpath .= "..$separator";
		last;
	}
}
my $siteshortname = pop @path;
$relpath .= $siteshortname;
###########

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/cart-lib.pm";
require "$relpath/lib/blowfisher.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=&setsite();

## get the CGI bits
#
# $length is what ReadParse returns first by default. 
# We don't need it, but have to take the data anyway.
%FORM;
&ReadParse;

## establish connection to database  
#
my $q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

# Add dbh to $site, for convenience
$site->{dbh} = $dbh;

$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ($FORM{'sid'});

($om_render_lang, $interface) = ''; 

if ($FORM{'sid'}) {
   $sth = &get_lang_interf($FORM{'sid'}, $site->{dbh});
   my $h=$sth->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $interface=$h->{'interface'};
   $sth->finish();
}


$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

# Add render_lang to site, for libs
$site->{'om_render_lang'} = $om_render_lang;
$site->{'current_interface'} = $interface;



## load messages
my %script_msg = &message();          # user interaction messages

## disconnect so that it does not interfer with setsessionid
#$dbh->disconnect;

## check for a session id
#
my $sid = &setsessionid();    # either a sid > 0 or 0

## reconnect after setsessionid
#
#$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## start the response header
#
print "Content-type: text/html\n\n";

## deal with form elements that may need defaults
#
# destination upon successful login
if ( exists($FORM{'pg_targ'}) ) {       # target page element exists
                                        # user is coming from with script
                                        # don't need to do anything

} elsif ( $ENV{'HTTP_REFERER'} ) {      # no target page exists
                                        # do they have a environment referer  

   ## check that refered from inside site
   #
   if (( $ENV{'HTTP_REFERER'} =~
      /($site->{'sitedomain'}|$site->{'sitessldomain'})/ ) and
      ( $ENV{'HTTP_REFERER'} !~ /$scriptname/ )) {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'};

   } else {
                                         # referer is outside site or this 
                                         # script, default to home page
     
      $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
   } #/done looking at plausibility of using the referer as page target

} else {                                         # default target to home page
   $FORM{'pg_targ'}="http://$site->{'siteurl'}/html/$om_render_lang/home.shtml";
} #/done checking over page to use on outbound

## fork env and track user 
#
#`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;

## determine identity of next page in checkout sequence
#
$sth = &get_next_pg_id($site, \%FORM);

my ($uid) = '';

if ( my ( $a,$b,$c ) = $sth->fetchrow ) {

	($uid, %FORM) = &make_nextpg_user($a,$b,$c,$site,\%FORM);
	
} else {  # user has no cookie or no session id is being generated
          # add error checking and default user to wrapper script 
          # stub for now - there should be a session id on file.
	(%FORM) = &make_nextpg_nouser($a,$b,$c,$site,\%FORM);

} #/end of checking on sid for login
# finish that statement handle
$sth->finish();

# check if any items have been checked out
# if so, put hquant back to lstock
# and set hquant and squant to 0
&put_checkout_items_back($FORM{'sid'});

my ($a,$b,$c_err);

if ( $FORM{'objid'} ) {                   # an object id exists, lets validate
                                          # this objid and see if it is an item 
                                          # we can add to the cart 

   ## validate the addition of this item to the cart
   #
   if ( $FORM{'add'} ) {                  # form add is the amount we are being
                                          # given to add to the cart

	## cartaddcheck - make sure item is available
	#
        $FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ($FORM{'sid'} && length($FORM{'sid'}) > 11);      
	($a,$b,$c_err)=&cartaddcheck($FORM{'add'},'',$FORM{'objid'},$FORM{'sid'},$FORM{'cartclass'},'','',$site);


    # a      is objid    (line id) 
    # b      is quant    (quantity available to user)
    # c_err  is err      (error message)

      if ( $c_err eq "1" )  { 
         $c_err=$script_msg{4};
      } elsif ( $c_err eq "2" ) { 
         $c_err=$script_msg{5};
      } elsif ( $c_err eq "3" ) { 
         $c_err=$script_msg{6};     
      } elsif ( $c_err eq "4" ) {
         $c_err=$script_msg{7};  
      } elsif ( $c_err eq "5" ) {
         $c_err=$script_msg{8};
      } elsif ( $c_err eq "6" ) {
         $c_err=$script_msg{9};
      } elsif ( $c_err eq "7" ) {
         $c_err=$script_msg{10};
      } elsif ( $c_err eq "8" ) {
         $c_err=$script_msg{11};
      } 

        
      ## set the lineid to a form variable
      #
      $FORM{'newrow_objid'}=$a;

      my $aa="row.".$a.".quant_err";
      my $bb="row.".$a.".quant_inp";
      $FORM{$aa}=$c_err."<BR>" if ( $c_err ); 
      $FORM{$bb}=$b;
  
   } #/done seeing if they are attempting to add a promotion sku
} #/done adding new rows

## add item to wishlist      
#
 
foreach my $k (keys %FORM ) {
   next if ( $k !~ /mv_pcart$/ );
   next if ( $FORM{$k} ne 'on');
   my $tmp_lineid = (split /\./, $k)[1];
 
   if ($FORM{'wishlist_en'} == 1 && ($uid)) {
      if (tcart_to_pcart($sid,$uid,$tmp_lineid)) {
         $k =~ s/mv_pcart/kill/;
         $FORM{$k}='on';
      }
   } else {
      $k =~ s/mv_pcart/QUANT_err/;
      $FORM{$k}=$script_msg{3};
   }
}                  

## remove item from cart 
#
my @temp = keys %FORM;

   while ( @temp ) {
      my $k = shift @temp;
      next if ( $k !~ /kill$/ && ($k !~ /quant_inp$/ || $FORM{$k} != 0));
      next if ( $FORM{$k} ne "on" && ($k !~ /quant_inp$/ || $FORM{$k} != 0));
      $k = ( split /\./, $k )[1];
      next if ($k<1);

      $q = "DELETE from tcart where objid='$k' ";
#      $dbh->do( $q );
      $sth = $dbh->prepare( $q );
      $sth->execute;
   } #/ end of processing kills

                                          # adjust quantities in cart

@temp = keys %FORM;

   while (@temp) {
      my $k=shift @temp;

      my ($kp, $kk, $kn);
		next if ( $k !~ /^row/ );           # only want row entries
      next if ( $k !~ /quant_inp/ );
      next if ( $FORM{$k} eq "no" );      # skip the new ones
      $kp = $k;
      $kk = $k;
      $kk =~ s/quant_inp/kill/ ;
      next if ( exists($FORM{$kk}) and ( $FORM{$kk} eq "on" ));  # skip remove items 
      next if ( $k =~ /quant_inp$/ && $FORM{$k} == 0); 
      $kn = ( split /\./, $k )[1];        # rowid
  
      next if ( $kn eq $FORM{'newrow_objid'} );   # skip newrow
      $kp =~ s/quant_inp/quant_pre/ ;
    

      ##change the quantity in the cart
      #
      if ( $FORM{$k} != $FORM{$kp} ) {    # quantity change
         my $objid=$FORM{"row.".$kn.".lineobjid"};
         my $err="row.".$kn.".quant_err";
			my $sku;
			
         if ( $FORM{$sku} =~ /^xpr/ ) {    # promotional sku
                                           # do not allow quantity changes
            $FORM{$err}=$script_msg{1};

          } else {                         # normal sku
            $FORM{$k}=$FORM{$kp}-$FORM{$k} if ( $FORM{$k}<0 );
            $FORM{$k}=0 if ( $FORM{$k}<0 );
                                $FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ($FORM{'sid'} && length($FORM{'sid'}) > 11);
				($a,$b,$c_err)=&cartaddcheck($FORM{'add'},$FORM{$k},$objid,$FORM{'sid'},$FORM{'cartclass'},'','',$site);



          # a      is objid    (line id)
          # b      is quant    (quantity available to user)
          # c_err  is err      (error message)
 
          if ( $c_err eq "1" )  {
             $c_err=$script_msg{4};
          } elsif ( $c_err eq "2" ) {
             $c_err=$script_msg{5};
          } elsif ( $c_err eq "3" ) {
             $c_err=$script_msg{6};
          } elsif ( $c_err eq "4" ) {
             $c_err=$script_msg{7};
          } elsif ( $c_err eq "5" ) {
             $c_err=$script_msg{8}; 
          } elsif ( $c_err eq "6" ) {
             $c_err=$script_msg{9};
          } elsif ( $c_err eq "7" ) {
             $c_err=$script_msg{10};
          } elsif ( $c_err eq "8" ) {
             $c_err=$script_msg{11};
          }                         

          $FORM{$err}=$c_err."<BR>" if ( $c_err );
      } #/done sniffing for disallowed quantity changes
   } #/done with while
} #/done with adjustments

## use the sid and pull all rows from tcart
#

my ($rows, $FORM, $count) = &get_cart_rows($site, $dbh, $c_err, %FORM);           # row hashrefs
%rows = %{$rows};
%FORM = %{$FORM};

unless ( $count ) {                 # error messages when either no items
                                  # are in the cart or cartaddcheck 

   if ( $FORM{'cart_error'} eq '' ) {
      # sorry you have no items in your cart
      $FORM{'cart_error'}=$script_msg{2};

   } else {
      # error message from cartaddcheck
      $FORM{'cart_error'}="$c_err";
   }
}  


my $page_error;
## page error message
#
$FORM{'page_error'}=$page_error;  

## load and permute templates
#
my %templates = &cart_perm_template($om_render_lang, $interface);

## construct "new" item row
#
my ($tmpl, $frm) = &new_item_row(\%rows, \%FORM, \%templates);
%FORM = %{$frm};
%templates = %{$tmpl};


## construct "old" item rows
#
%FORM = &old_item_row(\%FORM, \%rows, \%templates);

## output the file to stdout
#
my $thispage=localize_template("page_cart_cart",$om_render_lang,$interface,0);

## output the file to stdout
#
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, $om_render_lang, "html", 0);

print $thispage;

## cleanup
#
#$sth->finish if ( $sth );

#$dbh->disconnect if ( $dbh );

## provide a return value
#
1;
