#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# inbound.cgi
#    session id setting and redirecting script
#    RF 981208 - based on sid.cgi, version 1-981208
#
#####

####
# Version 2 JC 20001003
#    secure sid
# Version 1 NC 20000920
#    change $dbh->do($q); to $sth=$dbh->prepare($q); $sth->execute;
# Version 0.7.40 JC 20000712
#    wml support 
# Version 0.7.39 JC 20000707
#    put coma in update statement for sessions
# Version 0.7.38 IB 20000605
#    corrected typos
# Version 0.7.37 IB 20000531
#    added custom-lib.pm
# Version 0.7.35 GF 20000519
#    debugging for datastructure 0.9.18
#    script cleanup and lowercase fieldnames
# Version 0.7.34 JC 20000428
#    changed logging of om_render_lang from cookie to sessions table
# Version 0.7.33 IB 20000421
#    removed loading of messages
# Version 0.7.32 HVC 20000420
#    call wrapper.cgi for no cookie request
# Version 0.7.31 IB 20000411
#    default to language in site.pm
# Version 0.7.30 IB 20000410
#    corrected =~ to eq
# Version 0.7.29 IB 20000409
#    declared the array %script_msg().
# Version 0.7.28 IB 20000408
#    multilingual messages
# Version 0.7.27 RF 20000406
#    setup of user interface language and setting cookie OM_UI_LANGUAGE
# Version 0.7.26 IB 20000406
#    corrections
# Version 0.7.25 JC 20000405
#    localization message support
# Version 0.7.24 JC 20000405
#    check browser lang settings
# Version 0.7.23 JC 20000405
#    localization message support
# Version 0.7.22 JC 20000404
#    check to see if default language is valid
# Version 0.7.21 JC 20000403
#    localization support
# Version 0.7.20 JC 20000330
#    changed connect statement
# Version 0.7.19 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.18 IB 20000327
#    corrected $relpath
# Version 0.7.17 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.16 IB 20000308
#    changed REFERER to HTTP_REFERER
#    initialized uninitialized variables to avoid error messages
# Version 0.7.15 IB 20000302
#    updated copyright
# Version 0.7.14 IB 20000226
#    changed store to site
# Version 0.7.13 GF 991203
#    commented out getpage redirect
#    redirected to cookie warning
# Version 0.7.12 IB 991116
#    corrected the number of arguments in a database call
# Version 0.7.11 IB 991113
#    removed cgi-lib.pm because it is not needed
# Version 0.7.10 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.9 IB 991111
#    fixed list of libraries
# Version 0.7.8 IB 991110
#    correction of a database call
# Version 0.7.7 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.6 IB 991025
#    the UID field has been dropped from table clicks
# Version 0.7.5 RF 991022
#    fixed path failure to static pages
# Version 0.7.4 RF 991022
#    fixed redirection failure to getpage.cgi
# Version 0.7.3 RF 991022
#    added patch to older store.pm - assume database name is
#    also the name of the directory below ./cgi-bin in the 
#    tree, and provide that as an argument to setstore()
#    Also derefed the $store hashref to satisfy older libraries
# Version 0.7.2 RF 991022
#    near total rewrite
#    added relative path detection for requires statements
#    trimmed diagnostic printing
#    added logic to spot non-cookie taking customers
# Version 0.7.1 GF 990830
#    trying to revitalize this script
# Version 4 - 981218 
#    efficiency improvements in prep for eWallet hit
# Version 2 - 981213
#    added logging of inbounds...
# Version 1 - 981208
#
#####

$sid=$ENV{'HTTP_COOKIE'};
$sid=( split /sid=/, $sid )[1] if ( $sid );
$sid=( split /&/, $sid )[0] if ( $sid );

## wml support
#
$http_accept=$ENV{"HTTP_ACCEPT"};
$http_user_agent=$ENV{"HTTP_USER_AGENT"};
 
# Determine the device from where request is coming from
if ( ($http_accept =~ "text\/vnd\.wap\.wml") ||
     ($http_user_agent =~ "wap") ||
     ($http_user_agent =~ "7110") ) {
    # Device is cell phone
    $interface="wml";
    # print "Location: http://www.zelerate.org/wml/eng/welcome.wml \n\n"; 
}

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );
$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/custom-lib.pm";
require "$relpath/lib/blowfisher.pm";

## establish site-specific parameters
#
$site=setsite();

$now=time();
$sid=&os_unhash(pack(H16, $sid), $site->{'hash_key'}) if ( $sid );
## set up localization
#

$lang=$ENV{'HTTP_ACCEPT_LANGUAGE'};
@langs=split(/,/, $lang);

foreach $k (@langs) {
   
   next if ( $om_render_lang );

   $k =~ s/\s+//g;                     # kill spaces

   if ( $k =~ /-/ ) {
      $langcomp=(split(/-/, $k))[0];   # throw away bits after dash
   } else {
      $langcomp=$k;
   }
   # now have a language code, get the 3-digit code used by OM
   # and see if this is on the list of active languages
   $lang_three=(split /\t/, om_iso_639($langcomp))[0];
   next if ( ! $lang_three );

   if ( $lang_three =~ /$site->{'om_locale_lang_act'}/ ) {
      $om_render_lang=$lang_three;
   } 

} # done running through list of browser preferred languages

# if null render language, select first of the defined active languages
$om_render_lang=( split /\W+/, $site->{'om_locale_lang_act'} )[0]
   if ( ! $om_render_lang );

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );

# if still null, hardcode to english just to get something set
$om_render_lang="eng" if ( ! $om_render_lang );

$interface="html" if ( ! $interface);

## open database connection
#
$q="$site->{'db_site_config'}";
$dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## now either have a sid or not...
#
if ( $sid ) {                         # session id cookie present
                                      # have a cookie, just send them 
                                      # to their requested page with 
                                      # simple logging
 
   $target = ( split /page=/,$ENV{'REQUEST_URI'},1 )[1];
   $target = "" if ( ! $target );     # default to homepage
   $target =~ s/&cookietest=on// ;

   $target="/$interface/$om_render_lang/home.shtml" if ( ! $target ); 
    
   ## update language setting in sessions
   #
   $q="UPDATE sessions SET language='$om_render_lang',interface='$interface' WHERE sid=$sid";
#   $dbh->do( $q ); 
   $sth = $dbh->prepare( $q );
   $sth->execute;

   ## log the click to the table of clicks
   #
   $q="INSERT INTO clicks VALUES ";
   if ($ENV{'HTTP_REFERER'}) {
      $value = $ENV{'HTTP_REFERER'}; 
   } else {
      $value = "";
   }
   $q.=" ('$sid','$now','$ENV{'REQUEST_URI'}','$value', ";
   $q.=" '$site->{'clusterid'}')";
#   $dbh->do( $q );
#   $sth = $dbh->prepare( $q );
#   $sth->execute;

   print "Status: 302/Moved\n";
   print "Location: $target\n";    
   print "\n\n";

} else {                              # session id cookie absent
                                      # do not have a cookie, redirect 
                                      # user request to wrapper.cgi

   $ENV{'REQUEST_URI'}="" if ( ! $ENV{'REQUEST_URI'} ); 

   if ( $ENV{'REQUEST_URI'}=~/sid=/ ) {               # sid embeded in URI
      $sid=$ENV{'REQUEST_URI'};
      $sid=( split /sid=/, $sid )[1];
      $sid=( split /&/, $sid )[0] if ( $sid );
   } # done looking for embeded sid

   if ( $ENV{'REQUEST_URI'} =~ /cookietest=on/ )  {   # we just tried to give 
                                                      # them a cookie, and failed

      $target = ( split /page=/,$ENV{'REQUEST_URI'},1 )[1];
      $target="/$interface/$om_render_lang/home.shtml" if ( ! $target ); 

      ## log the click to the table of clicks
      #
      if ($ENV{'HTTP_REFERER'}) {
	$value = $ENV{'HTTP_REFERER'}; 
      } else {
	$value = "";
      }
      $q="INSERT INTO clicks VALUES ";
      $q.=" ('$sid','$now','$ENV{'REQUEST_URI'}','$value','$site->{'clusterid'}')";
#      $dbh->do( $q );
      $sth = $dbh->prepare( $q );
      $sth->execute;

      print "Status: 302/Moved\n";
      print "Location: /cgi-bin/om/wrapper.cgi?sid=$sid&target=$target\n";
      print "\n\n";

                                                     # give them a cookie and 
                                                     # redirect them back here
   } else { 
      $target = $ENV{'REQUEST_URI'};
      if (!$target || $target eq "/" ) {
         $target = "";
      }

      if ( ! $sid ) {                                # set a cookie
         $sid=setsessionid();                     

      } else {                                       # set a cookie with sid 
                                                     # salvaged from URI
 
        print "Set-Cookie: sid=$sid; path=/; domain=$ENV{'SERVER_NAME'}\n" if ( $interface eq "html");
        print "Set-Cookie: sid=$sid Comment=setting sid \n" if ( $interface eq "wml");
      } #/done with selection of how to set the cookie 

      print "Status: 302/Moved\n";
      print "Location: /cgi-bin/om/inbound.cgi?sid=$sid&cookietest=on&target=$target\n";
      print "\n\n";

      $q="INSERT INTO clicks VALUES ";

      if ($ENV{'HTTP_REFERER'}) {
         $value = $ENV{'HTTP_REFERER'};
      } else {
         $value = "";
      }

      $q.=" ('$sid','$now','$ENV{'REQUEST_URI'}','$value','$site->{'clusterid'}')";
#      $dbh->do( $q );
      $sth = $dbh->prepare( $q );
      $sth->execute;

   } #/done with cookie acceptance testing for cookieless sessions 

   ## insert sessions the language being used
   #
   $q="UPDATE sessions SET language='$om_render_lang',interface='$interface' WHERE sid='$sid'";
#   $dbh->do( $q );
    $sth = $dbh->prepare( $q );
    $sth->execute;
} #/done with examining session id cookie present or absent

## cleanup statement handles and close connection
#
$dbh->disconnect if ( $dbh );

1;
