#!/usr/bin/perl 
#
# palm_cart.cgi
#
# Palm Pilot Demonstration Cart
#
############################################################################
#    Copyright (C) 1999 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# palm_cart.cgi
#    palm aware shopping cart script
#    RF 20000424 - based on cart 0.8.18 of GF 20000202
#
####

####
# Version 3 - 20000424 RF
#    fix for cart write failures
# Version 1 - 20000424 RF

## determine path from store root and store db name...
#
#  note - this script runs in /cgi-bin only - hardwired for Palm VII
#
$scriptname = "palm_cart.cgi";

$rundir= "/home/httpd/pre6/openmerchant0_7/cgi-bin";
chdir( $rundir );

$relpath="..";
$storeshortname="demo";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/store.pm";
require "$relpath/lib/state.pm";

## establish store-specific parameters
#
$site=setstore();

## get the CGI bits
#
%FORM=();
&ReadParse;

open( FH, ">/tmp/palm.rf");
foreach $k ( sort keys %FORM ) {
   print FH "FORM $k = $FORM{$k}\n";
}
foreach $k ( sort keys %ENV ) {
   print FH "ENV $k = $ENV{$k}\n";
}
close(FH);

$skeletonpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site";

## check for a session id...
#
if ( ! $FORM{'sid'} ) {
   if ( ! $FORM{'id'} ) {
      &setsessionid();    # either a sid > 0 or 0
   } else {
      $FORM{'sid'}=( split /\./, $FORM{'id'} )[1];
   } # done constructing a sid-esque thing
}

## start the response header
#
print "Content-type: text/html\n\n";

## establish connection to database  
#
$q = "DBI:$site->{'datadriver'}:$site->{'table'}:$site->{'table_serv'}:$site->{'table_port'}";
$dbh = DBI->connect($q, $site->{'store_dbiuser'}, $site->{'store_dbipwd'} );

## translate out sku   #glenn 
# 

$varsku=$FORM{'VSKU'};
if (!$varsku) {$varsku=$FORM{'SKU'};}

$sku=substr($varsku,0,8);
$var=substr($varsku,8);

$quant=$FORM{'quant'};
$add=$FORM{'add'};
$FORM{'wh'}="1";
$FORM{'sidwh'}=1;

## RF - get the sid-esque thing
#
$sid=$FORM{'sid'};

# there is only one checkout path
$FORM{'nextcheckoutpg'}="/cgi-bin/palm_checkout.cgi";

## now abort process if the $page_error starts with Error
#

if ( $page_error =~ /^Error/ ) {
   ## shutdown connections, load templates, permute and exit
   #
   $sts->finish;
   $dbh->disconnect if ( $dbh );
   $thispage=loadtemplate( );
} # done with shortcircuit bit in case locked in final checkout


## process new lines now
#
if ( $FORM{'VSKU'} ) { # add items to the cart

   # validate the addition of this item to the cart
   if ( $FORM{'add'} =~ /^socheata/ ) { # can't add promotions - done by system

   } else { # all other items 

      ## cartaddcheck - lets make sure we have this available
      #
      ($a,$b,$c ) = cartaddcheck( $add,$sku,$var,$sid,$quant,0,$site->{'series'},'',$FORM{'ADDRID'} );

      # a is $lineid   (line id) 
      # b is quantf    (quantity available to user)
      # c is err       (error message)

      $FORM{'newrow_rowid'}=$a;

      $aa="row.".$a.".QUANT_err";
      $bb="row.".$a.".QUANT_inp";
      $FORM{$aa}=$c."<BR>" if ( $c ); 
      $FORM{$bb}=$b;
  
 } # done seeing if they are attempting to add a promotion sku
}; #/adding new rows


## process kills of lines now
#
@temp = keys %FORM;

while ( @temp ) {
   $k = shift @temp;

   next if ( $k !~ /kill$/ && ($k !~ /QUANT_inp$/ || $FORM{$k} != 0));
   next if ( $FORM{$k} ne "on" && ($k !~ /QUANT_inp$/ || $FORM{$k} != 0));
   $k = ( split /\./, $k )[1];
   next if ($k<1);
   $q = "DELETE from tcart where LINEID='$k' ";
   $dbh->do( $q );
}; # end of processing kills

## adjust quantities
#
@temp = keys %FORM;
while (@temp) {
   $k=shift @temp;

   next if ( $k !~ /^row/ );           # only want row entries
   next if ( $k !~ /QUANT_inp/ );
   next if ( $FORM{$k} eq "no" );      # skip the new ones
   $kp = $k;
   $kk = $k;
   $kk =~ s/QUANT_inp/kill/ ;
   next if ( exists($FORM{$kk}) and ( $FORM{$kk} eq "on" ));     # skip kills
   next if ( $k =~ /QUANT_inp$/ && $FORM{$k} == 0); 
  $kn = ( split /\./, $k )[1];        # rowid
  
 next if ( $kn eq $FORM{'newrow_rowid'} );   # skip newrow
   $kp =~ s/QUANT_inp/QUANT_pre/ ;
    

   ##change the quantity in the cart

   if ( $FORM{$k} != $FORM{$kp} ) {    # quantity change

               #note - kn represent the number in quantity submitted 

      $sku="row.".$kn.".SKU";
      $var="row.".$kn.".VCODE";
      $err="row.".$kn.".QUANT_err";

      if ( $FORM{$sku} =~ /^xpr/ ) {    # promotionals - no quantity changes
         $c="We're tremendously sorry, limit this item to one per order!<BR>";
         $FORM{$err}=$c;

      } else {                   # normal skus
         $FORM{$k}=$FORM{$kp}-$FORM{$k} if ( $FORM{$k}<0 );
         $FORM{$k}=0 if ( $FORM{$k}<0 );
        # $FORM{$k}="q".$FORM{$k}."q";

         ( $a,$b,$c ) = cartaddcheck($add, $FORM{$sku},$FORM{$var},$FORM{'sid'},$FORM{$k},0,$site->{'series'},'',$FORM{'ADDRID'} );

         $FORM{$err}=$c."<BR>" if ( $c );
      } # done sniffing for disallowed quantity changes
   }

} # done with adjustments




## use the sid and pull all rows from scart
#
%rows=();           # row hashrefs

$q = "SELECT * from tcart where SID='$FORM{'sid'}' ";
$sts = $dbh->prepare( $q );
$sts->execute;
$num=$sts->rows;

if ($num < 1) {$FORM{'no_item'}="You currently have no items in your cart.";}

foreach ( 1..$num ) {

   $h=$sts->fetchrow_hashref;
   $row=$h->{'LINEID'};
   $rows{$row}=\%{$h};
   $h->{'LINEID'}=$row;
   $sku=$h->{'SKU'};
   $var=$h->{'VCODE'};

   $q = "SELECT * from things where SKU='$sku' ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
   $n=$sth->rows;

   if ( $n==1 ) {

      $h=$sth->fetchrow_hashref;

      foreach ( keys %{$h} ) {
         $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
      }

   } # end of loading the specifics from products for this one
 
   $q= " SELECT * from variants where SKU='$sku' and VCODE='$var' ";
   $sth=$dbh->prepare( $q );
   $sth->execute;
   $n=$sth->rows;
 
   for (1..$n ) {
      $h=$sth->fetchrow_hashref;

      foreach ( keys %{$h} ) {
         $rows{$row}->{$_} = $h->{$_} if ( ! $rows{$row}->{$_} );
      } #
      
   }

  
   $p = "SELECT * from prices where SKU='$sku' and VCODE='$var' and status='ac' ";
   $stp=$dbh->prepare($p);
   $stp->execute;
   $np=$stp->rows;
   for (1..$np) {
      $pp=$stp->fetchrow_hashref;
      foreach ( keys %{$pp} ) {
      next if ($_ ne "UNITPR");
         $rows{$row}->{$_} = $pp->{$_} if ( ! $rows{$row}->{$_} || $rows{$row}->{$_} eq "0.00" );

      } 

   } # end of loading the specifics from variants for this one

} # done loading fields


$FORM{'page_error'}=$page_error;  

#$templates{'cell_cart_300_header'}=loadtemplate("cell_cart_300_header",
#   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
$templates{'cell_palm_cart_list'}=loadtemplate("cell_palm_cart_list",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
#$templates{'cell_cart_300_subtotal'}=loadtemplate("cell_cart_300_subtotal",
#   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");
#$templates{'cell_cart_300_buttons'}=loadtemplate("cell_cart_300_buttons",
#   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site");

## construct "new" item row
#

if ( $FORM{'newrow_rowid'} ) {

   $row=$FORM{'newrow_rowid'};
   $h=$rows{$row};
   $k="row\.$row\.QUANT_err";
   $h->{'QUANT_err'}=$FORM{$k} if ( $FORM{$k} );

   ## cleanup decimals on prices...

   $h->{'UNITPR'} = nicedecimals( $rows{$row}->{'UNITPR'} );

   $h->{'sid'}=$FORM{'sid'};


   $h->{'ROWID'}=$h->{'LINEID'};

   $h->{'VSKU'}=$FORM{'VSKU'};
   $u=permutebit( $templates{'cell_palm_cart_list'}, $h );
   $u=permuteclean( $u );
   $FORM{'cell_palm_new_cart_list'}=$u;
#   $FORM{'newrow_cell_cart_300_header'}=$templates{'cell_cart_300_header'};
#   $FORM{'newrow_cell_cart_300_buttons'}=
#      permutebit( $templates{'cell_cart_300_buttons'}, \%FORM );

}

## construct "old" item rows
#
$u="";
$FORM{'newrow_rowid'}=0 if ( ! defined($FORM{'newrow_rowid'}) );


foreach $r ( keys %rows ) {

   $rows{$r}->{'sid'}=$FORM{'sid'};
   $rows{$r}->{'sidwh'}=$sidwh;
   $rows{$r}->{'nextwh'}=$nextwh;
   next if ( $r == $FORM{'newrow_rowid'} || $skip );
   $k="row\.$r\.QUANT_err";
   $rows{$r}->{'QUANT_err'}=$FORM{$k};
   $FORM{'ROWID'}=$FORM{'LINEID'};

   $rows{$r}->{'UNITPR'} = nicedecimals ( $rows{$r}->{'UNITPR'} ) ;

   $nextrow=$r+1;
   $rows{$r}->{'VSKU'}=$rows{$r}->{'SKU'}.$rows{$r}->{'VCODE'};
   if ($rows{$r}->{'SKU'} eq $rows{$nextrow}->{'SKU'}) {$skip=1; $rows{$r}->{'QUANT'} = $rows{$r}->{'QUANT'}+$rows{$nextrow}->{'QUANT'}; } else {$skip=0;}
   $rows{$r}->{'ROWID'}=$r;
   $ub=permutebit( $templates{'cell_palm_cart_list'}, $rows{$r} );
   $ub=permuteclean( $ub );
   $u.=$ub;
} # end of constructing old rows     

if ( $u ) {
   $FORM{'cell_cart_300_header'}=$templates{'cell_cart_300_header'};
   $FORM{'cell_cart_300_buttons'}=
      permutebit( $templates{'cell_cart_300_buttons'}, \%FORM );
   $FORM{'cell_palm_cart_list'}=$u;
}

## other included bits
#

## spit the file to stdout
#
$thispage = loadtemplate("page_palm_cart",
   "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site/pages");

$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage =~ s/__SCRIPTNAME__/$scriptname/gsm ;
$thispage = permuteclean ( $thispage  );
print $thispage;

## cleanup
#
$sth->finish if ( $sth );
$sts->finish if ( $sts );

$dbh->disconnect if ( $dbh );

## terminal logging
#
open( FH, ">/tmp/xpalm.rf");
foreach $k ( sort keys %FORM ) {
   print FH "FORM $k = $FORM{$k}\n";
}
foreach $k ( sort keys %ENV ) {
   print FH "ENV $k = $ENV{$k}\n";
}
print FH "\n\n\n==============\n$thispage\n";
close(FH);

## provide a return value...

1;
