#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# search.cgi
#    search site script
#    990828 RF
#
####
 
####
#    
# Version 0.8.48 JC 20001003
#    secure sid
# Version 0.8.47 TG 20000922
#    Bug fixes for variant products
# Version 0.8.46 TG 20000918
#    Check to make sure search request is NOT blank
# Version 0.8.45 JC 20000914
#    oracle integration
# Version 0.8.44 TG 20000721
#    Limited to renderable products
#    Added search by weight
# Version 0.8.43 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.8.41 TG 20000712
#    Added search for variant products if master matched
# Version 0.8.40 TG 20000711
#    Added search for variant encoding.  
#    Known bugs:
#        Cannot search on variant titles, ie Pens
#        Have to have multiple words in the right order for search
# Version 0.8.39 TG 20000710
#    Added search for product, product_line, brand, and article.
# Version 0.8.38 TG 20000707
#    Added Next, back and pages
# Version 0.8.37 TG 20000706
#    Only return products in search, retrofit for new table definitions
# Version 0.8.36 IB 20000606
#    language and interface from table 'sessions'
# Version 0.8.35 IB 20000531
#    added custom-lib.pm
# Version 0.8.34 TG 20000524
#    fixed problem with language support 
#       and new cell template names
# Version 0.8.32 GF 20000520
#    retrofit for 0.9 datastructure
# Version 0.8.31 JC 20000418
#    replaced loadtemplate with localize_template
#    included permute_include
#    removed $skeleton
# Version 0.8.30 IB 20000411
#    default to language in site.pm
# Version 0.8.29 IB 20000410
#    database changes
# Version 0.8.28 IB 20000410
#    multilingual messages
# Version 0.8.27 IB 20000402
#    topbarnav -> jump_to_nav
# Version 0.8.26 IB 20000401
#    new directory structure
# Version 0.8.25 IB 20000330
#    changed connect statement
# Version 0.8.24 JC 20000329
#    changed DBI prepare/connect
# Version 0.8.23 IB 20000327
#    corrected $relpath
# Version 0.8.22 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.8.21 JC 20000323
#    fix for bug #56 on line 280
# Version 0.8.20 IB 20000317
#    new template names
# Version 0.8.19 IB 20000302
#    updated copyright
# Version 0.8.18 IB 20000226
#    change store to site
# Version 0.8.17 IB 20000119
#    limited the search to only displayable items
# Version 0.8.16 IB 20000111
#    corrected search output
# search.cgi 0.8.15 GF 991203
#    search just display items using status="pn" 
# search.cgi 0.8.14 GF 991203
#    added /site to /bits
#    changed page name
#    changed cell names
#    general cleanup
# search.cgi, 0.8 series
#    total rewrite as of 990828
# Version 0.8.1 990828 RF
#    core querry construction engine 
#
###

###
# Overview:
#   Assemble search parameters
#   Obtain list of fields to query against by special term
#   Construct field-specific querries
#   Determine effected tables
#   Run querries by table
#   construct table-by-table result sets
#      NOTE - only tables searched now are:
#         things
#         variants
#         extraprop
#         prices
#         linkage?
#         thesaurus?
#   perform eliminative combinatorics
#   prepare final result set
#   handoff to display routines
#
###

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/variant.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/blowfisher.pm";

# must be tha last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

## reading cgi stuff
#
%FORM=();
&ReadParse; 


## establish connection to table
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
$interface = "";
$numQueries = 0;
$numBind = 0;

$debug = 0;
if ($debug) {
    open (ERLOG,">/tmp/search");
}

$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'} );

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );

&setsessionid();

######
### Assemble search parameters
######
#   Syntax for form variables:
#      search_fieldname_inp (value can contain range specifiers)
#      search_parameter_inp (generally lacks range specifiers)
#      
$sinput={};           # empty hashref of search terms
foreach $k ( keys %FORM ) {
   next if ( $k !~ /^search_/ );       # skip if it isn't search
   next if ( $k !~ /_inp$/ );          # skip if it isn't an input
   next if ( ! $FORM{$k} );            # skip blank parameters
   $ki = $k;
   $ki =~ s/^search_// ;               # generate new key   
   $ki =~ s/_inp$// ;                  # trim "input" flag
   $sinput->{$ki}=$FORM{$k};           # create entry in search term hash

} #/done constructing earch term list


######
### Catch the "redirect" entries and act
######
$rtarget="";                            # target for redirection
foreach $k ( keys %{$sinput} ) {
   next if ( $k !~ /^redirect/ );
   $rtarget=$sinput->{$k} if ( $sinput->{$k} );
} # done looking at $sinput->  keys for redirects

$rtarget="" if ( length($rtarget)<8 );  # minimum sku length
if ( $rtarget ) {
   $rtarget="/html/$om_render_lang/$rtarget.shtml" 
   if ( $rtarget !~ /(.shtml$|^\/cgi-bin|^http:)/ );
   print "Status: 302/Moved\n";
   print "Location: $rtarget\n";
   print "\n\n";

   exit 1;
} #

## defaults that don't live elsewhere yet
#
$objid="";

######
### Initialize "constants"
######
$maxrec=200;                           # max recs to pull per table
%fieldtype=();                         # field types
%fieldlist=();                         # field lists by table
%prikey=();                            # primary key field by table

## load field types for fields of interest
#     TBD - load from table descriptions
#
$fieldtype{'brief'}="char";  
$fieldtype{'msku'}="char";  
$fieldtype{'title'}="char";  
$fieldtype{'keywords'}="char";  
$fieldtype{'custid'}="char";  
$fieldtype{'u_email'}="char";  
$fieldtype{'uname'}="char";  
$fieldtype{'objid'}="char";  
$fieldtype{'vcode'}="char";  

## load field lists by table
#
$fieldlist{'things'}="objid,msku,keywords,vcode,title,brief,axisnames";
$fieldlist{'contacts'}="objid,u_email,uname";
$fieldlist{'addresses'}="name,city,state,postcode";

## load primary keys by table
#
$prikey{'things'}="objid";
$prikey{'extraprop'}="objid";

$big_fieldlist = join ",", ( values %fieldlist );

######
### Obtain mapping of special terms to fields
######
%termmap=();                           # blank term map hash
#                                      # TBD - obtain from database
$termmap{'keywords'}= join ":", ( 
   "title",
   "brief",
   "msku",
   "keywords",
   "encoding"				  
   );
if (0) {
$termmap{'partno'}= join ":", (
   "msku",
   "isbn",
   "upc"
   );

}

######
### First Wave of Construct list of querries by field - mapped fields
######
#   precedence: 
#      a precise fieldname excludes broader mappings from the field
#      a field is querried against a table it is a key of

%fieldq=();                          # holder for growing querries by field
%where=();                           # where clauses by table
foreach $k ( keys %{$sinput} ) {     # first wave - mappings
    next if ( $k !~ /[a-z]/ );        # skip all uppercase keys this pass
    next if ( ! $termmap{$k} );       # skip unmapped keys
    next if ( ! $sinput->{$k} );      # skip null inputs
    $sinput->{$k} =~ s/'/''/g;
   foreach $j ( split /:/, $termmap{$k} ) {   # run through mapped fields CHAR?
      $fieldq{$j}.=" OR " if ( $fieldq{$j} );
      #$fieldq{$j}='{'.$fieldq{$j} if ( ( $fieldq{$j} )
      #                 and ( $fieldq{$j} !~ /^\{/ ) );   
      $fieldq{$j}.="( $j like '\%$sinput->{$k}\%' )";
   }                                 # done running through mapped fields
}                                    # done with first wave

                                # Construct "OR"ed table-level
                                # "WHERE" clauses since mapped terms are
                                # "or"ed together. Exact fieldnames are
                                # anded together after second wave

foreach $k ( keys %fieldlist ) {             # run through relevant fields
   foreach $j ( split /\,/, $fieldlist{$k} ) {
      $where{$k}.=" OR " if ( ( $where{$k} ) 
                            and ( $fieldq{$j} ) );
      $where{$k}="{".$where{$k} if ( ( $where{$k} ) 
         and ( $where{$k} !~ /^\{/ ) and ( $fieldq{$j} ) );
      $where{$k}.=$fieldq{$j} if ( $fieldq{$j} );
   }                                         # done running through fields 
}                                            # done examining table


                                # Enclose multiple "OR" WHERE clauses
foreach $k ( keys %where ) {                 # run through tables
   next if ( $where{$k} !~ /^\{/ );          # skip if not start with {
   $where{$k} =~ s/^\{// ;                   # kill leading {
   $where{$k} = "(".$where{$k}.")";          # enclose with ()
}                                            # done running through tables


######
### Second Wave - exact search fields
######
                                # Flush non-extraprop field-level queries
foreach $k ( keys %fieldq ) {   # run through field level querries
   delete $fieldq{$k} 
   if ( $big_fieldlist =~ /(^|,)$k(,|$)/ );  # eliminate handled fields
} # done flushing fields that may occour in both waves

foreach $k ( keys %{$sinput} ) {     # second wave - exact fields
   next if ( $k =~ /[a-z]/ );        # skip keys with lowercase this pass
   $fieldq{$k}.=" AND " if ( $fieldq{$k} );

   ## minimal sensitivity to the field type
   #
   if ( $fieldtype{$k} !~ /char/ ) { # not character data 
      #                              # strip illegal characters
      $sinput->{$k} =~ tr/0123456789.><=//cd;
      #                              # TBD - allow +/- and kill 
      #                              #       internal gt/lt/eq 
      #                              # look for gt/lt/eq operators
      if ( $sinput->{$k} =~ /^(\<\=|\=\<)/ ) {       # less than or equal
         $fieldq{$k}.="( $k<=";
      } elsif ( $sinput->{$k} =~ /(\>\=|\=\>)$/ ) {  # less than or equal
         $fieldq{$k}.="( $k<=";
      } elsif ( $sinput->{$k} =~ /(\<\=|\=\<)$/ ) {  # greater than or equal
         $fieldq{$k}.="( $k>=";
      } elsif ( $sinput->{$k} =~ /^(\>\=|\=\>)/ ) {  # greater than or equal
         $fieldq{$k}.="( $k>=";
      } elsif ( $sinput->{$k} =~ /(^\>|\<$)/ ) {   # greater than
         $fieldq{$k}.="( $k>";
      } elsif ( $sinput->{$k} =~ /(^\<|\>$)/ ) {   # less than
         $fieldq{$k}.="( $k<";
      } else {                                     # equal
         $fieldq{$k}.="( $k=";
      }                                            # done with inequality
      #                                            # remove <>=
      $sinput->{$k} =~ tr/<>=//d ;
      $fieldq{$k}.="$sinput->{$k} ) ";
      $fieldq{$k}="" if ( ! $sinput->{$k} );       # just in case nothing left
   } else {                                  # assume character of some sort
      $fieldq{$k}.="( $k like '\%$sinput->{$k}\%' )";
   }                                         # /character or numeric decision
}                                            # done with second wave

foreach $k ( keys %fieldq ) {                # check for compound clauses
   next if ( $fieldq{$k} !~ /^\{/ );         # looking for initial curly brace
   $fieldq{$k} =~ s/^\{// ;                  # remove leading curly brace
   $fieldq{$k}="($fieldq{$k})";              # enclose the group   
}                                            # done checking compound clauses

@mapped=();                                  # list of covered fields
foreach $k ( keys %fieldlist ) {             # run through relevant fields
   foreach $j ( split /\,/, $fieldlist{$k} ) {
      $where{$k}.=" AND " if ( ( $where{$k} ) 
                            and ( $fieldq{$j} ) );
      $where{$k}.=$fieldq{$j} if ( $fieldq{$j} );
   }                                         # done running through fields 
}                                            # done examining table

######
### Construct Exraprop Querry (any "none of the above" fields)
######
#                               # EXTRAPROP search
                                # fieldname,body searched, objid relevant
$use_objid="";
$use_objid=$sinput->{'objid'} if ( $sinput->{'objid'} );

foreach $k ( keys %fieldq ) {   # run through field level querries
   next if ( $big_fieldlist =~ /(^|,)$k(,|$)/ );  # eliminate handled fields
   #next if ( $fieldq{$k} =~ /[<>=]/ ) ;           # numeric? handle elsewhere  
   next if ( ! $fieldq{$k} );                     # has value?
   $where{'extraprop'}.=" OR " if ( ( $where{'extraprop'} ) 
       and ( $fieldq{$k} ) );
   # parse the field query into more complex format
   $s=$fieldq{$k};
   if ( $use_objid ) {          # use objectid in query
     $u="( objid LIKE '\%$use_objid\%' AND fieldname='$k' AND body";
     $s=~s/^\( $k/$u/e;
   } else {                     # do not use objectid in query
     $u="( fieldname='$k' AND body";
     $s=~s/^\( $k/$u/e;
   }                            # done with field translation
   $where{'extraprop'} .= $s;
}                               # done with construction of extraprop

###### 
### Kill off uninformative or degenerate querries
######

######
### Execute Querries
######
%MasterRec = {};
%rows=();                                    # returned search rows
$numRes = 0;
$extra = 0;
$is_there_search = $FORM{'search_keywords_inp'};
$is_there_search =~ s/ //gms;
if (length ($is_there_search) > 0) {

foreach $k ( keys %where ) {
   $q="SELECT \* from $k where $where{$k}";
   $sth=$dbh->prepare( $q );
   $sth->execute;   
   $numQueries++;
#   $num=$sth->rows;
   $num=0;
   while ( $rwh = $sth->fetchrow_hashref(NAME_lc) ) {
      $num++;
   }
   $sth=$dbh->prepare( $q );
   $sth->execute; 
   if ($debug) {
     print ERLOG "$q\n$num rows returned\n";
   }
   $numr=0;                                  # count of returned recs
   $result={};                               # blank hashref

   $i = 0;

   $continue = 1;
   while (( $numr < $maxrec ) and ( $numr < $num ) && ($continue == 1)) {
      $h=$sth->fetchrow_hashref(NAME_lc);
      if (defined $h) {
          $objtype = $h->{'objtype'};
          print ERLOG "$k is the table\n";
          if ($k eq "extraprop") {
             print ERLOG "Going into searchVariantEncodings!\n";
             ($numsve, $bnd, $qer) = &searchVariantEncodings($h, $FORM{'search_keywords_inp'}, $dbh);
              $numr = $numr + $numsve;
               $i++;
               print ERLOG "$numr is num records, $numsve is num save, $maxrec is maxrec\n";
               $numBind = $numBind + $bnd;
               $numQueries = $numQueries + $qer;
          }
          else {
              &addResult($h, $k, $objtype);    # add the result to the global $result
         }
     }
    else {  # no more records to find
        $continue = 0;
    }
   }
}                                            # done running searches

print ERLOG "going into addVariantProducts\n";
# Add the variant products that had masters that matched the routine
$bnd = &addVariantProducts($dbh, \%MasterRec);
$numBind = $numBind + $bnd;
}

###### 
### sort records by sort key and cut set to necessary entries
######
#        # $startatrow - lowest number result, first is zero
#        # $resultsperpg - max results per page
#        # $sortfield - name of field to sort results by
#
$sortfield='weight_man';                           # HACK, absract later
$startatrow=0 if ( ! $startatrow );           # default start at first rec
$resultsperpg=10 if ( ! $resultsperpg );      # default 12 per pg.
@sort = ();    # blank array for sort results
foreach $k ( keys %{$rows{'things'}} ) {
    if ($debug) {
      print ERLOG "\tAdding $k onto sort array!\n";
    }
    push @sort, $rows{'things'}->{$k};
} # done constructing array

if ($debug) {
   print ERLOG "There are $#sort items before the sort!\n";
}

## actually sort the stuff now
@sort = sort { $a->{$sortfield} <=> $b->{$sortfield} } @sort;
reverse @sort;   # weight is to be sorted from highest to lowest, so reverse the list


$resultcount= $#sort + 1;
$numRes = $resultcount;
$resultcount=0 if ($resultcount < 0);
if ($debug) {
   print ERLOG "There are $resultcount entries that have been sorted!\n";
}

$maxrows = 10;

if ( exists($FORM{'startrow'} )) {
   $startnum = $FORM{'startrow'};
} # done checking on passed startnum
else {
   $startnum = 0;
}

$thisstartrow = $startnum;

$numLastPage = 0;
$lastrec= $startnum + $maxrows;
if ($lastrec > $numRes) {
   $lastrec = $numRes;
   $numLastPage = $lastrec - $thisstartrow;
}
$lastrow = $lastrec;

if ( $resultcount > $lastrec ) {
   $nextstartnum=$startnum+$resultsperpg; 
   $nextflag="yes";
} 

if ($numRes > 0) {
   $FORM{'start'} = $startnum + 1;
   $FORM{'end'} = $lastrec;
   $FORM{'startrow'} = $nextstartnum;
   $FORM{'searchnum'} = $numRes;
}
else {
   $FORM{'start'} = 0;
   $FORM{'end'} = 0;
   $FORM{'startrow'} = 0;
   $FORM{'searchnum'} = 0;
}
                           

if ($debug) {
   print ERLOG "Resultcount is $resultcount, lastrec is $lastrec, Startrow is $thisstartrow, next start is $nextstartnum!\n";
}
$sid_encrypt=unpack(H16, &os_hash($sid, $site->{'hash_key'}));                      
$maxrows = 10;
$scriptname = "cgi-bin/om/$scriptname";
$pr = "sid=$sid_encrypt&search_keywords_inp=$FORM{'search_keywords_inp'}";
($back, $next, $pages, $firstrecord) = &setSearchNavigation($pr, $numRes,$maxrows, $thisstartrow, $lastrow);
$FORM{'back'} = $back;
$FORM{'next'} = $next;
$FORM{'pages'} = $pages;
                           
$lastrec=$resultcount if ( $lastrec > $resultcount );
print ERLOG "Sort before partitioning:  $#sort items\n";
@sort = @sort[$startnum..$lastrec];
print ERLOG "Sort after partitioning:  $#sort items\n";

$resultcount++ if ( $resultcount>0 );

######
### Construct output page
######

print "Content-type: text/html\n\n";

$cell_np=localize_template("cell_search_intermediate",$om_render_lang,$interface,0);
$cell_pr=localize_template("cell_search_product",$om_render_lang,$interface,0);
$thispage=localize_template("page_search_result",$om_render_lang,$interface,0);

`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;

# track the keywords
open FH, ">>$relpath/data/site_search_keywords.txt";
print FH "$FORM{'search_keywords_inp'}\n";
close FH;

# if there are less than $resultsperpage entries, split the results in 1/2 to
# find 2 columns
if ($resultsperpg > $resultcount) {
    $breaktot=$resultcount;
} 
# split up last page into 2 columns
elsif ($numLastPage != 0) {
    $breaktot = $numLastPage + 1;   # add one for odd numbers, don't want to miss any
}
# split up into full pages
else {
    $breaktot=$resultsperpg;
}



$breakat1=int($breaktot/2);
$breakat2=$breakat1+$breakat1;
if ($debug) {
    print ERLOG "Set break total to be $breaktot\n";
    print ERLOG "Break points are $breakat1, $breakat2, $#sort\n";
}

if ($breakat1 > $#sort) {
	$breakat1=$#sort;
}
if ($breakat2 > $#sort) {
        $breakat2=$#sort;
}

if ($startnum > 0) {
   $prevstartnum=$startnum-$resultsperpg; 
   $prevflag="yes";
}


if ($debug) {
    print ERLOG "Break points are $breakat1, $breakat2, $#sort\n";
}

$lastrec = $thisstartrow + 10;

if ($debug) {
   print ERLOG "Startrow is $thisstartrow!  End row is $lastrow! numsort is $#sort\n";                  
}
$endrow = 10;
  for ($i=0; $i < $endrow; $i++) {

   next if ($#sort == 0);	

   $objid=$sort[$i]->{'objid'};
   if ($debug){
       print ERLOG "In forloop with $objid!\n";
   }

    next if (!$objid);
   
   if ($objid =~ /^x/ ) { # non-sellable objid
       $u=$cell_np;
   } else {
       $u=$cell_pr;
   }
   $h=$sort[$i];

    $q=permutebit($u,$h);
   if ($i < $breakat1) {
      $expand1.=$q;
   } elsif ($i < $breakat2 && $i >= $breakat1) {
       $expand2.=$q;
   }

}

if ($debug) {
    print ERLOG "It took a total of $numQueries queries, and $numBind bind queries to find the results!\n";
}

$h={};
$h->{'headergif'}="search_results.gif";
$h->{'sitename'}=$site->{'sitename'};
$h->{'title'}="Search Results!";
$h->{'column_220_1'}=$expand1;
$h->{'column_220_2'}=$expand2;
$h->{'brief'}="Your search returned ";

# used to be resultcount
if ($numRes) {
  $h->{'brief'}.=" $numRes matches! ";
} else {
    $h->{'brief'}.="nothing! Please try again!<P>";
}
$h->{'site_background'}=$site->{'site_background'};

$h->{'os_render_language'}=$om_render_lang;
$h->{'os_language'}=$om_render_lang;

## output the file to stdout
#

$thispage = permutebit( $thispage, $h);
$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, $om_render_lang, "html", 0); 

print $thispage;
1;


#  Determine if the type of object is good, and if it is, then save it in the results
#  hash
sub addResult {
    my ($h) = $_[0];
    my ($k) = $_[1];
    my ($objtype) = $_[2];
    

    if (($k eq "things") && ($objtype ne "45000-A") &&
	($objtype ne "47005-A") &&
	($objtype ne "47001-A") &&
	($objtype ne "47004-A")) {
	$numr++;
	return;
    }

    # only want to show visibile products
    if ($h->{'visibility'} eq "110001-A") {
	$numr++;
	return;
    }


    if  ($h->{'ref_from'} ne "") {
	
	# set the title for variant products that matched
	if ( $h->{'ref_from'} eq $h->{'objid'}) {
	    $MasterRec{$h->{'objid'}} = $h;
	    if ($debug) {
		print ERLOG "Set MasterRecs with $h->{'objid'}\n";
	  }
	}
	# set the title for variant products that matched
	if ( $h->{'ref_from'} ne $h->{'objid'}) {
	    $res = &get_fields_and_title("","",$h->{'objid'}, $dbh, "brief");
	    $h->{'title'} = $res->{'title'};
	    $h->{'brief'} = $res->{'brief'};
	    
	}
    }                            
    $i=$numr;                              # default handle
    if ( $prikey{$k} ) {
	$j=$prikey{$k};                     # get key to use for table
	if ( $j eq "objid" ) {
	    
            $i=$h->{'objid'};                 # construct psudofield Vsku
            $h->{'objid'}=$i;                 # populate field
	    
	} else {
            $i=$h->{$j};                     # use key
	}
    }                                      # done with key entry
    
    $result = $rows{$k};   # get the saved rows
    $result->{$i}=$h;                      # add record to hashref
    $rows{$k} = $result;      # add the rows back
    $numr++;
      $numRes++;
    if ($debug) {
	print ERLOG "\tSaved $h->{'objid'}, $h->{'title'}! $numRes results now\n";
     }
}





















