#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

######
# sid.cgi
#    session id setting script
#    RF 981208 - based on welcome.cgi, version 4-981207
######

####
#
# Version 0.7.19 JC 20001003
#    secure sid
# Version 0.7.18 JC 20000914
#    oracle integration
# Version 0.7.17 IB 20000717
#    $om_render_language=$om_render_lang
# Version 0.7.16 IB 20000627
#    added cgi-lib.pm
# Version 0.7.15 IB 20000606
#    language from table 'sessions'
# Version 0.7.14 IB 20000601
#    added custom-lib.pm
# Version 0.7.13 IB 20000411
#    default to language in site.pm
# Version 0.7.12 IB 20000410
#    multilingual messages
# Version 0.7.11 IB 20000401
#    new directory structure
# Version 0.7.10 IB 20000327
#    corrected $relpath
# Version 0.7.9 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.8 IB 20000302
#    updated copyright
# Version 0.7.7 IB 20000227
#    changed store to site
# Version 0.7.6 SV 20000113
#    corrected call to 'cat' in clear-image-replace code
#    added single quotes, added call to print
# Version 0.7.5 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.4 IB 991110
#    replacing with a clear image
# Version 0.7.3 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.2 IB 991025
#    determine path from store root
#    adjust this script to work with track.cgi and inbound.cgi
# Version 0.7.1 GF 990720
#    debugging and testing
# Version 3 SH 990708
#    got rid of quick hack hardcode where storecode was set to W
# Version 2 - 981218
#    efficiency cleanup
# Version 1 - 981208
#
#### 

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/blowfisher.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

%FORM=();
&ReadParse;

## establish connection to database
#
$q="$site->{'db_site_config'}";
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

$om_render_lang = "";
# $interface = "";

$FORM{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ( $FORM{'sid'});

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
#  $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
# $interface="html" if ( ! $interface );

## just need to know if there is a sid
#
&setsessionid() if (!$ENV{'HTTP_COOKIE'});

## and now lets replace this with a clear image
print "Content-type: image/gif\n\n";
print `cat $site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/general/clear.gif`;

1;
