#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#############################
# Checkout.cgi              #
#   Version 0.9.0           #
#############################
#
# Version 0.9.26 JC 20001003
#    secure sid
# Version 0.9.25 IB 20000930
#    corrected siteeurl->siteurl
# Version 0.9.22 JN 20000903
#    Abstracted out all of the pages from this script
#    to checkout_pages.pm
# Version 0.9.21 JC 20000728
#    credit card number blanks out when error
# Version 0.9.20 IB 20000720
#    added a call to track.cgi
# Version 0.9.19 IB 20000717
#    $om_render_language=$om_render_lang
# Version 0.9.18 JC 20000709
#    fixed variant display issue in shipping and order summary
# Version 0.9.17 JN 20000629
#    fixed orderid entry when using the address enter page
# Version 0.9.16 JN 20000613
#    fixed uppercase addrid to all lowercase
# Version 0.9.15 JN 20000612
#    fixed address insert from billpay using address enter 
# Version 0.9.14 GF 20000608
#    removed comma from custid
# Version 0.9.13 IB 20000608
#    fixing transition from welcome login to checkout
# Version 0.9.12 IB 20000607
#    language and interface from table 'sessions'
# Version 0.9.11 IB 20000601
#    corrected the sequence of require statements (cust-lib.pm must be last) 
#    corrected relative path
#    removed -w
## Version 0.9.8 20000524

## Missing Revs all dealt with converting
## code to all-commerce                     
####
# Relative directory finding taken from

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#


if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
   } else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;
$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
#chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;
   
   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels
   
   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );
   
   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root
   
} # done constructing relative path to store root

$relpath .= "/../$siteshortname";
use DBI;
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/lib/formtools.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
#require "$relpath/lib/payment.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/checkout_pages.pm";
require "$relpath/lib/checkout_cells.pm";
# must be the last require statement
require "$relpath/lib/custom-lib.pm"; 
require "$relpath/lib/blowfisher.pm";

$now=time();

###########
# 	Init
#		Get SID
#			- error handling
#		Get custid
#			- go to welcome if can't
#		Get State
#			- go to first page if can't
#		Load hash re: current State

######
# Init

#####
# Get Site Hash
$site=setsite();

## establish connection to database
#
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

#######
# Get Sid and Form
%FORM = ();
%ORDER = ();
&ReadParse;

$FORM{'sid'}=&os_unhash(pack(H16,$FORM{'sid'}), $site->{'hash_key'} ) if ( $FORM{'sid'} );

$sid = $FORM{'sid'};
$sid = &setsessionid();    # Either a sid > 0 or 0
$sid = $FORM{'sid'};

$om_render_lang = "";
$interface = "";

if ($FORM{'sid'}) {
   $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   $h=$sts->fetchrow_hashref(NAME_lc);
   $om_render_lang=$h->{'language'};
   $interface=$h->{'interface'};
}

$om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang );
$om_render_lang="eng" if ( ! $om_render_lang );
$interface="html" if ( ! $interface );
$site->{'om_render_lang'} = $om_render_lang;

#######
# Check if user logged in
# get custid

$test_custidok=1;    # assume OK
if ( $sid ) {
   $q="SELECT custid FROM sessions where SID='$sid' ";
   $sts = $dbh->prepare( $q );
   $sts->execute;
#   $num=$sts->rows;
#   if ( $num==1 ) {
   if ( $custid=$sts->fetchrow ) {

   } else {
      $test_custidok=0;   # bad sid
      $custid="";
   } #/testing on records for sid
} else {          # probable cookieless user!
   $test_custidok=0;
   $custid="";
} #/testing if user logged in

#####
# If we have a sid and custid get orderid
#

if ($sid and $custid) {
   
   ## update the tcart with the data coming from sessions;
   $q="update tcart set custid='$custid' where sid='$sid'";
#   $dbh->do($q);
   $sts = $dbh->prepare( $q );
   $sts->execute;
   ## now get the orderid(s)
   ## there can be more than one
   $q="SELECT objid FROM orders where custid = '$custid' and SID='$sid' and status='15012-A'";
   $sts = $dbh->prepare( $q );
   $sts->execute;
   #$num=$sts->rows;
   if ($orderid = $sts->fetchrow) {
      ## Great we got only one
#      $orderid = $sts->fetchrow(NAME_lc);
      $orderid_array[0] = $orderid;
      
   } else {
      
      ## okay we got more than one, lets put them in orderid_array
#      foreach $t (1..$num)   {
#      while ( $orderid = $sts->fetchrow ) {
#         push (@orderid_array ,$orderid);
#      }
   }
}
$loadpoint = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/bits/site";

$FORM{'topnav'}=localize_template("topnav",$om_render_lang,$interface,0);
$FORM{'bottom_nav'}=localize_template("bottom_nav",$om_render_lang,$interface,0);



###########
# page list hashref
#	this is so that input from FORM is never blindly used to call
#	a function

#getPageList();
$pagelist = getPageList();

#getCellList();
$celllist = getCellList();

###########
# 	Transfer Hash
#	Key					Descript
#	ERROR					scalar, null if no errors
#	(FIELDNAME)				scalar, Database pull
#	orderid_array				array ref,  list of order ids for split shipments
#	orderid					scalar, order id
#	sid					scalar, session id
#	custnum					scalar, custumer #
#	mode					scalar, requested mode
# 	templatename				scalar, template string
###########


###########
# Page Logic
$ret_hash->{'FORM'}->{'topnav'}=localize_template("topnav",$om_render_lang,$interface,0);





$cur_page = $pagelist->{$FORM{'cur_page'}};   	#get the current page from the hash
$ret_hash->{'mode'} = $FORM{'mode'};			#get the mode
$ret_hash->{'ERROR'} = $FORM{'ERROR'};			#get any error
$ret_hash->{'FORM'} = \%FORM;					#get all the form variables
$ret_hash->{'orderid'} = $orderid;						#get the orderid
$ret_hash->{'orderid_array'} = \@orderid_array;			#get a reference to the orderid_array
$ret_hash->{'sid'} = $sid;						#get the sid
$ret_hash->{'custid'} = $custid;						#get the custid
$ret_hash->{'DISPLAY'}=$FORM{'cur_page'};		#set the page to be displayed
# if no custid or sid send to welcome
$ret_hash->{'func'} = $ret_hash->{'FORM'}->{'func'}; #for some cells a function needs to be set
$ret_hash->{'FORM'}->{'scriptname'}=$scriptname;	#put the scriptname in there



# if we have no sid we have got to move them to the home page

if (!$sid ) {
   print "Status: 302/Moved\n";
   print "Location: http://$site->{'siteurl'}/cgi-bin/om/inbound.cgi\n\n\n";
   exit 0;
   
}


# if we have no user identification we move them to welcome
if (!$custid ) {
   $welcome_arg = "pg_targ=$site{'siteurl'}/cgi-bin/om/ssl/checkout.cgi";
   print "Status: 302/Moved\n";
   print "Location: http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?$welcome_arg\n\n\n";
   exit 0;
   
}

###  Changed to adapt for CyberCash
#
if ($cur_page eq "pg_billpay") {
  $tmp_hash = &{$cur_page}($ret_hash);
  if ($tmp_hash->{'ERROR'} =~ /problems/) {
	print "Content-type: text/html\n\n";
  }
}
else {
  print "Content-type: text/html\n\n";
}

#`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;

# if no order id pg_shippingaddress
$cur_page = getFirstPage($cur_page,$orderid,$pagelist);


### 
# We just got first page


# goto currentpage

# mode = mode
# MODES :
#			SHOW
#				This is to tell the cells to permute there stuff and put it into the form
#				part of the ret_hash
#
#			APPROVE
#				This is to tell the cells that they're going to get data to validate
#
# if we don't have a mode given to us the mode is to SHOW
if (!$ret_hash->{'mode'}) { $ret_hash->{'mode'} = 'SHOW';};
# we need to store the mode given to us from the returning data
$mode = $ret_hash->{'mode'};

######
#
# Now we execute the page definitions
# Idealy the page is just a list of cells. Inside the page sub there shouldn't be much
# logic, however some things need to be set for that pages purpose so logic is includes
# to do such.

$ret_hash = &{$cur_page}($ret_hash);


if ($mode eq 'SHOW') {

   # if the checkout script was entered with a SHOW function we only go through the logic once
   
   $page = localize_template($ret_hash->{'template'},$om_render_lang,$interface,0);
   
   $page = permutebit ($page,$ret_hash->{'FORM'});
   $page = permutebit ($page,$site);
   $page = permuteclean ($page);
 $page = permute_include( $page, $om_render_lang, "html", 0);
   print $page;
   
  
 

   } elsif ($mode eq 'APPROVE') {
   
   # if we got into the checkout script through an approve, we have just finished earlier
   # computing the cells approvals of the data and should have been switched to SHOW to
   # print out the data
   
   # It is up to the pages to tell us what page we want to use when they return the ret_hash
   # to this part of the program. They do this with the DISPLAY part of ret_hash. If there
   # was an error the page should tell us to display its page again, however if there wasn't
   # the page will tell us what page needs to be displayed next.
   
   $ret_hash = &{$pagelist->{$ret_hash->{'DISPLAY'}}}($ret_hash);
   $page = localize_template($ret_hash->{'template'},$om_render_lang,$interface,0);

   $page = permutebit ($page,$ret_hash->{'FORM'});
   $page = permutebit ($page,$site);
   
  $page = permuteclean ($page);
  $page = permute_include( $page, $om_render_lang, "html", 0);
   print $page;
}

#}
#close ();
