#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# track.cgi
#    IB 991025 - the script for tracking site usage
#                (the script inbound.cgi also helps keep track of site usage)
#
#####

####
#
# Version 0.7.20 JC 20001003
#    secure sid
# Version 0.7.19 GF 20000920
#    changed do to prepare
# Version 0.7.18 IB 20000606
#    added comment for custom-lib.pm
# Version 0.7.17 IB 20000601
#    added custom-lib.pm
# Version 0.7.16 IB 20000330
#    changed connect statement
# Version 0.7.15 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.14 IB 20000327
#    corrected $relpath
# Version 0.7.13 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.12 IB 20000309
#    replaced uninitialized variable with initialized one to avoid message
# Version 0.7.11 IB 20000302
#    updated copyright and removed -w
# Version 0.7.10 IB 20000226
#    changed store to site
# Version 0.7.8 GF 991203
#    relaced REFERER with HTTP_REFERER 
# Version 0.7.7 RF 991111
#    minor change to add script name detection
# Version 0.7.6 IB 991111
#    correcting the location of a DBI statement
# Version 0.7.5 RF 991108
#    added handling for lib location if called from command line
# Version 0.7.4 RF 991108
#    repaired defective relative link to libraries 
# Version 0.7.3 IB 991025
#    the UID field has been dropped from table clicks 
# Version 0.7.2 RF 991022
#    stole appropriate bits from inbound.cgi
#
#####

## use a very restricted library set -- get cookie from %ENV
#     only invoke libraries etc... if we have to set a sid
#
$sid=$ENV{'HTTP_COOKIE'};
$sid=( split /sid=/, $sid )[1] if ( $sid );
$sid=( split /&/, $sid )[0] if ( $sid );


## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
# 
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath; 
   $relpath=".";   
   @temp=();
} # done testing for degenerate case 

while ( @temp ) {
   $u = pop @temp;
  
   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp]; 
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/blowfisher.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

$now=time();

$sid=&os_unhash(pack(H16,$sid), $site->{'hash_key'}) if ($sid);

## open database connection
#
$q="$site->{'db_site_config'}";
$dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

## write the pageview to the clicks table...
#
$q="INSERT INTO clicks VALUES ";

if ($ENV{'REQUEST_URI'}) {
   $value = $ENV{'REQUEST_URI'};
} else {
   $value = "";
}

if ($ENV{'HTTP_REFERER'}) {
    $value1 = $ENV{'HTTP_REFERER'};
} else {
    $value1 = "";
}

$q.=" ('$sid','$now','$value','$value1','$site->{'clusterid'}')";
$sth = $dbh->prepare( $q );
$sth->execute; 


print "";

## cleanup statement handles and close connection
#
$dbh->disconnect if ( $dbh );

1;
