#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# welcome.cgi
#    customer login screen set
#    RF 981203 
#
####

####
# Version 3 JC 20001006
#    fix to sid fork problem
# Version 2 JC 20000919
#    fixed login loop
# Version 1 LCF 20000901
#	Substantial rewrite, moved most stuff into welcome-lib.
# Version 0.9.12 JC 20000823
#    ->rows
# Version 0.9.11 JC 20000816
#    case sensitive to login/password
# Version 0.9.10 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.9 IB 20000608
#    fix for a bug related to login and proceeding to checkout
# Version 0.9.8 IB 20000607
#    HINT -> hint
# Version 0.9.7 IB 20000606
#    corrected a typo
# Version 0.9.6 IB 20000605
#    language and interface from table 'sessions'
#    html -> $interface
#    u_email -> uname
# Version 0.9.5 IB 20000531
#    added custom-lib.pm
# Version 0.9.4 GF 20000524
#    fixed problem with storing of custid for new user
#    removed u_email from query into sessions
#    storing objtype and class
# Version 0.9.2 GF 20000509
#    fixed a problem setting a null custid
# Version 0.9.1 IB 20000502
#    introduced $script variable
# Version 0.7.33 GF 20000504
#    error messages
# Version 0.7.32 GF 20000502
#    field names lowercase
# Version 0.7.31 GF 20000501
#    CUSTID -> OBJID
# Version 0.7.29 IB 20000420
#    set->SET
# Version 0.7.28 JC 20000418
#    replaced loadtemplate with localize_template
#    included permute_include
#    removed $skeleton
# Version 0.7.27 GF 20000413
#    fixed levent entry
# Version 0.7.26 GF 20000411
#    moved sendmail info to site->{'mailserver'} 
#    changed UID to U_EMAIL, CUSTNUM to CUSTID 
#    reformatted
# Version 0.7.25 IB 20000411
#    default to language in site.pm
# Version 0.7.24 IB 20000410
#    multilingual messages
# Version 0.7.23 IB 20000404
#    new directory structure
# Version 0.7.22 IB 20000402
#    new directory structure
# Version 0.7.21 IB 20000331
#    cell template renaming
# Version 0.7.20 IB 20000330
#    changed connect statement
# Version 0.7.19 JC 20000329
#    changed DBI prepare/connect
# Version 0.7.18 IB 20000327
#    corrected $relpath
# Version 0.7.17 IB 20000324
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.16 JC 20000322
#    added colon to ssl_prefix
# Version 0.7.15 IB 20000302
#    updated copyright and removed -w
# Version 0.7.14 IB 20000226
#    change store to site
# Version 0.7.13 JN 20000117
#    using ssl_prefix instead of https/http for checkout
# Version 0.7.12 JN 20000111
#    When checking the HINT string let spaces remain spaces
#    Tightened up the checking to remove quotes
# Version 0.7.11 IB/GF 991203
#    added in track 
# Version 0.7.10 IB/GF 991202
#    added in skeletonpath
# Version 0.7.9 IB 991112
#    corrected the determining of the relpath
#    removed foreach
#    corrected $scriptname
# Version 0.7.8 IB 991110
#    correcting a list of databases
# Version 0.7.7 IB 991109
#    removing of HACKS, and correcting of relpath
# Version 0.7.6 IB 991101
#    general cleanup
# Version 0.7.5 GF 990914
#    changed password to encrypt
# Version 0.7.4 SH 990901
#    uid into levents 
# Version 0.7.3 SH 990831
#    fixed EMAIL ok
# Version 0.7.1 GF 990830
#    changed template names from 450 to 300
# Version 1 - 981204
#
####

#use strict;
#my $script_data = {};	# utility hash for all the current data.

## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
my $s;
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
my @temp=split /\//, $s;

my @rpath=@temp;

my $scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

my $rundir= join "/", @rpath;
chdir( $rundir );

my $relpath="";
my $siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   my $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/filetools.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/state.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/validate.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/welcome-lib.pm";	# &wel_foo() routines are in here.
require "$relpath/lib/blowfisher.pm";
# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
($site, $form) = &wel_set_site_data();
my %FORM = %{$form};

## establish connection to database  
#
my $dbh = &wel_connect_db($site);

## Find out what language and interface to use
#
my ($om_render_lang, $interface) = &wel_get_lang_interface(\%FORM, $dbh, $site);

## load messages
#
my $script=( split /\./, $scriptname )[0];
my %script_msg = &wel_message($relpath, $om_render_lang, $scriptname); # user interaction messages

## initialize other bits
#
my $now=time();
my $mode = &wel_mode();

## Form elements that are needed for page generation
#
$site->{'scriptname'}=$scriptname;

## email_ok checkbox
#
%FORM = &wel_account_ok_check(\%FORM);

## check for a session id
#
$sid = &setsessionid();
#my $sid = &setsessionid($site, $dbh);    # Either a sid > 0 or 0
my $orig_sid = $sid;
$FORM{'sid'} = $sid;

## destination upon successful login
#
$site->{'pg_targ'} = $FORM{'pg_targ'};


## sort submitted form data into "existing acct" and "new acct" hashes.
#  also, ditch "email" and put acct data in {'acct'}
#
my ($new, $old) = wel_sort_form_input(\%FORM);

## evaluate existing customer options first
#
my $oldok=1;	# Ok to proceed with validation
my $olderr=0; 	# Set true if there's an error

## Validate the account input
#
($oldok, $olderr, %FORM) = &wel_validate_old_account($old, \%script_msg, %FORM);

## Check for password errors (if account input was invalid)
#
($olderr, %FORM) = &wel_check_passwd_error($old, \%script_msg, %FORM) unless $oldok;

## Validate password input (if account input was valid)
#
($oldok, $olderr, %FORM) = &wel_validate_old_pass($old, \%script_msg, %FORM) if $oldok;

## Ok, Now, if $oldok is still true, try to log the user in.
#
my $err = &wel_customerlogin( $FORM{'sid'},$old->{'acct'},$old->{'passwd_inp'}, $site, $dbh, \%script_msg ) if $oldok;


if ( $err ) {
	$FORM{'old.login_err'}="<P>".$err;
    $oldok=0;
    $olderr=1;
} else {  
    $mode="redirectok";  
} #/done evaluating login


## if login from existing customer data not OK, try the new data
#
my $newok=1;
my $newerr=0;
my $gf_custid="";
if (( ! $oldok ) or ( $olderr )) {    # existing login didn't work 

	my $u = &wel_validate_acct( $new->{'acct'} );

	if ( $u ) {
 		# We know there's a problem, but what kind of problem?
			($newok, $newerr, $FORM{'new.email_err'}) = &wel_set_new_acct_err($u, \%script_msg, $new);

	}

    # if there's a plausible email,
    # check the passwords to see if 
    # they match and are long enough
	($newok, $newerr, %FORM) = &wel_validate_new_pass($new, \%FORM, \%script_msg) if ($newok);
    
	## see if the email is unique
	#
	($newok, $newerr, %FORM) = &wel_unique_acct($new, $dbh, \%FORM, \%script_msg) if ($newok);		
			
            
     ## create the event for the account
     my $objid = &wel_create_acct_event($site, $dbh) if ($newok);
     $gf_custid = $objid;

	 ## create the user account
     &wel_create_user_acct($dbh, $new, $objid, \%FORM) if ($newok);
	 ## set passwd to a form variable
     #
     $FORM{'passwd'}=$new->{'passwd1_inp'} if ($newok);

     ## send the user a confirmation via email
     #
     if ( $site->{'mailserver'} && $newok) {
         &wel_send_mail($site, $new, %script_msg); 
     }
	 # For the default page template
	 $FORM{'email'} = $new->{'acct'};

} else {	#/done examining new bits
	$newok = 0;
	$newerr = 0;
	$gf_custid="";
}

## update SID record
#
$FORM{'sid'}=$sid; 
my $h = &wel_update_sid(\%FORM, $dbh);
&wel_update_session($dbh, $FORM{'sid'}) unless ($h);

if ( $h ) {
   my $em;

   if (( $newok ) and ( ! $newerr )) {
      $em=$new->{'acct'};
   } elsif (( $oldok ) and ( ! $olderr )) {
      $em=$old->{'acct'};
   } #/done checking on new vs. old worked

   ## store uname in FORM variable
   # 
   $FORM{'acct'}=$em;
   $FORM{'email'}=$em;
   
   # see if uname = $em
   if ( length($em)>8 ) {
    
      if ( length($h->{'custid'})>2 ) {

         ## see if em and uname match what we have 
         #
         my $check_email = &wel_check_uname($dbh, $h->{'custid'});
		 
         if ( $check_email eq $em ) {          # there is a uname on file
                                               # is it the same?
			
         	&wel_update_session($dbh, $FORM{'sid'}, $h->{'custid'});
			
         } else {                  # we have a user logging in on a sid
                                   # that has a custid that does not match
   
            &wel_update_session($dbh, $FORM{'sid'}, $gf_custid);

            ## TBD - return error message
            #

            $FORM{'login_error'}=$script_msg{23};

         } #/done checking if this is a new uname

      } else {                          # no uname on file
                                        # so let's log it
            &wel_update_session($dbh, $FORM{'sid'}, $gf_custid);
      } #/end of permutations on uname update
   } #/no else - if $em is null there is a login error

} 

#warn "Orig sid = $orig_sid, Form sid = $FORM{'sid'}, pg_targ = $FORM{'pg_targ'}\n";
#if ($FORM{'sid'} != $orig_sid) {
#	%FORM = &wel_page_targ($site, \%FORM, $scriptname, $om_render_lang);
#}
#warn "PG targ is $FORM{'pg_targ'}, site says it's $site->{'pg_targ'}\n";
$FORM{'pg_targ'} =~ s/sid=\d+/sid=$FORM{'sid'}/;
unless ($FORM{'pg_targ'}) { $FORM{'pg_targ'} = $site->{'pg_targ'}; }

my ($thispage, $cell_rc, $cell_nc);

if (( $newok ) and ( ! $newerr )) {       # new, session OK
   $thispage=localize_template("page_welcome_confirm", $om_render_lang, $interface, 0);
   $mode="confirm";

} elsif (( $oldok ) and ( ! $olderr )) {  # existing login
   $thispage=localize_template("page_welcome_onwards", $om_render_lang, $interface, 0);
   $mode="redirect";

} else {  # not logged in!
   $thispage=localize_template("page_welcome_login", $om_render_lang, $interface,0);
   $cell_rc = localize_template("cell_welcome_return_customer", $om_render_lang, "$interface",0);
   $cell_nc = localize_template("cell_welcome_new_customer", $om_render_lang, $interface, 0);

   # done loading templates that are endemic
   $cell_rc=permutebit( $cell_rc, \%FORM );
   $cell_nc=permutebit( $cell_nc, \%FORM );
   $FORM{'cell_welcome_return_customer'}=$cell_rc;
   $FORM{'cell_welcome_new_customer'}=$cell_nc;
   
   $mode="login"; 
} #/done evaluating session

## start the response header - NOTE cookie set way up at start
#
print "Content-type: text/html\n\n";

## track user in site 
#
`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/cgi-bin/om/track.cgi`;


## send the file to stdout
#

$thispage = permutebit( $thispage, \%FORM );
$thispage = permutebit( $thispage, $site );
$thispage = permutebit( $thispage, \%ENV );
$thispage = permuteclean ( $thispage  );
$thispage = permute_include( $thispage, $om_render_lang, "html", 0);
print $thispage;

## cleanup
#
$dbh->disconnect if ( $dbh );

1;
