#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

####
# wrapper.cgi
#    wrapperizer script that handles user request that don't accept cookies
#    HVC 20000327
#
####

#####
# Version 0.9.21 JC 20001003
#   secure sid
# Version 0.9.20 GF 20000920
#   do element changed to execute
# Version 0.9.14 JC 2000914
#   oracle integration
# Version 0.9.13 HVC 20000728
#    Handle http/https requests
# Version 0.9.12 HVC 20000725
#    Clean code,Handle multiple page search result and hint
# Version 0.9.11 HVC 20000720
#    Rewrite wrapper to be compatible with os_allcommerce
# Version 0.9.10 IB 20000717
#    $om_render_language->$om_render_lang
# Version 0.9.9 IB 20000606
#    commented out interface, because it is not needed
# Version 0.9.8 IB 20000606
#    language and interface from table 'sessions'
# Version 0.9.7 IB 20000531
#    added custom-lib.pm
# Version 0.9.6 IB 20000502
#    introduced $script variable
# Version 0.9.5 IB 20000421
#    clean up 
# Version 0.9.4 HVC 20000420
#    replace ERLOG with message subroutine
# Version 0.9.02 HVC 20000403
#    clean up code
#    modify FixLinks
# Version 0.9.01 HVC 20000327
#    handle both GET/POST method
#    compatible with openmerchant0_7
#
#####


## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in cgi-bin/om,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );
$relpath="";
$siteshortname="";
## short circuit if $s does not contain cgi-bin
if ( $s !~ /cgi-bin/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "cgi-bin" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - cgi-bin is off the site root, so the next up is site root

} # done constructing relative path to store root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/conf/site.pm";
require "$relpath/lib/state.pm";
require "$relpath/lib/localization.pm";
require "$relpath/lib/custom-lib.pm";
require "$relpath/lib/cgi-lib.pm";
require "$relpath/lib/blowfisher.pm";

## establish site-specific parameters
$site=setsite();
$now=time();



## load messages
$om_render_lang="eng";   # hard coded before reading from the tables
%script_msg=();          # user interaction messages
$script=( split /\./, $scriptname )[0];
&message;


## HVC - Make wrapper.cgi act like a browser.
## Here wrapper.cgi asks for the contents of the target page 
## from the apache server, and then parses the returned contents
## to change links, so that user is always 
## within wrapper.cgi, it also handle GET/POST method accordingly.


# Load Module - Checks to see if the required module is present
Load_Module("LWP::UserAgent");
print "Content-type: text/html\n\n";
%FORM=();
&ReadParse;
# Check for SID

$FORM{'sid'}=&os_unhash($FORM{'sid'}, $site->{'hash_key'}) if ( $FORM{'sid'} ); 
$sid_encrypt=unpack(H16,&os_hash($FORM{'sid'},$site->{'hash_key'})) if ($FORM{'sid'});

if ($FORM{'sid'}) {
  $sid=$FORM{'sid'};
  # open database connection
  $q="$site->{'db_site_config'}";
  $dbh=DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});
  $q="SELECT language,interface from sessions where sid=$FORM{'sid'} ";
  $sts = $dbh->prepare( $q );
  $sts->execute;
  $h=$sts->fetchrow_hashref;
  $om_render_language=$h->{'language'};
  $interface=$h->{'interface'}; 
  $om_render_lang=$site->{'om_locale_lang_def'} if ( ! $om_render_lang ); 
  $om_render_lang="eng" if ( ! $om_render_lang );
  $interface="html" if ( ! $interface ); } 
else {
   print "Content-type: text/html\n\n"; 
   print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{1}</BODY></HTML>";
   print "\n\n";
   exit -1 ; }


# Define path
$wrapper_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi",$ENV{'HTTP_HOST'});
$default_path=sprintf("http\:\/\/%s\/cgi\-bin\/om\/wrapper.cgi\?sid=%s\&target=\/html\/eng\/home.shtml",$ENV{'HTTP_HOST'},$sid_encrypt);
$old_home_path=sprintf("http\:\/\/%s\/$interface\/$om_render_lang\/home.shtml",$ENV{'HTTP_HOST'});
$new_home_path_end=sprintf("\/cgi-bin\/om\/wrapper.cgi\?sid=%s\&target=\/$interface\/$om_render_lang\/home.shtml",$sid_encrypt);
$welcome_path=sprintf("http://%s/cgi-bin/om/welcome.cgi",$ENV{'HTTP_HOST'});
$new_welcome_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi\?sid=%s&target=/cgi-bin/om/welcome.cgi",$ENV{'HTTP_HOST'},$sid_encrypt);
$checkout_path=sprintf("http://%s/cgi-bin/om/wrapper.cgi\?sid=%s&target=/cgi-bin/om/ssl/checkout.cgi",$ENV{'HTTP_HOST'},$sid_encrypt);


# Check for target
if ($FORM{'target1'}) {
  $pg_targ=$FORM{'pg_targ'} ;
  $pg_targ.=$FORM{'target1'};
  $pg_targ=sprintf("%s&target=%s",$FORM{'pg_targ'},$FORM{'target1'});
  $FORM{'pg_targ'}=$pg_targ;
  $target=$FORM{'target'}; }
elsif ($FORM{'target'}) {
  $target=$FORM{'target'} ;
  if(($FORM{'search_keywords_inp'}) && (($FORM{'startrow'} eq "0") || ($FORM{'startrow'}))) {
    # Searching for multiple pages
    $target2="&search_keywords_inp=";
    $target2.=$FORM{'search_keywords_inp'};
    $target2.="&startrow=";
    $target2.=$FORM{'startrow'};}
  if ($ENV{'HTTP_REFERER'} ne $wrapper_path) { 
    if ( ($ENV{'HTTP_REFERER'} =~ /target1/) || ($ENV{'HTTP_REFERER'} eq $welcome_path) ) {
      $FORM{'pg_targ'}=$checkout_path;
      $pg_targ=$FORM{'pg_targ'}; } 
    else {
      $FORM{'pg_targ'}=$ENV{'HTTP_REFERER'} ;
      $pg_targ=$FORM{'pg_targ'}; }}
  elsif (! $FORM{'pg_targ'}) {
    $FORM{'pg_targ'}=$default_path;
    $pg_targ=$FORM{'pg_targ'} ; 
    $pattern_xyz="\/html\/eng\/http\:\/\/$ENV{'HTTP_HOST'}\/cgi\-bin\/om\/wrapper.cgi\?sid=$sid_encrypt";
    $target =~ s/$pattern_xyz//gi;}}
else {
  print "Content-type: text/html\n\n"; 
  print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{2}</BODY></HTML>";
  print "\n\n";
  exit -1; }

# Handle diffrent conditions
if (($FORM{'mode'} eq "APPROVE")&& ($FORM{'abc'})) {
  $argument=sprintf("sid=%s\&mode=%s\&addrid=%s\&addressbook=%s\&nextage=%s",$sid_encrypt,$FORM{'mode'},$FORM{'addrid'},$FORM{'addressbook'},$FORM{'nextage'});
  $new_target=sprintf("http://%s%s\?%s",$ENV{'HTTP_HOST'},$target,$argument);
  $FORM{'mode'}=" ";
  $target=" ";}
elsif ($FORM{'mode'} eq "SHOW") {
  $argument=sprintf("sid=%s\&mode=%s\&load=%s\&cur_page=%s\&nextpage=%s\&addrid=%s\&func=%s",$sid_encrypt,$FORM{'mode'},$FORM{'load'},$FORM{'cur_page'},$FORM{'nextpage'},$FORM{'addrid'},$FORM{'func'});
  $new_target=sprintf("http://%s%s\?%s",$ENV{'HTTP_HOST'},$target,$argument);
  $FORM{'mode'}=" ";}
else {$new_target=sprintf("http://%s%s\?sid=%s%s",$ENV{'HTTP_HOST'},$target,$sid_encrypt,$target2);}


## Determine which method   
if ($ENV{REQUEST_METHOD} eq 'GET' ) { 
  $ua = new LWP::UserAgent;
  $ua->agent("Mozilla/4.0" . $ua->agent);
  my $request = new HTTP::Request GET=>$new_target;
  my $response = $ua->request($request);
  if ($response->is_error()) { 
    print "Content-type: text/html\n\n"; 
    print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{3}</BODY></HTML>";
    print "\n\n";
    exit -1;} 
  else { 
    my $content = $response->content();
    FixLinks($content,$sid);
    InsertEntry($sid);}} 
elsif ($ENV{REQUEST_METHOD} eq 'POST' ) {
  $ua = new LWP::UserAgent;
  $ua->agent("Mozilla/4.0" . $ua->agent);
  my $request = new HTTP::Request POST=>$new_target;
  $request->content_type('application/x-www-form-urlencoded');
  foreach $keyval (keys(%FORM)) {
    #SAM's magic number
    $FORM{$keyval} =~ s/\&/\%26/g;
    $postdata .= ("$keyval=$FORM{$keyval}&");}
  chomp($postdata);
  $request->content($postdata);
  my $response = $ua->request($request);
  if ($response->is_error()) { 
    print "Content-type: text/html\n\n"; 
    print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{4}</BODY></HTML>";
    print "\n\n";
    exit -1;} 
  else { 
    my $content = $response->content();
    FixLinks($content,$sid);
    InsertEntry($sid);}} 
else {
  print "Content-type: text/html\n\n"; 
  print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD><BODY><BR><BR>$script_msg{5}</BODY></HTML>";
  print "\n\n";
  exit -1;}


## Function FixLinks - Fix links to pass through wrapper 
sub FixLinks {
$home_path_wc="HREF=\"\/$interface\/$om_render_lang\/home\.shtml\"";
$home_path_nc="HREF=\/$interface\/$om_render_lang\/home\.shtml";
$new_home_path="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/$interface\/$om_render_lang\/home.shtml";
$cart_path="HREF=\"\/cgi-bin\/om\/cart.cgi\"";
$new_cart_path="HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/cart.cgi\"";
$account_path="HREF=\"\/cgi-bin\/om\/account.cgi\"";
$new_account_path="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/account.cgi";
$wishlist_path="HREF=\"\/cgi-bin\/om\/wishlist.cgi\"";
$new_wishlist_path="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/wishlist.cgi";
$registry_path="HREF=\"\/cgi-bin\/om\/registry.cgi\"";
$new_registry_path="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/registry.cgi";
$hint_path="\"\/cgi-bin\/om\/hint.cgi\\?pg_targ=https:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/ssl\/checkout\.cgi\\?sid=$sid_encrypt\"";
$new_hint_path="/cgi-bin/om/wrapper.cgi?sid=$sid_encrypt&target=/cgi-bin/om/hint.cgi&pg_targ=/cgi-bin/om/wrapper.cgi?sid=$sid_encrypt&target1=/cgi-bin/om/ssl/checkout.cgi";
$pattern2="method=post action=";
$pattern3="name=\"sid\" value=\"\"" ;
$pattern4="name=\"sid\" value=\"$sid_encrypt\"" ;
$pattern5=sprintf("http://%s/%s/%s/home.shtml",$ENV{'HTTP_HOST'},$interface,$om_render_lang);
$pattern6="/cgi-bin/om/wrapper.cgi?sid=$sid_encrypt&target=/$interface/$om_render_lang/home.shtml";
$pattern7=sprintf("http://%s/cgi-bin/om/welcome.cgi\\?sid=$sid_encrypt\&pg_targ=https://%s/cgi-bin/om/ssl/checkout.cgi\\?sid=$sid_encrypt",$ENV{'HTTP_HOST'},$ENV{'HTTP_HOST'});
$pattern8="/cgi-bin/om/wrapper.cgi?sid=$sid_encrypt&target=/cgi-bin/om/welcome.cgi&pg_targ=/cgi-bin/om/wrapper.cgi?sid=$sid_encrypt&target1=/cgi-bin/om/ssl/checkout.cgi";
$pattern9="HREF\=\"http\:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/ssl\/checkout.cgi\\?sid\=$sid_encrypt\"";
$pattern10="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/cgi-bin\/om\/ssl\/checkout.cgi";
$pattern11="VALUE\=\"checkout.cgi\"";
$pattern12="VALUE\=\"\/cgi-bin\/om\/ssl\/checkout.cgi\"";
$pattern13="HREF=\"checkout.cgi\\?";
$pattern14="HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/cgi-bin\/om\/ssl\/checkout.cgi\&abc=abc\&";
$pattern15="HREF=\"https:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/ssl\/checkout\.cgi\\?sid=$sid_encrypt\"";
$pattern16=sprintf("http://%s/cgi-bin/om/welcome.cgi\\?sid=$sid_encrypt\&pg_targ=http://%s/cgi-bin/om/ssl/checkout.cgi\\?sid=$sid_encrypt",$ENV{'HTTP_HOST'},$ENV{'HTTP_HOST'});
$pattern17="HREF=http:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/welcome.cgi\\?sid=$sid_encrypt";
$pattern18="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/welcome.cgi";
$pattern19="target=\/cgi-bin\/om\/ssl\/checkout.cgi";
$pattern20="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/ss/\/checkout.cgi";
$pattern22="METHOD=\"POST\" action=";
$pattern23="HREF=\"\/cgi-bin\/om\/search.cgi\\?sid=\&search_keywords_inp";
$pattern24="HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/cgi-bin\/om\/search.cgi\&search_keywords_inp";
$pattern25="HREF=http:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/welcome.cgi\\?sid=$sid_encrypt&pg_targ=\>";
$pattern26="HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target=\/cgi-bin\/om\/welcome.cgi&pg_targ=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target1=\/cgi-bin\/om\/ssl\/checkout.cgi\>";
$pattern27="pg_targ=http://$ENV{'HTTP_HOST'}/cgi-bin/om/wrapper.cgi\\?sid=$sid_encrypt\&";
$pattern28="pg_targ=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt&target1=\/cgi-bin\/om\/ssl\/checkout.cgi";
$pattern29="\"\/cgi-bin\/om\/hint.cgi\\?pg_targ=http:\/\/$ENV{'HTTP_HOST'}\/cgi-bin\/om\/ssl\/checkout\.cgi\\?sid=$sid_encrypt\"";

$sid=$_[1];
@entirepage = split(/\n/,$_[0]);
foreach $eachline (@entirepage) {
  if ($eachline =~ /$home_path_wc/i) {
    $eachline =~ s/$home_path_wc/$new_home_path/gi ;}
  if ($eachline =~ /$home_path_nc/i) {
    $eachline =~ s/$home_path_nc/$new_home_path/gi ;}
  if ($eachline =~ /$cart_path/i) {
    $eachline =~ s/$cart_path/$new_cart_path/gi ;}
  if ($eachline =~ /$account_path/i) {
    $eachline =~ s/$account_path/$new_account_path/gi ;}
  if ($eachline =~ /$wishlist_path/i) {
    $eachline =~ s/$wishlist_path/$new_wishlist_path/gi ;}
  if ($eachline =~ /$registry_path/i) {
    $eachline =~ s/$registry_path/$new_registry_path/gi ;}
  if ($eachline =~ /$hint_path/i) {
    $eachline =~ s/$hint_path/$new_hint_path/gi ;}
  if ($eachline =~ /$pattern29/i) {
    $eachline =~ s/$pattern29/$new_hint_path/gi ;}
  if ($eachline =~ /$old_home_path/i) {
    $eachline =~ s/$old_home_path/$new_home_path_end/ig ;}
  if((($eachline !~ /HREF=\"\//) || ($eachline !~ /HREF=\//)) && ($eachline !~ /HREF=\"http/) && ($eachline =~ /HREF=\"[a-zA-Z0-9].*html\"/)){
    @junk=split(/\"/,$&);
    $eachline =~ s/HREF=\"[a-zA-Z0-9].*$interface\"/HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/$interface\/$om_render_lang\/$junk[1]\"/gi;}
  if($eachline =~ /HREF=\"\/$interface\/$om_render_lang\/[0-9]+\-[a-zA-Z]+\.shtml\"/){
    $eachline =~ s/HREF=\"\/$interface\/$om_render_lang/HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/$interface\/$om_render_lang/gi;}
  if($eachline =~ /href=\"\/$interface\/$om_render_lang\/[0-9]+\-[a-zA-Z]+\.shtml\"/){
    $eachline =~ s/href=\"\/$interface\/$om_render_lang/HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/$interface\/$om_render_lang/gi;}
  if($eachline =~ /HREF=\"\/$interface\/$om_render_lang\/auto\/[0-9]+\-[a-zA-Z]+\.shtml\"/){
    $eachline =~ s/HREF=\"\/$interface\/$om_render_lang\/auto/HREF=\"\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/$interface\/$om_render_lang\/auto/gi;}
  if($eachline =~ /HREF=\/$interface\/$om_render_lang\/[0-9]+\-[a-zA-Z]+\.shtml/){
    $eachline =~ s/HREF=\/$interface\/$om_render_lang/HREF=\/cgi-bin\/om\/wrapper.cgi\?sid=$sid_encrypt\&target=\/$interface\/$om_render_lang/;}
  if ($eachline =~ /$pattern2/i)  {
    $eachline =~ s/$pattern2/METHOD=POST ACTION=\"\/cgi\-bin\/om\/wrapper.cgi\"\>\<INPUT TYPE=\"HIDDEN\" NAME=\"sid\" VALUE=\"$sid_encrypt\"\>\<INPUT TYPE=\"HIDDEN\" NAME=\"target\" VALUE=/gi; }
  if ($eachline =~ /$pattern22/i) {
    $eachline =~ s/$pattern22/METHOD=\"POST\" ACTION=\"\/cgi\-bin\/om\/wrapper.cgi\"\>\<INPUT TYPE=\"HIDDEN\" NAME=\"sid\" VALUE=\"$sid_encrypt\"\>\<INPUT TYPE=\"HIDDEN\" NAME=\"target\" VALUE=/gi; }
  if ($eachline =~ /$pattern3/i) {
    $eachline =~ s/$pattern3/$pattern4/gi ;}
  if ($eachline =~ /$pattern5/i) {
    $eachline =~ s/$pattern5/$pattern6/gi ;}
  if ($eachline =~ /$pattern7/i) {
    $eachline =~ s/$pattern7/$pattern8/gi ;}
  if ($eachline =~ /$pattern16/i) {
    $eachline =~ s/$pattern16/$pattern8/gi ;}
  if ($eachline =~ /$pattern9/i) {
    $eachline =~ s/$pattern9/$pattern10/gi ;}
  if ($eachline =~ $pattern15 ) {
    $eachline =~ s/$pattern15/$pattern10/gi ;}
  if ($eachline =~ /$pattern11/i) {
    $eachline =~ s/$pattern11/$pattern12/gi ;}
  if ($eachline =~ /$pattern13/i) {
    $eachline =~ s/$pattern13/$pattern14/gi ;}
  if ($eachline =~ /$pattern25/i) {
    $eachline =~ s/$pattern25/$pattern26/gi ;}
  if ($eachline =~ /$pattern27/){
    $eachline =~ s/$pattern27/$pattern28/gi ;}
  if (($eachline =~ /$pattern17/i) && ($eachline !~ /$pattern19/)) {
    $eachline =~ s/$pattern17/$pattern18/gi ;}
  if (($eachline =~ /$pattern17/i) && ($eachline =~ /$pattern19/)) {
    $eachline =~ s/$pattern19//gi;
    $eachline =~ s/$pattern17/$pattern18/gi ;}
 if ($eachline =~ /$pattern23/i) {
    $eachline =~ s/$pattern23/$pattern24/gi ;}
  #Print contents
  print $eachline;
  print "\n"; }}



## Make entry in clicks database
sub InsertEntry {
$now=time();
$sid=$_[0];

# establish store-specific parameters
$site=setsite();

# insert values in clicks
$q="INSERT INTO clicks VALUES ";

if ($ENV{'HTTP_REFERER'}) {
  $value = $ENV{'HTTP_REFERER'};} 
else {
   $value = "";}

$q.="('$sid','$now','$ENV{'REQUEST_URI'}','$value','$site->{'clusterid'}')";
$sth = $dbh->prepare( $q );
$sth->execute;  
$dbh->disconnect if ( $dbh ); }



## Print error messages
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
  
  if ($om_render_lang eq "eng" ) {
    $script_msg{1}="sid not found, wrapper.cgi fails.";
    $script_msg{2}="target not found, wrapper.cgi fails."; 
    $script_msg{3}="Error in GET Method, wrapper.cgi fails."; 
    $script_msg{4}="Error in POST Method, wrapper.cgi fails."; 
    $script_msg{5}="Neither GET/POST Method, wrapper.cgi fails."; } 
  else {
    open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
    while(<EM>) {
      chomp;
      next if /^\#/;
      next if (! $_);
      @temp=split /\t/;
      $script_msg{$temp[0]}=$temp[1]; }
    close(EM); }}


## Check to see if required module is present
sub Load_Module{
  eval "require $_[0]";
  if($@) { 
    print "Content-type: text/html\n\n"; 
    print "<HTML><HEAD><TITLE>wrapper.cgi messages</TITLE></HEAD>";
    print "<BODY>";
    print "<BR><BR>Problem with $_[0] Module ";
    print "<BR><BR>Got the following error message";
    print "<BR><BR>$@<BR><BR></BODY></HTML>";
    print "\n\n";
    exit -1 ; }}
 
1;
