#!/usr/bin/perl 
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# generate_site.pl
#
# Program to generate temporary data files
#    to feed into various general pulldowns
#
# Version 0.9.24 JC 20000918
#    fixed repetitive variants
# Version 0.9.23 JC 20000914
#    oracle intergration
# Version 0.9.22 JC 20000828
#    fixed variant title
# Version 0.9.21 JC 20000817
#    fixed variant descript
# Version 0.9.20 JC 20000803
#    fixed alttitle again
# Version 0.9.19 JC 20000802
#    removed Home link 
# Version 0.9.18 JC 20000721
#    take out a debug statement
# Version 0.9.17 JC 20000720
#    fixed linkage (non-display) bug
# Version 0.9.16 JC 20000717
#    fixed alttitle
# Version 0.9.15 JC 20000706
#    fixed display for variants page
# Version 0.9.14 JC 20000705
#    another fix for descript
# Version 0.9.13 JC 20000630
#    correction to variants
# Version 0.9.12 JC 20000628
#    correct error with linkage
# Version 0.9.11 JC 20000627
#    debugged jump to nav
# Version 0.9.10 JC 20000621
#    fixed descript from extraprop
# Version 0.9.9 JC 20000620
#    remove support for generation of page_pqa_home.html
#    generation based on visibility flag
#    contents of site.pm added to generating hash
# Version 0.9.8 JC 20000613
#    added support for the generation
#    of page_pqa_home.html
# Version 0.9.7 IB 20000610
#    comment about custom-lib.pl
#    corrected typo
# Version 0.9.6 IB 20000531
#    added custom-lib.pm
# Version 0.9.5 JC 20000525
#    changed from msku-vcode to objid
# Version 0.9.4 JC 20000524
#    ajusted for new database scheme 
# Version 0.9.3 IB 20000502
#    corrected the sequence of statements
# Version 0.9.2 JC 20000427
#    changes to hashrefs to fit new tables
# Version 0.9.1 IB 20000426
#    introduced $script variable
# Version 0.7.31 JC 20000421
#    update of template and multilinugal support
# Version 0.7.30 IB 20000420
#    corrected a typo
# Version 0.7.29 JC 20000418
#    changed localize_template to match latest revisions 
# Version 0.7.28 JC 20000418
#    redid quotes around jump_to_nav on line 754 part II
# Version 0.7.27 JC 20000415
#    redid quotes around jump_to_nav on line 754
# Version 0.7.26 JC 20000415
#    symlink multilingual support
# Version 0.7.25 JC 20000414
#    multilingual support
# Version 0.7.24 IB 20000412
#    cell template renaming
# Version 0.7.23 JC 20000412
#    removed AUTHOR
# Version 0.7.22 IB 20000411
#    $def_lang to $om_render_lang
# Version 0.7.21 JC 20000411
#    default to eng if no default lang
# Version 0.7.20 JC 20000410
#    multilingual messages
# Version 0.7.19 JC 20000330
#    correction to connect
# Version 0.7.18 IB 20000329
#    corrected the path for formtools.pm
# Version 0.7.17 JC 20000328
#    changed DBI prepare/connect
# Version 0.7.16 IB 20000326
#    corrected $relpath
# Version 0.7.15 IB 20000323
#    changed the way site.pm is obtained (multiple stores)
# Version 0.7.14 JC 20000321
#    changed tobarnav to jump_to_nav
# Version 0.7.13 JC 20000320
#    updated for om_locale_lang_def
#    changed topbarnav.html to jump_to_nav.html
# Version 0.7.12 IB 20000317
#    renaming of templates
# Version 0.7.11 IB 20000301
#    updated copyright
# Version 0.7.10 IB 20000229
#    changed table to database
# Version 0.7.9 IB 20000223
#    changed the name store.pm to site.pm
# Version 0.7.8 JN 20000202
#    Added Geometry calculation
# Version 0.7.7 JN 991221
#    Fixed variant names
# Version 0.7.6 JN 991220
#    Fixed errors disconnecting databases
#    Sortlinks implemented for cells
#    topbarnav is fixed
#    junk .shtmls cleaned up
# Version 0.7.5 JN 991202
#    Purchase button watches stock
# Version 0.7.4 JN 991202
#    Multidimensional variants 
# Version 0.7.3 IB 991115
#    ERLOG
# Version 0.7.2 IB 991112
#    updated the absolute path to update_symlinks.pl, corrected relpath
# Version 0.7.1 IB 991110
#    relative path to libraries and calls to databases
# Version 32 SH 991006
#    looks for duotone blank images + home link added to everypage
# Version 30 SH 990903
#    fixing dead end on one variant prod page
# Version 29 SH 990903
#    default image for broken images
# Version 28 SH 990903
#    fiddling w/ case where only one finish
# Version 27 SH 990902
#    prices works now  11:40pm
#    trying to get unitpr to appear 11:15pm
# Version 26 RF 990902
#    further work on global linkage hashes
# Version 25 RF 990831
#    complete rewrite of global linkage hashes
#       %linkup{sku}=@links (array of hashrefs) topbar stuff
#       %linkdown{sku}=@links (array of hashrefs) on-page stuff
#    fixed pseudolinkage failure with sortlinks -1 links defect
# Version 24 RF 990831
#    fixed pseudolinkage on product master pages
# Version 23 RF 990831
#    work on population of DESCRIPT field and finish pseudo
#    introduction of master product/variational pages
# Version 22 RF 990830
#    cleanup of print statements and tighter link control
# Version 21 RF 990830
#    added de-mysqling of text
# Version 20 RF 990829
#    massive speed improvements
# Version 19 SH 990707
#    moved to system 6 structure and queries
#    need to still do compareat price 
#    orginally msrp and regprice, now -- how to compare complex prices?
#
# Version 18 RF 990128
#    looks locally to storefront for templates,
#    only goes to all if failure locally
# Version 17 RF 990120
#    linkage? what the hell...
# Version 16 RF 981222
#    more generation fixes
# Version 15 RF 981211
#    added logic so generation and cart about equal
# Version 14 RF 981208
#    added sid.cgi as a gif to the spine...
# Version 13 RF 981205
#    needs globalized iconographic vars
#    added $store_env-> hashref
#    fixed broken topbarnav include file generation
# Version 12 RF 981203
#    deprecated machine.pm, switched spine elements to setserver()
#    now uses store.pm version 6+
# Version 11 RF 981203
#    nondisplay pages are not generated nor linked to
#    default topbar navigation include created
# Version 10 RF 981130
#    changed spine construction
# Version 9 RF 981129
#    fixed ALTTITLE not being used bug
# Version 8 RF 981128
#    simple list cells added
# Version 7 RF 981128
#    simple cells, columnar replacement
# Version 6 RF 981128
#
#
#
#    added header defaults
#    further work towards production code
# Version 5 RF 981128 based on generate_temps.pl version 9 of 981127
#     

$started=(times)[0];

## determine path from store root and store db name...
#
#  note - this script runs at server root or in crons,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff



$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain crons
if ( $s !~ /crons/ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath );

   if ( $u eq "crons" ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - crons is off the site root, so the next up is site root

} # done constructing relative path to store (site) root

$relpath .= "/../$siteshortname";

use DBI;
require "$relpath/lib/formtools.pm";
require "$relpath/lib/filetools.pm";
require "$relpath/conf/site.pm";
require "$relpath/lib/localization.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm";

## establish site-specific parameters
#
$site=setsite();

$om_render_lang="$site->{'om_locale_lang_def'}";
$om_render_lang="eng" if ( ! $om_render_lang );

## load messages
#
%script_msg=();
$script=( split /\./, $scriptname )[0];
&message;

chdir "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/crons/";

## establish connection in
#
$q = "$site->{'db_site_config'}"; 
$dbh = DBI->connect($site->{'db_site_connect'}, "$site->{'site_dbiuser'}", "$site->{'site_dbipwd'}");

$symbol=",";

########### general flow
##  load all skus to hash of hashes on SKU
#
##  for each sku...
##  load all linkages to hash on SKU1  of sorted arrays of hashrefs 
#
##  start page generation sku-by-sku
#

%templates=();   # hash of templates by short name
%objid=();        # hash of hashrefs to sku data
%variants=();    # hash of hashrefs to variants, keyed on VSKU
%linkup=();      # hash on vsku/sku of arrays( of hashrefs ) topbar 
%linkdown=();    # hash on vsku/sku of arrays( of hashrefs ) on-page
%columns=();     # hash of hashrefs of columns per template
%axiscodes=();   # hash of hashrefs of plaintext per encoding
%defcells=();    # default cells for different objects
%extantvars=();  # extant variants per master sku
%stock=();       # hash of stock values
%skus=();
## setup default cells by object
#
$defcells{'variants'}="cell_140_master_vv";
$defcells{'subcat'}="cell_123_search_80_sc";
$defcells{'masterprod'}="cell_123_search_80_mp";

## get languages that will be used to generate template
#
@langs=split /,/, $site->{'om_locale_lang_act'};
$notlangs=$site->{'om_locale_lang_inact'}; # inactive languages
@langsgen=("$om_render_lang");  # include default language 

if ( $notlangs ) {
   foreach $lang (@langs) {
      if ( $notlangs !~ $lang ) { push @langsgen,$lang; }; # do not include languages that are inactive
   } # done checking for inactive languages
}  elsif ( @langs ) {
      push @langsgen,@langs;
   } 

@interfaces=split /,/, $site->{'interfaces'};
if ( ! @interfaces ) { @interfaces="html"; }

$q2="SELECT * from things WHERE visibility='110000-A' ";
$sth = $dbh->prepare( $q2 );
$sth->execute;
#$num=$sth->rows;
#foreach ( 1..$num ) {
#   $h=$sth->fetchrow_hashref;
while ( $h=$sth->fetchrow_hashref(NAME_lc) ) {
   ## backconvert from mysql-ish text and make html safe  
   foreach $k ( keys %{$h} ) {
      next if ( "title,brief|pagestyle" !~ /$k/ );
      $h->{$k}=string_exmysql($h->{$k});     
      next if ( "pagestyle" eq $k );       # do not html-ize this
      $h->{$k}=string_tohtml($h->{$k}); 
   }
      $objid{$h->{'objid'}}=$h;
      $variants{$h->{'objid'}}=$h;
}

$q3 = " SELECT * from prices WHERE status='15000-A' ";
$stp=$dbh->prepare($q3);
$stp->execute;
#$nump=$stp->rows;
#for (1..$nump) {
#   $p = $stp->fetchrow_hashref;
while ( $p = $stp->fetchrow_hashref(NAME_lc) ) {
   next if ( $p->{'unitct'}!=1 );            # only need unit prices...
   next if ( $p->{'groupid'} );              # for anyone
   if ( (! $objid{$p->{'objid'}}->{'unitpr'}) || ($p->{'unitpr'} < $objid{$p->{'objid'}}->{'unitpr'}) ) {
      $objid{$p->{'objid'}}->{'unitpr'}=$p->{'unitpr'};
      $variants{$p->{'objid'}}->{'unitpr'}=$p->{'unitpr'};
   }
}

#load extracopy fields, as applicable
$q3 = "SELECT objid,fieldname,body,language,status FROM extraprop ";
$stg = $dbh->prepare( $q3 );
$stg->execute;
#$necq = $stg->rows;
#foreach ( 1..$necq ) {
#   ( $k,$c,$b,$l,$st ) = $stg->fetchrow_array;
while ( ( $k,$c,$b,$l,$st ) = $stg->fetchrow_array ) {
   $l="$om_render_lang" if ( ! $l ); # set to default language if none is given
   $b=string_exmysql($b);
   $b=string_tohtml($b);
#   next if ( ! $objid{$k});
#   $objid{$k}->{$l}->{$c}=$b if ( ! $objid{$k}->{$l}->{$c} );
    $variants{$k}->{$l}->{$c}=$b if ( ! $variants{$k}->{$l}->{$c} && ( $st eq "15000-A" || $st eq "" ) );
    $variants{$k}->{$l}->{'status'}=$st if ( ! $variants{$k}->{$l}->{'status'} && $st eq "15000-A" ); 
#   $variants{$k}->{$c}=$b
} # done running through extracopy fields 

$q="SELECT objid,lstock from inventory";
$sts = $dbh->prepare( $q );
$sts->execute;
#$num=$sts->rows;

#foreach (1..$num) {
#      $h=$sts->fetchrow_hashref;
while ( $h=$sts->fetchrow_hashref(NAME_lc) ) {      
      $stock{$h->{'objid'}}=$h->{'lstock'} if ($h->{'lstock'});
       
} # done running through inventory...



## load all linkage data
#
#     %linkage{objid} for objid=obj1
#     %toplinkags{objid} for objid=obj2
#
$q="SELECT \* FROM linkage WHERE status='15000-A' ORDER BY cdate";
$sth = $dbh->prepare( $q );
$sth->execute;
#$num=$sth->rows;
#foreach ( 1..$num ) {
#   $h=$sth->fetchrow_hashref;
while ( $h=$sth->fetchrow_hashref(NAME_lc) ) {
   $s1=$h->{'obj1'};
   $s2=$h->{'obj2'};
#   next if ( length( $s1 ) < 8 );      # skip implausibly short skus
#   next if ( length( $s2 ) < 8 );      # skip implausibly short skus

#   $h->{'alttitle'}=string_exmysql($h->{'alttitle'});  
   $h->{'cellstyle'}=string_exmysql($h->{'cellstyle'});

   ## push up topbar stuff, where this objid would be in OBJ2
   push @{$linkup{$s2}}, $h;
   ## push up on-page links, where this objid would be in OBJ1
   push @{$linkdown{$s1}}, $h;

} # done loading links



## sort linkage lists by weight
#
#  TBD - RF get back to this 990901
#

$q2="SELECT * from things WHERE visibility='110000-A' "; 
#$q2="SELECT * from things ";    
$sth = $dbh->prepare( $q2 );
$sth->execute;
#$num=$sth->rows;
#foreach ( 1..$num ) {
#   $h=$sth->fetchrow_hashref;
while ( $h=$sth->fetchrow_hashref(NAME_lc)) {
   ## backconvert from mysql-ish text and make html safe
   foreach $k ( keys %{$h} ) {
      next if ( "title,brief|pagestyle" !~ /$k/ );
      $h->{$k}=string_exmysql($h->{$k});
      next if ( "pagestyle" eq $k );       # do not html-ize this
      $h->{$k}=string_tohtml($h->{$k});
   }
   # done with loading all information on this skus to hash...
   if ($h->{'ref_from'} ne $h->{'objid'}) {
      $extantvars{$h->{'ref_from'}}.="\t" if $extantvars{$h->{'ref_from'}};
      $extantvars{$h->{'ref_from'}}.=$h->{'objid'};
   }

   $thevariant="";                        # plaintext axis values

   if (( $variants{$h->{'ref_from'}}->{'axisnames'} ) and ( $h->{'ref_from'} ne $h->{'objid'})) {
      @ab = ( split /:/, $variants{$h->{'ref_from'}}->{'axisnames'} );
      @tmp_code_array = ();  ## 2D array to hold variant codes  x  y  each variant sku is x, values in variant are y
      @tmp_decode_array = (); ## 2D array that matches codes
      $tmp_yax_num  = 0;
      $tmp_xax_num  = 0;
      @maxarray = ();  ## array of maximum num  of variants in y direction
      ## Loop for languages - fill in with default language if no other language is present
#      foreach $language (@langsgen) {
        foreach $a (@ab){  
           ## if variant does not exist for a specifc lanugae use default
           if ( ($variants{$a}->{$om_render_lang}->{'encoding'}) and ( ! $variants{$a}->{$language}->{'encoding'} ) ) {
              $variants{$a}->{$language}->{'encoding'} = $variants{$a}->{$om_render_lang}->{'encoding'};
           }
           #must add the two iterations together so that k = VCODE
           #must check to see if there's more thatn one
           if ( ( ! $axiscodes{$a} ) and ( $variants{$a}->{$language}->{'encoding'} )) {   # the decoding not loaded yet
              @tomap = split /(\n|\r|\f)+/, $variants{$a}->{$language}->{'encoding'};  # tomap now contains ind sku's complete 1D variance table
              $tmp_yax_num = 0;
              foreach ( @tomap ) {         # get the actual code/decodes
                 ($k,$v) = split /:/, $_ ;    # split that table up into code/decode
                 next if ( ! $k );            # if the cde is nothing get out of here
                 $v2 = $v;
                 $v2 =~ tr/ //d ;             # if decode is nothing insert warning
                 next if ( ! $v2 );
                                        #have to build new temp table here
                 $tmp_code_array[$tmp_xax_num][$tmp_yax_num]=$k;
                 $tmp_decode_array[$tmp_xax_num][$tmp_yax_num]=$v;
                 $tmp_yax_num++;
              }
              $maxarray[$tmp_xax_num]=$tmp_yax_num;
           } # done if
           $tmp_xax_num++;
           @current_val_array = ();
           $maxnum = 1;
           for $n (0.. $tmp_xax_num)    {$current_val_array[$n]=0;  ## init array to all zeros
           if ($maxarray[$n]) {$maxnum = $maxnum * $maxarray[$n];} ## find out maximum number of possibilites
        } # done foreach $a

        for $i (0 .. $maxnum)  ## create all possibilities of multidimensional variants
           {
           $fin_code = "";
           $fin_decode ="";
           for $n (0.. $tmp_xax_num)                                                                                                             {
              if (($fin_decode) and ($tmp_decode_array[$n][$current_val_array[$n]])) {$fin_decode.=", ";} ### if in next pass there exists a decode at a coma    

              $fin_decode .= $tmp_decode_array[$n][$current_val_array[$n]];
              if (($fin_code) and ($tmp_code_array[$n][$current_val_array[$n]])) {$fin_code.=':';} ## if in next pass there exists a code add a :
              $fin_code .= $tmp_code_array[$n][$current_val_array[$n]];
           }
           @current_val_array = &increment_array(\@current_val_array, \@maxarray); ## passing references to arrays and incrementing them
           $axiscodes{$h->{'objid'}}->{$fin_code}=$fin_decode;
        }
        $thevariant.="$symbol " if ( $thevariant );
        $thevariant.=$axiscodes{$h->{'objid'}}->{$h->{'vcode'}};
#      } # done foreach
   } # done loading plaintext by axisname
   ## decode the axis
   #
   if ( $thevariant ) {
      $h->{'variant_plaintext'}=$thevariant;
   } # done adding plaintext translation of axis values

  $varprice=$variants{$h->{'objid'}}->{'unitpr'}; #socheata
  $variants{$h->{'objid'}}=$h;
  $variants{$h->{'objid'}}->{'unitpr'}=$varprice;
} # done loading things data to hash
}
## check for variant-less skus
# 
foreach $k ( keys %objid ) {
   next if ($variants{$k});
   next if ($objid{$k}->{'ref_from'} ne $objid{$k});
   $variants{$k}=$objid{$k};
#   $variants{$k}->{'vcode'}="";
} # done writing null variants into variants table


## fill in variant information
#
foreach $k ( keys %variants ) {

   if ( $variants{$k}->{'objid'} && $variants{$k}->{'ref_from'} && $variants{$k}->{'objid'} ne  $variants{$k}->{'ref_from'} ) {   
      $variants{$k}->{'title'}=$variants{$variants{$k}->{'ref_from'}}->{'title'}." ".$variants{$k}->{'variant_plaintext'};
      $variants{$k}->{'brief'}=$variants{$variants{$k}->{'ref_from'}}->{'brief'};
   }
}


## spine - it's list of links is @spine
@spine1=();  # display roots by definition
@spine2=();
@spine3=();

$loadtime=(times)[0];


## page generation
#
$tot_page = 0;
foreach $s ( sort keys %variants ) {

next if ( $variants{$s}->{'visibility'} ne "110000-A" );

   foreach $interface (@interfaces) {

      ## run through each language to generate pages   
      #
      foreach $language (@langsgen) {
      $om_render_lang = $language;

      $targetpath="$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/$interface/$om_render_lang/auto";

      $lng=$variants{$s}->{'language'};
      $lng="$site->{'om_locale_lang_def'}" if ( ! $lng );

         if ( $lng eq $om_render_lang ) {
#            $sku = $variants{$s}->{'msku'};
#            $vcode = $variants{$s}->{'vcode'};
            $targ = "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/$interface/$om_render_lang/auto/$sku.shtml";
            ## check the template is loaded
            #
            $tn=$variants{$s}->{'pagestyle'};
            ## Is this page supposed to be generated at all
            # 
   

            ## skip generation if this is nondisplay or out of stock and not persistent
            #
            ## TBD - reinstate when trust status flags
            #next if ( $variants{$s}->{'status'} eq "nd" );

            ## set a default pagestyle if blank
            $tn="page_product_master" if ( ! $tn );     # temp - want all pgs


            ## override page template if the site has variants and it is
            #     a variant page
            #
            $tn="page_product_master_vv" if ( ( $variants{$s}->{'vcode'} ) and ( $tn =~ /master$/ )); 

            ## give title and descript from master to variants
            #
            if ( $variants{$s}->{'vcode'} ) {
               $z=$variants{$s}->{'ref_from'};
               $variants{$s}->{'title'}=$variants{$z}->{'title'};
               $variants{$s}->{$om_render_lang}->{'descript'}=$variants{$z}->{$om_render_lang}->{'descript'}; 
               $variants{$s}->{$om_render_lang}->{'alttitle'}=$variants{$z}->{$om_render_lang}->{'alttitle'};
            }
            
            &templatecheck( $tn, $om_render_lang, $interface, 0);
            $thispage = $templates{$tn};
            %nccol=%{$columns{$tn}};  # number of columns per cell width

            ######
            ### Start Generation of on-page Cells
            ######

            ## load down linkage data of relevance
            #
            @links = @{$linkdown{$s}};

            @links = sortlinks(@links); 
            ## override default linkage for master products - show only variants
            #
            if ( $s eq $variants{$s}->{'ref_from'} ) {
               @links=();
               ## create link to own variants 
               #
               @temp = split /\t/, $extantvars{$s};
               foreach $k ( @temp ) {
                  $h=();
                  $h->{'obj1'}=$s;             # from this sku
#                  $h->{'obj2'}="$variants{$k}->{'msku'}"."$variants{$k}->{'vcode'}";             # to it's variant
                  $h->{'obj2'}=$k;
                  $h->{'title'}=$variants{$k}->{'title'};     # needs a title
                  $h->{'linkwt_use'}=$variants{$k}->{'weight_use'}; # relative weight
                  $h->{'cellstyle'}=$defcells{'variants'};

                  push @links, $h;
               } # done pushing phony links up
            } # done with load

      # Commented for future revisitation OUTSIDE main loop 990901 RF
      #   ## special cases - spine and default navbar
      #   # 
      #   @spine1=@links if ( $s eq $sku_spine1 );
      #   @spine2=@links if ( $s eq $sku_spine2 );
      #   @spine3=@links if ( $s eq $sku_spine3 );

         ## generate cells from this...
         #     go through links in order, construct %expand{colwidth}
         # 
         %expand=(); # holds expanded strings for column substitution
         %cellct=(); # count of linkage cells per cellwidth
         foreach $i ( 0..$#links ) {
            $q="";
            $u=$links[$i]->{'cellstyle'} ;
            next if ( ! $variants{$links[$i]->{'obj2'}}->{'visibility'} );    
          #next if ( length($u)<8 );

            $x= ( split /_/, $u )[1];
            &templatecheck( $u, $om_render_lang, $interface, 0);

            if ( $expand{$x} ) {
               $cellct{$x}++;
               $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
            } else {
               $cellct{$x}=1;
               $expand{$x}="<!-- start of column -->\n";
               $expand{$x}.="\n <!-- START_ELEMENT_$cellct{$x} --> \n";
               }
            ## add subcell handling...
            #
   
            ## overwrite default fields with manual entries
            #     just TITLE for now...
            %h=%{$variants{$links[$i]->{'obj2'}}};
#            $h{'title'}=$variants{$links[$i]->{'obj2'}}->{'title'};
            $h{'title'}=$variants{$links[$i]->{'objid'}}->{$om_render_lang}->{'alttitle'} if ( $variants{$links[$i]->{'objid'}}->{$om_render_lang}->{'alttitle'} && $variants{$links[$i]->{'objid'}}->{$om_render_lang}->{'status'} eq "15000-A");
            $image=$s."_80x80.jpg";
            $image2=$s.".gif";      
            if ( -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/products/80/$image" || -e "$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/duotone/$image2" ) {
               $h->{'image'}=$s;
               $h{'image'}=$s; 
            } else {
               $h->{'image'}="default";
               $h{'image'}="default";
         

            }
            $h{'unitpr'}=$objid{$links[$i]->{'obj2'}}->{'unitpr'}; #socheata add in

            $tempvar = $h{'objid'};
            if (($stock{$tempvar} <=  0) and ($variants{$tempvar}->{'behavior'} =~ /(os|dp)/ )) {
              $h{'cartlink'} =  "<img src=/images/$om_render_lang/buttons/button_outofstock.gif> ";
            } else {
              $tempvar = $h{'objid'};
              $h{'cartlink'} = "<input type=\"image\" src=\"/images/$om_render_lang/buttons/button_purchase.gif\" BORDER=0 alt=\"add to cart\">";
            }          

            $q=permutebit( $templates{$u}, \%h );
#            $q=permuteclean( $q );

            $expand{$x}.=$q;      
         } # done constructing gross column substitution units
         ## now construct bits in case multiple columns per width
         #

         ## split up column substitution strings as needed
         #
         foreach $w ( keys %nccol ) {
            $n = $nccol{$w};
            if ( $n == 1 ) {
               $k="column_$w"."_1";
               $variants{$s}->{$k}=$expand{$w};
               ## geometry addin
               $expand{$w} =~ s/__c__/$n/g; 
 
               my @temp_str = split /\n/, $expand{$w};
               my $temp_out = "";
               my $temp_r=0; 
               foreach (@temp_str) {
                  if ($_ =~ /START_ELEMENT/) { $temp_r++; }
                  $_ =~ s/__r__/$temp_r/g;
                  $temp_out .= $_ . "\n";
               }
               $expand{$w} = $temp_out;         

               $variants{$s}->{$k}=$expand{$w};
            } else {
               $u = $cellct{$w}/$nccol{$w};
               if ( $u>int($u) ) {
                  $u=int($u)+1;
               }
               # use $u cells per column of this type
               ## assemble columns
               #
               foreach $k ( 1..$n ) {
                  $min = (( $k - 1 ) * $u ) + 1 ;
                  $max = ($k * $u) + 1;
                  next if ( $min > $cellct{$w} );
                  $min='<!-- START_ELEMENT_'.$min.' -->';
                  $max='<!-- START_ELEMENT_'.$max.' -->';
                  if ( $expand{$w} =~ /$min/ ) { # there is something to cut
                     $q = ( split /$min/, $expand{$w} )[1];
                  } else { 
                     $q = $expand{$w};
                  } # done cutting too early bits
                  if ( $k < $n ) {
                     $q = ( split( /$max/, $q ) )[0]
                     if ( $max < $cellct{$w} ) ;
                  } # done cutting too late bits
                  $q =~ s/__c__/$k/g;# 
                                                       
                  my $temp_r = 0;
 
                  my @temp_str = split /\n/, $q;
                  my $temp_out = "";
 
                  foreach (@temp_str) {
                     if ($_ =~ /START_ELEMENT/) { $temp_r++; }
                     $_ =~ s/__r__/$temp_r/g;
                     $temp_out .= $_ . "\n";
                  }
                  $q = $temp_out;       


                  $ky="column_$w"."_$k";
                  $variants{$s}->{$ky}=$q;
               } # done assembling column bits
            } # done with split or not split branches    
         } # done splitting up columns for substitution into template 

         ## topnav construction -- load "up" linkage data of relevance
         #
         @links=@{$linkup{$s}};   

         ## push link for main sku if the vcode nonnull
         #
         if ( $variants{$s}->{'vcode'} ) {
            $h={};
            $h->{'obj1'}=$variants{$s}->{'ref_from'};
            $h->{'obj2'}=$s;
#            $h->{'title'}=$variants{$variants{$s}->{'ref_from'}}->{'title'};
            $h->{'linkwt_use'}=$variants{$variants{$s}->{'ref_from'}}->{'weight_use'};
            push @links, $h;
            push @links, @{$linkup{$z}};
         } # done forging linkage
         
         ## create sorted list on weight
         #
         @links = sortlinks( @links );

         ## construct topnav 
         #
         %knownlinks=();                              # blank hash for links
         $q="";

         $x = $#links;

         $x=($site->{'maxtopnav'} - 1) if ( $x > ( $site->{'maxtopnav'} - 1) );
         foreach $i ( 0..$x ) {
            # check for duplicate links
            next if ( $knownlinks{$links[$i]->{'obj1'}} );
            next if ( ! $variants{$links[$i]->{'obj1'}}->{'title'} );
            $knownlinks{$links[$i]->{'obj1'}}="here";  # note "been here, done that"
            $q.=" - " if ( $q );
            $q.='&nbsp;<A HREF="/html/'.$om_render_lang.'/'.$links[$i]->{'obj1'}.'.shtml">';   
            $q.=$variants{$links[$i]->{'obj1'}}->{'title'};
            $q.='</A>&nbsp;';
            $replacetitle=$variants{$links[$i]->{'obj1'}}->{'title'};
         } # done constructing topnav
  
 
         ## insert topnav if real, otherwise insert include of default
         if ( length($q)>2 ) {
#            if ($q !~ /<A HREF=\"\/html\/$om_render_lang\/home.shtml\">$script_msg{1}<\/A>/ ) {
#               $variants{$s}->{'jump_to_nav'} = "<A HREF=\"/html/$om_render_lang/home.shtml\">$script_msg{2}</A>&nbsp - ".$q; 
#	    } else {
	       $variants{$s}->{'jump_to_nav'}=$q;
#            }
         } else {
            $variants{$s}->{'jump_to_nav'} = "<a href=\"/html/$om_render_lang/home.shtml\">$script_msg{1}</a>";
         } # done with jump_to_nav  

         ## computed field-like things...
         #
         #
         if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/headers/$s.gif" ) {
            $variants{$s}->{'headergif'} = "$s.gif";
         } else {
            $variants{$s}->{'headergif'} = "genericheader.gif";
         } #/headers   

         $image=$s."_80x80.jpg";
	
         if ( -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/products/80/$image" || -e "/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/images/$om_render_lang/duotone/$image" ) {
         $variants{$s}->{'image'} = $s;
         } else {
            $variants{$s}->{'image'} = "default";
         }      
         if (($stock{$s} < 1) and ($variants{$s}->{'behavior'} =~ /(os|dp)/ )) {
              $variants{$s}->{'cartlink'} =  "<img src=/images/$om_render_lang/buttons/button_outofstock.gif> ";
         } else {
              $variants{$s}->{'cartlink'} = "<input type=\"image\" src=\"/images/$om_render_lang/buttons/button_purchase.gif\" BORDER=0 alt=\"add to cart\">";

         }         
         ## backgroundimage
         #
         $variants{$s}->{'site_background'} = $site->{'site_background'};
         $variants{$s}->{'sitename'} = $site->{'sitename'};
         ## permute the file and dump to the filesystem
         #
         $t=permutebit( $thispage, $variants{$s} ); 
         ## permute any variables from site hash
         #

         $t=permutebit( $t, $site );
         #$t=permuteclean( $t, "$s.shtml" );
         $t=permuteclean( $t  );

         if ( $interface eq "html" || $interface eq "palm" ) {
            $filetype="shtml";
         }  else {
            $filetype=$interface;
         }

         if ($catch{$s} ne "yes" ) {
            open( FH, ">$targetpath/$s.$filetype" );  
       
            print FH $t;
            close(FH);  
            $tot_page++;
         }
	
         if ( $interface eq "html" ) {


#            $root=$sku;
            $root=$s;

            ##socheata
            #change later?

            @temp=split /\t/, $extantvars{$root};


            if (($#temp==0)  && (length($s) > 8) ) {
    
               $space="";
               $tobereplace="<A HREF=\"/html/$om_render_lang/$s.shtml\">$replacetitle</A>";
#               $defaulttopbar="<A HREF=\"/html/$om_render_lang/xedm0002.shtml\">Home</A>";

               $t=~ s/$tobereplace/$space/g;
#               $t=~ s/$defaulttopbar/$space/g;

               $t=~ s/<\!--replace-->/$variants{$s}->{'jump_to_nav'}/g;

               $t=~ s/<a href=\"\/html\/$om_render_lang\/$s.shtml\"><IMG SRC=\"\/images\/$om_render_lang\/buttons\/view_button.gif/<IMG SRC=\"\/images\/$om_render_lang\/general\/clear.gif/g;
               open (FH2, ">$targetpath/$s.$filetype");
               print FH2 $t;
               close(FH2);
               $tot_page++;
               $catch{$root}="yes";
               }

           }

        }
 
      }
   }
}

## generate default topbar navigation
#
if ( @spine1 ) {
   ## topnav construction -- load "up" linkage data of relevance
   #
   $q='SELECT * FROM linkage WHERE obj1='."'$sku_spine1'";
   $q.="and status='15000-A'";
   $sth = $dbh->prepare( $q );
   $sth->execute;
   $num=$sth->rows;
   @links=();   
}

if ( @spine1) {

   foreach $language (@langsgen) {
   $om_render_lang=$language; 

      foreach $i ( 1..$num ) {
     
 
         $h=$sth->fetchrow_hashref;
         #next if ( $variants{$h->{'obj2'}}->{'status'} eq "nd" );
         push @links, $h;


      } # done loading links

      ## create sorted list on weight
      #
      @links = sortlinks( @links );


      open( FH, ">/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/$om_render_lang/include/jump_to_nav.html");
      $q="";
      $x = $#links;
      $x=($maxtopnav - 1) if ( $x > ( $maxtopnav - 1) );

      foreach $i ( 0..$x ) {

         # skip nondisplay items when building topnav
         next if ( $variants{$links[$i]->{'obj2'}}->{'status'} eq "nd" );

         $q.=" - " if ( $q );
         $q.='&nbsp;<A HREF="/html/'.$links[$i]->{'obj2'}.'.shtml">';   
         $q.=$variants{$links[$i]->{'obj2'}}->{'title'};
         $q.='</A>&nbsp;';
      } # done constructing topnav
      print FH $q;
      close(FH);
      $tot_page++;
   } # done constructing default topbar

   ## regenerate spine file
   #
   if ( @spine1 ) {
      open( FH, ">/$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/html/$om_render_lang/include/spine.html");
      print FH <<EOF;

      <A HREF="/html/$om_render_lang/home.shtml?v=spine&c=0&r=0&p=0&s=spine&t=img"><IMG SRC="/images/$om_render_lang/general/logo.gif" ALT="$site->{'sitename'}" HEIGHT=139 WIDTH=150 BORDER=0></A><BR><IMG SRC="/cgi-bin/om/sid.cgi" WIDTH=1 HEIGHT=1 BORDER=0><BR>
      <FORM METHOD="post" ACTION="/cgi-bin/om/search.cgi" NAME="search">
      <IMG SRC="/images/$om_render_lang/spine/search_$siteshortname.gif" WIDTH=114 HEIGHT=21 ALT="Search $site->{'sitename'}"><BR>
      <INPUT TYPE="text" NAME="search" SIZE="10" MAXWIDTH="25"> &nbsp; <INPUT TYPE="image" SRC="/images/$om_render_lang/spine/go.gif" WIDTH=17 HEIGHT=17 ALIGN=ABSMIDDLE BORDER=0 ALT="go">
      </FORM>
   
   <FONT FACE="arial,helvetica,san-serif"><B>$sku_spine1_title<B></FONT>
      <p>
      <FONT FACE="arial,helvetica,san-serif" size="-1">

EOF
      foreach $zz ( 0..$#spine1 ) {
         $k = $spine1[$zz];
         $sb=$k->{'sku2'};
         $q=variants{$sb}->{'title'};
         print FH "<A HREF=\"/html/$om_render_lang/$sb.shtml\?&v=spine&c=0&r=$zz";
         print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
      } # done with display roots list

      print FH <<EOF;
      </FONT>
      <P>
      <FONT FACE="arial,helvetica,san-serif"><B>$sku_spine2_title<B></FONT>
      <p>
      <FONT FACE="arial,helvetica,san-serif" size="-1">
  
EOF

      foreach $zz ( 0..$#spine2 ) {
         $k = $spine2[$zz];
         $sb=$k->{'OBJ2'};
         $q=$variants{$sb}->{'title'};
         $x = $zz + $#spine1 + 1;
         print FH "<A HREF=\"/html/$om_render_lang/$sb.shtml\?&v=spine&c=0&r=$x";
         print FH "&p=0&s=spine&t=txt\"><B>$q</B></A><BR>\n";
      } # done with display roots list

      print FH <<EOF;
      </FONT>
      <P>
      <A HREF="/cgi-bin/om/cart.cgi"><IMG SRC="/images/$om_render_lang/spine/shopping_bag.gif" 
      WIDTH=105 HEIGHT=21 BORDER=0 ALT="shopping bag"></A>
EOF

      foreach $zz ( 0..$#spine3 ) {
         $k = $spine3[$zz];
         $sb=$k->{'sku2'};
         $q=$variants{$sb}->{'title'};
         $x = $zz + $#spine + $#spine2 + 2;
         print FH "<A HREF=\"/html/$om_render_lang/$sb.shtml\?&v=spine&c=0&r=$x";
         print FH "&p=0&s=spine&t=txt\"><IMG SRC=\"/images/$om_render_lang/spine/$sb.gif\" ";
         print FH "WIDTH=130 HEIGHT=21 BORDER=0 ALT=\"$q\"></A><BR>\n";
      } # done with display roots list

      close(FH);
      $tot_page++;
   } #/end of spine generation

}

## generate links 
#

`$site->{'fsroothtml'}/$site->{'fsrelativeroot'}/crons/update_symlinks.pl`;

$loadtime = $loadtime - $started;
$started = (times)[0] - $started;
$x = $tot_page;

print "generate_site.pl $scriptversion $script_msg{3} $x $script_msg{4} $started $script_msg{5} \n";
$started = $started - $loadtime;

## turn off because of sym link problem

#$y = $x/$started;
#print "(of which $loadtime was loading data, net $started secs or $y p/s) \n";
$stp->finish if ( $stp );
$sts->finish if ( $sts );
$sth->finish if ( $sth );
$stv->finish if ( $stv );
$ste->finish if ( $ste );
$stg->finish if ( $stg );
$dbh->disconnect if ( $dbh );

################## subs

##### readcols( $s ): @;  takes a template, returns list of columns
#
sub readcols {
   my(@cols,$s);
   $s=$_[0];
   @cols = ( $s =~ m/__column_(\w+?)__/gs );
   return @cols;
} #/readcols


##### templatecheck( templatename ) - loads a template to globals
#        
sub templatecheck {
   my($tn,$om_render_lang,$interface,@temp2,$h);
   $tn=$_[0];
   $om_render_lang = $_[1];
   $interface = $_[2];
#   if ( ! exists($templates{$tn}) ) {
      # need to load the template
      $templates{$tn}=localize_template( $tn, $om_render_lang, "$interface", 0 );
#      print "Loading template $tn for $s\n";

      @temp2 = readcols($templates{$tn});
      $h={};
      while (@temp2) {
         ( $k,$v ) = ( split /_/, shift @temp2 )[0..1];
         $h->{$k}=$v if ( ! exists ( $h->{$k} ) );
         $h->{$k}=$v if ( $v > $h->{$k} );
      } # done running through columns
      $columns{$tn} = $h;
#   } # done seeing if the template needs loaded
   return 1;
} #/templatecheck
###### increment_array( current array, array of maximums)
#  Given array, will treat each element in array as as if it was one digit in a larger number
#  each digit will roll over at the value in maximums in the coresponding array element
#  Thus we scroll through every possibility given enough repititions        
  sub increment_array {
        my @curr = ();
        @curr = @{$_[0]}; 
 
        my @maxar = ();
        @maxar = @{$_[1]};
 
        $curr[$#curr]++;
 
        $carryover=0;
        for ($i = $#curr; $i >= 0; $i--){
                $curr[$i] += $carryover;
                $carryover = 0;
                if ($curr[$i] >= $maxar[$i]){
                        $curr[$i] = 0;
                        $carryover = 1;
                }
        }
        return @curr;
}
  
sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below

   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="Home Page";
      $script_msg{2}="Home";
      $script_msg{3}="made";
      $script_msg{4}="pages in";
      $script_msg{5}="seconds";
   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$script.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
}    
1;
