#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# cart-lib.pm
#
# Version 6 JC 20001004
# Version 5 JC 20001003
#   secure sid
# Version 4 JC    20000918
#   use ref_from from variant main title
# Version 3 JC/NC 20000913
#   nicedemical to linetotal
# Version 2 LCF 20000907
#   moved more of cart.cgi in here
# Version 1 LCF 20000824
#	split out lots of cart.cgi into here.
#
# Library of subroutines for cart.cgi

# Start docs
=pod
=head1 NAME 

cart-lib.pm

=head1 SYNOPSIS

This is a library of functions used in cart.cgi. 

=head1 DESCRIPTION

All of the DB calls formerly found in cart.cgi are here now. Routines that do DB calls will generally return an active (executed) statement handle.

Also, a big chunk of the logic for finding variants and creating the "next page" URLs is now in here.

=head1 NOTES & BUGS

More of cart.cgi should be put in here, and the check_for_variants and make_nextpg_* routines should probably be broken up further.

=cut
# End docs

#use strict;

sub get_cart_rows {
	my ($site, $dbh, $c_err, %FORM) = @_;
	
	my ($items_sth) = &get_cart_items($site, \%FORM, $dbh);

	$FORM{'cart_error'}="$c_err" if ( $c_err ne '' );
	my %variant;
	my $count = 0;

	while ( my $items = $items_sth->fetchrow_hashref(NAME_lc) ) {
		$count++;
    	my $row=$items->{'objid'};
		$rows{$row}=$items;
		#warn "Calling check_for_variants\n";
		my $return_rows = &check_for_variants($items, \%rows, $row, $dbh);
		%rows = %{$return_rows};

		## get price data
		#
		my $price_sth = &get_price_data(\%rows, $row, $site);

		for (1..2) {
			my $pp=$price_sth->fetchrow_hashref(NAME_lc);
#                while ( my $pp=$price_sth->fetchrow_hashref(NAME_lc) ) {
			foreach my $key ( keys %{$pp} ) {
				next if ($key ne "unitpr");
				if ( $rows{$row}->{$key} > $pp->{$key} || $rows{$row}->{$key} eq "0.00" ) {
					$rows{$row}->{$key} = $pp->{$key} 
				}		
			} #/ done populating price data 
		} #/end of loading the specifics from variants for this one
		$price_sth->finish();

	} #/done loading fields

	# finish sth's
	$items_sth->finish();

	return (\%rows, \%FORM, $count);
}

sub get_cart_items {
	my $site = shift;
	my $FORM = shift;
	my $dbh  = shift;
		
	my $query="SELECT * from tcart where sid='$FORM->{'sid'}' AND objclass != '140-A' ";
	my $sth = $dbh->prepare( $query );
	my $rv = $sth->execute;
	return ($sth);
}


sub check_for_variants {
	##warn "  In check_for_variants...\n";
	my $items  = shift;
	my $rows   = shift;
	my $obj_id = shift;
	my $dbh    = shift;
	my $variants_sth = &get_variants($items, $dbh);
		
	while ( my $variants = $variants_sth->fetchrow_hashref(NAME_lc) ) {
      #warn "  We have a variant...\n";
      foreach my $key ( keys %{$variants} ) {
         $rows->{$obj_id}->{$key} = $variants->{$key} unless ( $rows->{$obj_id}->{$key} );
      }
      ## do we have a variant
      #
      if ( length($variants->{'ref_from'}) >2 ) {

         my $vardescript="";
         my $vcode="";
         if ( $variants->{'lineobjid'} ne $variants->{'ref_from'} ) {
            $vcode = $variants->{'vcode'};
            
			my $from_sth = &get_ref_from($variants, $dbh);
			
			my $ref_from = $from_sth->fetchrow_hashref(NAME_lc);
			$from_sth->finish();
            my @vcodes = split /:/, $vcode;
            my @axisname = split /:/, $ref_from->{'axisnames'};
            foreach my $axis (@axisname) {
            	my $body = &get_extraprop_body($axis, $dbh);
					my @valuepairs = split /\r\n/, $body;
            	
					foreach my $pair (@valuepairs) {
           		my ($key,$value) = split/:/, $pair;
            		$variants->{$key}=$value;
            	}
            	
					my $code = shift @vcodes;
            	$vardescript.=" ".$variants->{$code};
            }

            $variants->{'title'} = $ref_from->{'title'}.$vardescript;
         } 

         foreach ( keys %{$variants} ) {
            $rows->{$obj_id}->{$_} = $variants->{$_} unless ( $rows->{$obj_id}->{$_} );
         }                                           
      } #/done checking for variants
   }
   $variants_sth->finish();
   #warn "  Leaving check_for_variants...\n";
   return $rows;
}
	
sub get_variants {
	my $h   = shift;
	my $dbh = shift;
	
	my $q="SELECT * from things where objid='$h->{'lineobjid'}' ";
	my $sth=$dbh->prepare( $q );
	$sth->execute;
	
	return ($sth);
}
 
sub get_ref_from {
	my $h   = shift;
	my $dbh = shift;
	
	my $q = "SELECT * from things where objid='$h->{'ref_from'}' ";
    my $sth = $dbh->prepare( $q );
    my $rv = $sth->execute;
    return ($sth);
}

sub get_extraprop_body {
	my $axis = shift;
	my $dbh  = shift;
	
	my $s="SELECT body FROM extraprop WHERE objid='$axis' AND fieldname='encoding'";
    my $sth=$dbh->prepare($s);
    $sth->execute;
    my ($body)=$sth->fetchrow;
	$sth->finish();
	return $body;
}

sub get_next_pg_id {
	my ($site, $FORM) = @_;

        $FORM->{'sid'}=&os_unhash(pack(H16, $FORM{'sid'}), $site->{'hash_key'}) if ($FORM{'sid'} && length($FORM{'sid'}) > 11);	
	my $q="SELECT sid,custid,mdate from sessions where sid=$FORM->{'sid'} ";
	my $sth = $site->{dbh}->prepare( $q );
	$sth->execute;

	return $sth;
}


sub make_nextpg_user {
	my ($a,$b,$c,$site,$FORM) = @_;
	my %FORM = %{$FORM};
	my $uid;
	my $wishlisturl;


      $sid_encrypt=unpack(H16, &os_hash($FORM{'sid'},$site->{'hash_key'}));	
	if ( length($b)>2 ) { # event - series 

      # user logged in
      my $q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/";
      $q.="checkout.cgi?sid=$sid_encrypt";
      $FORM{'nextcheckoutpg'}=$q;

      ## wishlist sequence 
      # Note-- This does nothing. I don't know why it's here.
      $FORM{'wishlist_en'}=1;
      $FORM{'wishlist_button'}=$wishlisturl;
      $uid=$b;

	} else {

	  my ($q, $u, $wishlisttarg, $collectiontarg);
      # user not logged in
      $q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/";
      $q.="checkout.cgi?sid=$sid_encrypt";
      $u="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?sid=$sid_encrypt&pg_targ=$q";
      $FORM{'nextcheckoutpg'}=$u;

      ## wishlist sequence 
      #
      $wishlisttarg="http://$site->{'siteurl'}/cgi-bin/om/cart.cgi?wishlist=1";
      $wishlisturl="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?";
      $wishlisturl="sid=$sid_encrypt&pg_targ=$collectiontarg";
      $FORM{'wishlist_button'}=$wishlisturl;

   } #/done checking on login when session registered
   
   return ($uid, %FORM);
}

sub make_nextpg_nouser {
	my ($a,$b,$c,$site,$FORM) = @_;
	my %FORM = %{$FORM};
	my $wishlisturl;
	
	my ($q, $u, $wishlisttarg);

        $sid_encrypt=unpack(H16, &os_hash($FORM{'sid'},$site->{'hash_key'}));

	$q="$site->{'ssl_prefix'}://$site->{'sitesslurl'}/cgi-bin/om/ssl/checkout.cgi?";
	$q.="sid=$sid_encrypt";
	$u="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?sid=$sid_encrypt&pg_targ=$q";
	$FORM{'nextcheckoutpg'}=$u;

	## wishlist sequence
	#
	$wishlisttarg="http://$site->{'siteurl'}/cgi-bin/om/cart.cgi?wishlist=1";
	$wishlisturl="http://$site->{'siteurl'}/cgi-bin/om/welcome.cgi?";
	$wishlisturl.="sid=$sid_encrypt&pg_targ=$wishlisttarg";
	$FORM{'wishlist_button'}=$wishlisturl;
	
	return %FORM;
}

sub get_price_data {
	my $rows      = shift;
	my $curr_row  = shift;
	my $site	  = shift;
	
	my $p="SELECT * FROM prices WHERE objid='$rows->{$curr_row}->{'lineobjid'}' "; 
	$p.=" AND status='15000-A' ";
	my $sth=$site->{dbh}->prepare($p);
	$sth->execute;
	
	return $sth;
}

sub get_lang_interf {
	my $sid = shift;
	my $dbh = shift;
	
	my $q="SELECT language,interface from sessions where sid=$sid";
	my $sth = $dbh->prepare( $q );
	$sth->execute;
	return $sth;
}

sub cart_perm_template {
	my ($om_render_lang, $interface) = @_;
	
	my %templates;
	$templates{'cell_cart_message'}=
   		localize_template("cell_cart_message",$om_render_lang,$interface,0);
	$templates{'cell_cart_header'}=
   		localize_template("cell_cart_header",$om_render_lang,$interface,0);
	$templates{'cell_cart_list'}=
   		localize_template("cell_cart_list",$om_render_lang,$interface,0);
	$templates{'cell_cart_subtotal'}=
   		localize_template("cell_cart_subtotal",$om_render_lang,$interface,0);
	$templates{'cell_cart_buttons'}=
   		localize_template("cell_cart_buttons",$om_render_lang,$interface,0);
	
	return %templates;
}

sub new_item_row {
	my ($rows, $form, $templates) = @_;
	my %rows = %{$rows};
	my %FORM = %{$form};
	my %templates = %{$templates};
	
	if ( $FORM{'newrow_objid'} ) {
		my $row=$FORM{'newrow_objid'};
		my $h=$rows{$row};
		my $k="row\.$row\.quant_err";
		$h->{'quant_err'}=$FORM{$k} if ( $FORM{$k} );

		## cleanup decimals on prices
		#
		$h->{'unitpr'} = nicedecimals( $rows{$row}->{'unitpr'} );
                $h->{'linetotal'} = nicedecimals( $rows{$row}->{'linetotal'} ); 

		## permute and build cells

		my $u=permutebit( $templates{'cell_cart_list'}, $h );
		$u=permuteclean( $u );
		$FORM{'newrow_cell_cart_list'}=$u;
		$FORM{'newrow_cell_cart_message'}=$templates{'cell_cart_message'};
		$FORM{'newrow_cell_cart_header'}=$templates{'cell_cart_header'};
		$FORM{'newrow_cell_cart_buttons'}=
		   permutebit( $templates{'cell_cart_buttons'}, \%FORM );
	}

	return (\%templates, \%FORM);
}

sub old_item_row {
	my ($frm, $rws, $tmpl) = @_;
	my %FORM = %{$frm};
	my %rows = %{$rws};
	my %templates = %{$tmpl};
	
	my $u="";

	$FORM{'newrow_objid'}=0 if ( ! defined($FORM{'newrow_objid'}) );
		my $skip;
	   foreach my $r ( keys %rows ) {
    	  $rows{$r}->{'sid'}=$FORM{'sid'};
    	  next if ( $r eq $FORM{'newrow_objid'} || $skip );
    	  my $k="row\.$r\.quant_err";
    	  $rows{$r}->{'quant_err'}=$FORM{$k};

    	  $rows{$r}->{'unitpr'} = nicedecimals ( $rows{$r}->{'unitpr'} ) ;
          $rows{$r}->{'linetotal'} = nicedecimals ( $rows{$r}->{'linetotal'} ) ;

    	  $rows{$r}->{'objid'}=$r;

    	  my $ub=permutebit( $templates{'cell_cart_list'}, $rows{$r} );
    	  $ub=permuteclean( $ub );
    	  $u.=$ub;
	   } #/end of constructing old rows     

	if ( $u ) {
	   $FORM{'cell_cart_header'}=$templates{'cell_cart_header'};
	   $FORM{'cell_cart_buttons'}=permutebit( $templates{'cell_cart_buttons'}, \%FORM );
	   $FORM{'cell_cart_list'}=$u;
	}
	
	return %FORM;
}

sub put_checkout_items_back {

my $sid = shift;
my $q, $stss, $sts, $h;

    $q = " SELECT * from tcart where SID='$sid' and objclass != '140-A' ";
    $stss = $dbh->prepare($q);
    $stss->execute;

    while ($h=$stss->fetchrow_hashref(NAME_lc)) {

        if ($h->{'hquant'} > 0 || $h->{'squant'} > 0) {
           $q= "UPDATE inventory SET lstock=lstock+$h->{'hquant'} ";
           $q.=" where objid='$h->{'lineobjid'}' ";
           $sts = $dbh->prepare($q);
           $sts->execute;

           $q = "UPDATE tcart set hquant='0', squant='0' ";
           $q.="where objid='$h->{'objid'}' and sid='$h->{'sid'}' ";
           $q.="and custid='$h->{'custid'}' ";
           $sts = $dbh->prepare($q);
           $sts->execute;
        } # end of if
    } # end of while

} # end of put_checkout_items_back


sub message {
   # check the language that is being used and open appropriate
   # message language file or get messages below
	my %script_msg;
	
   if ($om_render_lang eq "eng" ) {
      $script_msg{1}="We're sorry! Limit one per order!";
      $script_msg{2}="You currently have no items in your cart.";
      $script_msg{3}="Sorry you must log in before you can place items into your Wishlist";
      $script_msg{4}="Sorry quantity is limited to this item. ";
      $script_msg{5}="Sorry, we have a quantity limit on this item.";
      $script_msg{6}="Sorry, but this item is now out of stock.";
      $script_msg{7}="This item cannot be added to your cart.";
      $script_msg{8}="You can not add the item you just select into the cart at this time.";
      $script_msg{9}="The item you just selected has been discontinued.";
      $script_msg{10}="The item you just selected has been recalled.";
      $script_msg{11}="You have exceeded the purchase limit.  Delete an item or go to checkout and purchase the items you have now before adding anything else to your cart.";
 


   } else {
      open( EM, "<$relpath/bits/$om_render_lang/system/$scriptname.$om_render_lang.messages");
      while(<EM>) {
         chomp;
         next if /^\#/;
         next if (! $_);
         my @temp=split /\t/;
         $script_msg{$temp[0]}=$temp[1];
      }
      close(EM);
   }
   return %script_msg;
}


1;
