#!/usr/bin/perl
#
###############################################################
#
# CyberCash CashRegister interface for OpenSales AllCommernce 1.0.1
#
#  (c) 2000 - 2001 Guardian Digital, Inc.
#
#  This module is part of the interface for CyberCash
#  It has three main functions, receiptCell, printOrder, and
#  readCCInfo.  The ReadCCinfo function gets the encrypted
#  credit informaiton from the temp file.  The printOrder
#  write the necessary information to the order.log file for
#  CyberCash to use and receiptCell draws up the main receipt.
#  Everything around the receipt is in a template.
#
###############################################################
# + 01/29/00 Nick DeClario <nick@guardinadigital.com>
#   - Fixed error checking for fetching shipping
#     information from the database
#
# + 09/07/00 Nick DeClario <nick@guardiandigital.com>
#   - Fixed incorrect shipping cost in display
#
# + 09/06/00 Nick DeClario <nick@guardiandigital.com>
#   - Added proper information to config files
#
# + 09/05/00 Nick DeClario <nick@guardiandigital.com>
#   - Created
#
##################################
#
sub receiptCell {
  use DBI;

  $relpath = &getRelPath();
 
  require "$relpath/conf/site.pm";

  my $orderId = $_[0];
  my ($receipt, $shipTo, $billTo);
  my ($sName, $sAddress1, $sAddress2, $snum, $bName, $bAddress1, $bAddress2, $bNum);
  my ($sCity, $sState, $sZip, $bCity, $bState, $bZip, $custId, $subtotal, @temp);
  my ($sMethod, $sMethodId, $ccName, $ccExp, $userID, $sessionNum, $price, $qty, $sTotal, $msku);
  my ($taxRate, $tax, $sCost, $total, $totalItems, @itemList, $items, $shipZone);
  $ccExp = $_[1];
  $ccName = $_[2];

  $site=setsite();

  $q = "$site->{'db_site_config'}";
  $dbh = DBI->connect($site->{'db_site_connect'}, $site->{'site_dbiuser'}, $site->{'site_dbipwd'});

  $stf = $dbh->prepare("SELECT custid FROM orders where objid='$orderId'");
  $stf->execute;
  $custId = $stf->fetchrow; 
  $stf->finish();

  $stf = $dbh->prepare("SELECT uname FROM contacts where objid='$custId'");
  $stf->execute;
  $userID = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT shipto FROM orders where objid='$orderId'");
  $stf->execute;
  $shipTo = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT billto FROM orders where objid='$orderId'");
  $stf->execute;
  $billTo = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT name FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sName = $stf->fetchrow;
  $sName =~ s/\|/ /g;
  $stf->finish();
  
  $stf = $dbh->prepare("SELECT name FROM addresses where objid='$billTo'");
  $stf->execute;
  $bName = $stf->fetchrow;
  $bName =~ s/\|/ /g;
  $stf->finish();

  $stf = $dbh->prepare("SELECT address1 FROM addresses where objid='$billTo'");
  $stf->execute;
  $bAddress1 = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT address1 FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sAddress1 = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT address2 FROM addresses where objid='$billTo'");
  $stf->execute;
  $bAddress2 = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT address2 FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sAddress2 = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT city FROM addresses where objid='$billTo'");
  $stf->execute;
  $bCity = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT city FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sCity = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT state FROM addresses where objid='$billTo'");
  $stf->execute;
  $bState = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT state FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sState = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT postcode FROM addresses where objid='$billTo'");
  $stf->execute;
  $bZip = $stf->fetchrow;
  $stf->finish();

  $stf = $dbh->prepare("SELECT postcode FROM addresses where objid='$shipTo'");
  $stf->execute;
  $sZip = $stf->fetchrow;
  $stf->finish();

  ### Get tax and taxRate and total
  #
  $stf = $dbh->prepare("SELECT taxrate, st_tax, ordtotal, shipwt FROM orders where objid='$orderId'");
  $stf->execute;
  @temp = $stf->fetchrow;
  $stf->finish();
  $taxRate = sprintf("%.2f", $temp[0]);
  $tax = sprintf("%.2f", $temp[1]);
  $total = sprintf("%.2f", $temp[2]); 
  $sWeight = $temp[3];

  ### Get the number of different products the user is trying to buy
  ### Note: this does not include quantity per product
  #
  $stf = $dbh->prepare("SELECT lineobjid FROM tcart where custid='$custId' and orderid='$orderId' and objclass='81001-A'");
  $stf->execute;
  $totalItems = $stf->rows;
  for ($n = 0; $n <= $totalItems; $n++) {
     $itemList[$n] = $stf->fetchrow;
  }
  $stf->finish();

  ### Get shipping information, title, amount...
  #

  $stf = $dbh->prepare("SELECT lineobjid FROM tcart where custid='$custId' and orderid='$orderId' and objclass='140-A'");
  $stf->execute;
  $sMethodId = $stf->fetchrow;

  $stf = $dbh->prepare("SELECT unitpr FROM tcart where custid='$custId' and orderid='$orderId' and lineobjid='$sMethodId'");
  $stf->execute;
  $sCost = sprintf("%.2f", $stf->fetchrow); 
 
  $stf->finish();  

  $stf = $dbh->prepare("SELECT title FROM things where objid='$sMethodId'");
  $stf->execute;
  $sMethod = $stf->fetchrow;
  $stf->finish();

  ### Get session #
  #
  $stf = $dbh->prepare("SELECT sid from sessions where custid='$custId' ORDER BY mdate DESC");
  $stf->execute;
  $sessionNum = $stf->fetchrow;
  $stf->finish();

  $bAddress2 .= "<br>" if ($bAddress2);
  $sAddress2 .= "<br>" if ($sAddress2);

  ### Product list loop
  ### Displays product, sku, price, qty, and subtotal
  #

  for ($n = 0; $n <= $totalItems; $n++) {
     ### get product name
     #          

     $stf = $dbh->prepare("SELECT title FROM things where objid='$itemList[$n - 1]'");
     $stf->execute;

     $product = $stf->fetchrow;
     $stf->finish();
 
     ### get product price
     #
     $stf = $dbh->prepare("SELECT unitpr FROM prices where objid='$itemList[$n - 1]'");
     $stf->execute;

     $price = sprintf("%.2f", $stf->fetchrow);
     $stf->finish();

     ### get quantity and sku
     #
     $stf = $dbh->prepare("SELECT quant, msku  FROM tcart where custid='$custId' && orderid='$orderId' && lineobjid='$itemList[$n - 1]'");
     $stf->execute;
     @temp = $stf->fetchrow;
     $stf->finish();
     $qty = $temp[0];
     $msku = $temp[1];

     $subtotal = sprintf("%.2f", $price * $qty);

     $summary = "<TR><TD valign=top><FONT FACE=\"arial, helvetica\" szie=-1>$product<\/FONT><BR><FONT FACE=\"arial, helvetica\" size=-1>SKU: $msku<\/TD><TD align=right valign=top><FONT FACE=\"arial, helvetica\" size=-1>\$$price<\/TD> <TD align=center valign=top><FONT FACE=\"arial, helvetica\" size=-1>$qty<\/TD> <TD align=right valign=top><FONT FACE=\"arial, helvetica\" size=-1>\$$subtotal<\/TD> <\/TR> "
  } 

  #
  ### End of product list loop

  $dbh->disconnect();

  $receipt = <<RECEIPT;

<!------- This has all products from your scart -------->
<pre>
</pre>
      <TABLE BORDER=0 width=100% CELLSPACING=0 CELLPADDING=20 align=center>
      <FORM METHOD="POST" ACTION="checkout.cgi">
      <INPUT TYPE="hidden" NAME="pg_targ" VALUE="">
      <input type="hidden" name="sid" value="54">
      <input type="hidden" name="Amount" value="">
      <input type="hidden" name="CERTCHARGED" value="">
      <input type="hidden" name="CERTPICKED" value="">

         <TR>
            <TD VALIGN=TOP COLSPAN=2>
		<FONT FACE="arial, helvetica"><b>Order ID : </b>$orderId</FONT>
	    </TD>
         </TR>
         <TR>
            <TD VALIGN=TOP><font face="arial, helvetica"
               size=-1><B>Ship to</B></font><BR>

          <table cellpadding=0 cellspacing=0 border=0 width=100%>
               <tr>
                  <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
               </tr>
            </table>

            <FONT FACE="arial, helvetica" SIZE=-1>$sName<br>
$sAddress1<br>
$sAddress2
$sCity, $sState $sZip</FONT>
</font></TD>

            <TD VALIGN=TOP><font face="arial, helvetica" size=-1><B>Bill to</B></font><BR>

            <table cellpadding=0 cellspacing=0 border=0 width=100%>
               <tr>
                  <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
               </tr>
            </table>

            <FONT FACE="arial, helvetica" SIZE=-1>$bName<br>
$bAddress1<br>
$bAddress2
$bCity, $bState $bZip</FONT>
</font></TD></TR>


          <TR>
            <TD VALIGN=TOP COLSPAN=2><font face="arial, helvetica" size=-1><B>Ship Via</B><BR>
            <table cellpadding=0 cellspacing=0 border=0 width=100%>
               <tr>
                  <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
               </tr>
            </table>
             <font face="arial, helvetica" size=-1>$sMethod</FONT></TD>
           </TR>


          <TR>
            <TD VALIGN=TOP COLSPAN=2><font face="arial, helvetica"
               size=-1><b>Payment Method</b></font><BR>

            <table cellpadding=0 cellspacing=0 border=0 width=100%>
               <tr>
                  <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
               </tr>
            </table>
            <font face="arial, helvetica" size=-1><b>Card</b>:  $ccName<br>
            <b>Expiration</b>: $ccExp</font></TD>
         </TR>


         <TR>  
            <TD VALIGN=TOP COLSPAN=2><font
               face="arial, helvetica" size=-1><B>User ID</B></FONT>

            <BR>

            <table cellpadding=0 cellspacing=0 border=0 width=100%>
               <tr>
                  <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
               </tr>
            </table>

            <font face="arial, helvetica" size=-1>$userID, Session #$sessionNum</FONT></TD>
         </TR>
      </TABLE>

     <table cellpadding=0 cellspacing=5 border=0>
         <tr>
            <td>&nbsp;</td>
         </tr>
      </table>
      <TABLE BORDER=0 cellspacing="0" cellpadding="3" width=80% align=center>

<TR>
   <TD width=35% valign=bottom><font
      face="arial, helvetica" size=-1><B>Product</B></TD>
   <TD width=25% valign=bottom align=right><font
      face="arial, helvetica" size=-1><B>Price</B></TD>
   <TD width=25% valign=bottom align=center><font
      face="arial, helvetica" size=-1><B>Qty.</B></TD>
   <TD width=15% valign=bottom align=right><font
      face="arial, helvetica" size=-1><B>Subtotal</B></TD>
</TR>

<tr>
   <td colspan=4>
   <table cellpadding=0 cellspacing=0 border=0 width=100%>
      <tr>
         <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
      </tr>
   </table></td>
</tr>
$summary
<TR>
   <TD COLSPAN=3 ALIGN=RIGHT><FONT
      FACE="arial, helvetica" size=-1>Sales tax (Tax rate $taxRate%):</TD>
   <TD align=right><FONT FACE="arial, helvetica" size=-1>\$$tax</TD>
   <input type="hidden" name="taxraten" value="$taxRate">
   <input type="hidden" name="st_tax" value="$tax">
</TR>

<TR>
   <TD COLSPAN=3 ALIGN=RIGHT><font face="arial, helvetica" size=-1>$sMethod Shipping:</TD>
   <TD align=right><FONT FACE="arial, helvetica" size=-1>\$$sCost</TD>
</TR>

<TR>
   <TD COLSPAN=3></TD>
   <TD>
   <table cellpadding=0 cellspacing=0 border=0 width=100%>
      <tr>
         <td bgcolor=#000000><img src=/images/eng/general/clear.gif height=2 width=1></td>
      </tr>
   </table></TD>
</TR>
<TR>
   <TD COLSPAN=3 ALIGN=RIGHT><FONT FACE="arial, helvetica" size=-1><B>Total amount to be charged:</B></TD>
   <TD align=right valign=top><FONT FACE="arial, helvetica" size=-1><B>\$$total</B>
   <input type=hidden name=ordtotal value="$total"></TD>

</TR>

</TABLE><br><br>
		    </TD>
		  </TR>
       </TABLE>

RECEIPT

  return $receipt;
}

sub getRelPath {

  if ( $0 !~ /^\// ) {  # $0 is not an absolute path
     $s=`pwd`;          # hope pwd on path...
     chomp $s;
     $s.="/$0";
     } else {              # $0 IS an absolute path
     $s=$0;
  } # done determining if $0 is relative or absolute
  @temp=split /\//, $s;

  @rpath=@temp;
  $scriptname = pop @rpath;
  $scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

  $rundir= join "/", @rpath;
  #chdir( $rundir );

  $relpath="";
  $siteshortname="";
  ## short circuit if $s does not contain cgi-bin
  if ( $s !~ /cgi-bin/ ) {
     $siteshortname = pop @rpath;
     $relpath=".";
     @temp=();
  } # done testing for degenerate case

  while ( @temp ) {
     $u = pop @temp;

     ## skip references to the present directory
     next if ( $u eq '.' );
     next if ( length($u)==0 );        # skip null directory levels

     $relpath.="/.." if ( $relpath);
     $relpath.="." if ( ! $relpath );

     if ( $u eq "cgi-bin" ) {
        $siteshortname = $temp[$#temp];
        @temp=();
     } # note - cgi-bin is off the site root, so the next up is site root
  }
  $relpath .= "/../$siteshortname";

  return $relpath;

}

sub readCCInfo {
   my($info) = $_[0];
   my(@lines);

   $relpath = &getRelPath();

   open (INFO, "< $relpath/transit/temp/mck.tmp");
   @lines = <INFO>;
   close INFO;
   unlink ("$relpath/transit/temp/mck.tmp");

   $info->{'orderID'} = $lines[0];
   $info->{'ccNum1'} = $lines[1];
   $info->{'ccNum2'} = $lines[2];
   $info->{'ccExp'} = $lines[3];
   $info->{'ccName'} = $lines[4];
   $info->{'ccName'} = "n/a" if (!$info->{'ccName'});
   $info->{'ccExp'} = "n/a" if (!$info->{'ccExp'});
	
   return $info;
}

sub printOrder {
 my ($orderId, $timestamp, $price, $valid, $payload, $cust, $orderDesc) = @_;

  $ORDER_RSEP = '&';
  $relpath = &getRelPath();
  $progdir = $relpath . "/";
  $ConfigFile =  $progdir . "conf/merchant_conf";

  open (CONFIG, "< $ConfigFile");
  @lines = <CONFIG>;
  foreach $line (@lines) {
    if (substr($line,0,8) eq "ORDER_DB") {
      $orderLog = $line;
    }
  }
  close (CONFIG);
  
  $orderLog =~ s/ORDER_DB//s;
  $orderLog =~ s/\=//g;
  $orderLog =~ s/ //g;

  unless(open (ORDERDB, ">> $orderLog")) {
        return $E_No_OrderLog;  # DB failure
  }

    print ORDERDB $orderId
                . $ORDER_RSEP . $timestamp
                . $ORDER_RSEP . $price
                . $ORDER_RSEP . $valid
                . $ORDER_RSEP . $payload
                . $ORDER_RSEP . $cust
                . $ORDER_RSEP . $orderDesc
                . "\n";
   close(ORDERDB);
}

return true;
