#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################

#####
# om_db.pm
#   file for setting global database routines that are db specific
#   (client agnostic mappings)
#
#   written on 20000230 GF
#
#####

#####
#
# Version 0.9.13 20000422 JC
#    updated connection strings
# Version 0.9.12 20000420 JC
#    removed a missed stats entry and updated connection strings
# Version 0.9.11 20000412 JC
#    removed stats* entires
# Version 0.9.10 20000405 JC
#    correction database entries
# Version 0.9.9 20000403 JC
#    correction to Postgres entry
# Version 0.9.8 20000329 JC
#    filling in some of the entries below
# Version 0.9.7 20000328 JC
#    corrections to stats entries
# Version 0.9.6 20000327 JC
#    including stats database section
# Version 0.9.5 20000326 JC
#    hashref model with update_conf.pl 
# Version 0.9.4 20000306 GF
#    continued worked on hashref model
# Version 0.9.3 20000206 GF
#    changed to hashref model
# Version 0.9.2 20000206 GF
#    fixed some known problems
#    added postgres
# Version 0.7.1 20000130 GF
#
#####  


sub om_db {
   # returns a hashref to be set as $om_db
   my($h);
   $h={};

   ##
   # Client agnostic database routines that are db specific.
   #
   $h = {

      db_site_config  => {

         mysql          => "DBI:mysql:\$h->{\'site_database\'}:\$h->{\'site_database_serv\'}:\$h->{\'site_database_port\'}",
         Pg	        => "DBI:Pg:dbname=\$h->{\'site_database\'};port=\$h->{\'site_database_port\'};host=\$h->{\'site_database_serv\'}",
         Oracle         => "DBI:Oracle:host=localhost;sid=$ORACLE_SID",
         informix       => "DBI:Informix:\$h->{\'site_database\'}\@\$h->{\'site_database_serv\'}",
         sybase         => "DBI:Sybase:server=\$h->{\'site_database_serv\'},database=\$h->{\'site_database\'}",
         db2            => "DBI:DB2:\$h->{\'site_database\'}",
         msql           => "DBI:mSQL:\$h->{\'site_database\'}:\$h->{\'site_database_serv\'}:\$h->{\'site_database_port\'}",
      },

      db_site_connect  => {

         mysql          => "DBI:mysql:\$h->{\'site_database\'}:\$h->{\'site_database_serv\'}:\$h->{\'site_database_port\'}",
         Pg             => "DBI:Pg:dbname=\$h->{\'site_database\'};port=\$h->{\'site_database_port\'};host=\$h->{\'site_database_serv\'}",
         Oracle         => "DBI:Oracle:host=localhost;sid=$ORACLE_SID",
         informix       => "DBI:Informix:\$h->{\'site_database\'}\@\$h->{\'site_database_serv\'}",
         sybase         => "DBI:Sybase:server=\$h->{\'site_database_serv\'},database=\$h->{\'site_database\'}",
         db2            => "DBI:DB2:\$h->{\'site_database\'}",
         msql           => "DBI:mSQL:\$h->{\'site_database\'}:\$h->{\'site_database_serv\'}:\$h->{\'site_database_port\'}",
      },

   }; # done with  $h

   return $h;

} #/om_db

1;     
