#!/usr/bin/perl
############################################################################
#    Copyright (C) 1999-2000 Zelerate, Inc.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
############################################################################
#
# link_home.pl
#   script that allows one to create your (via a symlink) home page  
#   from the <objid>.shtml web page.  
#    
#    Version 1 JC 20000723
#       creation  
#
#
## determine path from store (site) root and store db name...
#
#  note - this script runs at server root or in crons,
#    generally. Test these conditions first.
#  $0 - may not contain a full path, bootstrap with "pwd"
#
if ( $0 !~ /^\// ) {  # $0 is not an absolute path
   $s=`pwd`;          # hope pwd on path...
   chomp $s;
   $s.="/$0";
} else {              # $0 IS an absolute path
   $s=$0;
} # done determining if $0 is relative or absolute
@temp=split /\//, $s;

@rpath=@temp;

$scriptname = pop @rpath;
$scriptname = ( split /\?/, $scriptname )[0];   # ignore GET stuff

$rundir= join "/", @rpath;
chdir( $rundir );

$relpath="";
$siteshortname="";
## short circuit if $s does not contain crons
if ( $s !~ /\./ ) {
   $siteshortname = pop @rpath;
   $relpath=".";
   @temp=();
} # done testing for degenerate case

while ( @temp ) {
   $u = pop @temp;

   ## skip references to the present directory
   next if ( $u eq '.' );
   next if ( length($u)==0 );        # skip null directory levels

   $relpath.="/.." if ( $relpath);
   $relpath.="." if ( ! $relpath ); 

   if ( $u eq 'tools' ) {
      $siteshortname = $temp[$#temp];
      @temp=();
   } # note - crons is off the site root, so the next up is site root
} # done constructing relative path to store root

$relpath .= "/../$siteshortname"; 

require "$relpath/conf/site.pm";

# must be the last require statement
require "$relpath/lib/custom-lib.pm"; 

## establish site-specific parameters
#
$site=setsite();

$om_render_lang="$site->{'om_locale_lang_def'}";
$om_render_lang="eng" if ( ! $om_render_lang ); 

if ( @ARGV ) {  

   $lang=$om_render_lang;
   $lang=$ARGV[1] if ( $ARGV[1] );
   $interface="html";
   $interface=$ARGV[2] if ( $ARGV[2] );
   $directory="$relpath/$interface/$lang";

   chdir("$directory") || die "$directory does not exist.\n\n";

   if ( -f "./auto/$ARGV[0].shtml" ) {
      `ln -fs ./auto/$ARGV[0].shtml home.shtml`;
      `/bin/chown nobody:nobody home.shtml`;
      print "\nln -fs ./auto/$ARGV[0].shtml home.shtml completed in directory $directory\n\n";
   } else {
      print "\n $directory/$ARGV[0].shtml does not exist.\n\n";
   }

} else {

print "\nNeed an objid argument (e.g. 2-AA ) in order to create link to home page.\n\n";

} 
